/*

 Counter block mode compatible with  Dr Brian Gladman fileenc.c
 derived from CryptoJS.mode.CTR
 Jan Hruby jhruby.web@gmail.com

 (c) 2012 by C?dric Mesnil. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

     - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
     - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 Yusuke Kawasaki
 @license MIT
 @constructor
 @see https://github.com/kawanet/event-lite
 @see http://kawanet.github.io/event-lite/EventLite.html
 @example
 var EventLite = require("event-lite");

 function MyClass() {...}             // your class

 EventLite.mixin(MyClass.prototype);  // import event methods

 var obj = new MyClass();
 obj.on("foo", function() {...});     // add event listener
 obj.once("bar", function() {...});   // add one-time event listener
 obj.emit("foo");                     // dispatch event
 obj.emit("bar");                     // dispatch another event
 obj.off("foo");                      // remove event listener
 bignumber.js v3.0.1 https://github.com/MikeMcl/bignumber.js/LICENCE  The buffer module from node.js, for the browser.

 @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 @license  MIT
 Determine if an object is a Buffer

 @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 @license  MIT
 https://mths.be/punycode v1.4.1 by @mathias  MIT License (c) copyright 2013-2014 original author or authors  MIT License (c) copyright 2010-2014 original author or authors */
var $jscomp=$jscomp||{};$jscomp.scope={};$jscomp.defineProperty="function"==typeof Object.defineProperties?Object.defineProperty:function(Q,f,m){Q!=Array.prototype&&Q!=Object.prototype&&(Q[f]=m.value)};$jscomp.getGlobal=function(Q){return"undefined"!=typeof window&&window===Q?Q:"undefined"!=typeof global&&null!=global?global:Q};$jscomp.global=$jscomp.getGlobal(this);$jscomp.SYMBOL_PREFIX="jscomp_symbol_";
$jscomp.initSymbol=function(){$jscomp.initSymbol=function(){};$jscomp.global.Symbol||($jscomp.global.Symbol=$jscomp.Symbol)};$jscomp.symbolCounter_=0;$jscomp.Symbol=function(Q){return $jscomp.SYMBOL_PREFIX+(Q||"")+$jscomp.symbolCounter_++};
$jscomp.initSymbolIterator=function(){$jscomp.initSymbol();var Q=$jscomp.global.Symbol.iterator;Q||(Q=$jscomp.global.Symbol.iterator=$jscomp.global.Symbol("iterator"));"function"!=typeof Array.prototype[Q]&&$jscomp.defineProperty(Array.prototype,Q,{configurable:!0,writable:!0,value:function(){return $jscomp.arrayIterator(this)}});$jscomp.initSymbolIterator=function(){}};$jscomp.arrayIterator=function(Q){var f=0;return $jscomp.iteratorPrototype(function(){return f<Q.length?{done:!1,value:Q[f++]}:{done:!0}})};
$jscomp.iteratorPrototype=function(Q){$jscomp.initSymbolIterator();Q={next:Q};Q[$jscomp.global.Symbol.iterator]=function(){return this};return Q};$jscomp.inherits=function(Q,f){function m(){}m.prototype=f.prototype;Q.superClass_=f.prototype;Q.prototype=new m;Q.prototype.constructor=Q;for(var k in f)if(Object.defineProperties){var b=Object.getOwnPropertyDescriptor(f,k);b&&Object.defineProperty(Q,k,b)}else Q[k]=f[k]};
$jscomp.makeIterator=function(Q){$jscomp.initSymbolIterator();var f=Q[Symbol.iterator];return f?f.call(Q):$jscomp.arrayIterator(Q)};$jscomp.polyfill=function(Q,f,m,k){if(f){m=$jscomp.global;Q=Q.split(".");for(k=0;k<Q.length-1;k++){var b=Q[k];b in m||(m[b]={});m=m[b]}Q=Q[Q.length-1];k=m[Q];f=f(k);f!=k&&null!=f&&$jscomp.defineProperty(m,Q,{configurable:!0,writable:!0,value:f})}};$jscomp.EXPOSE_ASYNC_EXECUTOR=!0;$jscomp.FORCE_POLYFILL_PROMISE=!1;
$jscomp.polyfill("Promise",function(Q){function f(){this.batch_=null}if(Q&&!$jscomp.FORCE_POLYFILL_PROMISE)return Q;f.prototype.asyncExecute=function(a){null==this.batch_&&(this.batch_=[],this.asyncExecuteBatch_());this.batch_.push(a);return this};f.prototype.asyncExecuteBatch_=function(){var a=this;this.asyncExecuteFunction(function(){a.executeBatch_()})};var m=$jscomp.global.setTimeout;f.prototype.asyncExecuteFunction=function(a){m(a,0)};f.prototype.executeBatch_=function(){for(;this.batch_&&this.batch_.length;){var a=
this.batch_;this.batch_=[];for(var b=0;b<a.length;++b){var c=a[b];delete a[b];try{c()}catch(l){this.asyncThrow_(l)}}}this.batch_=null};f.prototype.asyncThrow_=function(a){this.asyncExecuteFunction(function(){throw a;})};var k=function(a){this.state_=0;this.result_=void 0;this.onSettledCallbacks_=[];var b=this.createResolveAndReject_();try{a(b.resolve,b.reject)}catch(c){b.reject(c)}};k.prototype.createResolveAndReject_=function(){function a(a){return function(g){c||(c=!0,a.call(b,g))}}var b=this,c=
!1;return{resolve:a(this.resolveTo_),reject:a(this.reject_)}};k.prototype.resolveTo_=function(a){if(a===this)this.reject_(new TypeError("A Promise cannot resolve to itself"));else if(a instanceof k)this.settleSameAsPromise_(a);else{a:switch(typeof a){case "object":var b=null!=a;break a;case "function":b=!0;break a;default:b=!1}b?this.resolveToNonPromiseObj_(a):this.fulfill_(a)}};k.prototype.resolveToNonPromiseObj_=function(a){var b=void 0;try{b=a.then}catch(c){this.reject_(c);return}"function"==typeof b?
this.settleSameAsThenable_(b,a):this.fulfill_(a)};k.prototype.reject_=function(a){this.settle_(2,a)};k.prototype.fulfill_=function(a){this.settle_(1,a)};k.prototype.settle_=function(a,b){if(0!=this.state_)throw Error("Cannot settle("+a+", "+b|"): Promise already settled in state"+this.state_);this.state_=a;this.result_=b;this.executeOnSettledCallbacks_()};k.prototype.executeOnSettledCallbacks_=function(){if(null!=this.onSettledCallbacks_){for(var a=this.onSettledCallbacks_,b=0;b<a.length;++b)a[b].call(),
a[b]=null;this.onSettledCallbacks_=null}};var b=new f;k.prototype.settleSameAsPromise_=function(a){var b=this.createResolveAndReject_();a.callWhenSettled_(b.resolve,b.reject)};k.prototype.settleSameAsThenable_=function(a,b){var c=this.createResolveAndReject_();try{a.call(b,c.resolve,c.reject)}catch(l){c.reject(l)}};k.prototype.then=function(a,b){function c(a,b){return"function"==typeof a?function(d){try{g(a(d))}catch(r){e(r)}}:b}var g,e,h=new k(function(a,b){g=a;e=b});this.callWhenSettled_(c(a,g),
c(b,e));return h};k.prototype["catch"]=function(a){return this.then(void 0,a)};k.prototype.callWhenSettled_=function(a,g){function c(){switch(l.state_){case 1:a(l.result_);break;case 2:g(l.result_);break;default:throw Error("Unexpected state: "+l.state_);}}var l=this;null==this.onSettledCallbacks_?b.asyncExecute(c):this.onSettledCallbacks_.push(function(){b.asyncExecute(c)})};k.resolve=function(a){return a instanceof k?a:new k(function(b,c){b(a)})};k.reject=function(a){return new k(function(b,c){c(a)})};
k.race=function(a){return new k(function(b,c){for(var g=$jscomp.makeIterator(a),e=g.next();!e.done;e=g.next())k.resolve(e.value).callWhenSettled_(b,c)})};k.all=function(a){var b=$jscomp.makeIterator(a),c=b.next();return c.done?k.resolve([]):new k(function(a,e){function g(d){return function(b){l[d]=b;w--;0==w&&a(l)}}var l=[],w=0;do l.push(void 0),w++,k.resolve(c.value).callWhenSettled_(g(l.length-1),e),c=b.next();while(!c.done)})};$jscomp.EXPOSE_ASYNC_EXECUTOR&&(k.$jscomp$new$AsyncExecutor=function(){return new f});
return k},"es6-impl","es3");$jscomp.iteratorFromArray=function(Q,f){$jscomp.initSymbolIterator();Q instanceof String&&(Q+="");var m=0,k={next:function(){if(m<Q.length){var b=m++;return{value:f(b,Q[b]),done:!1}}k.next=function(){return{done:!0,value:void 0}};return k.next()}};k[Symbol.iterator]=function(){return k};return k};$jscomp.polyfill("Array.prototype.keys",function(Q){return Q?Q:function(){return $jscomp.iteratorFromArray(this,function(f){return f})}},"es6-impl","es3");
$jscomp.polyfill("Number.isFinite",function(Q){return Q?Q:function(f){return"number"!==typeof f?!1:!isNaN(f)&&Infinity!==f&&-Infinity!==f}},"es6-impl","es3");$jscomp.polyfill("Number.isInteger",function(Q){return Q?Q:function(f){return Number.isFinite(f)?f===Math.floor(f):!1}},"es6-impl","es3");
$jscomp.polyfill("Array.prototype.fill",function(Q){return Q?Q:function(f,m,k){var b=this.length||0;0>m&&(m=Math.max(0,b+m));if(null==k||k>b)k=b;k=Number(k);0>k&&(k=Math.max(0,b+k));for(m=Number(m||0);m<k;m++)this[m]=f;return this}},"es6-impl","es3");$jscomp.polyfill("Number.MAX_SAFE_INTEGER",function(){return 9007199254740991},"es6-impl","es3");$jscomp.owns=function(Q,f){return Object.prototype.hasOwnProperty.call(Q,f)};
$jscomp.polyfill("WeakMap",function(Q){function f(a){$jscomp.owns(a,k)||$jscomp.defineProperty(a,k,{value:{}})}function m(a){var b=Object[a];b&&(Object[a]=function(a){f(a);return b(a)})}if(function(){if(!Q||!Object.seal)return!1;try{var a=Object.seal({}),b=Object.seal({}),l=new Q([[a,2],[b,3]]);if(2!=l.get(a)||3!=l.get(b))return!1;l["delete"](a);l.set(b,4);return!l.has(a)&&4==l.get(b)}catch(e){return!1}}())return Q;var k="$jscomp_hidden_"+Math.random().toString().substring(2);m("freeze");m("preventExtensions");
m("seal");var b=0,a=function(a){this.id_=(b+=Math.random()+1).toString();if(a){$jscomp.initSymbol();$jscomp.initSymbolIterator();a=$jscomp.makeIterator(a);for(var c;!(c=a.next()).done;)c=c.value,this.set(c[0],c[1])}};a.prototype.set=function(a,b){f(a);if(!$jscomp.owns(a,k))throw Error("WeakMap key fail: "+a);a[k][this.id_]=b;return this};a.prototype.get=function(a){return $jscomp.owns(a,k)?a[k][this.id_]:void 0};a.prototype.has=function(a){return $jscomp.owns(a,k)&&$jscomp.owns(a[k],this.id_)};a.prototype["delete"]=
function(a){return $jscomp.owns(a,k)&&$jscomp.owns(a[k],this.id_)?delete a[k][this.id_]:!1};return a},"es6-impl","es3");$jscomp.MapEntry=function(){};$jscomp.ASSUME_NO_NATIVE_MAP=!1;
$jscomp.polyfill("Map",function(Q){if(!$jscomp.ASSUME_NO_NATIVE_MAP&&function(){if(!Q||!Q.prototype.entries||"function"!=typeof Object.seal)return!1;try{var a=Object.seal({x:4}),b=new Q($jscomp.makeIterator([[a,"s"]]));if("s"!=b.get(a)||1!=b.size||b.get({x:4})||b.set({x:4},"t")!=b||2!=b.size)return!1;var e=b.entries(),h=e.next();if(h.done||h.value[0]!=a||"s"!=h.value[1])return!1;h=e.next();return h.done||4!=h.value[0].x||"t"!=h.value[1]||!e.next().done?!1:!0}catch(n){return!1}}())return Q;$jscomp.initSymbol();
$jscomp.initSymbolIterator();var f=new WeakMap,m=function(b){this.data_={};this.head_=a();this.size=0;if(b){b=$jscomp.makeIterator(b);for(var c;!(c=b.next()).done;)c=c.value,this.set(c[0],c[1])}};m.prototype.set=function(a,b){var c=k(this,a);c.list||(c.list=this.data_[c.id]=[]);c.entry?c.entry.value=b:(c.entry={next:this.head_,previous:this.head_.previous,head:this.head_,key:a,value:b},c.list.push(c.entry),this.head_.previous.next=c.entry,this.head_.previous=c.entry,this.size++);return this};m.prototype["delete"]=
function(a){a=k(this,a);return a.entry&&a.list?(a.list.splice(a.index,1),a.list.length||delete this.data_[a.id],a.entry.previous.next=a.entry.next,a.entry.next.previous=a.entry.previous,a.entry.head=null,this.size--,!0):!1};m.prototype.clear=function(){this.data_={};this.head_=this.head_.previous=a();this.size=0};m.prototype.has=function(a){return!!k(this,a).entry};m.prototype.get=function(a){return(a=k(this,a).entry)&&a.value};m.prototype.entries=function(){return b(this,function(a){return[a.key,
a.value]})};m.prototype.keys=function(){return b(this,function(a){return a.key})};m.prototype.values=function(){return b(this,function(a){return a.value})};m.prototype.forEach=function(a,b){for(var c=this.entries(),h;!(h=c.next()).done;)h=h.value,a.call(b,h[1],h[0],this)};m.prototype[Symbol.iterator]=m.prototype.entries;var k=function(a,b){var c=b&&typeof b;"object"==c||"function"==c?f.has(b)?c=f.get(b):(c=""+ ++g,f.set(b,c)):c="p_"+b;var h=a.data_[c];if(h&&$jscomp.owns(a.data_,c))for(var n=0;n<h.length;n++){var l=
h[n];if(b!==b&&l.key!==l.key||b===l.key)return{id:c,list:h,index:n,entry:l}}return{id:c,list:h,index:-1,entry:void 0}},b=function(a,b){var c=a.head_;return $jscomp.iteratorPrototype(function(){if(c){for(;c.head!=a.head_;)c=c.previous;for(;c.next!=c.head;)return c=c.next,{done:!1,value:b(c)};c=null}return{done:!0,value:void 0}})},a=function(){var a={};return a.previous=a.next=a.head=a},g=0;return m},"es6-impl","es3");$jscomp.ASSUME_NO_NATIVE_SET=!1;
$jscomp.polyfill("Set",function(Q){if(!$jscomp.ASSUME_NO_NATIVE_SET&&function(){if(!Q||!Q.prototype.entries||"function"!=typeof Object.seal)return!1;try{var f=Object.seal({x:4}),k=new Q($jscomp.makeIterator([f]));if(!k.has(f)||1!=k.size||k.add(f)!=k||1!=k.size||k.add({x:4})!=k||2!=k.size)return!1;var b=k.entries(),a=b.next();if(a.done||a.value[0]!=f||a.value[1]!=f)return!1;a=b.next();return a.done||a.value[0]==f||4!=a.value[0].x||a.value[1]!=a.value[0]?!1:b.next().done}catch(g){return!1}}())return Q;
$jscomp.initSymbol();$jscomp.initSymbolIterator();var f=function(f){this.map_=new Map;if(f){f=$jscomp.makeIterator(f);for(var k;!(k=f.next()).done;)this.add(k.value)}this.size=this.map_.size};f.prototype.add=function(f){this.map_.set(f,f);this.size=this.map_.size;return this};f.prototype["delete"]=function(f){f=this.map_["delete"](f);this.size=this.map_.size;return f};f.prototype.clear=function(){this.map_.clear();this.size=0};f.prototype.has=function(f){return this.map_.has(f)};f.prototype.entries=
function(){return this.map_.entries()};f.prototype.values=function(){return this.map_.values()};f.prototype.keys=f.prototype.values;f.prototype[Symbol.iterator]=f.prototype.values;f.prototype.forEach=function(f,k){var b=this;this.map_.forEach(function(a){return f.call(k,a,a,b)})};return f},"es6-impl","es3");$jscomp.polyfill("Array.prototype.entries",function(Q){return Q?Q:function(){return $jscomp.iteratorFromArray(this,function(f,m){return[f,m]})}},"es6-impl","es3");
$jscomp.checkStringArgs=function(Q,f,m){if(null==Q)throw new TypeError("The 'this' value for String.prototype."+m+" must not be null or undefined");if(f instanceof RegExp)throw new TypeError("First argument to String.prototype."+m+" must not be a regular expression");return Q+""};
$jscomp.polyfill("String.prototype.repeat",function(Q){return Q?Q:function(f){var m=$jscomp.checkStringArgs(this,null,"repeat");if(0>f||1342177279<f)throw new RangeError("Invalid count value");f|=0;for(var k="";f;)if(f&1&&(k+=m),f>>>=1)m+=m;return k}},"es6-impl","es3");
(function(Q){"object"===typeof exports&&"undefined"!==typeof module?module.exports=Q():"function"===typeof define&&define.amd?define([],Q):("undefined"!==typeof window?window:"undefined"!==typeof global?global:"undefined"!==typeof self?self:this).autobahn=Q()})(function(){return function f(m,k,b){function a(c,e){if(!k[c]){if(!m[c]){var h="function"==typeof require&&require;if(!e&&h)return h(c,!0);if(g)return g(c,!0);h=Error("Cannot find module '"+c+"'");throw h.code="MODULE_NOT_FOUND",h;}h=k[c]={exports:{}};
m[c][0].call(h.exports,function(b){var e=m[c][1][b];return a(e?e:b)},h,h.exports,f,m,k,b)}return k[c].exports}for(var g="function"==typeof require&&require,c=0;c<b.length;c++)a(b[c]);return a}({1:[function(f,m,k){var b=f("crypto-js");k.sign=function(a,g){return b.HmacSHA256(g,a).toString(b.enc.Base64)};k.derive_key=function(a,g,c,l){return b.PBKDF2(a,g,{keySize:(l||32)/4,iterations:c||1E3,hasher:b.algo.SHA256}).toString(b.enc.Base64)}},{"crypto-js":47}],2:[function(f,m,k){function b(a,b){var e=c.htob(b.challenge),
d=g.sign.detached(e,a.secretKey);return c.btoh(d)+c.btoh(e)}function a(a){return c.btoh(a.publicKey)}var g=f("tweetnacl"),c=f("../util.js"),l=f("../log.js"),e=f("../connection.js");k.load_private_key=function(a,b){var e=c.atob(localStorage.getItem(a));!e||b?(e=g.randomBytes(g.sign.seedLength),localStorage.setItem(a,c.btoa(e)),l.debug('new key seed "'+a+'" saved to local storage!')):l.debug('key seed "'+a+'" loaded from local storage!');return g.sign.keyPair.fromSeed(e)};k.delete_private_key=function(a){for(var b=
0;5>b;++b)seed=g.randomBytes(g.sign.seedLength),localStorage.setItem(a,c.btoa(seed)),localStorage.setItem(a,""),localStorage.setItem(a,null)};k.sign_challenge=b;k.public_key=a;k.create_connection=function(c){var g=c.url,h=c.realm,d=c.authid,l=c.pkey,f=c.activation_code,k=c.request_new_activation_code,A=c.serializers;c.debug&&(console.log(g),console.log(h),console.log(d),console.log(l),console.log(f),console.log(k),console.log(A));authextra={pubkey:a(l),trustroot:null,challenge:null,channel_binding:null,
activation_code:f,request_new_activation_code:k};return new e.Connection({url:g,realm:h,authid:d,authmethods:["cryptosign"],onchallenge:function(a,d,c){if("cryptosign"==d)return b(l,c);throw"don't know how to authenticate using '"+d+"'";},authextra:authextra,serializers:c.serializers})}},{"../connection.js":6,"../log.js":7,"../util.js":21,tweetnacl:130}],3:[function(f,m,k){f("when");f("when/function");k.auth=function(b,a,g){var c=b.defer();navigator.id.watch({loggedInUser:a,onlogin:function(a){c.resolve(a)},
onlogout:function(){b.leave("wamp.close.logout")}});return c.promise.then?c.promise:c}},{when:161,"when/function":137}],4:[function(f,m,k){var b="undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{};f("./polyfill.js");m=f("../package.json");var a=f("when"),g=f("msgpack-lite"),c=f("cbor"),l=f("tweetnacl");"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG&&(f("when/monitor/console"),"console"in b&&console.log("AutobahnJS debug enabled"));var b=f("./util.js"),e=f("./log.js"),
h=f("./session.js"),n=f("./connection.js"),w=f("./configure.js"),d=f("./serializer.js"),r=f("./auth/persona.js"),B=f("./auth/cra.js");f=f("./auth/cryptosign.js");k.version=m.version;k.transports=w.transports;k.Connection=n.Connection;k.Session=h.Session;k.Invocation=h.Invocation;k.Event=h.Event;k.Result=h.Result;k.Error=h.Error;k.Subscription=h.Subscription;k.Registration=h.Registration;k.Publication=h.Publication;k.serializer=d;k.auth_persona=r.auth;k.auth_cra=B;k.auth_cryptosign=f;k.when=a;k.msgpack=
g;k.cbor=c;k.nacl=l;k.util=b;k.log=e},{"../package.json":162,"./auth/cra.js":1,"./auth/cryptosign.js":2,"./auth/persona.js":3,"./configure.js":5,"./connection.js":6,"./log.js":7,"./polyfill.js":8,"./serializer.js":16,"./session.js":17,"./util.js":21,cbor:28,"msgpack-lite":80,tweetnacl:130,when:161,"when/monitor/console":159}],5:[function(f,m,k){function b(){this._repository={}}b.prototype.register=function(a,b){this._repository[a]=b};b.prototype.isRegistered=function(a){return this._repository[a]?
!0:!1};b.prototype.get=function(a){if(void 0!==this._repository[a])return this._repository[a];throw"no such transport: "+a;};b.prototype.list=function(){var a=[],b;for(b in this._repository)a.push(b);return a};m=new b;var a=f("./transport/websocket.js");m.register("websocket",a.Factory);a=f("./transport/longpoll.js");m.register("longpoll",a.Factory);f=f("./transport/rawsocket.js");m.register("rawsocket",f.Factory);k.transports=m},{"./transport/longpoll.js":18,"./transport/rawsocket.js":19,"./transport/websocket.js":20}],
6:[function(f,m,k){(function(b){var a=f("when"),g=f("./session.js"),c=f("./util.js"),l=f("./log.js"),e=f("./autobahn.js"),h=function(c){(this._options=c)&&c.use_es6_promises?"Promise"in b?this._defer=function(){var a={};a.promise=new Promise(function(b,c){a.resolve=b;a.reject=c});return a}:(l.debug("Warning: ES6 promises requested, but not found! Falling back to whenjs."),this._defer=a.defer):this._defer=c&&c.use_deferred?c.use_deferred:a.defer;this._options.transports||(this._options.transports=
[{type:"websocket",url:this._options.url}]);this._transport_factories=[];this._init_transport_factories();this._session_close_message=this._session_close_reason=this._session=null;this._retry_if_unreachable=void 0!==this._options.retry_if_unreachable?this._options.retry_if_unreachable:!0;this._max_retries="undefined"!==typeof this._options.max_retries?this._options.max_retries:15;this._initial_retry_delay=this._options.initial_retry_delay||1.5;this._max_retry_delay=this._options.max_retry_delay||
300;this._retry_delay_growth=this._options.retry_delay_growth||1.5;this._retry_delay_jitter=this._options.retry_delay_jitter||.1;this._connect_successes=0;this._retry=!1;this._retry_count=0;this._retry_delay=this._initial_retry_delay;this._is_retrying=!1;this._retry_timer=null};h.prototype._create_transport=function(){for(var a=0;a<this._transport_factories.length;++a){var b=this._transport_factories[a];l.debug("trying to create WAMP transport of type: "+b.type);try{var d=b.create();if(d)return l.debug("using WAMP transport type: "+
b.type),d}catch(r){l.warn("could not create WAMP transport '"+b.type+"': "+r)}}l.warn("could not create any WAMP transport");return null};h.prototype._init_transport_factories=function(){var a;c.assert(this._options.transports,"No transport.factory specified");for(var b=0;b<this._options.transports.length;++b){var d=this._options.transports[b];d.url||(d.url=this._options.url);d.serializers||(d.serializers=this._options.serializers);d.protocols||(d.protocols=this._options.protocols);c.assert(d.type,
"No transport.type specified");c.assert("string"===typeof d.type,"transport.type must be a string");try{if(a=e.transports.get(d.type)){var g=new a(d);this._transport_factories.push(g)}}catch(B){console.error(B)}}};h.prototype._autoreconnect_reset_timer=function(){this._retry_timer&&clearTimeout(this._retry_timer);this._retry_timer=null};h.prototype._autoreconnect_reset=function(){this._autoreconnect_reset_timer();this._retry_count=0;this._retry_delay=this._initial_retry_delay;this._is_retrying=!1};
h.prototype._autoreconnect_advance=function(){this._retry_delay_jitter&&(this._retry_delay=c.rand_normal(this._retry_delay,this._retry_delay*this._retry_delay_jitter));this._retry_delay>this._max_retry_delay&&(this._retry_delay=this._max_retry_delay);this._retry_count+=1;var a=this._retry&&(-1===this._max_retries||this._retry_count<=this._max_retries)?{count:this._retry_count,delay:this._retry_delay,will_retry:!0}:{count:null,delay:null,will_retry:!1};this._retry_delay_growth&&(this._retry_delay*=
this._retry_delay_growth);return a};h.prototype.open=function(){function a(){try{b._transport=b._create_transport()}catch(d){console.log(d)}if(b._transport)b._session=new g.Session(b._transport,b._defer,b._options.onchallenge),b._session_close_reason=null,b._session_close_message=null,b._transport.onopen=function(){b._autoreconnect_reset();b._connect_successes+=1;b._session.join(b._options.realm,b._options.authmethods,b._options.authid,b._options.authextra)},b._session.onjoin=function(a){if(b.onopen)try{a.transport=
b._transport.info,b.onopen(b._session,a)}catch(r){l.debug("Exception raised from app code while firing Connection.onopen()",r)}},b._session.onleave=function(a,c){b._session_close_reason=a;b._session_close_message=c.message||"";b._retry=!1;b._transport.close(1E3)},b._transport.onclose=function(d){b._autoreconnect_reset_timer();b._transport=null;if(0===b._connect_successes){var c="unreachable";b._retry_if_unreachable||(b._retry=!1)}else c=d.wasClean?"closed":"lost";var e=b._autoreconnect_advance();
if(b.onclose){d={reason:b._session_close_reason,message:b._session_close_message,retry_delay:e.delay,retry_count:e.count,will_retry:e.will_retry};try{var g=b.onclose(c,d)}catch(A){l.debug("Exception raised from app code while firing Connection.onclose()",A)}}b._session&&(b._session._id=null,b._session=null,b._session_close_reason=null,b._session_close_message=null);b._retry&&!g&&(e.will_retry?(b._is_retrying=!0,l.debug("retrying in "+e.delay+" s"),b._retry_timer=setTimeout(a,1E3*e.delay)):l.debug("giving up trying to reconnect"))};
else if(b._retry=!1,b.onclose)b.onclose("unsupported",{reason:null,message:null,retry_delay:null,retry_count:null,will_retry:!1})}var b=this;if(b._transport)throw"connection already open (or opening)";b._autoreconnect_reset();b._retry=!0;a()};h.prototype.close=function(a,b){if(!this._transport&&!this._is_retrying)throw"connection already closed";this._retry=!1;this._session&&this._session.isOpen?this._session.leave(a,b):this._transport&&this._transport.close(1E3)};Object.defineProperty(h.prototype,
"defer",{get:function(){return this._defer}});Object.defineProperty(h.prototype,"session",{get:function(){return this._session}});Object.defineProperty(h.prototype,"isOpen",{get:function(){return this._session&&this._session.isOpen?!0:!1}});Object.defineProperty(h.prototype,"isConnected",{get:function(){return this._transport?!0:!1}});Object.defineProperty(h.prototype,"transport",{get:function(){return this._transport?this._transport:{info:{type:"none",url:null,protocol:null}}}});Object.defineProperty(h.prototype,
"isRetrying",{get:function(){return this._is_retrying}});k.Connection=h}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./autobahn.js":4,"./log.js":7,"./session.js":17,"./util.js":21,when:161}],7:[function(f,m,k){(function(b){var a=function(){};"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG&&"console"in b&&(a=function(){console.log.apply(console,arguments)});b=console.warn;k.debug=a;k.warn=b}).call(this,"undefined"!==typeof global?global:
"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],8:[function(f,m,k){f("./polyfill/object.js");f("./polyfill/array.js");f("./polyfill/string.js");f("./polyfill/function.js");f("./polyfill/console.js");f("./polyfill/typedarray.js");f("./polyfill/json.js")},{"./polyfill/array.js":9,"./polyfill/console.js":10,"./polyfill/function.js":11,"./polyfill/json.js":12,"./polyfill/object.js":13,"./polyfill/string.js":14,"./polyfill/typedarray.js":15}],9:[function(f,m,k){"function"!==
typeof Array.prototype.reduce&&(Array.prototype.reduce=function(b){if(null===this||"undefined"===typeof this)throw new TypeError("Array.prototype.reduce called on null or undefined");if("function"!==typeof b)throw new TypeError(b+" is not a function");var a=Object(this);var g=a.length>>>0;var c=0;if(2<=arguments.length)var l=arguments[1];else{for(;c<g&&!c in a;)c++;if(c>=g)throw new TypeError("Reduce of empty array with no initial value");l=a[c++]}for(;c<g;c++)c in a&&(l=b(l,a[c],c,a));return l});
"indexOf"in Array.prototype||(Array.prototype.indexOf=function(b,a){void 0===a&&(a=0);0>a&&(a+=this.length);0>a&&(a=0);for(var g=this.length;a<g;a++)if(a in this&&this[a]===b)return a;return-1});"lastIndexOf"in Array.prototype||(Array.prototype.lastIndexOf=function(b,a){void 0===a&&(a=this.length-1);0>a&&(a+=this.length);a>this.length-1&&(a=this.length-1);for(a++;0<a--;)if(a in this&&this[a]===b)return a;return-1});"forEach"in Array.prototype||(Array.prototype.forEach=function(b,a){for(var g=0,c=
this.length;g<c;g++)g in this&&b.call(a,this[g],g,this)});"map"in Array.prototype||(Array.prototype.map=function(b,a){for(var g=Array(this.length),c=0,l=this.length;c<l;c++)c in this&&(g[c]=b.call(a,this[c],c,this));return g});"filter"in Array.prototype||(Array.prototype.filter=function(b,a){for(var g=[],c,l=0,e=this.length;l<e;l++)l in this&&b.call(a,c=this[l],l,this)&&g.push(c);return g});"every"in Array.prototype||(Array.prototype.every=function(b,a){for(var g=0,c=this.length;g<c;g++)if(g in this&&
!b.call(a,this[g],g,this))return!1;return!0});"some"in Array.prototype||(Array.prototype.some=function(b,a){for(var g=0,c=this.length;g<c;g++)if(g in this&&b.call(a,this[g],g,this))return!0;return!1});"function"!==typeof Array.prototype.reduceRight&&(Array.prototype.reduceRight=function(b){if(null===this||"undefined"===typeof this)throw new TypeError("Array.prototype.reduce called on null or undefined");if("function"!==typeof b)throw new TypeError(b+" is not a function");var a=Object(this),g=(a.length>>>
0)-1;if(2<=arguments.length)var c=arguments[1];else{for(;0<=g&&!g in a;)g--;if(0>g)throw new TypeError("Reduce of empty array with no initial value");c=a[g--]}for(;0<=g;g--)g in a&&(c=b(c,a[g],g,a));return c})},{}],10:[function(f,m,k){(function(b){b||(b=window.console={log:function(a,b,c,l,e){},info:function(a,b,c,l,e){},warn:function(a,b,c,l,e){},error:function(a,b,c,l,e){},assert:function(a,b){}});"object"===typeof b.log&&(b.log=Function.prototype.call.bind(b.log,b),b.info=Function.prototype.call.bind(b.info,
b),b.warn=Function.prototype.call.bind(b.warn,b),b.error=Function.prototype.call.bind(b.error,b),b.debug=Function.prototype.call.bind(b.info,b));"group"in b||(b.group=function(a){b.info("\n--- "+a+" ---\n")});"groupEnd"in b||(b.groupEnd=function(){b.log("\n")});"assert"in b||(b.assert=function(a,b){if(!a)try{throw Error("assertion failed: "+b);}catch(c){setTimeout(function(){throw c;},0)}});"time"in b||function(){var a={};b.time=function(b){a[b]=(new Date).getTime()};b.timeEnd=function(g){var c=(new Date).getTime();
b.info(g+": "+(g in a?c-a[g]:0)+"ms")}}()})("undefined"!==typeof console?console:void 0)},{}],11:[function(f,m,k){Function.prototype.bind||(Function.prototype.bind=function(b){var a=this,g=Array.prototype.slice.call(arguments,1);return function(){return a.apply(b,Array.prototype.concat.apply(g,arguments))}})},{}],12:[function(f,m,k){"object"!==typeof JSON&&(JSON={});(function(){function b(a){return 10>a?"0"+a:a}function a(a){h.lastIndex=0;return h.test(a)?'"'+a.replace(h,function(a){var b=n[a];return"string"===
typeof b?b:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+a+'"'}function g(b,h){var d,n=c,r=h[b];r&&"object"===typeof r&&"function"===typeof r.toJSON&&(r=r.toJSON(b));"function"===typeof e&&(r=e.call(h,b,r));switch(typeof r){case "string":return a(r);case "number":return isFinite(r)?String(r):"null";case "boolean":case "null":return String(r);case "object":if(!r)return"null";c+=l;var f=[];if("[object Array]"===Object.prototype.toString.apply(r)){var w=r.length;for(d=0;d<w;d+=1)f[d]=
g(d,r)||"null";var q=0===f.length?"[]":c?"[\n"+c+f.join(",\n"+c)+"\n"+n+"]":"["+f.join(",")+"]";c=n;return q}if(e&&"object"===typeof e)for(w=e.length,d=0;d<w;d+=1){if("string"===typeof e[d]){var I=e[d];(q=g(I,r))&&f.push(a(I)+(c?": ":":")+q)}}else for(I in r)Object.prototype.hasOwnProperty.call(r,I)&&(q=g(I,r))&&f.push(a(I)+(c?": ":":")+q);q=0===f.length?"{}":c?"{\n"+c+f.join(",\n"+c)+"\n"+n+"}":"{"+f.join(",")+"}";c=n;return q}}"function"!==typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?
this.getUTCFullYear()+"-"+b(this.getUTCMonth()+1)+"-"+b(this.getUTCDate())+"T"+b(this.getUTCHours())+":"+b(this.getUTCMinutes())+":"+b(this.getUTCSeconds())+"Z":null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(){return this.valueOf()});var c,l,e;if("function"!==typeof JSON.stringify){var h=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;var n={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f",
"\r":"\\r",'"':'\\"',"\\":"\\\\"};JSON.stringify=function(a,b,h){var d;l=c="";if("number"===typeof h)for(d=0;d<h;d+=1)l+=" ";else"string"===typeof h&&(l=h);if((e=b)&&"function"!==typeof b&&("object"!==typeof b||"number"!==typeof b.length))throw Error("JSON.stringify");return g("",{"":a})}}if("function"!==typeof JSON.parse){var f=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;JSON.parse=function(a,b){function d(a,c){var e,h=a[c];if(h&&"object"===
typeof h)for(e in h)if(Object.prototype.hasOwnProperty.call(h,e)){var g=d(h,e);void 0!==g?h[e]=g:delete h[e]}return b.call(a,c,h)}a=String(a);f.lastIndex=0;f.test(a)&&(a=a.replace(f,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)}));if(/^[\],:{}\s]*$/.test(a.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){var c=eval("("+a+")");return"function"===typeof b?
d({"":c},""):c}throw new SyntaxError("JSON.parse");}}})();k.JSON=JSON},{}],13:[function(f,m,k){Object.create||(Object.create=function(){function b(){}return function(a){if(1!=arguments.length)throw Error("Object.create implementation only accepts one parameter.");b.prototype=a;return new b}}());Object.keys||(Object.keys=function(){var b=Object.prototype.hasOwnProperty,a=!{toString:null}.propertyIsEnumerable("toString"),g="toString toLocaleString valueOf hasOwnProperty isPrototypeOf propertyIsEnumerable constructor".split(" "),
c=g.length;return function(l){if("object"!==typeof l&&("function"!==typeof l||null===l))throw new TypeError("Object.keys called on non-object");var e=[],h;for(h in l)b.call(l,h)&&e.push(h);if(a)for(h=0;h<c;h++)b.call(l,g[h])&&e.push(g[h]);return e}}())},{}],14:[function(f,m,k){"trim"in String.prototype||(String.prototype.trim=function(){return this.replace(/^\s+/,"").replace(/\s+$/,"")})},{}],15:[function(f,m,k){"undefined"===typeof Uint8Array&&function(b,a){function g(a){switch(typeof a){case "undefined":return"undefined";
case "boolean":return"boolean";case "number":return"number";case "string":return"string";default:return null===a?"null":"object"}}function c(a){return Object.prototype.toString.call(a).replace(/^\[object *|\]$/g,"")}function l(a){return"function"===typeof a}function e(a){if(null===a||void 0===a)throw TypeError();return Object(a)}function h(a){function b(b){Object.defineProperty(a,b,{get:function(){return a._getter(b)},set:function(d){a._setter(b,d)},enumerable:!0,configurable:!1})}if(1E5<a.length)throw RangeError("Array too large for polyfill");
var d;for(d=0;d<a.length;d+=1)b(d)}function n(a,b){var d=32-b;return a<<d>>d}function f(a,b){var d=32-b;return a<<d>>>d}function d(a){return[a&255]}function r(a){return n(a[0],8)}function B(a){return[a&255]}function k(a){return f(a[0],8)}function A(a){a=S(Number(a));return[0>a?0:255<a?255:a&255]}function y(a){return[a>>8&255,a&255]}function C(a){return n(a[0]<<8|a[1],16)}function q(a){return[a>>8&255,a&255]}function I(a){return f(a[0]<<8|a[1],16)}function G(a){return[a>>24&255,a>>16&255,a>>8&255,
a&255]}function K(a){return n(a[0]<<24|a[1]<<16|a[2]<<8|a[3],32)}function O(a){return[a>>24&255,a>>16&255,a>>8&255,a&255]}function J(a){return f(a[0]<<24|a[1]<<16|a[2]<<8|a[3],32)}function m(a,b,d){function c(a){var b=t(a);a-=b;return.5>a?b:.5<a?b+1:b%2?b+1:b}var e=(1<<b-1)-1;if(a!==a){var h=(1<<b)-1;var g=T(2,d-1);var l=0}else Infinity===a||-Infinity===a?(h=(1<<b)-1,g=0,l=0>a?1:0):0===a?(g=h=0,l=-Infinity===1/a?1:0):(l=0>a,a=p(a),a>=T(2,1-e)?(h=ca(t(z(a)/u),1023),g=c(a/T(2,h)*T(2,d)),2<=g/T(2,d)&&
(h+=1,g=1),h>e?(h=(1<<b)-1,g=0):(h+=e,g-=T(2,d))):(h=0,g=c(a/T(2,1-e-d))));for(a=[];d;--d)a.push(g%2?1:0),g=t(g/2);for(d=b;d;--d)a.push(h%2?1:0),h=t(h/2);a.push(l?1:0);a.reverse();b=a.join("");for(l=[];b.length;)l.push(parseInt(b.substring(0,8),2)),b=b.substring(8);return l}function L(a,b,d){var c=[],p,e;for(p=a.length;p;--p){var t=a[p-1];for(e=8;e;--e)c.push(t%2?1:0),t>>=1}c.reverse();e=c.join("");a=(1<<b-1)-1;c=parseInt(e.substring(0,1),2)?-1:1;p=parseInt(e.substring(1,1+b),2);e=parseInt(e.substring(1+
b),2);return p===(1<<b)-1?0!==e?NaN:Infinity*c:0<p?c*T(2,p-a)*(1+e/T(2,d)):0!==e?c*T(2,-(a-1))*(e/T(2,d)):0>c?-0:0}function N(a){return L(a,11,52)}function x(a){return m(a,11,52)}function U(a){return L(a,8,23)}function M(a){return m(a,8,23)}var u=Math.LN2,p=Math.abs,t=Math.floor,z=Math.log,v=Math.max,ca=Math.min,T=Math.pow,S=Math.round;(function(){var a=Object.defineProperty;try{var b=Object.defineProperty({},"x",{})}catch(W){b=!1}a&&b||(Object.defineProperty=function(b,d,c){if(a)try{return a(b,d,
c)}catch(P){}if(b!==Object(b))throw TypeError("Object.defineProperty called on non-object");Object.prototype.__defineGetter__&&"get"in c&&Object.prototype.__defineGetter__.call(b,d,c.get);Object.prototype.__defineSetter__&&"set"in c&&Object.prototype.__defineSetter__.call(b,d,c.set);"value"in c&&(b[d]=c.value);return b})})();(function(){function u(a){a>>=0;if(0>a)throw RangeError("ArrayBuffer size is not a small enough positive integer.");Object.defineProperty(this,"byteLength",{value:a});Object.defineProperty(this,
"_bytes",{value:Array(a)});for(var b=0;b<a;b+=1)this._bytes[b]=0}function n(){if(!arguments.length||"object"!==typeof arguments[0])return function(a){a>>=0;if(0>a)throw RangeError("length is not a small enough positive integer.");Object.defineProperty(this,"length",{value:a});Object.defineProperty(this,"byteLength",{value:a*this.BYTES_PER_ELEMENT});Object.defineProperty(this,"buffer",{value:new u(this.byteLength)});Object.defineProperty(this,"byteOffset",{value:0})}.apply(this,arguments);if(1<=arguments.length&&
"object"===g(arguments[0])&&arguments[0]instanceof n)return function(a){if(this.constructor!==a.constructor)throw TypeError();var b=a.length*this.BYTES_PER_ELEMENT;Object.defineProperty(this,"buffer",{value:new u(b)});Object.defineProperty(this,"byteLength",{value:b});Object.defineProperty(this,"byteOffset",{value:0});Object.defineProperty(this,"length",{value:a.length});for(b=0;b<this.length;b+=1)this._setter(b,a._getter(b))}.apply(this,arguments);if(1<=arguments.length&&"object"===g(arguments[0])&&
!(arguments[0]instanceof n)&&!(arguments[0]instanceof u||"ArrayBuffer"===c(arguments[0])))return function(a){var b=a.length*this.BYTES_PER_ELEMENT;Object.defineProperty(this,"buffer",{value:new u(b)});Object.defineProperty(this,"byteLength",{value:b});Object.defineProperty(this,"byteOffset",{value:0});Object.defineProperty(this,"length",{value:a.length});for(b=0;b<this.length;b+=1)this._setter(b,Number(a[b]))}.apply(this,arguments);if(1<=arguments.length&&"object"===g(arguments[0])&&(arguments[0]instanceof
u||"ArrayBuffer"===c(arguments[0])))return function(a,b,d){b>>>=0;if(b>a.byteLength)throw RangeError("byteOffset out of range");if(b%this.BYTES_PER_ELEMENT)throw RangeError("buffer length minus the byteOffset is not a multiple of the element size.");if(void 0===d){var c=a.byteLength-b;if(c%this.BYTES_PER_ELEMENT)throw RangeError("length of buffer minus byteOffset not a multiple of the element size");d=c/this.BYTES_PER_ELEMENT}else d>>>=0,c=d*this.BYTES_PER_ELEMENT;if(b+c>a.byteLength)throw RangeError("byteOffset and length reference an area beyond the end of the buffer");
Object.defineProperty(this,"buffer",{value:a});Object.defineProperty(this,"byteLength",{value:c});Object.defineProperty(this,"byteOffset",{value:b});Object.defineProperty(this,"length",{value:d})}.apply(this,arguments);throw TypeError();}function f(a,b,d){var c=function(){Object.defineProperty(this,"constructor",{value:c});n.apply(this,arguments);h(this)};"__proto__"in c?c.__proto__=n:(c.from=n.from,c.of=n.of);c.BYTES_PER_ELEMENT=a;var p=function(){};p.prototype=w;c.prototype=new p;Object.defineProperty(c.prototype,
"BYTES_PER_ELEMENT",{value:a});Object.defineProperty(c.prototype,"_pack",{value:b});Object.defineProperty(c.prototype,"_unpack",{value:d});return c}b.ArrayBuffer=b.ArrayBuffer||u;Object.defineProperty(n,"from",{value:function(a){return new this(a)}});Object.defineProperty(n,"of",{value:function(){return new this(arguments)}});var w={};n.prototype=w;Object.defineProperty(n.prototype,"_getter",{value:function(a){if(1>arguments.length)throw SyntaxError("Not enough arguments");a>>>=0;if(!(a>=this.length)){var b=
[],d;var c=0;for(d=this.byteOffset+a*this.BYTES_PER_ELEMENT;c<this.BYTES_PER_ELEMENT;c+=1,d+=1)b.push(this.buffer._bytes[d]);return this._unpack(b)}}});Object.defineProperty(n.prototype,"get",{value:n.prototype._getter});Object.defineProperty(n.prototype,"_setter",{value:function(a,b){if(2>arguments.length)throw SyntaxError("Not enough arguments");a>>>=0;if(!(a>=this.length)){var d=this._pack(b),c;var p=0;for(c=this.byteOffset+a*this.BYTES_PER_ELEMENT;p<this.BYTES_PER_ELEMENT;p+=1,c+=1)this.buffer._bytes[c]=
d[p]}}});Object.defineProperty(n.prototype,"constructor",{value:n});Object.defineProperty(n.prototype,"copyWithin",{value:function(a,b,d){var c=e(this),p=c.length>>>0,p=v(p,0);a>>=0;a=0>a?v(p+a,0):ca(a,p);b>>=0;b=0>b?v(p+b,0):ca(b,p);d=void 0===d?p:d>>0;d=0>d?v(p+d,0):ca(d,p);p=ca(d-b,p-a);from<a&&a<b+p?(d=-1,b=b+p-1,a=a+p-1):d=1;for(;0<count;)c._setter(a,c._getter(b)),b+=d,a+=d,--p;return c}});Object.defineProperty(n.prototype,"every",{value:function(a,b){if(void 0===this||null===this)throw TypeError();
var d=Object(this),c=d.length>>>0;if(!l(a))throw TypeError();for(var p=0;p<c;p++)if(!a.call(b,d._getter(p),p,d))return!1;return!0}});Object.defineProperty(n.prototype,"fill",{value:function(a,b,d){var c=e(this),p=c.length>>>0,p=v(p,0);b>>=0;b=0>b?v(p+b,0):ca(b,p);d=void 0===d?p:d>>0;for(p=0>d?v(p+d,0):ca(d,p);b<p;)c._setter(b,a),b+=1;return c}});Object.defineProperty(n.prototype,"filter",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!l(a))throw TypeError();
for(var p=[],e=0;e<c;e++){var t=d._getter(e);a.call(b,t,e,d)&&p.push(t)}return new this.constructor(p)}});Object.defineProperty(n.prototype,"find",{value:function(a){var b=e(this),d=b.length>>>0;if(!l(a))throw TypeError();for(var c=1<arguments.length?arguments[1]:void 0,p=0;p<d;){var t=b._getter(p);if(a.call(c,t,p,b))return t;++p}}});Object.defineProperty(n.prototype,"findIndex",{value:function(a){var b=e(this),d=b.length>>>0;if(!l(a))throw TypeError();for(var c=1<arguments.length?arguments[1]:void 0,
p=0;p<d;){var t=b._getter(p);if(a.call(c,t,p,b))return p;++p}return-1}});Object.defineProperty(n.prototype,"forEach",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!l(a))throw TypeError();for(var p=0;p<c;p++)a.call(b,d._getter(p),p,d)}});Object.defineProperty(n.prototype,"indexOf",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(0===d)return-1;var c=0;if(0<arguments.length){var e=Number(arguments[1]);
e!==c?c=0:0!==e&&e!==1/0&&e!==-(1/0)&&(c=(0<e||-1)*t(p(e)))}if(c>=d)return-1;for(c=0<=c?c:v(d-p(c),0);c<d;c++)if(b._getter(c)===a)return c;return-1}});Object.defineProperty(n.prototype,"join",{value:function(a){if(void 0===this||null===this)throw TypeError();for(var b=Object(this),d=b.length>>>0,c=Array(d),p=0;p<d;++p)c[p]=b._getter(p);return c.join(void 0===a?",":a)}});Object.defineProperty(n.prototype,"lastIndexOf",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),
d=b.length>>>0;if(0===d)return-1;var c=d;1<arguments.length&&(c=Number(arguments[1]),c!==c?c=0:0!==c&&c!==1/0&&c!==-(1/0)&&(c=(0<c||-1)*t(p(c))));for(d=0<=c?ca(c,d-1):d-p(c);0<=d;d--)if(b._getter(d)===a)return d;return-1}});Object.defineProperty(n.prototype,"map",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!l(a))throw TypeError();var p=[];p.length=c;for(var e=0;e<c;e++)p[e]=a.call(b,d._getter(e),e,d);return new this.constructor(p)}});Object.defineProperty(n.prototype,
"reduce",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(!l(a))throw TypeError();if(0===d&&1===arguments.length)throw TypeError();var c=0,p;for(p=2<=arguments.length?arguments[1]:b._getter(c++);c<d;)p=a.call(void 0,p,b._getter(c),c,b),c++;return p}});Object.defineProperty(n.prototype,"reduceRight",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(!l(a))throw TypeError();if(0===d&&1===arguments.length)throw TypeError();
var d=d-1,c;for(c=2<=arguments.length?arguments[1]:b._getter(d--);0<=d;)c=a.call(void 0,c,b._getter(d),d,b),d--;return c}});Object.defineProperty(n.prototype,"reverse",{value:function(){if(void 0===this||null===this)throw TypeError();for(var a=Object(this),b=a.length>>>0,d=t(b/2),c=0,b=b-1;c<d;++c,--b){var p=a._getter(c);a._setter(c,a._getter(b));a._setter(b,p)}return a}});Object.defineProperty(n.prototype,"set",{value:function(a,b){if(1>arguments.length)throw SyntaxError("Not enough arguments");
var d;if("object"===typeof arguments[0]&&arguments[0].constructor===this.constructor){var c=arguments[0];var p=arguments[1]>>>0;if(p+c.length>this.length)throw RangeError("Offset plus length of array is out of range");var e=this.byteOffset+p*this.BYTES_PER_ELEMENT;p=c.length*this.BYTES_PER_ELEMENT;if(c.buffer===this.buffer){var t=[];var h=0;for(d=c.byteOffset;h<p;h+=1,d+=1)t[h]=c.buffer._bytes[d];for(h=0;h<p;h+=1,e+=1)this.buffer._bytes[e]=t[h]}else for(h=0,d=c.byteOffset;h<p;h+=1,d+=1,e+=1)this.buffer._bytes[e]=
c.buffer._bytes[d]}else if("object"===typeof arguments[0]&&"undefined"!==typeof arguments[0].length){c=arguments[0];t=c.length>>>0;p=arguments[1]>>>0;if(p+t>this.length)throw RangeError("Offset plus length of array is out of range");for(h=0;h<t;h+=1)d=c[h],this._setter(p+h,Number(d))}else throw TypeError("Unexpected argument type(s)");}});Object.defineProperty(n.prototype,"slice",{value:function(a,b){for(var d=e(this),c=d.length>>>0,p=a>>0,p=0>p?v(c+p,0):ca(p,c),t=void 0===b?c:b>>0,c=0>t?v(c+t,0):
ca(t,c),t=new d.constructor(c-p),h=0;p<c;){var g=d._getter(p);t._setter(h,g);++p;++h}return t}});Object.defineProperty(n.prototype,"some",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!l(a))throw TypeError();for(var p=0;p<c;p++)if(a.call(b,d._getter(p),p,d))return!0;return!1}});Object.defineProperty(n.prototype,"sort",{value:function(a){if(void 0===this||null===this)throw TypeError();for(var b=Object(this),d=b.length>>>0,c=Array(d),p=0;p<
d;++p)c[p]=b._getter(p);a?c.sort(a):c.sort();for(p=0;p<d;++p)b._setter(p,c[p]);return b}});Object.defineProperty(n.prototype,"subarray",{value:function(a,b){a>>=0;b>>=0;1>arguments.length&&(a=0);2>arguments.length&&(b=this.length);0>a&&(a=this.length+a);0>b&&(b=this.length+b);var d=this.length;a=0>a?0:a>d?d:a;d=this.length;d=(0>b?0:b>d?d:b)-a;0>d&&(d=0);return new this.constructor(this.buffer,this.byteOffset+a*this.BYTES_PER_ELEMENT,d)}});var z=f(1,d,r),F=f(1,B,k),fa=f(1,A,k),m=f(2,y,C),D=f(2,q,I),
E=f(4,G,K),L=f(4,O,J),na=f(4,M,U),X=f(8,x,N);b.Int8Array=a.Int8Array=b.Int8Array||z;b.Uint8Array=a.Uint8Array=b.Uint8Array||F;b.Uint8ClampedArray=a.Uint8ClampedArray=b.Uint8ClampedArray||fa;b.Int16Array=a.Int16Array=b.Int16Array||m;b.Uint16Array=a.Uint16Array=b.Uint16Array||D;b.Int32Array=a.Int32Array=b.Int32Array||E;b.Uint32Array=a.Uint32Array=b.Uint32Array||L;b.Float32Array=a.Float32Array=b.Float32Array||na;b.Float64Array=a.Float64Array=b.Float64Array||X})();(function(){function a(a,b){return l(a.get)?
a.get(b):a[b]}function d(a,b,d){if(!(a instanceof ArrayBuffer||"ArrayBuffer"===c(a)))throw TypeError();b>>>=0;if(b>a.byteLength)throw RangeError("byteOffset out of range");d=void 0===d?a.byteLength-b:d>>>0;if(b+d>a.byteLength)throw RangeError("byteOffset and length reference an area beyond the end of the buffer");Object.defineProperty(this,"buffer",{value:a});Object.defineProperty(this,"byteLength",{value:d});Object.defineProperty(this,"byteOffset",{value:b})}function p(d){return function(c,p){c>>>=
0;if(c+d.BYTES_PER_ELEMENT>this.byteLength)throw RangeError("Array index out of range");c+=this.byteOffset;for(var e=new b.Uint8Array(this.buffer,c,d.BYTES_PER_ELEMENT),h=[],g=0;g<d.BYTES_PER_ELEMENT;g+=1)h.push(a(e,g));!!p===!!t&&h.reverse();return a(new d((new b.Uint8Array(h)).buffer),0)}}function e(d){return function(c,p,e){c>>>=0;if(c+d.BYTES_PER_ELEMENT>this.byteLength)throw RangeError("Array index out of range");p=new d([p]);p=new b.Uint8Array(p.buffer);var h=[],g;for(g=0;g<d.BYTES_PER_ELEMENT;g+=
1)h.push(a(p,g));!!e===!!t&&h.reverse();(new Uint8Array(this.buffer,c,d.BYTES_PER_ELEMENT)).set(h)}}var t=function(){var d=new b.Uint16Array([4660]),d=new b.Uint8Array(d.buffer);return 18===a(d,0)}();Object.defineProperty(d.prototype,"getUint8",{value:p(b.Uint8Array)});Object.defineProperty(d.prototype,"getInt8",{value:p(b.Int8Array)});Object.defineProperty(d.prototype,"getUint16",{value:p(b.Uint16Array)});Object.defineProperty(d.prototype,"getInt16",{value:p(b.Int16Array)});Object.defineProperty(d.prototype,
"getUint32",{value:p(b.Uint32Array)});Object.defineProperty(d.prototype,"getInt32",{value:p(b.Int32Array)});Object.defineProperty(d.prototype,"getFloat32",{value:p(b.Float32Array)});Object.defineProperty(d.prototype,"getFloat64",{value:p(b.Float64Array)});Object.defineProperty(d.prototype,"setUint8",{value:e(b.Uint8Array)});Object.defineProperty(d.prototype,"setInt8",{value:e(b.Int8Array)});Object.defineProperty(d.prototype,"setUint16",{value:e(b.Uint16Array)});Object.defineProperty(d.prototype,"setInt16",
{value:e(b.Int16Array)});Object.defineProperty(d.prototype,"setUint32",{value:e(b.Uint32Array)});Object.defineProperty(d.prototype,"setInt32",{value:e(b.Int32Array)});Object.defineProperty(d.prototype,"setFloat32",{value:e(b.Float32Array)});Object.defineProperty(d.prototype,"setFloat64",{value:e(b.Float64Array)});b.DataView=b.DataView||d})()}(k,window);"undefined"===typeof window||"Uint8ClampedArray"in window||(window.Uint8ClampedArray=window.Uint8Array)},{}],16:[function(f,m,k){function b(){return Math.floor(9007199254740992*
Math.random())}function a(a,d){this.replacer=a;this.reviver=d;this.SERIALIZER_ID="json";this.BINARY=!1;this.newid=b}function g(){this.SERIALIZER_ID="msgpack";this.BINARY=!0;this.codec=e.createCodec();this.newid=function(){return new h(b())}}function c(){this.SERIALIZER_ID="cbor";this.BINARY=!0;this.newid=b}var l=f("./log.js");a.prototype.serialize=function(a){try{return JSON.stringify(a,this.replacer)}catch(d){throw l.warn("JSON encoding error",d),d;}};a.prototype.unserialize=function(a){try{return JSON.parse(a,
this.reviver)}catch(d){throw l.warn("JSON decoding error",d),d;}};k.JSONSerializer=a;var e=f("msgpack-lite"),h=f("int64-buffer").Uint64BE;g.prototype.serialize=function(a){try{return e.encode(a,{codec:this.codec})}catch(d){throw l.warn("MessagePack encoding error",d),d;}};g.prototype.unserialize=function(a){try{return e.decode(new Uint8Array(a),{codec:this.codec})}catch(d){throw l.warn("MessagePack decoding error",d),d;}};g.prototype.registerExtType=function(a,b,c,e){c&&b&&this.codec.addExtPacker(a,
b,c);e&&this.codec.addExtUnpacker(a,e)};k.MsgpackSerializer=g;var n=f("cbor");c.prototype.serialize=function(a){try{return n.encode(a)}catch(d){throw l.warn("CBOR encoding error",d),d;}};c.prototype.unserialize=function(a){try{return n.decodeFirstSync(a)}catch(d){throw l.warn("CBOR decoding error",d),d;}};k.CBORSerializer=c},{"./log.js":7,cbor:28,"int64-buffer":77,"msgpack-lite":80}],17:[function(f,m,k){(function(b){f("when");var a=f("when/function"),g=f("./log.js"),c=f("./util.js");Date.now=Date.now||
function(){return+new Date};var l={caller:{features:{caller_identification:!0,progressive_call_results:!0}},callee:{features:{caller_identification:!0,pattern_based_registration:!0,shared_registration:!0,progressive_call_results:!0,registration_revocation:!0}},publisher:{features:{publisher_identification:!0,subscriber_blackwhite_listing:!0,publisher_exclusion:!0}},subscriber:{features:{publisher_identification:!0,pattern_based_subscription:!0,subscription_revocation:!0}}},e=function(a,b,d,c,e){this.procedure=
a;this.progress=b;this.caller=d;this.caller_authid=c;this.caller_authrole=e},h=function(a,b,d,c,e,h){this.publication=a;this.topic=b;this.publisher=d;this.publisher_authid=c;this.publisher_authrole=e;this.retained=h},n=function(a,b){this.args=a||[];this.kwargs=b||{}},w=function(a,b,d){this.error=a;this.args=b||[];this.kwargs=d||{}},d=function(a,b,d,c,e){this.topic=a;this.handler=b;this.options=d||{};this.session=c;this.id=e;this.active=!0;this._on_unsubscribe=c._defer();this.on_unsubscribe=this._on_unsubscribe.promise.then?
this._on_unsubscribe.promise:this._on_unsubscribe};d.prototype.unsubscribe=function(){return this.session.unsubscribe(this)};var r=function(a,b,d,c,e){this.procedure=a;this.endpoint=b;this.options=d||{};this.session=c;this.id=e;this.active=!0;this._on_unregister=c._defer();this.on_unregister=this._on_unregister.promise.then?this._on_unregister.promise:this._on_unregister};r.prototype.unregister=function(){return this.session.unregister(this)};var B=function(a){this.id=a},F=function(c,f,k){var q=this;
q._socket=c;q._defer=f;q._onchallenge=k;q._id=null;q._realm=null;q._features=null;q._goodbye_sent=!1;q._transport_is_closing=!1;q._publish_reqs={};q._subscribe_reqs={};q._unsubscribe_reqs={};q._call_reqs={};q._register_reqs={};q._unregister_reqs={};q._subscriptions={};q._registrations={};q._invocations={};q._prefixes={};q._caller_disclose_me=!1;q._publisher_disclose_me=!1;q._send_wamp=function(a){g.debug(a);q._socket.send(a)};q._protocol_violation=function(a){g.warn("failing transport due to protocol violation: "+
a);q._socket.close(1002,"protocol violation: "+a)};q._MESSAGE_MAP={};q._MESSAGE_MAP[8]={};q._process_SUBSCRIBED=function(a){var b=a[1];a=a[2];if(b in q._subscribe_reqs){var c=q._subscribe_reqs[b],e=c[0],h=c[1],g=c[2],c=c[3];a in q._subscriptions||(q._subscriptions[a]=[]);h=new d(h,g,c,q,a);q._subscriptions[a].push(h);e.resolve(h);delete q._subscribe_reqs[b]}else q._protocol_violation("SUBSCRIBED received for non-pending request ID "+b)};q._MESSAGE_MAP[33]=q._process_SUBSCRIBED;q._process_SUBSCRIBE_ERROR=
function(a){var b=a[2];b in q._subscribe_reqs?(a=new w(a[4],a[5],a[6]),q._subscribe_reqs[b][0].reject(a),delete q._subscribe_reqs[b]):q._protocol_violation("SUBSCRIBE-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][32]=q._process_SUBSCRIBE_ERROR;q._process_UNSUBSCRIBED=function(a){var b=a[1];if(b in q._unsubscribe_reqs){a=q._unsubscribe_reqs[b];var d=a[0];a=a[1];if(a in q._subscriptions){var c=q._subscriptions[a];for(var e=0;e<c.length;++e)c[e].active=!1,c[e].on_unsubscribe.resolve();
delete q._subscriptions[a]}d.resolve(!0);delete q._unsubscribe_reqs[b]}else if(0===b)if(b=a[2],a=b.subscription,b=b.reason,a in q._subscriptions){c=q._subscriptions[a];for(e=0;e<c.length;++e)c[e].active=!1,c[e]._on_unsubscribe.resolve(b);delete q._subscriptions[a]}else q._protocol_violation("non-voluntary UNSUBSCRIBED received for non-existing subscription ID "+a);else q._protocol_violation("UNSUBSCRIBED received for non-pending request ID "+b)};q._MESSAGE_MAP[35]=q._process_UNSUBSCRIBED;q._process_UNSUBSCRIBE_ERROR=
function(a){var b=a[2];b in q._unsubscribe_reqs?(a=new w(a[4],a[5],a[6]),q._unsubscribe_reqs[b][0].reject(a),delete q._unsubscribe_reqs[b]):q._protocol_violation("UNSUBSCRIBE-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][34]=q._process_UNSUBSCRIBE_ERROR;q._process_PUBLISHED=function(a){var b=a[1],d=a[2];b in q._publish_reqs?(a=q._publish_reqs[b][0],d=new B(d),a.resolve(d),delete q._publish_reqs[b]):q._protocol_violation("PUBLISHED received for non-pending request ID "+b)};q._MESSAGE_MAP[17]=
q._process_PUBLISHED;q._process_PUBLISH_ERROR=function(a){var b=a[2];b in q._publish_reqs?(a=new w(a[4],a[5],a[6]),q._publish_reqs[b][0].reject(a),delete q._publish_reqs[b]):q._protocol_violation("PUBLISH-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][16]=q._process_PUBLISH_ERROR;q._process_EVENT=function(a){var b=a[1];if(b in q._subscriptions){var d=a[3],c=a[4]||[],e=a[5]||{},b=q._subscriptions[b];a=new h(a[2],d.topic||b[0]&&b[0].topic,d.publisher,d.publisher_authid,d.publisher_authrole,
d.retained||!1);for(d=0;d<b.length;++d){var n=b[d];try{n.handler(c,e,a,n)}catch(L){g.debug("Exception raised in event handler",L)}}}else q._protocol_violation("EVENT received for non-subscribed subscription ID "+b)};q._MESSAGE_MAP[36]=q._process_EVENT;q._process_REGISTERED=function(a){var b=a[1];a=a[2];if(b in q._register_reqs){var d=q._register_reqs[b],c=d[0],d=new r(d[1],d[2],d[3],q,a);q._registrations[a]=d;c.resolve(d);delete q._register_reqs[b]}else q._protocol_violation("REGISTERED received for non-pending request ID "+
b)};q._MESSAGE_MAP[65]=q._process_REGISTERED;q._process_REGISTER_ERROR=function(a){var b=a[2];b in q._register_reqs?(a=new w(a[4],a[5],a[6]),q._register_reqs[b][0].reject(a),delete q._register_reqs[b]):q._protocol_violation("REGISTER-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][64]=q._process_REGISTER_ERROR;q._process_UNREGISTERED=function(a){var b=a[1];if(b in q._unregister_reqs){a=q._unregister_reqs[b];var d=a[0];a=a[1];a.id in q._registrations&&delete q._registrations[a.id];
a.active=!1;d.resolve();delete q._unregister_reqs[b]}else 0===b?(a=a[2],b=a.registration,d=a.reason,b in q._registrations?(a=q._registrations[b],a.active=!1,a._on_unregister.resolve(d),delete q._registrations[b]):q._protocol_violation("non-voluntary UNREGISTERED received for non-existing registration ID "+b)):q._protocol_violation("UNREGISTERED received for non-pending request ID "+b)};q._MESSAGE_MAP[67]=q._process_UNREGISTERED;q._process_UNREGISTER_ERROR=function(a){var b=a[2];b in q._unregister_reqs?
(a=new w(a[4],a[5],a[6]),q._unregister_reqs[b][0].reject(a),delete q._unregister_reqs[b]):q._protocol_violation("UNREGISTER-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][66]=q._process_UNREGISTER_ERROR;q._process_RESULT=function(a){var b=a[1];if(b in q._call_reqs){var d=a[2],c=a[3]||[],e=a[4]||{};a=null;1<c.length||0<Object.keys(e).length?a=new n(c,e):0<c.length&&(a=c[0]);e=q._call_reqs[b];c=e[0];e=e[1];d.progress?e&&e.receive_progress&&c.notify(a):(c.resolve(a),delete q._call_reqs[b])}else q._protocol_violation("CALL-RESULT received for non-pending request ID "+
b)};q._MESSAGE_MAP[50]=q._process_RESULT;q._process_CALL_ERROR=function(a){var b=a[2];b in q._call_reqs?(a=new w(a[4],a[5],a[6]),q._call_reqs[b][0].reject(a),delete q._call_reqs[b]):q._protocol_violation("CALL-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][48]=q._process_CALL_ERROR;q._process_INVOCATION=function(b){var d=b[1],c=b[2],h=b[3];if(c in q._registrations){var c=q._registrations[c],g=b[4]||[];b=b[5]||{};var l=null;h.receive_progress&&(l=function(a,b){var c=[70,d,{progress:!0}];
a=a||[];b=b||{};var e=Object.keys(b).length;if(a.length||e)c.push(a),e&&c.push(b);q._send_wamp(c)});h=new e(h.procedure||c.procedure,l,h.caller,h.caller_authid,h.caller_authrole);a.call(c.endpoint,g,b,h).then(function(a){var b=[70,d,{}];if(a instanceof n){var c=Object.keys(a.kwargs).length;if(a.args.length||c)b.push(a.args),c&&b.push(a.kwargs)}else b.push([a]);q._send_wamp(b)},function(a){var b=[8,68,d,{}];if(a instanceof w){b.push(a.error);var c=Object.keys(a.kwargs).length;if(a.args.length||c)b.push(a.args),
c&&b.push(a.kwargs)}else b.push("wamp.error.runtime_error"),b.push([a]);q._send_wamp(b)})}else q._protocol_violation("INVOCATION received for non-registered registration ID "+d)};q._MESSAGE_MAP[68]=q._process_INVOCATION;q._socket.onmessage=function(b){var d=b[0];if(q._id)if(6===d){if(q._goodbye_sent||q._send_wamp([6,{},"wamp.error.goodbye_and_out"]),q._id=null,q._realm=null,q._features=null,d=b[1],b=b[2],q.onleave)q.onleave(b,d)}else if(8===d){var c=b[1];if(c in q._MESSAGE_MAP[8])q._MESSAGE_MAP[d][c](b);
else q._protocol_violation("unexpected ERROR message with request_type "+c)}else if(d in q._MESSAGE_MAP)q._MESSAGE_MAP[d](b);else q._protocol_violation("unexpected message type "+d);else if(2===d){q._id=b[1];d=b[2];q._features={};if(d.roles.broker&&(q._features.subscriber={},q._features.publisher={},d.roles.broker.features)){for(c in l.publisher.features)q._features.publisher[c]=l.publisher.features[c]&&d.roles.broker.features[c];for(c in l.subscriber.features)q._features.subscriber[c]=l.subscriber.features[c]&&
d.roles.broker.features[c]}if(d.roles.dealer&&(q._features.caller={},q._features.callee={},d.roles.dealer.features)){for(c in l.caller.features)q._features.caller[c]=l.caller.features[c]&&d.roles.dealer.features[c];for(c in l.callee.features)q._features.callee[c]=l.callee.features[c]&&d.roles.dealer.features[c]}if(q.onjoin)q.onjoin(b[2])}else if(3===d){if(d=b[1],b=b[2],q.onleave)q.onleave(b,d)}else 4===d?q._onchallenge?a.call(q._onchallenge,q,b[1],b[2]).then(function(a){q._send_wamp([5,a,{}])},function(a){g.debug("onchallenge() raised:",
a);q._send_wamp([3,{message:"sorry, I cannot authenticate (onchallenge handler raised an exception)"},"wamp.error.cannot_authenticate"]);q._socket.close(1E3)}):(g.debug("received WAMP challenge, but no onchallenge() handler set"),b=[3,{message:"sorry, I cannot authenticate (no onchallenge handler set)"},"wamp.error.cannot_authenticate"],q._send_wamp(b),q._socket.close(1E3)):q._protocol_violation("unexpected message type "+d)};q._created="performance"in b&&"now"in performance?performance.now():Date.now()};
Object.defineProperty(F.prototype,"defer",{get:function(){return this._defer}});Object.defineProperty(F.prototype,"id",{get:function(){return this._id}});Object.defineProperty(F.prototype,"realm",{get:function(){return this._realm}});Object.defineProperty(F.prototype,"isOpen",{get:function(){return null!==this.id}});Object.defineProperty(F.prototype,"features",{get:function(){return this._features}});Object.defineProperty(F.prototype,"caller_disclose_me",{get:function(){return this._caller_disclose_me},
set:function(a){this._caller_disclose_me=a}});Object.defineProperty(F.prototype,"publisher_disclose_me",{get:function(){return this._publisher_disclose_me},set:function(a){this._publisher_disclose_me=a}});Object.defineProperty(F.prototype,"subscriptions",{get:function(){for(var a=Object.keys(this._subscriptions),b=[],d=0;d<a.length;++d)b.push(this._subscriptions[a[d]]);return b}});Object.defineProperty(F.prototype,"registrations",{get:function(){for(var a=Object.keys(this._registrations),b=[],d=0;d<
a.length;++d)b.push(this._registrations[a[d]]);return b}});F.prototype.log=function(){if("console"in b){if(this._id&&this._created){var a="performance"in b&&"now"in performance?performance.now()-this._created:Date.now()-this._created;a="WAMP session "+this._id+" on '"+this._realm+"' at "+Math.round(1E3*a)/1E3+" ms"}else a="WAMP session";if("group"in console){console.group(a);for(a=0;a<arguments.length;a+=1)console.log(arguments[a]);console.groupEnd()}else{var d=[a+": "];for(a=0;a<arguments.length;a+=
1)d.push(arguments[a]);console.log.apply(console,d)}}};F.prototype.join=function(a,b,d,e){c.assert(!a||"string"===typeof a,"Session.join: <realm> must be a string");c.assert(!b||Array.isArray(b),"Session.join: <authmethods> must be an array []");c.assert(!d||"string"===typeof d,"Session.join: <authid> must be a string");if(this.isOpen)throw"session already open";this._goodbye_sent=!1;this._realm=a;var h={};h.roles=l;b&&(h.authmethods=b);d&&(h.authid=d);e&&(h.authextra=e);this._send_wamp([1,a,h])};
F.prototype.leave=function(a,b){c.assert(!a||"string"===typeof a,"Session.leave: <reason> must be a string");c.assert(!b||"string"===typeof b,"Session.leave: <message> must be a string");if(!this.isOpen)throw"session not open";a||(a="wamp.close.normal");var d={};b&&(d.message=b);this._send_wamp([6,d,a]);this._goodbye_sent=!0};F.prototype.call=function(a,b,d,e){c.assert("string"===typeof a,"Session.call: <procedure> must be a string");c.assert(!b||Array.isArray(b),"Session.call: <args> must be an array []");
c.assert(!d||d instanceof Object,"Session.call: <kwargs> must be an object {}");c.assert(!e||e instanceof Object,"Session.call: <options> must be an object {}");if(!this.isOpen)throw"session not open";e=e||{};void 0===e.disclose_me&&this._caller_disclose_me&&(e.disclose_me=!0);var h=this._defer(),g=this._socket.serializer.newid();this._call_reqs[g]=[h,e];a=[48,g,e,this.resolve(a)];b?(a.push(b),d&&a.push(d)):d&&(a.push([]),a.push(d));this._send_wamp(a);return h.promise.then?h.promise:h};F.prototype.publish=
function(a,b,d,e){c.assert("string"===typeof a,"Session.publish: <topic> must be a string");c.assert(!b||Array.isArray(b),"Session.publish: <args> must be an array []");c.assert(!d||d instanceof Object,"Session.publish: <kwargs> must be an object {}");c.assert(!e||e instanceof Object,"Session.publish: <options> must be an object {}");if(!this.isOpen)throw"session not open";e=e||{};void 0===e.disclose_me&&this._publisher_disclose_me&&(e.disclose_me=!0);var h=null,g=this._socket.serializer.newid();
e.acknowledge&&(h=this._defer(),this._publish_reqs[g]=[h,e]);a=[16,g,e,this.resolve(a)];b?(a.push(b),d&&a.push(d)):d&&(a.push([]),a.push(d));this._send_wamp(a);if(h)return h.promise.then?h.promise:h};F.prototype.subscribe=function(a,b,d){c.assert("string"===typeof a,"Session.subscribe: <topic> must be a string");c.assert("function"===typeof b,"Session.subscribe: <handler> must be a function");c.assert(!d||d instanceof Object,"Session.subscribe: <options> must be an object {}");if(!this.isOpen)throw"session not open";
var e=this._socket.serializer.newid(),h=this._defer();this._subscribe_reqs[e]=[h,a,b,d];b=[32,e];d?b.push(d):b.push({});b.push(this.resolve(a));this._send_wamp(b);return h.promise.then?h.promise:h};F.prototype.register=function(a,b,d){c.assert("string"===typeof a,"Session.register: <procedure> must be a string");c.assert("function"===typeof b,"Session.register: <endpoint> must be a function");c.assert(!d||d instanceof Object,"Session.register: <options> must be an object {}");if(!this.isOpen)throw"session not open";
var e=this._socket.serializer.newid(),h=this._defer();this._register_reqs[e]=[h,a,b,d];b=[64,e];d?b.push(d):b.push({});b.push(this.resolve(a));this._send_wamp(b);return h.promise.then?h.promise:h};F.prototype.unsubscribe=function(a){c.assert(a instanceof d,"Session.unsubscribe: <subscription> must be an instance of class autobahn.Subscription");if(!this.isOpen)throw"session not open";if(!(a.active&&a.id in this._subscriptions))throw"subscription not active";var b=this._subscriptions[a.id],e=b.indexOf(a);
if(-1===e)throw"subscription not active";b.splice(e,1);a.active=!1;e=this._defer();b.length?e.resolve(!1):(b=this._socket.serializer.newid(),this._unsubscribe_reqs[b]=[e,a.id],this._send_wamp([34,b,a.id]));return e.promise.then?e.promise:e};F.prototype.unregister=function(a){c.assert(a instanceof r,"Session.unregister: <registration> must be an instance of class autobahn.Registration");if(!this.isOpen)throw"session not open";if(!(a.active&&a.id in this._registrations))throw"registration not active";
var b=this._socket.serializer.newid(),d=this._defer();this._unregister_reqs[b]=[d,a];this._send_wamp([66,b,a.id]);return d.promise.then?d.promise:d};F.prototype.prefix=function(a,b){c.assert("string"===typeof a,"Session.prefix: <prefix> must be a string");c.assert(!b||"string"===typeof b,"Session.prefix: <uri> must be a string or falsy");b?this._prefixes[a]=b:a in this._prefixes&&delete this._prefixes[a]};F.prototype.resolve=function(a){c.assert("string"===typeof a,"Session.resolve: <curie> must be a string");
var b=a.indexOf(":");if(0<=b){var d=a.substring(0,b);return d in this._prefixes?this._prefixes[d]+"."+a.substring(b+1):a}return a};k.Session=F;k.Invocation=e;k.Event=h;k.Result=n;k.Error=w;k.Subscription=d;k.Registration=r;k.Publication=B}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./log.js":7,"./util.js":21,when:161,"when/function":137}],18:[function(f,m,k){function b(b){a.assert(void 0!==b.url,"options.url missing");a.assert("string"===
typeof b.url,"options.url must be a string");this._options=b}f("when");var a=f("../util.js"),g=f("../log.js"),c=f("../serializer.js");b.prototype.type="longpoll";b.prototype.create=function(){var b=this;g.debug("longpoll.Factory.create");var e={protocol:void 0};e.serializer=new c.JSONSerializer;e.send=void 0;e.close=void 0;e.onmessage=function(){};e.onopen=function(){};e.onclose=function(){};e.info={type:"longpoll",url:null,protocol:"wamp.2.json"};e._run=function(){var c=null,n=!1,l=b._options.request_timeout||
12E3;a.http_post(b._options.url+"/open",JSON.stringify({protocols:["wamp.2.json"]}),l).then(function(d){function h(){g.debug("longpoll.Transport: polling for message ...");a.http_post(f+"/receive",null,l).then(function(a){a&&(a=JSON.parse(a),g.debug("longpoll.Transport: message received",a),e.onmessage(a));n||h()},function(a){g.debug("longpoll.Transport: could not receive message",a.code,a.text);n=!0;e.onclose({code:1001,reason:"transport receive failure (HTTP/POST status "+a.code+" - '"+a.text+"')",
wasClean:!1})})}c=JSON.parse(d);var f=b._options.url+"/"+c.transport;e.info.url=f;g.debug("longpoll.Transport: open",c);e.close=function(b,d){if(n)throw"transport is already closing";n=!0;a.http_post(f+"/close",null,l).then(function(){g.debug("longpoll.Transport: transport closed");e.onclose({code:1E3,reason:"transport closed",wasClean:!0})},function(a){g.debug("longpoll.Transport: could not close transport",a.code,a.text)})};e.send=function(b){if(n)throw"transport is closing or closed already";g.debug("longpoll.Transport: sending message ...",
b);b=JSON.stringify(b);a.http_post(f+"/send",b,l).then(function(){g.debug("longpoll.Transport: message sent")},function(a){g.debug("longpoll.Transport: could not send message",a.code,a.text);n=!0;e.onclose({code:1001,reason:"transport send failure (HTTP/POST status "+a.code+" - '"+a.text+"')",wasClean:!1})})};h();e.onopen()},function(a){g.debug("longpoll.Transport: could not open transport",a.code,a.text);n=!0;e.onclose({code:1001,reason:"transport open failure (HTTP/POST status "+a.code+" - '"+a.text+
"')",wasClean:!1})})};e._run();return e};k.Factory=b},{"../log.js":7,"../serializer.js":16,"../util.js":21,when:161}],19:[function(f,m,k){(function(b,a){function g(a){a.protocols?l.assert(Array.isArray(a.protocols),"options.protocols must be an array"):a.protocols=["wamp.2.json"];a.rawsocket_max_len_exp=a.rawsocket_max_len_exp||24;this._options=a}function c(b,c){this._options={_peer_serializer:null,_peer_max_len_exp:0};this._options=l.defaults(this._options,c,this.DEFAULT_OPTIONS);l.assert(this._options.serializer in
this.SERIALIZERS,"Unsupported serializer: "+this._options.serializer);l.assert(9<=this._options.max_len_exp&&36>=this._options.max_len_exp,"Message length out of bounds [9, 36]: "+this._options.max_len_exp);l.assert(!this._options.autoping||Number.isInteger(this._options.autoping)&&0<=this._options.autoping,"Autoping interval must be positive");l.assert(!this._options.ping_timeout||Number.isInteger(this._options.ping_timeout)&&0<=this._options.ping_timeout,"Ping timeout duration must be positive");
l.assert(!this._options.packet_timeout||Number.isInteger(this._options.packet_timeout)&&0<=this._options.packet_timeout,"Packet timeout duration must be positive");l.assert(!this._options.autoping||!this._options.ping_timeout||this._options.autoping>this._options.ping_timeout,"Autoping interval ("+this._options.autoping+") must be lower than ping timeout ("+this._options.ping_timeout+")");this._ping_interval=this._ping_payload=this._ping_timeout=null;this._status=this.STATUS.UNINITIATED;this._stream=
b;this._emitter=new n;this._buffer=new a(4);this._msgLen=this._bufferLen=0;var d=this;this._stream.on("data",function(a){d._read(a)});this._stream.on("connect",function(){d._handshake()});["close","drain","end","error","timeout"].forEach(function(a){d._stream.on(a,function(b){d._emitter.emit(a,b)})})}var l=f("../util.js"),e=f("../log.js"),h=f("../serializer.js"),n=f("events").EventEmitter;g.prototype.type="rawsocket";g.prototype.create=function(){var a=this,g={protocol:void 0};g.serializer=new h.JSONSerializer;
g.send=void 0;g.close=void 0;g.onmessage=function(){};g.onopen=function(){};g.onclose=function(){};g.info={type:"rawsocket",url:null,protocol:"wamp.2.json"};if(b.process&&b.process.versions.node)(function(){var b=f("net");if(a._options.path)connectionOptions={path:a._options.path,allowHalfOpen:!0};else if(a._options.port)connectionOptions={port:a._options.port||8E3,host:a._options.host||"localhost",allowHalfOpen:!0};else throw"You must specify a host/port combination or a unix socket path to connect to";
b=b.connect(connectionOptions);var d=new c(b,{serializer:"json",max_len_exp:a._options.rawsocket_max_len_exp});d.on("connect",function(a){e.debug("RawSocket transport negociated");g.onopen(a)});d.on("data",function(a){e.debug("RawSocket transport received",a);g.onmessage(a)});d.on("close",function(a){e.debug("RawSocket transport closed");g.onclose({code:999,reason:"",wasClean:!a})});d.on("error",function(a){e.debug("RawSocket transport error",a)});g.close=function(a,b){e.debug("RawSocket transport closing",
a,b);d.close()};g.send=function(a){e.debug("RawSocket transport sending",a);d.write(a)}})();else throw"No RawSocket support in browser";return g};c.prototype._MAGIC_BYTE=127;c.prototype.SERIALIZERS={json:1};c.prototype.STATUS={CLOSED:-1,UNINITIATED:0,NEGOCIATING:1,NEGOCIATED:2,RXHEAD:3,RXDATA:4,RXPING:5,RXPONG:6};c.prototype.ERRORS={0:"illegal (must not be used)",1:"serializer unsupported",2:"maximum message length unacceptable",3:"use of reserved bits (unsupported feature)",4:"maximum connection count reached"};
c.prototype.MSGTYPES={WAMP:0,PING:1,PONG:2};c.prototype.DEFAULT_OPTIONS={fail_on_ping_timeout:!0,strict_pong:!0,ping_timeout:2E3,autoping:0,max_len_exp:24,serializer:"json",packet_timeout:2E3};c.prototype.close=function(){this._status=this.STATUS.CLOSED;this._stream.end();return this.STATUS.CLOSED};c.prototype.write=function(b,c,e){c=void 0===c?0:c;c===this.MSGTYPES.WAMP&&(b=JSON.stringify(b));var d=a.byteLength(b,"utf8");if(d>Math.pow(2,this._options._peer_max_len_exp))this._emitter.emit("error",
new w("Frame too big"));else{var h=new a(d+4);h.writeUInt8(c,0);h.writeUIntBE(d,1,3);h.write(b,4);this._stream.write(h,e)}};c.prototype.ping=function(a){a=a||255;if(Number.isInteger(a))for(var b=Math.max(1,a),d=0;d<b;d++)a+="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789&~\"#'{([-|`_\\^@)]=},?;.:/!*$<>".charAt(92*Math.random()|0);this._ping_payload=a;return this.write(a,this.MSGTYPES.PING,this._setupPingTimeout.bind(this))};c.prototype._setupPingTimeout=function(){this._options.ping_timeout&&
(this._ping_timeout=setTimeout(this._onPingTimeout.bind(this),this._options.ping_timeout))};c.prototype._clearPingTimeout=function(){this._ping_timeout&&(clearTimeout(this._ping_timeout),this._ping_timeout=null)};c.prototype._setupAutoPing=function(){this._clearAutoPing();this._options.autoping&&(this._autoping_interval=setInterval(this.ping.bind(this),this._options.autoping))};c.prototype._clearAutoPing=function(){this._autoping_interval&&(clearInterval(this._autoping_interval),this._autoping_interval=
null)};c.prototype._onPingTimeout=function(){this._emitter.emit("error",new w("PING timeout"));this._options.fail_on_ping_timeout&&this.close()};c.prototype._read=function(a){switch(this._status){case this.STATUS.CLOSED:case this.STATUS.UNINITIATED:this._emitter.emit("error",w("Unexpected packet"));break;case this.STATUS.NEGOCIATING:var b=this._handleHandshake;var d=4;break;case this.STATUS.NEGOCIATED:case this.STATUS.RXHEAD:this._status=this.STATUS.RXHEAD;b=this._handleHeaderPacket;d=4;break;case this.STATUS.RXDATA:b=
this._handleDataPacket;d=this._msgLen;break;case this.STATUS.RXPING:b=this._handlePingPacket;d=this._msgLen;break;case this.STATUS.RXPONG:b=this._handlePongPacket,d=this._msgLen}if(a=this._splitBytes(a,d))this._status=b.call(this,a[0]),0<a[1].length&&this._read(a[1])};c.prototype._handshake=function(){if(this._status!==this.STATUS.UNINITIATED)throw"Handshake packet already sent";var b=new a(4);b.writeUInt8(this._MAGIC_BYTE,0);b.writeUInt8(this._options.max_len_exp-9<<4|this.SERIALIZERS[this._options.serializer],
1);b.writeUInt8(0,2);b.writeUInt8(0,3);this._stream.write(b);this._status=this.STATUS.NEGOCIATING};c.prototype._splitBytes=function(b,c){c!==this._buffer.length&&(this._buffer=new a(c),this._bufferLen=0);b.copy(this._buffer,this._bufferLen);if(this._bufferLen+b.length<c)return this._bufferLen+=b.length,null;var d=this._buffer.slice(),e=b.slice(c-this._bufferLen);this._bufferLen=0;return[d,e]};c.prototype._handleHandshake=function(a){if(a[0]!==this._MAGIC_BYTE)return this._emitter.emit("error",new w("Invalid magic byte. Expected 0x"+
this._MAGIC_BYTE.toString(16)+", got 0x"+a[0].toString(16))),this.close();if(0===(a[1]&15))return a=a[1]>>4,this._emitter.emit("error",new w("Peer failed handshake: "+(this.ERRORS[a]||"0x"+a.toString(16)))),this.close();this._options._peer_max_len_exp=(a[1]>>4)+9;this._options._peer_serializer=a[1]&15;if(this._options._peer_serializer!==this.SERIALIZERS.json)return this._emitter.emit("error",new w("Unsupported serializer: 0x"+this._options._peer_serializer.toString(16))),this.close();this._emitter.emit("connect");
this._setupAutoPing();return this.STATUS.NEGOCIATED};c.prototype._handleHeaderPacket=function(a){var b=a[0]&15;this._msgLen=a.readUIntBE(1,3);switch(b){case this.MSGTYPES.WAMP:return this.STATUS.RXDATA;case this.MSGTYPES.PING:return this.STATUS.RXPING;case this.MSGTYPES.PONG:return this.STATUS.RXPONG;default:return this._emitter.emit("error",new w("Invalid frame type: 0x"+b.toString(16))),this.close()}};c.prototype._handleDataPacket=function(a){try{var b=JSON.parse(a.toString("utf8"))}catch(B){return this._emitter.emit("error",
new w("Invalid JSON frame")),this.STATUS.RXHEAD}this._emitter.emit("data",b);return this.STATUS.RXHEAD};c.prototype._handlePingPacket=function(a){this.write(a.toString("utf8"),this.MSGTYPES.PONG);return this.STATUS.RXHEAD};c.prototype._handlePongPacket=function(a){this._clearPingTimeout();return this._options.strict_pong&&this._ping_payload!==a.toString("utf8")?(this._emitter.emit("error",new w("PONG response payload doesn't match PING.")),this.close()):this.STATUS.RXHEAD};c.prototype.on=function(a,
b){return this._emitter.on(a,b)};c.prototype.once=function(a,b){return this._emitter.once(a,b)};c.prototype.removeListener=function(a,b){return this._emitter.removeListener(a,b)};var w=k.ProtocolError=function(a){Error.apply(this,Array.prototype.splice.call(arguments));Error.captureStackTrace(this,this.constructor);this.message=a;this.name="ProtocolError"};w.prototype=Object.create(Error.prototype);k.Factory=g;k.Protocol=c}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:
"undefined"!==typeof window?window:{},f("buffer").Buffer)},{"../log.js":7,"../serializer.js":16,"../util.js":21,buffer:27,events:74,net:25}],20:[function(f,m,k){(function(b){function a(a){g.assert(void 0!==a.url,"options.url missing");g.assert("string"===typeof a.url,"options.url must be a string");a.serializers?g.assert(Array.isArray(a.serializers),"options.serializers must be an array"):(a.serializers=[new l.JSONSerializer],l.MsgpackSerializer&&a.serializers.push(new l.MsgpackSerializer));a.protocols?
g.assert(Array.isArray(a.protocols),"options.protocols must be an array"):(a.protocols=[],a.serializers.forEach(function(b){a.protocols.push("wamp.2."+b.SERIALIZER_ID)}));this._options=a}var g=f("../util.js"),c=f("../log.js"),l=f("../serializer.js");a.prototype.type="websocket";a.prototype.create=function(){var a=this,h={protocol:void 0,serializer:void 0,send:void 0,close:void 0,onmessage:function(){},onopen:function(){},onclose:function(){}};h.info={type:"websocket",url:a._options.url,protocol:null};
b.process&&b.process.versions.node?function(){var b=f("ws");if(a._options.protocols){var c=a._options.protocols;Array.isArray(c)&&(c=c.join(","));var d=new b(a._options.url,{protocol:c})}else d=new b(a._options.url);h.send=function(a){a=h.serializer.serialize(a);d.send(a,{binary:h.serializer.BINARY})};h.close=function(a,b){d.close()};d.on("open",function(){var b=d.protocol.split(".")[2],c;for(c in a._options.serializers){var e=a._options.serializers[c];if(e.SERIALIZER_ID==b){h.serializer=e;break}}h.info.protocol=
d.protocol;h.onopen()});d.on("message",function(a,b){var d=h.serializer.unserialize(a);h.onmessage(d)});d.on("close",function(a,b){h.onclose({code:a,reason:b,wasClean:1E3===a})});d.on("error",function(a){h.onclose({code:1006,reason:"",wasClean:!1})})}():function(){if("WebSocket"in b){var e=a._options.protocols?new b.WebSocket(a._options.url,a._options.protocols):new b.WebSocket(a._options.url);e.binaryType="arraybuffer"}else if("MozWebSocket"in b)e=a._options.protocols?new b.MozWebSocket(a._options.url,
a._options.protocols):new b.MozWebSocket(a._options.url);else throw"browser does not support WebSocket or WebSocket in Web workers";e.onmessage=function(a){c.debug("WebSocket transport receive",a.data);a=h.serializer.unserialize(a.data);h.onmessage(a)};e.onopen=function(){var b=e.protocol.split(".")[2],d;for(d in a._options.serializers){var c=a._options.serializers[d];if(c.SERIALIZER_ID==b){h.serializer=c;break}}h.info.protocol=e.protocol;h.onopen()};e.onclose=function(a){h.onclose({code:a.code,reason:a.message,
wasClean:a.wasClean})};h.send=function(a){a=h.serializer.serialize(a);c.debug("WebSocket transport send",a);e.send(a)};h.close=function(a,b){e.close(a,b)}}();return h};k.Factory=a}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"../log.js":7,"../serializer.js":16,"../util.js":21,ws:24}],21:[function(f,m,k){(function(b){var a=f("./log.js"),g=f("when");k.atob=function(a){return a?new Uint8Array(atob(a).split("").map(function(a){return a.charCodeAt(0)})):
null};k.btoa=function(a){return a?btoa(String.fromCharCode.apply(null,a)):null};k.btoh=function(a){if(a){for(var b="",c=0;c<a.length;++c)b+=("0"+(a[c]&255).toString(16)).slice(-2);return b}return null};k.htob=function(a){if(a){if("string"!==typeof a)throw new TypeError("Expected input to be a string");if(0!==a.length%2)throw new RangeError("Expected string to be an even number of characters");for(var b=new Uint8Array(a.length/2),c=0;c<a.length;c+=2)b[c/2]=parseInt(a.substring(c,c+2),16);return b}return null};
var c=function(a,h){if(!a){if(c.useDebugger||"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG)debugger;throw Error(h||"Assertion failed!");}},l=function(){var a;if(0===arguments.length)return{};var b=arguments[0],c=!1,g=arguments.length;"boolean"===typeof arguments[g-1]&&(c=arguments[g-1],--g);var d=function(d){var e=a[d];d in b?c&&"object"===typeof e&&"object"===typeof b[d]&&l(b[d],e):b[d]=e},f=1;for(;f<g;f++)if(a=arguments[f]){if("object"!==typeof a)throw Error("Expected argument at index "+f+" to be an object");
Object.keys(a).forEach(d)}return b};k.rand_normal=function(a,b){do{var c=2*Math.random()-1;var e=2*Math.random()-1;e=c*c+e*e}while(1<=e||0==e);return(a||0)+c*Math.sqrt(-2*Math.log(e)/e)*(b||1)};k.assert=c;k.http_post=function(b,c,l){a.debug("new http_post request",b,c,l);var e=g.defer(),d=new XMLHttpRequest;d.withCredentials=!0;d.onreadystatechange=function(){if(4===d.readyState){var a=1223===d.status?204:d.status;200===a&&e.resolve(d.responseText);if(204===a)e.resolve();else{var b=null;try{b=d.statusText}catch(F){}e.reject({code:a,
text:b})}}};d.open("POST",b,!0);d.setRequestHeader("Content-type","application/json; charset=utf-8");0<l&&(d.timeout=l,d.ontimeout=function(){e.reject({code:501,text:"request timeout"})});c?d.send(c):d.send();return e.promise.then?e.promise:e};k.defaults=l}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./log.js":7,when:161}],22:[function(f,m,k){function b(a){var b=a.length;if(0<b%4)throw Error("Invalid string. Length must be a multiple of 4");
return"="===a[b-2]?2:"="===a[b-1]?1:0}function a(a,b,c){for(var e=[],d=b;d<c;d+=3)b=(a[d]<<16)+(a[d+1]<<8)+a[d+2],e.push(g[b>>18&63]+g[b>>12&63]+g[b>>6&63]+g[b&63]);return e.join("")}k.byteLength=function(a){return 3*a.length/4-b(a)};k.toByteArray=function(a){var e=a.length;var g=b(a);var f=new l(3*e/4-g);var d=0<g?e-4:e;var r=0;for(e=0;e<d;e+=4){var k=c[a.charCodeAt(e)]<<18|c[a.charCodeAt(e+1)]<<12|c[a.charCodeAt(e+2)]<<6|c[a.charCodeAt(e+3)];f[r++]=k>>16&255;f[r++]=k>>8&255;f[r++]=k&255}2===g?(k=
c[a.charCodeAt(e)]<<2|c[a.charCodeAt(e+1)]>>4,f[r++]=k&255):1===g&&(k=c[a.charCodeAt(e)]<<10|c[a.charCodeAt(e+1)]<<4|c[a.charCodeAt(e+2)]>>2,f[r++]=k>>8&255,f[r++]=k&255);return f};k.fromByteArray=function(b){for(var c=b.length,e=c%3,l="",d=[],f=0,k=c-e;f<k;f+=16383)d.push(a(b,f,f+16383>k?k:f+16383));1===e?(b=b[c-1],l+=g[b>>2],l+=g[b<<4&63],l+="=="):2===e&&(b=(b[c-2]<<8)+b[c-1],l+=g[b>>10],l+=g[b>>4&63],l+=g[b<<2&63],l+="=");d.push(l);return d.join("")};var g=[],c=[],l="undefined"!==typeof Uint8Array?
Uint8Array:Array;for(f=0;64>f;++f)g[f]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[f],c["ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charCodeAt(f)]=f;c[45]=62;c[95]=63},{}],23:[function(f,m,k){(function(b){function a(b){function n(a,b){var c,d,e,g,h=this;if(!(h instanceof n))return S&&N(26,"constructor call without new",a),new n(a,b);if(null!=b&&Z(b,2,64,U,"base")){b|=0;var u=a+"";if(10==b)return h=new n(a instanceof n?a:u),x(h,p+h.e+1,t);if((e="number"==
typeof a)&&0!=0*a||!(new RegExp("^-?"+(c="["+"0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".slice(0,b)+"]+")+"(?:\\."+c+")?$",37>b?"i":"")).test(u))return B(h,u,e,b);e?(h.s=0>1/a?(u=u.slice(1),-1):1,S&&15<u.replace(/^0\.0*|\./,"").length&&N(U,"number type has more than 15 significant digits",a),e=!1):h.s=45===u.charCodeAt(0)?(u=u.slice(1),-1):1;u=q(u,10,b,h.s)}else{if(a instanceof n){h.s=a.s;h.e=a.e;h.c=(a=a.c)?a.slice():a;U=0;return}if((e="number"==typeof a)&&0==0*a){h.s=0>1/
a?(a=-a,-1):1;if(a===~~a){c=0;for(d=a;10<=d;d/=10,c++);h.e=c;h.c=[a];U=0;return}u=a+""}else{if(!F.test(u=a+""))return B(h,u,e);h.s=45===u.charCodeAt(0)?(u=u.slice(1),-1):1}}-1<(c=u.indexOf("."))&&(u=u.replace(".",""));0<(d=u.search(/e/i))?(0>c&&(c=d),c+=+u.slice(d+1),u=u.substring(0,d)):0>c&&(c=u.length);for(d=0;48===u.charCodeAt(d);d++);for(g=u.length;48===u.charCodeAt(--g););if(u=u.slice(d,g+1))if(g=u.length,e&&S&&15<g&&(9007199254740991<a||a!==y(a))&&N(U,"number type has more than 15 significant digits",
h.s*a),c=c-d-1,c>T)h.c=h.e=null;else if(c<ca)h.c=[h.e=0];else{h.e=c;h.c=[];d=(c+1)%14;0>c&&(d+=14);if(d<g){d&&h.c.push(+u.slice(0,d));for(g-=14;d<g;)h.c.push(+u.slice(d,d+=14));u=u.slice(d);d=14-u.length}else d-=g;for(;d--;u+="0");h.c.push(+u)}else h.c=[h.e=0];U=0}function q(a,b,e,h){var g=a.indexOf("."),u=p,l=t;37>e&&(a=a.toLowerCase());if(0<=g){var q=ba;ba=0;a=a.replace(".","");var r=new n(e);var k=r.pow(a.length-g);ba=q;r.c=f(d(c(k.c),k.e),10,b);r.e=r.c.length}var y=f(a,e,b);for(e=q=y.length;0==
y[--q];y.pop());if(!y[0])return"0";if(0>g)--e;else{k.c=y;k.e=e;k.s=h;k=P(k,r,u,l,b);y=k.c;var w=k.r;e=k.e}a=e+u+1;g=y[a];q=b/2;w=w||0>a||null!=y[a+1];w=4>l?(null!=g||w)&&(0==l||l==(0>k.s?3:2)):g>q||g==q&&(4==l||w||6==l&&y[a-1]&1||l==(0>k.s?8:7));if(1>a||!y[0])a=w?d("1",-u):"0";else{y.length=a;if(w)for(--b;++y[--a]>b;)y[a]=0,a||(++e,y.unshift(1));for(q=y.length;!y[--q];);g=0;for(a="";g<=q;a+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".charAt(y[g++]));a=d(a,e)}return a}function w(a,
b,p,e){p=null!=p&&Z(p,0,8,e,"rounding mode")?p|0:t;if(!a.c)return a.toString();var g=a.c[0];var h=a.e;if(null==b){var u=c(a.c);u=19==e||24==e&&h<=z?k(u,h):d(u,h)}else{a=x(new n(a),b,p);p=a.e;u=c(a.c);var l=u.length;if(19==e||24==e&&(b<=p||p<=z)){for(;l<b;u+="0",l++);u=k(u,p)}else if(b-=h,u=d(u,p),p+1>l){if(0<--b)for(u+=".";b--;u+="0");}else if(b+=p-l,0<b)for(p+1==l&&(u+=".");b--;u+="0");}return 0>a.s&&g?"-"+u:u}function I(a,b){var c,d=0;h(a[0])&&(a=a[0]);for(c=new n(a[0]);++d<a.length;){var p=new n(a[d]);
if(p.s)b.call(c,p)&&(c=p);else{c=p;break}}return c}function m(a,b,c,d,p){(a<b||a>c||a!=r(a))&&N(d,(p||"decimal places")+(a<b||a>c?" out of range":" not an integer"),a);return!0}function L(a,b,c){for(var d=1,p=b.length;!b[--p];b.pop());for(p=b[0];10<=p;p/=10,d++);(c=d+14*c-1)>T?a.c=a.e=null:c<ca?a.c=[a.e=0]:(a.e=c,a.c=b);return a}function N(a,b,c){a=Error("new BigNumber;cmp;config;div;divToInt;eq;gt;gte;lt;lte;minus;mod;plus;precision;random;round;shift;times;toDigits;toExponential;toFixed;toFormat;toFraction;pow;toPrecision;toString;BigNumber".split(";")[a]+
"() "+b+": "+c);a.name="BigNumber Error";U=0;throw a;}function x(a,b,c,d){var p,e,h=a.c,g=C;if(h){a:{var u=1;for(p=h[0];10<=p;p/=10,u++);var t=b-u;if(0>t){t+=14;var n=b;var l=h[e=0];p=l/g[u-n-1]%10|0}else if(e=A((t+1)/14),e>=h.length)if(d){for(;h.length<=e;h.push(0));l=p=0;u=1;t%=14;n=t-14+1}else break a;else{l=p=h[e];for(u=1;10<=p;p/=10,u++);t%=14;n=t-14+u;p=0>n?0:l/g[u-n-1]%10|0}d=d||0>b||null!=h[e+1]||(0>n?l:l%g[u-n-1]);d=4>c?(p||d)&&(0==c||c==(0>a.s?3:2)):5<p||5==p&&(4==c||d||6==c&&(0<t?0<n?l/
g[u-n]:0:h[e-1])%10&1||c==(0>a.s?8:7));if(1>b||!h[0])return h.length=0,d?(b-=a.e+1,h[0]=g[(14-b%14)%14],a.e=-b||0):h[0]=a.e=0,a;0==t?(h.length=e,p=1,e--):(h.length=e+1,p=g[14-t],h[e]=0<n?y(l/g[u-n]%g[n])*p:0);if(d)for(;;)if(0==e){t=1;for(n=h[0];10<=n;n/=10,t++);n=h[0]+=p;for(p=1;10<=n;n/=10,p++);t!=p&&(a.e++,1E14==h[0]&&(h[0]=1));break}else{h[e]+=p;if(1E14!=h[e])break;h[e--]=0;p=1}for(t=h.length;0===h[--t];h.pop());}a.e>T?a.c=a.e=null:a.e<ca&&(a.c=[a.e=0])}return a}var U=0,M=n.prototype,u=new n(1),
p=20,t=4,z=-7,v=21,ca=-1E7,T=1E7,S=!0,Z=m,ha=!1,W=1,ba=0,R={decimalSeparator:".",groupSeparator:",",groupSize:3,secondaryGroupSize:0,fractionGroupSeparator:"\u00a0",fractionGroupSize:0};n.another=a;n.ROUND_UP=0;n.ROUND_DOWN=1;n.ROUND_CEIL=2;n.ROUND_FLOOR=3;n.ROUND_HALF_UP=4;n.ROUND_HALF_DOWN=5;n.ROUND_HALF_EVEN=6;n.ROUND_HALF_CEIL=7;n.ROUND_HALF_FLOOR=8;n.EUCLID=9;n.config=n.set=function(){var a,b=0,c={},d=arguments,g=d[0],u=g&&"object"==typeof g?function(){if(g.hasOwnProperty(a))return null!=(n=
g[a])}:function(){if(d.length>b)return null!=(n=d[b++])};u(a="DECIMAL_PLACES")&&Z(n,0,1E9,2,a)&&(p=n|0);c[a]=p;u(a="ROUNDING_MODE")&&Z(n,0,8,2,a)&&(t=n|0);c[a]=t;u(a="EXPONENTIAL_AT")&&(h(n)?Z(n[0],-1E9,0,2,a)&&Z(n[1],0,1E9,2,a)&&(z=n[0]|0,v=n[1]|0):Z(n,-1E9,1E9,2,a)&&(z=-(v=(0>n?-n:n)|0)));c[a]=[z,v];u(a="RANGE")&&(h(n)?Z(n[0],-1E9,-1,2,a)&&Z(n[1],1,1E9,2,a)&&(ca=n[0]|0,T=n[1]|0):Z(n,-1E9,1E9,2,a)&&(n|0?ca=-(T=(0>n?-n:n)|0):S&&N(2,a+" cannot be zero",n)));c[a]=[ca,T];u(a="ERRORS")&&(n===!!n||1===
n||0===n?(U=0,Z=(S=!!n)?m:e):S&&N(2,a+" not a boolean or binary digit",n));c[a]=S;if(u(a="CRYPTO"))if(!0===n||!1===n||1===n||0===n)if(n){var n="undefined"==typeof crypto;!n&&crypto&&(crypto.getRandomValues||crypto.randomBytes)?ha=!0:S?N(2,"crypto unavailable",n?void 0:crypto):ha=!1}else ha=!1;else S&&N(2,a+" not a boolean or binary digit",n);c[a]=ha;u(a="MODULO_MODE")&&Z(n,0,9,2,a)&&(W=n|0);c[a]=W;u(a="POW_PRECISION")&&Z(n,0,1E9,2,a)&&(ba=n|0);c[a]=ba;u(a="FORMAT")&&("object"==typeof n?R=n:S&&N(2,
a+" not an object",n));c[a]=R;return c};n.max=function(){return I(arguments,M.lt)};n.min=function(){return I(arguments,M.gt)};n.random=function(){var a=9007199254740992*Math.random()&2097151?function(){return y(9007199254740992*Math.random())}:function(){return 8388608*(1073741824*Math.random()|0)+(8388608*Math.random()|0)};return function(b){var c,d=0,e=[],h=new n(u);b=null!=b&&Z(b,0,1E9,14)?b|0:p;var g=A(b/14);if(ha)if(crypto.getRandomValues){for(c=crypto.getRandomValues(new Uint32Array(g*=2));d<
g;){var t=131072*c[d]+(c[d+1]>>>11);9E15<=t?(t=crypto.getRandomValues(new Uint32Array(2)),c[d]=t[0],c[d+1]=t[1]):(e.push(t%1E14),d+=2)}d=g/2}else if(crypto.randomBytes){for(c=crypto.randomBytes(g*=7);d<g;)t=281474976710656*(c[d]&31)+1099511627776*c[d+1]+4294967296*c[d+2]+16777216*c[d+3]+(c[d+4]<<16)+(c[d+5]<<8)+c[d+6],9E15<=t?crypto.randomBytes(7).copy(c,d):(e.push(t%1E14),d+=7);d=g/7}else ha=!1,S&&N(14,"crypto unavailable",crypto);if(!ha)for(;d<g;)t=a(),9E15>t&&(e[d++]=t%1E14);g=e[--d];b%=14;g&&
b&&(t=C[14-b],e[d]=y(g/t)*t);for(;0===e[d];e.pop(),d--);if(0>d)e=[b=0];else{for(b=-1;0===e[0];e.shift(),b-=14);d=1;for(t=e[0];10<=t;t/=10,d++);14>d&&(b-=14-d)}h.e=b;h.c=e;return h}}();var P=function(){function a(a,b,c){var d=0,p=a.length,e=b%1E7,h=b/1E7|0;for(a=a.slice();p--;){var g=a[p]%1E7;var u=a[p]/1E7|0;b=h*g+u*e;g=e*g+b%1E7*1E7+d;d=(g/c|0)+(b/1E7|0)+h*u;a[p]=g%c}d&&a.unshift(d);return a}function b(a,b,c,d){if(c!=d)var p=c>d?1:-1;else for(d=p=0;d<c;d++)if(a[d]!=b[d]){p=a[d]>b[d]?1:-1;break}return p}
function c(a,b,c,d){for(var p=0;c--;)a[c]-=p,p=a[c]<b[c]?1:0,a[c]=p*d+a[c]-b[c];for(;!a[0]&&1<a.length;a.shift());}return function(d,p,e,h,u){var t,l=d.s==p.s?1:-1;var f=d.c;var q=p.c;if(!(f&&f[0]&&q&&q[0]))return new n(d.s&&p.s&&(f?!q||f[0]!=q[0]:q)?f&&0==f[0]||!q?0*l:l/0:NaN);var r=new n(l);var k=r.c=[];var w=d.e-p.e;l=e+w+1;u||(u=1E14,w=g(d.e/14)-g(p.e/14),l=l/14|0);for(d=0;q[d]==(f[d]||0);d++);q[d]>(f[d]||0)&&w--;if(0>l)k.push(1),f=!0;else{var B=f.length;var z=q.length;d=0;l+=2;var A=y(u/(q[0]+
1));1<A&&(q=a(q,A,u),f=a(f,A,u),z=q.length,B=f.length);var G=z;var I=f.slice(0,z);for(t=I.length;t<z;I[t++]=0);var ea=q.slice();ea.unshift(0);var aa=q[0];q[1]>=u/2&&aa++;do{A=0;p=b(q,I,z,t);if(0>p){A=I[0];z!=t&&(A=A*u+(I[1]||0));A=y(A/aa);if(1<A){A>=u&&(A=u-1);var C=a(q,A,u);var K=C.length;for(t=I.length;1==b(C,I,K,t);)A--,c(C,z<K?ea:q,K,u),K=C.length,p=1}else 0==A&&(p=A=1),C=q.slice(),K=C.length;K<t&&C.unshift(0);c(I,C,t,u);t=I.length;if(-1==p)for(;1>b(q,I,z,t);)A++,c(I,z<t?ea:q,t,u),t=I.length}else 0===
p&&(A++,I=[0]);k[d++]=A;I[0]?I[t++]=f[G]||0:(I=[f[G]],t=1)}while((G++<B||null!=I[0])&&l--);f=null!=I[0];k[0]||k.shift()}if(1E14==u){d=1;for(l=k[0];10<=l;l/=10,d++);x(r,e+(r.e=d+14*w-1)+1,h,f)}else r.e=w,r.r=+f;return r}}();B=function(){var a=/^(-?)0([xbo])(?=\w[\w.]*$)/i,b=/^([^.]+)\.$/,d=/^\.([^.]+)$/,c=/^-?(Infinity|NaN)$/,p=/^\s*\+(?=[\w.])|^\s+|\s+$/g;return function(e,h,g,u){var t=g?h:h.replace(p,"");if(c.test(t))e.s=isNaN(t)?null:0>t?-1:1;else{if(!g){t=t.replace(a,function(a,b,d){l="x"==(d=
d.toLowerCase())?16:"b"==d?2:8;return u&&u!=l?a:b});if(u){var l=u;t=t.replace(b,"$1").replace(d,"0.$1")}if(h!=t)return new n(t,l)}S&&N(U,"not a"+(u?" base "+u:"")+" number",h);e.s=null}e.c=e.e=null;U=0}}();M.absoluteValue=M.abs=function(){var a=new n(this);0>a.s&&(a.s=1);return a};M.ceil=function(){return x(new n(this),this.e+1,2)};M.comparedTo=M.cmp=function(a,b){U=1;return l(this,new n(a,b))};M.decimalPlaces=M.dp=function(){var a,b=this.c;if(!b)return null;var d=14*((a=b.length-1)-g(this.e/14));
if(a=b[a])for(;0==a%10;a/=10,d--);0>d&&(d=0);return d};M.dividedBy=M.div=function(a,b){U=3;return P(this,new n(a,b),p,t)};M.dividedToIntegerBy=M.divToInt=function(a,b){U=4;return P(this,new n(a,b),0,1)};M.equals=M.eq=function(a,b){U=5;return 0===l(this,new n(a,b))};M.floor=function(){return x(new n(this),this.e+1,3)};M.greaterThan=M.gt=function(a,b){U=6;return 0<l(this,new n(a,b))};M.greaterThanOrEqualTo=M.gte=function(a,b){U=7;return 1===(b=l(this,new n(a,b)))||0===b};M.isFinite=function(){return!!this.c};
M.isInteger=M.isInt=function(){return!!this.c&&g(this.e/14)>this.c.length-2};M.isNaN=function(){return!this.s};M.isNegative=M.isNeg=function(){return 0>this.s};M.isZero=function(){return!!this.c&&0==this.c[0]};M.lessThan=M.lt=function(a,b){U=8;return 0>l(this,new n(a,b))};M.lessThanOrEqualTo=M.lte=function(a,b){U=9;return-1===(b=l(this,new n(a,b)))||0===b};M.minus=M.sub=function(a,b){var d,c=this.s;U=10;a=new n(a,b);b=a.s;if(!c||!b)return new n(NaN);if(c!=b)return a.s=-b,this.plus(a);var p=this.e/
14;var e=a.e/14,h=this.c,u=a.c;if(!p||!e){if(!h||!u)return h?(a.s=-b,a):new n(u?this:NaN);if(!h[0]||!u[0])return u[0]?(a.s=-b,a):new n(h[0]?this:3==t?-0:0)}p=g(p);e=g(e);h=h.slice();if(c=p-e){(d=0>c)?(c=-c,p=h):(e=p,p=u);p.reverse();for(b=c;b--;p.push(0));p.reverse()}else for(p=(d=(c=h.length)<(b=u.length))?c:b,c=b=0;b<p;b++)if(h[b]!=u[b]){d=h[b]<u[b];break}d&&(p=h,h=u,u=p,a.s=-a.s);b=(p=u.length)-(d=h.length);if(0<b)for(;b--;h[d++]=0);for(b=1E14-1;p>c;){if(h[--p]<u[p]){for(d=p;d&&!h[--d];h[d]=b);
--h[d];h[p]+=1E14}h[p]-=u[p]}for(;0==h[0];h.shift(),--e);return h[0]?L(a,h,e):(a.s=3==t?-1:1,a.c=[a.e=0],a)};M.modulo=M.mod=function(a,b){U=11;a=new n(a,b);if(!this.c||!a.s||a.c&&!a.c[0])return new n(NaN);if(!a.c||this.c&&!this.c[0])return new n(this);if(9==W){var d=a.s;a.s=1;var c=P(this,a,0,3);a.s=d;c.s*=d}else c=P(this,a,0,W);return this.minus(c.times(a))};M.negated=M.neg=function(){var a=new n(this);a.s=-a.s||null;return a};M.plus=M.add=function(a,b){var d=this.s;U=12;a=new n(a,b);b=a.s;if(!d||
!b)return new n(NaN);if(d!=b)return a.s=-b,this.minus(a);var c=this.e/14;var p=a.e/14,e=this.c,h=a.c;if(!c||!p){if(!e||!h)return new n(d/0);if(!e[0]||!h[0])return h[0]?a:new n(e[0]?this:0*d)}c=g(c);p=g(p);e=e.slice();if(d=c-p){0<d?(p=c,c=h):(d=-d,c=e);for(c.reverse();d--;c.push(0));c.reverse()}d=e.length;b=h.length;0>d-b&&(c=h,h=e,e=c,b=d);for(d=0;b;)d=(e[--b]=e[b]+h[b]+d)/1E14|0,e[b]=1E14===e[b]?0:e[b]%1E14;d&&(e.unshift(d),++p);return L(a,e,p)};M.precision=M.sd=function(a){var b=this.c;null!=a&&
a!==!!a&&1!==a&&0!==a&&(S&&N(13,"argument not a boolean or binary digit",a),a!=!!a&&(a=null));if(!b)return null;var d=b.length-1;var c=14*d+1;if(d=b[d]){for(;0==d%10;d/=10,c--);for(d=b[0];10<=d;d/=10,c++);}a&&this.e+1>c&&(c=this.e+1);return c};M.round=function(a,b){var d=new n(this);(null==a||Z(a,0,1E9,15))&&x(d,~~a+this.e+1,null!=b&&Z(b,0,8,15,"rounding mode")?b|0:t);return d};M.shift=function(a){return Z(a,-9007199254740991,9007199254740991,16,"argument")?this.times("1e"+r(a)):new n(this.c&&this.c[0]&&
(-9007199254740991>a||9007199254740991<a)?this.s*(0>a?0:1/0):this)};M.squareRoot=M.sqrt=function(){var a=this.c;var b=this.s,d=this.e,e=p+4,h=new n("0.5");if(1!==b||!a||!a[0])return new n(!b||0>b&&(!a||a[0])?NaN:a?this:1/0);b=Math.sqrt(+this);if(0==b||b==1/0){a=c(a);0==(a.length+d)%2&&(a+="0");b=Math.sqrt(a);d=g((d+1)/2)-(0>d||d%2);b==1/0?a="1e"+d:(a=b.toExponential(),a=a.slice(0,a.indexOf("e")+1)+d);var u=new n(a)}else u=new n(b+"");if(u.c[0])for(d=u.e,b=d+e,3>b&&(b=0);;){var l=u;u=h.times(l.plus(P(this,
l,e,1)));if(c(l.c).slice(0,b)===(a=c(u.c)).slice(0,b))if(u.e<d&&--b,a=a.slice(b-3,b+1),"9999"==a||!f&&"4999"==a){if(!f&&(x(l,l.e+p+2,0),l.times(l).eq(this))){u=l;break}e+=4;b+=4;var f=1}else{if(!+a||!+a.slice(1)&&"5"==a.charAt(0)){x(u,u.e+p+2,1);var q=!u.times(u).eq(this)}break}}return x(u,u.e+p+1,t,q)};M.times=M.mul=function(a,b){var d=this.c,c=(U=17,a=new n(a,b)).c;if(!(d&&c&&d[0]&&c[0]))return!this.s||!a.s||d&&!d[0]&&!c||c&&!c[0]&&!d?a.c=a.e=a.s=null:(a.s*=this.s,d&&c?(a.c=[0],a.e=0):a.c=a.e=null),
a;var p=g(this.e/14)+g(a.e/14);a.s*=this.s;var e=d.length;var h=c.length;if(e<h){var u=d;d=c;c=u;var t=e;e=h;h=t}t=e+h;for(u=[];t--;u.push(0));for(t=h;0<=--t;){var l=0;var f=c[t]%1E7;var q=c[t]/1E7|0;var r=e;for(h=t+r;h>t;){var k=d[--r]%1E7;var y=d[r]/1E7|0;var w=q*k+y*f;k=f*k+w%1E7*1E7+u[h]+l;l=(k/1E14|0)+(w/1E7|0)+q*y;u[h--]=k%1E14}u[h]=l}l?++p:u.shift();return L(a,u,p)};M.toDigits=function(a,b){var d=new n(this);a=null!=a&&Z(a,1,1E9,18,"precision")?a|0:null;b=null!=b&&Z(b,0,8,18,"rounding mode")?
b|0:t;return a?x(d,a,b):d};M.toExponential=function(a,b){return w(this,null!=a&&Z(a,0,1E9,19)?~~a+1:null,b,19)};M.toFixed=function(a,b){return w(this,null!=a&&Z(a,0,1E9,20)?~~a+this.e+1:null,b,20)};M.toFormat=function(a,b){var d=w(this,null!=a&&Z(a,0,1E9,21)?~~a+this.e+1:null,b,21);if(this.c){var c=d.split(".");var d=+R.groupSize,p=+R.secondaryGroupSize,e=R.groupSeparator,h=c[0],u=c[1],t=0>this.s,g=t?h.slice(1):h,n=g.length;p&&(c=d,d=p,p=c,n-=c);if(0<d&&0<n){c=n%d||d;for(h=g.substr(0,c);c<n;c+=d)h+=
e+g.substr(c,d);0<p&&(h+=e+g.slice(c));t&&(h="-"+h)}d=u?h+R.decimalSeparator+((p=+R.fractionGroupSize)?u.replace(new RegExp("\\d{"+p+"}\\B","g"),"$&"+R.fractionGroupSeparator):u):h}return d};M.toFraction=function(a){var b,d,p;var e=S;var h=this.c;var g=new n(u),l=b=new n(u),f=p=new n(u);if(null!=a){S=!1;var q=new n(a);S=e;if(!(e=q.isInt())||q.lt(u))S&&N(22,"max denominator "+(e?"out of range":"not an integer"),a),a=!e&&q.c&&x(q,q.e+1,1).gte(u)?q:null}if(!h)return this.toString();h=c(h);e=g.e=h.length-
this.e-1;g.c[0]=C[0>(d=e%14)?14+d:d];a=!a||0<q.cmp(g)?0<e?g:l:q;d=T;T=1/0;q=new n(h);for(p.c[0]=0;;){var r=P(q,g,0,1);h=b.plus(r.times(f));if(1==h.cmp(a))break;b=f;f=h;l=p.plus(r.times(h=l));p=h;g=q.minus(r.times(h=g));q=h}h=P(a.minus(b),f,0,1);p=p.plus(h.times(l));b=b.plus(h.times(f));p.s=l.s=this.s;e*=2;a=1>P(l,f,e,t).minus(this).abs().cmp(P(p,b,e,t).minus(this).abs())?[l.toString(),f.toString()]:[p.toString(),b.toString()];T=d;return a};M.toNumber=function(){return+this};M.toPower=M.pow=function(a,
b){var d,c=y(0>a?-a:+a),p=this;null!=b&&(U=23,b=new n(b));if(!Z(a,-9007199254740991,9007199254740991,23,"exponent")&&(!isFinite(a)||9007199254740991<c&&(a/=0)||parseFloat(a)!=a&&!(a=NaN))||0==a){var e=Math.pow(+p,a);return new n(b?e%b:e)}if(b)if(1<a&&p.gt(u)&&p.isInt()&&b.gt(u)&&b.isInt())p=p.mod(b);else{var h=b;b=null}else ba&&(e=A(ba/14+2));for(d=new n(u);;){if(c%2){d=d.times(p);if(!d.c)break;e?d.c.length>e&&(d.c.length=e):b&&(d=d.mod(b))}c=y(c/2);if(!c)break;p=p.times(p);e?p.c&&p.c.length>e&&(p.c.length=
e):b&&(p=p.mod(b))}if(b)return d;0>a&&(d=u.div(d));return h?d.mod(h):e?x(d,ba,t):d};M.toPrecision=function(a,b){return w(this,null!=a&&Z(a,1,1E9,24,"precision")?a|0:null,b,24)};M.toString=function(a){var b=this.s,p=this.e;if(null===p)if(b){var e="Infinity";0>b&&(e="-"+e)}else e="NaN";else e=c(this.c),e=null!=a&&Z(a,2,64,25,"base")?q(d(e,p),a|0,10,b):p<=z||p>=v?k(e,p):d(e,p),0>b&&this.c[0]&&(e="-"+e);return e};M.truncated=M.trunc=function(){return x(new n(this),this.e+1,1)};M.valueOf=M.toJSON=function(){var a=
this.e;if(null===a)return this.toString();var b=c(this.c);b=a<=z||a>=v?k(b,a):d(b,a);return 0>this.s?"-"+b:b};null!=b&&n.config(b);return n}function g(a){var b=a|0;return 0<a||a===b?b:b-1}function c(a){for(var b,d,c=1,e=a.length,h=a[0]+"";c<e;){b=a[c++]+"";for(d=14-b.length;d--;b="0"+b);h+=b}for(e=h.length;48===h.charCodeAt(--e););return h.slice(0,e+1||1)}function l(a,b){var d=a.c,c=b.c,e=a.s,h=b.s,g=a.e,n=b.e;if(!e||!h)return null;var l=d&&!d[0];var f=c&&!c[0];if(l||f)return l?f?0:-h:e;if(e!=h)return e;
l=0>e;f=g==n;if(!d||!c)return f?0:!d^l?1:-1;if(!f)return g>n^l?1:-1;h=(g=d.length)<(n=c.length)?g:n;for(e=0;e<h;e++)if(d[e]!=c[e])return d[e]>c[e]^l?1:-1;return g==n?0:g>n^l?1:-1}function e(a,b,d){return(a=r(a))>=b&&a<=d}function h(a){return"[object Array]"==Object.prototype.toString.call(a)}function f(a,b,d){for(var c,e=[0],h=0,g=a.length;h<g;){for(c=e.length;c--;e[c]*=b);for(e[c=0]+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".indexOf(a.charAt(h++));c<e.length;c++)e[c]>d-1&&
(null==e[c+1]&&(e[c+1]=0),e[c+1]+=e[c]/d|0,e[c]%=d)}return e.reverse()}function k(a,b){return(1<a.length?a.charAt(0)+"."+a.slice(1):a)+(0>b?"e":"e+")+b}function d(a,b){var d;if(0>b){for(d="0.";++b;d+="0");a=d+a}else{var c=a.length;if(++b>c){d="0";for(b-=c;--b;d+="0");a+=d}else b<c&&(a=a.slice(0,b)+"."+a.slice(b))}return a}function r(a){a=parseFloat(a);return 0>a?A(a):y(a)}var B,F=/^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i,A=Math.ceil,y=Math.floor,C=[1,10,100,1E3,1E4,1E5,1E6,1E7,1E8,1E9,1E10,1E11,1E12,
1E13];var q=a();q["default"]=q.BigNumber=q;"undefined"!=typeof m&&m.exports?m.exports=q:(b||(b="undefined"!=typeof self?self:Function("return this")()),b.BigNumber=q)})(this)},{}],24:[function(f,m,k){},{}],25:[function(f,m,k){arguments[4][24][0].apply(k,arguments)},{dup:24}],26:[function(f,m,k){(function(b){var a=f("buffer"),g=a.Buffer,c=a.SlowBuffer,l=a.kMaxLength||2147483647;k.alloc=function(a,b,c){if("function"===typeof g.alloc)return g.alloc(a,b,c);if("number"===typeof c)throw new TypeError("encoding must not be number");
if("number"!==typeof a)throw new TypeError("size must be a number");if(a>l)throw new RangeError("size is too large");var e=b;void 0===e&&(c=void 0,e=0);b=new g(a);if("string"===typeof e){c=new g(e,c);for(var e=c.length,d=-1;++d<a;)b[d]=c[d%e]}else b.fill(e);return b};k.allocUnsafe=function(a){if("function"===typeof g.allocUnsafe)return g.allocUnsafe(a);if("number"!==typeof a)throw new TypeError("size must be a number");if(a>l)throw new RangeError("size is too large");return new g(a)};k.from=function(a,
c,n){if("function"===typeof g.from&&(!b.Uint8Array||Uint8Array.from!==g.from))return g.from(a,c,n);if("number"===typeof a)throw new TypeError('"value" argument must not be a number');if("string"===typeof a)return new g(a,c);if("undefined"!==typeof ArrayBuffer&&a instanceof ArrayBuffer){var e=c;if(1===arguments.length)return new g(a);"undefined"===typeof e&&(e=0);var d=n;"undefined"===typeof d&&(d=a.byteLength-e);if(e>=a.byteLength)throw new RangeError("'offset' is out of bounds");if(d>a.byteLength-
e)throw new RangeError("'length' is out of bounds");return new g(a.slice(e,e+d))}if(g.isBuffer(a))return e=new g(a.length),a.copy(e,0,0,a.length),e;if(a){if(Array.isArray(a)||"undefined"!==typeof ArrayBuffer&&a.buffer instanceof ArrayBuffer||"length"in a)return new g(a);if("Buffer"===a.type&&Array.isArray(a.data))return new g(a.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.");};k.allocUnsafeSlow=function(a){if("function"===typeof g.allocUnsafeSlow)return g.allocUnsafeSlow(a);
if("number"!==typeof a)throw new TypeError("size must be a number");if(a>=l)throw new RangeError("size is too large");return new c(a)}}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{buffer:27}],27:[function(f,m,k){function b(b){if(b>x)throw new RangeError("Invalid typed array length");b=new Uint8Array(b);b.__proto__=a.prototype;return b}function a(a,b,d){if("number"===typeof a){if("string"===typeof b)throw Error("If encoding is specified then the first argument must be a string");
return l(a)}return g(a,b,d)}function g(d,c,e){if("number"===typeof d)throw new TypeError('"value" argument must not be a number');if(d instanceof ArrayBuffer){if(0>c||d.byteLength<c)throw new RangeError("'offset' is out of bounds");if(d.byteLength<c+(e||0))throw new RangeError("'length' is out of bounds");d=void 0===c&&void 0===e?new Uint8Array(d):void 0===e?new Uint8Array(d,c):new Uint8Array(d,c,e);d.__proto__=a.prototype;return d}if("string"===typeof d){var p=c;if("string"!==typeof p||""===p)p=
"utf8";if(!a.isEncoding(p))throw new TypeError('"encoding" must be a valid string encoding');c=w(d,p)|0;e=b(c);d=e.write(d,p);d!==c&&(e=e.slice(0,d));return e}return h(d)}function c(a){if("number"!==typeof a)throw new TypeError('"size" argument must be a number');if(0>a)throw new RangeError('"size" argument must not be negative');}function l(a){c(a);return b(0>a?0:n(a)|0)}function e(a){for(var d=0>a.length?0:n(a.length)|0,c=b(d),e=0;e<d;e+=1)c[e]=a[e]&255;return c}function h(d){if(a.isBuffer(d)){var c=
n(d.length)|0,h=b(c);if(0===h.length)return h;d.copy(h,0,0,c);return h}if(d){if("function"===typeof ArrayBuffer.isView&&ArrayBuffer.isView(d)||"length"in d)return(c="number"!==typeof d.length)||(c=d.length,c=c!==c),c?b(0):e(d);if("Buffer"===d.type&&Array.isArray(d.data))return e(d.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.");}function n(a){if(a>=x)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+x.toString(16)+
" bytes");return a|0}function w(b,d){if(a.isBuffer(b))return b.length;if("function"===typeof ArrayBuffer.isView&&ArrayBuffer.isView(b)||b instanceof ArrayBuffer)return b.byteLength;"string"!==typeof b&&(b=""+b);var c=b.length;if(0===c)return 0;for(var p=!1;;)switch(d){case "ascii":case "latin1":case "binary":return c;case "utf8":case "utf-8":case void 0:return O(b).length;case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":return 2*c;case "hex":return c>>>1;case "base64":return L.toByteArray(K(b)).length;
default:if(p)return O(b).length;d=(""+d).toLowerCase();p=!0}}function d(a,b,d){var c=!1;if(void 0===b||0>b)b=0;if(b>this.length)return"";if(void 0===d||d>this.length)d=this.length;if(0>=d)return"";d>>>=0;b>>>=0;if(d<=b)return"";for(a||(a="utf8");;)switch(a){case "hex":a=b;b=d;d=this.length;if(!a||0>a)a=0;if(!b||0>b||b>d)b=d;c="";for(d=a;d<b;++d)a=c,c=this[d],c=16>c?"0"+c.toString(16):c.toString(16),c=a+c;return c;case "utf8":case "utf-8":return A(this,b,d);case "ascii":a="";for(d=Math.min(this.length,
d);b<d;++b)a+=String.fromCharCode(this[b]&127);return a;case "latin1":case "binary":a="";for(d=Math.min(this.length,d);b<d;++b)a+=String.fromCharCode(this[b]);return a;case "base64":return b=0===b&&d===this.length?L.fromByteArray(this):L.fromByteArray(this.slice(b,d)),b;case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":b=this.slice(b,d);d="";for(a=0;a<b.length;a+=2)d+=String.fromCharCode(b[a]+256*b[a+1]);return d;default:if(c)throw new TypeError("Unknown encoding: "+a);a=(a+"").toLowerCase();
c=!0}}function r(a,b,d){var c=a[b];a[b]=a[d];a[d]=c}function B(b,d,c,e,h){if(0===b.length)return-1;"string"===typeof c?(e=c,c=0):2147483647<c?c=2147483647:-2147483648>c&&(c=-2147483648);c=+c;c!==c&&(c=h?0:b.length-1);0>c&&(c=b.length+c);if(c>=b.length){if(h)return-1;c=b.length-1}else if(0>c)if(h)c=0;else return-1;"string"===typeof d&&(d=a.from(d,e));if(a.isBuffer(d))return 0===d.length?-1:F(b,d,c,e,h);if("number"===typeof d)return d&=255,"function"===typeof Uint8Array.prototype.indexOf?h?Uint8Array.prototype.indexOf.call(b,
d,c):Uint8Array.prototype.lastIndexOf.call(b,d,c):F(b,[d],c,e,h);throw new TypeError("val must be string, number or Buffer");}function F(a,b,d,c,e){function p(a,b){return 1===h?a[b]:a.readUInt16BE(b*h)}var h=1,g=a.length,n=b.length;if(void 0!==c&&(c=String(c).toLowerCase(),"ucs2"===c||"ucs-2"===c||"utf16le"===c||"utf-16le"===c)){if(2>a.length||2>b.length)return-1;h=2;g/=2;n/=2;d/=2}if(e)for(c=-1;d<g;d++)if(p(a,d)===p(b,-1===c?0:d-c)){if(-1===c&&(c=d),d-c+1===n)return c*h}else-1!==c&&(d-=d-c),c=-1;
else for(d+n>g&&(d=g-n);0<=d;d--){g=!0;for(c=0;c<n;c++)if(p(a,d+c)!==p(b,c)){g=!1;break}if(g)return d}return-1}function A(a,b,d){d=Math.min(a.length,d);for(var c=[];b<d;){var p=a[b],e=null,h=239<p?4:223<p?3:191<p?2:1;if(b+h<=d)switch(h){case 1:128>p&&(e=p);break;case 2:var g=a[b+1];128===(g&192)&&(p=(p&31)<<6|g&63,127<p&&(e=p));break;case 3:g=a[b+1];var n=a[b+2];128===(g&192)&&128===(n&192)&&(p=(p&15)<<12|(g&63)<<6|n&63,2047<p&&(55296>p||57343<p)&&(e=p));break;case 4:g=a[b+1];n=a[b+2];var l=a[b+3];
128===(g&192)&&128===(n&192)&&128===(l&192)&&(p=(p&15)<<18|(g&63)<<12|(n&63)<<6|l&63,65535<p&&1114112>p&&(e=p))}null===e?(e=65533,h=1):65535<e&&(e-=65536,c.push(e>>>10&1023|55296),e=56320|e&1023);c.push(e);b+=h}a=c.length;if(a<=U)c=String.fromCharCode.apply(String,c);else{d="";for(b=0;b<a;)d+=String.fromCharCode.apply(String,c.slice(b,b+=U));c=d}return c}function y(a,b,d){if(0!==a%1||0>a)throw new RangeError("offset is not uint");if(a+b>d)throw new RangeError("Trying to access beyond buffer length");
}function C(b,d,c,e,h,g){if(!a.isBuffer(b))throw new TypeError('"buffer" argument must be a Buffer instance');if(d>h||d<g)throw new RangeError('"value" argument is out of bounds');if(c+e>b.length)throw new RangeError("Index out of range");}function q(a,b,d,c,e,h){if(d+c>a.length)throw new RangeError("Index out of range");if(0>d)throw new RangeError("Index out of range");}function I(a,b,d,c,e){b=+b;d>>>=0;e||q(a,b,d,4,3.4028234663852886E38,-3.4028234663852886E38);N.write(a,b,d,c,23,4);return d+4}function G(a,
b,d,c,e){b=+b;d>>>=0;e||q(a,b,d,8,1.7976931348623157E308,-1.7976931348623157E308);N.write(a,b,d,c,52,8);return d+8}function K(a){a=a.trim().replace(M,"");if(2>a.length)return"";for(;0!==a.length%4;)a+="=";return a}function O(a,b){b=b||Infinity;for(var d,c=a.length,e=null,p=[],h=0;h<c;++h){d=a.charCodeAt(h);if(55295<d&&57344>d){if(!e){if(56319<d){-1<(b-=3)&&p.push(239,191,189);continue}else if(h+1===c){-1<(b-=3)&&p.push(239,191,189);continue}e=d;continue}if(56320>d){-1<(b-=3)&&p.push(239,191,189);
e=d;continue}d=(e-55296<<10|d-56320)+65536}else e&&-1<(b-=3)&&p.push(239,191,189);e=null;if(128>d){if(0>--b)break;p.push(d)}else if(2048>d){if(0>(b-=2))break;p.push(d>>6|192,d&63|128)}else if(65536>d){if(0>(b-=3))break;p.push(d>>12|224,d>>6&63|128,d&63|128)}else if(1114112>d){if(0>(b-=4))break;p.push(d>>18|240,d>>12&63|128,d>>6&63|128,d&63|128)}else throw Error("Invalid code point");}return p}function J(a){for(var b=[],d=0;d<a.length;++d)b.push(a.charCodeAt(d)&255);return b}function D(a,b,d,c){for(var e=
0;e<c&&!(e+d>=b.length||e>=a.length);++e)b[e+d]=a[e];return e}var L=f("base64-js"),N=f("ieee754");k.Buffer=a;k.SlowBuffer=function(b){+b!=b&&(b=0);return a.alloc(+b)};k.INSPECT_MAX_BYTES=50;var x=2147483647;k.kMaxLength=x;a.TYPED_ARRAY_SUPPORT=function(){try{var a=new Uint8Array(1);a.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}};return 42===a.foo()}catch(p){return!1}}();a.TYPED_ARRAY_SUPPORT||"undefined"===typeof console||"function"!==typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support.");
$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();"undefined"!==typeof Symbol&&Symbol.species&&a[Symbol.species]===a&&($jscomp.initSymbol(),Object.defineProperty(a,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}));a.poolSize=8192;a.from=function(a,b,d){return g(a,b,d)};a.prototype.__proto__=Uint8Array.prototype;a.__proto__=Uint8Array;a.alloc=function(a,d,e){c(a);a=0>=a?b(a):void 0!==d?"string"===typeof e?b(a).fill(d,e):b(a).fill(d):b(a);return a};a.allocUnsafe=function(a){return l(a)};
a.allocUnsafeSlow=function(a){return l(a)};a.isBuffer=function(a){return null!=a&&!0===a._isBuffer};a.compare=function(b,d){if(!a.isBuffer(b)||!a.isBuffer(d))throw new TypeError("Arguments must be Buffers");if(b===d)return 0;for(var c=b.length,e=d.length,p=0,h=Math.min(c,e);p<h;++p)if(b[p]!==d[p]){c=b[p];e=d[p];break}return c<e?-1:e<c?1:0};a.isEncoding=function(a){switch(String(a).toLowerCase()){case "hex":case "utf8":case "utf-8":case "ascii":case "latin1":case "binary":case "base64":case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":return!0;
default:return!1}};a.concat=function(b,d){if(!Array.isArray(b))throw new TypeError('"list" argument must be an Array of Buffers');if(0===b.length)return a.alloc(0);var c;if(void 0===d)for(c=d=0;c<b.length;++c)d+=b[c].length;var e=a.allocUnsafe(d),p=0;for(c=0;c<b.length;++c){var h=b[c];if(!a.isBuffer(h))throw new TypeError('"list" argument must be an Array of Buffers');h.copy(e,p);p+=h.length}return e};a.byteLength=w;a.prototype._isBuffer=!0;a.prototype.swap16=function(){var a=this.length;if(0!==a%
2)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var b=0;b<a;b+=2)r(this,b,b+1);return this};a.prototype.swap32=function(){var a=this.length;if(0!==a%4)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var b=0;b<a;b+=4)r(this,b,b+3),r(this,b+1,b+2);return this};a.prototype.swap64=function(){var a=this.length;if(0!==a%8)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var b=0;b<a;b+=8)r(this,b,b+7),r(this,b+1,b+6),r(this,b+2,b+5),r(this,
b+3,b+4);return this};a.prototype.toString=function(){var a=this.length;return 0===a?"":0===arguments.length?A(this,0,a):d.apply(this,arguments)};a.prototype.equals=function(b){if(!a.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?!0:0===a.compare(this,b)};a.prototype.inspect=function(){var a="",b=k.INSPECT_MAX_BYTES;0<this.length&&(a=this.toString("hex",0,b).match(/.{2}/g).join(" "),this.length>b&&(a+=" ... "));return"<Buffer "+a+">"};a.prototype.compare=function(b,d,
c,e,h){if(!a.isBuffer(b))throw new TypeError("Argument must be a Buffer");void 0===d&&(d=0);void 0===c&&(c=b?b.length:0);void 0===e&&(e=0);void 0===h&&(h=this.length);if(0>d||c>b.length||0>e||h>this.length)throw new RangeError("out of range index");if(e>=h&&d>=c)return 0;if(e>=h)return-1;if(d>=c)return 1;d>>>=0;c>>>=0;e>>>=0;h>>>=0;if(this===b)return 0;var p=h-e,g=c-d,n=Math.min(p,g);e=this.slice(e,h);b=b.slice(d,c);for(d=0;d<n;++d)if(e[d]!==b[d]){p=e[d];g=b[d];break}return p<g?-1:g<p?1:0};a.prototype.includes=
function(a,b,d){return-1!==this.indexOf(a,b,d)};a.prototype.indexOf=function(a,b,d){return B(this,a,b,d,!0)};a.prototype.lastIndexOf=function(a,b,d){return B(this,a,b,d,!1)};a.prototype.write=function(a,b,d,c){if(void 0===b)c="utf8",d=this.length,b=0;else if(void 0===d&&"string"===typeof b)c=b,d=this.length,b=0;else if(isFinite(b))b>>>=0,isFinite(d)?(d>>>=0,void 0===c&&(c="utf8")):(c=d,d=void 0);else throw Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");var e=this.length-
b;if(void 0===d||d>e)d=e;if(0<a.length&&(0>d||0>b)||b>this.length)throw new RangeError("Attempt to write outside buffer bounds");c||(c="utf8");for(e=!1;;)switch(c){case "hex":a:{b=Number(b)||0;c=this.length-b;d?(d=Number(d),d>c&&(d=c)):d=c;c=a.length;if(0!==c%2)throw new TypeError("Invalid hex string");d>c/2&&(d=c/2);for(c=0;c<d;++c){e=parseInt(a.substr(2*c,2),16);if(e!==e){a=c;break a}this[b+c]=e}a=c}return a;case "utf8":case "utf-8":return D(O(a,this.length-b),this,b,d);case "ascii":return D(J(a),
this,b,d);case "latin1":case "binary":return D(J(a),this,b,d);case "base64":return D(L.toByteArray(K(a)),this,b,d);case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":c=a;for(var e=this.length-b,h=[],p=0;p<c.length&&!(0>(e-=2));++p){var g=c.charCodeAt(p);a=g>>8;g%=256;h.push(g);h.push(a)}return D(h,this,b,d);default:if(e)throw new TypeError("Unknown encoding: "+c);c=(""+c).toLowerCase();e=!0}};a.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};
var U=4096;a.prototype.slice=function(b,d){var c=this.length;b=~~b;d=void 0===d?c:~~d;0>b?(b+=c,0>b&&(b=0)):b>c&&(b=c);0>d?(d+=c,0>d&&(d=0)):d>c&&(d=c);d<b&&(d=b);c=this.subarray(b,d);c.__proto__=a.prototype;return c};a.prototype.readUIntLE=function(a,b,d){a>>>=0;b>>>=0;d||y(a,b,this.length);d=this[a];for(var c=1,e=0;++e<b&&(c*=256);)d+=this[a+e]*c;return d};a.prototype.readUIntBE=function(a,b,d){a>>>=0;b>>>=0;d||y(a,b,this.length);d=this[a+--b];for(var c=1;0<b&&(c*=256);)d+=this[a+--b]*c;return d};
a.prototype.readUInt8=function(a,b){a>>>=0;b||y(a,1,this.length);return this[a]};a.prototype.readUInt16LE=function(a,b){a>>>=0;b||y(a,2,this.length);return this[a]|this[a+1]<<8};a.prototype.readUInt16BE=function(a,b){a>>>=0;b||y(a,2,this.length);return this[a]<<8|this[a+1]};a.prototype.readUInt32LE=function(a,b){a>>>=0;b||y(a,4,this.length);return(this[a]|this[a+1]<<8|this[a+2]<<16)+16777216*this[a+3]};a.prototype.readUInt32BE=function(a,b){a>>>=0;b||y(a,4,this.length);return 16777216*this[a]+(this[a+
1]<<16|this[a+2]<<8|this[a+3])};a.prototype.readIntLE=function(a,b,d){a>>>=0;b>>>=0;d||y(a,b,this.length);d=this[a];for(var c=1,e=0;++e<b&&(c*=256);)d+=this[a+e]*c;d>=128*c&&(d-=Math.pow(2,8*b));return d};a.prototype.readIntBE=function(a,b,d){a>>>=0;b>>>=0;d||y(a,b,this.length);d=b;for(var c=1,e=this[a+--d];0<d&&(c*=256);)e+=this[a+--d]*c;e>=128*c&&(e-=Math.pow(2,8*b));return e};a.prototype.readInt8=function(a,b){a>>>=0;b||y(a,1,this.length);return this[a]&128?-1*(255-this[a]+1):this[a]};a.prototype.readInt16LE=
function(a,b){a>>>=0;b||y(a,2,this.length);var d=this[a]|this[a+1]<<8;return d&32768?d|4294901760:d};a.prototype.readInt16BE=function(a,b){a>>>=0;b||y(a,2,this.length);var d=this[a+1]|this[a]<<8;return d&32768?d|4294901760:d};a.prototype.readInt32LE=function(a,b){a>>>=0;b||y(a,4,this.length);return this[a]|this[a+1]<<8|this[a+2]<<16|this[a+3]<<24};a.prototype.readInt32BE=function(a,b){a>>>=0;b||y(a,4,this.length);return this[a]<<24|this[a+1]<<16|this[a+2]<<8|this[a+3]};a.prototype.readFloatLE=function(a,
b){a>>>=0;b||y(a,4,this.length);return N.read(this,a,!0,23,4)};a.prototype.readFloatBE=function(a,b){a>>>=0;b||y(a,4,this.length);return N.read(this,a,!1,23,4)};a.prototype.readDoubleLE=function(a,b){a>>>=0;b||y(a,8,this.length);return N.read(this,a,!0,52,8)};a.prototype.readDoubleBE=function(a,b){a>>>=0;b||y(a,8,this.length);return N.read(this,a,!1,52,8)};a.prototype.writeUIntLE=function(a,b,d,c){a=+a;b>>>=0;d>>>=0;c||C(this,a,b,d,Math.pow(2,8*d)-1,0);c=1;var e=0;for(this[b]=a&255;++e<d&&(c*=256);)this[b+
e]=a/c&255;return b+d};a.prototype.writeUIntBE=function(a,b,d,c){a=+a;b>>>=0;d>>>=0;c||C(this,a,b,d,Math.pow(2,8*d)-1,0);c=d-1;var e=1;for(this[b+c]=a&255;0<=--c&&(e*=256);)this[b+c]=a/e&255;return b+d};a.prototype.writeUInt8=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,1,255,0);this[b]=a&255;return b+1};a.prototype.writeUInt16LE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,2,65535,0);this[b]=a&255;this[b+1]=a>>>8;return b+2};a.prototype.writeUInt16BE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,2,65535,0);
this[b]=a>>>8;this[b+1]=a&255;return b+2};a.prototype.writeUInt32LE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,4,4294967295,0);this[b+3]=a>>>24;this[b+2]=a>>>16;this[b+1]=a>>>8;this[b]=a&255;return b+4};a.prototype.writeUInt32BE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,4,4294967295,0);this[b]=a>>>24;this[b+1]=a>>>16;this[b+2]=a>>>8;this[b+3]=a&255;return b+4};a.prototype.writeIntLE=function(a,b,d,c){a=+a;b>>>=0;c||(c=Math.pow(2,8*d-1),C(this,a,b,d,c-1,-c));c=0;var e=1,h=0;for(this[b]=a&255;++c<d&&
(e*=256);)0>a&&0===h&&0!==this[b+c-1]&&(h=1),this[b+c]=(a/e>>0)-h&255;return b+d};a.prototype.writeIntBE=function(a,b,d,c){a=+a;b>>>=0;c||(c=Math.pow(2,8*d-1),C(this,a,b,d,c-1,-c));c=d-1;var e=1,h=0;for(this[b+c]=a&255;0<=--c&&(e*=256);)0>a&&0===h&&0!==this[b+c+1]&&(h=1),this[b+c]=(a/e>>0)-h&255;return b+d};a.prototype.writeInt8=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,1,127,-128);0>a&&(a=255+a+1);this[b]=a&255;return b+1};a.prototype.writeInt16LE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,2,32767,
-32768);this[b]=a&255;this[b+1]=a>>>8;return b+2};a.prototype.writeInt16BE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,2,32767,-32768);this[b]=a>>>8;this[b+1]=a&255;return b+2};a.prototype.writeInt32LE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,4,2147483647,-2147483648);this[b]=a&255;this[b+1]=a>>>8;this[b+2]=a>>>16;this[b+3]=a>>>24;return b+4};a.prototype.writeInt32BE=function(a,b,d){a=+a;b>>>=0;d||C(this,a,b,4,2147483647,-2147483648);0>a&&(a=4294967295+a+1);this[b]=a>>>24;this[b+1]=a>>>16;this[b+2]=
a>>>8;this[b+3]=a&255;return b+4};a.prototype.writeFloatLE=function(a,b,d){return I(this,a,b,!0,d)};a.prototype.writeFloatBE=function(a,b,d){return I(this,a,b,!1,d)};a.prototype.writeDoubleLE=function(a,b,d){return G(this,a,b,!0,d)};a.prototype.writeDoubleBE=function(a,b,d){return G(this,a,b,!1,d)};a.prototype.copy=function(a,b,d,c){d||(d=0);c||0===c||(c=this.length);b>=a.length&&(b=a.length);b||(b=0);0<c&&c<d&&(c=d);if(c===d||0===a.length||0===this.length)return 0;if(0>b)throw new RangeError("targetStart out of bounds");
if(0>d||d>=this.length)throw new RangeError("sourceStart out of bounds");if(0>c)throw new RangeError("sourceEnd out of bounds");c>this.length&&(c=this.length);a.length-b<c-d&&(c=a.length-b+d);var e=c-d;if(this===a&&d<b&&b<c)for(c=e-1;0<=c;--c)a[c+b]=this[c+d];else if(1E3>e)for(c=0;c<e;++c)a[c+b]=this[c+d];else Uint8Array.prototype.set.call(a,this.subarray(d,d+e),b);return e};a.prototype.fill=function(b,d,c,e){if("string"===typeof b){"string"===typeof d?(e=d,d=0,c=this.length):"string"===typeof c&&
(e=c,c=this.length);if(1===b.length){var h=b.charCodeAt(0);256>h&&(b=h)}if(void 0!==e&&"string"!==typeof e)throw new TypeError("encoding must be a string");if("string"===typeof e&&!a.isEncoding(e))throw new TypeError("Unknown encoding: "+e);}else"number"===typeof b&&(b&=255);if(0>d||this.length<d||this.length<c)throw new RangeError("Out of range index");if(c<=d)return this;d>>>=0;c=void 0===c?this.length:c>>>0;b||(b=0);if("number"===typeof b)for(e=d;e<c;++e)this[e]=b;else for(b=a.isBuffer(b)?b:new a(b,
e),h=b.length,e=0;e<c-d;++e)this[e+d]=b[e%h];return this};var M=/[^+/0-9A-Za-z-_]/g},{"base64-js":22,ieee754:75}],28:[function(f,m,k){k.Commented=f("./commented");k.Diagnose=f("./diagnose");k.Decoder=f("./decoder");k.Encoder=f("./encoder");k.Simple=f("./simple");k.Tagged=f("./tagged");k.comment=k.Commented.comment;k.decodeAll=k.Decoder.decodeAll;k.decodeFirst=k.Decoder.decodeFirst;k.decodeAllSync=k.Decoder.decodeAllSync;k.decodeFirstSync=k.Decoder.decodeFirstSync;k.diagnose=k.Diagnose.diagnose;k.encode=
k.Encoder.encode;k.decode=k.Decoder.decodeFirstSync;k.leveldb={decode:k.Decoder.decodeAllSync,encode:k.Encoder.encode,buffer:!0,name:"cbor"}},{"./commented":29,"./decoder":31,"./diagnose":32,"./encoder":33,"./simple":34,"./tagged":35}],29:[function(f,m,k){(function(b){var a=f("stream"),g=f("util");f("./utils");f("./simple");var c=f("./decoder"),l=f("./constants"),e=f("bignumber.js"),h=f("nofilter"),n=l.MT,k=l.NUMBYTES,d=l.SYMS,r=function(b){b=b||{};b.readableObjectMode=!1;b.writableObjectMode=!1;
var d=null!=b.max_depth?b.max_depth:10;delete b.max_depth;var e=a.Transform.call(this,b)||this;e.depth=1;e.max_depth=d;e.all=new h;e.parser=new c(b);e.parser.on("value",e._on_value.bind(e));e.parser.on("start",e._on_start.bind(e));e.parser.on("start-string",e._on_start_string.bind(e));e.parser.on("stop",e._on_stop.bind(e));e.parser.on("more-bytes",e._on_more.bind(e));e.parser.on("error",e._on_error.bind(e));e.parser.on("data",e._on_data.bind(e));e.parser.bs.on("read",e._on_read.bind(e));return e};
$jscomp.inherits(r,a.Transform);r.prototype._transform=function(a,b,d){this.parser.write(a,b,function(a){d(a)})};r.prototype._flush=function(a){return this.parser._flush(a)};r.comment=function(a,b,d){if(null==a)throw Error("input required");var c="string"===typeof a?"hex":void 0,e=10;switch(typeof b){case "function":d=b;break;case "string":c=b;break;case "number":e=b;break;case "object":var g,n,c=null!=(g=b.encoding)?g:c,e=null!=(n=b.max_depth)?n:e;break;case "undefined":break;default:throw Error("Unknown option type");
}var l=new h,f=new r({max_depth:e});b=null;"function"===typeof d?(f.on("end",function(){return d(null,l.toString("utf8"))}),f.on("error",d)):b=new Promise(function(a,b){f.on("end",function(){return a(l.toString("utf8"))});return f.on("error",b)});f.pipe(l);f.end(a,c);return b};r.prototype._on_error=function(a){return this.push("ERROR: ")&&this.push(a.toString())&&this.push("\n")};r.prototype._on_read=function(a){this.all.write(a);a=a.toString("hex");this.push(Array(this.depth+1).join("  "));this.push(a);
var b=2*(this.max_depth-this.depth),b=b-a.length;1>b&&(b=1);this.push(Array(b+1).join(" "));return this.push("-- ")};r.prototype._on_more=function(a,b,d,c){this.depth++;d="";switch(a){case n.POS_INT:d="Positive number,";break;case n.NEG_INT:d="Negative number,";break;case n.ARRAY:d="Array, length";break;case n.MAP:d="Map, count";break;case n.BYTE_STRING:d="Bytes, length";break;case n.UTF8_STRING:d="String, length";break;case n.SIMPLE_FLOAT:d=1===b?"Simple value,":"Float,"}return this.push(d+" next "+
b+" byte"+(1<b?"s":"")+"\n")};r.prototype._on_start_string=function(a,b,d,c){this.depth++;d="";switch(a){case n.BYTE_STRING:d="Bytes, length: "+b;break;case n.UTF8_STRING:d="String, length: "+b.toString()}return this.push(d+"\n")};r.prototype._on_start=function(a,b,c,e){this.depth++;b!==d.BREAK&&this.push(function(){switch(c){case n.ARRAY:return"["+e+"], ";case n.MAP:return e%2?"{Val:"+Math.floor(e/2)+"}, ":"{Key:"+Math.floor(e/2)+"}, "}}());this.push(function(){switch(a){case n.TAG:return"Tag #"+
b;case n.ARRAY:return b===d.STREAM?"Array (streaming)":"Array, "+b+" item"+(1<b?"s":"");case n.MAP:return b===d.STREAM?"Map (streaming)":"Map, "+b+" pair"+(1<b?"s":"");case n.BYTE_STRING:return"Bytes (streaming)";case n.UTF8_STRING:return"String (streaming)"}}());return this.push("\n")};r.prototype._on_stop=function(a){return this.depth--};r.prototype._on_value=function(a,c,h,l){a!==d.BREAK&&this.push(function(){switch(c){case n.ARRAY:return"["+h+"], ";case n.MAP:return h%2?"{Val:"+Math.floor(h/2)+
"}, ":"{Key:"+Math.floor(h/2)+"}, "}}());a===d.BREAK?this.push("BREAK\n"):a===d.NULL?this.push("null\n"):a===d.UNDEFINED?this.push("undefined\n"):"string"===typeof a?(this.depth--,0<a.length&&(this.push(JSON.stringify(a)),this.push("\n"))):b.isBuffer(a)?(this.depth--,0<a.length&&(this.push(a.toString("hex")),this.push("\n"))):(a instanceof e?this.push(a.toString()):this.push(g.inspect(a)),this.push("\n"));switch(l){case k.ONE:case k.TWO:case k.FOUR:case k.EIGHT:this.depth--}};r.prototype._on_data=
function(){this.push("0x");this.push(this.all.read().toString("hex"));return this.push("\n")};m.exports=r}).call(this,{isBuffer:f("../../is-buffer/index.js")})},{"../../is-buffer/index.js":78,"./constants":30,"./decoder":31,"./simple":34,"./utils":36,"bignumber.js":23,nofilter:108,stream:128,util:136}],30:[function(f,m,k){k.MT={POS_INT:0,NEG_INT:1,BYTE_STRING:2,UTF8_STRING:3,ARRAY:4,MAP:5,TAG:6,SIMPLE_FLOAT:7};k.TAG={DATE_STRING:0,DATE_EPOCH:1,POS_BIGINT:2,NEG_BIGINT:3,DECIMAL_FRAC:4,BIGFLOAT:5,BASE64URL_EXPECTED:21,
BASE64_EXPECTED:22,BASE16_EXPECTED:23,CBOR:24,URI:32,BASE64URL:33,BASE64:34,REGEXP:35,MIME:36};k.NUMBYTES={ZERO:0,ONE:24,TWO:25,FOUR:26,EIGHT:27,INDEFINITE:31};k.SIMPLE={FALSE:20,TRUE:21,NULL:22,UNDEFINED:23};$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();k.SYMS={NULL:Symbol("null"),UNDEFINED:Symbol("undef"),PARENT:Symbol("parent"),BREAK:Symbol("break"),STREAM:Symbol("stream")};k.SHIFT32=Math.pow(2,32)},{}],31:[function(f,m,k){(function(b){function a(a,
b,d){var c=[];c[y]=d;c[B.PARENT]=a;c[C]=b;return c}var g=f("../vendor/binary-parse-stream"),c=f("./tagged"),l=f("./simple"),e=f("./utils"),h=f("bignumber.js"),n=f("nofilter"),k=f("./constants"),d=k.MT,r=k.NUMBYTES,B=k.SYMS,F=new h(-1),A=F.sub(new h(Number.MAX_SAFE_INTEGER.toString(16),16));$jscomp.initSymbol();var y=Symbol("count");$jscomp.initSymbol();Symbol("pending_key");$jscomp.initSymbol();var C=Symbol("major type");$jscomp.initSymbol();var q=Symbol("error");$jscomp.initSymbol();var I=Symbol("not found"),
G=function(a){a=a||{};var b=a.tags;delete a.tags;var d=null!=a.max_depth?a.max_depth:-1;delete a.max_depth;a=g.call(this,a)||this;a.running=!0;a.max_depth=d;a.tags=b;return a};$jscomp.inherits(G,g);G.nullcheck=function(a){switch(a){case B.NULL:return null;case B.UNDEFINED:break;case I:throw Error("Value not found");default:return a}};G.decodeFirstSync=function(a,b){b=b||{encoding:"hex"};var d={};switch(typeof b){case "string":var c=b;break;case "object":d=e.extend({},b),c=d.encoding,delete d.encoding}d=
new G(d);c=new n(a,null!=c?c:e.guessEncoding(a));for(var d=d._parse(),h=d.next();!h.done;){var g=c.read(h.value);if(null==g||g.length!==h.value)throw Error("Insufficient data");h=d.next(g)}return G.nullcheck(h.value)};G.decodeAllSync=function(a,b){b=b||{encoding:"hex"};var d={};switch(typeof b){case "string":var c=b;break;case "object":d=e.extend({},b),c=d.encoding,delete d.encoding}d=new G(d);c=new n(a,null!=c?c:e.guessEncoding(a));for(var h=[];0<c.length;){for(var g=d._parse(),l=g.next();!l.done;){var f=
c.read(l.value);if(null==f||f.length!==l.value)throw Error("Insufficient data");l=g.next(f)}h.push(G.nullcheck(l.value))}return h};G.decodeFirst=function(a,b,d){var c={},h=!1,g="hex";switch(typeof b){case "function":d=b;g=e.guessEncoding(a);break;case "string":g=b;break;case "object":c=e.extend({},b),g=null!=c.encoding?c.encoding:e.guessEncoding(a),delete c.encoding,h=null!=c.required?c.required:!1,delete c.required}var n=new G(c),l=I;n.on("data",function(a){l=G.nullcheck(a);n.close()});if("function"===
typeof d)n.once("error",function(a){var b=l;l=q;n.close();return d(a,b)}),n.once("end",function(){switch(l){case I:return h?d(Error("No CBOR found")):d(null,l);case q:break;default:return d(null,l)}});else var f=new Promise(function(a,b){n.once("error",function(a){l=q;n.close();return b(a)});return n.once("end",function(){switch(l){case I:return h?b(Error("No CBOR found")):a(l);case q:break;default:return a(l)}})});n.end(a,g);return f};G.decodeAll=function(a,b,d){var c={},h="hex";switch(typeof b){case "function":d=
b;h=e.guessEncoding(a);break;case "string":h=b;break;case "object":c=e.extend({},b),h=null!=c.encoding?c.encoding:e.guessEncoding(a),delete c.encoding}var g=new G(c),n=[];g.on("data",function(a){return n.push(G.nullcheck(a))});if("function"===typeof d)g.on("error",function(a){return d(a)}),g.on("end",function(){return d(null,n)});else var l=new Promise(function(a,b){g.on("error",function(a){return b(a)});return g.on("end",function(){return a(n)})});g.end(a,h);return l};G.prototype.close=function(){this.running=
!1;this.__fresh=!0};G.prototype._parse=function(){function g(g,K){for(;;)switch(f){case 0:V=null,ka=0,X=null;case 1:if(!(0<=da.max_depth&&ka>da.max_depth)){f=3;break}f=-1;throw Error("Maximum depth "+da.max_depth+" exceeded");case 3:return f=4,{value:1,done:!1};case 4:if(void 0===K){f=5;break}f=-1;throw K;case 5:na=g;ja=na[0];if(da.running){f=6;break}f=-1;throw Error("Unexpected data: 0x"+ja.toString(16));case 6:E=ja>>5;ga=ja&31;Y=null!=V?V[C]:void 0;fa=null!=V?V.length:void 0;P=!1;R=ga;if(!P&&R!==
r.ONE){f=8;break}P=!0;da.emit("more-bytes",E,1,Y,fa);f=9;return{value:1,done:!1};case 9:if(void 0===K){f=10;break}f=-1;throw K;case 10:ba=g;X=ba[0];f=7;break;case 8:if(P||R===r.TWO)P=!0;if(P||R===r.FOUR)P=!0;if(!P&&R!==r.EIGHT){f=11;break}P=!0;W=1<<ga-24;da.emit("more-bytes",E,W,Y,fa);f=12;return{value:W,done:!1};case 12:if(void 0===K){f=13;break}f=-1;throw K;case 13:Z=ha=g;X=E===d.SIMPLE_FLOAT?Z:e.parseCBORint(ga,Z);f=7;break;case 11:if(P||28===R)P=!0;if(P||29===R)P=!0;if(!P&&30!==R){f=14;break}P=
!0;da.running=!1;f=-1;throw Error("Additional info not implemented: "+ga);case 14:if(!P&&R!==r.INDEFINITE){f=15;break}P=!0;X=-1;f=7;break;case 15:P=!0,X=ga;case 7:S=!1;T=E;if(!S&&T!==d.POS_INT){f=17;break}S=!0;f=16;break;case 17:if(!S&&T!==d.NEG_INT){f=18;break}S=!0;X=X===Number.MAX_SAFE_INTEGER?A:X instanceof h?F.sub(X):-1-X;f=16;break;case 18:if(S||T===d.BYTE_STRING)S=!0;if(!S&&T!==d.UTF8_STRING){f=19;break}S=!0;ca=!1;v=X;if(!ca&&0!==v){f=21;break}ca=!0;da.emit("start-string",E,X,Y,fa);X=E===d.BYTE_STRING?
new b(0):"";f=20;break;case 21:if(!ca&&-1!==v){f=22;break}ca=!0;da.emit("start",E,B.STREAM,Y,fa);var N=V,J=E,O=new n;O[B.PARENT]=N;O[C]=J;V=O;ka++;f=1;break;case 22:return ca=!0,da.emit("start-string",E,X,Y,fa),f=23,{value:X,done:!1};case 23:if(void 0===K){f=24;break}f=-1;throw K;case 24:X=z=g,E===d.UTF8_STRING&&(X=X.toString("utf-8"));case 20:f=16;break;case 19:if(S||T===d.ARRAY)S=!0;if(!S&&T!==d.MAP){f=25;break}S=!0;t=!1;p=X;if(!t&&0!==p){f=27;break}t=!0;X=E===d.MAP?{}:[];X[B.PARENT]=V;f=26;break;
case 27:if(!t&&-1!==p){f=28;break}t=!0;da.emit("start",E,B.STREAM,Y,fa);V=a(V,E,-1);ka++;f=1;break;case 28:t=!0;da.emit("start",E,X,Y,fa);V=a(V,E,X*(E-3));ka++;f=1;break;case 26:f=16;break;case 25:if(!S&&T!==d.TAG){f=29;break}S=!0;da.emit("start",E,X,Y,fa);V=a(V,E,1);V.push(X);ka++;f=1;break;case 29:if(S||T===d.SIMPLE_FLOAT)S=!0,X="number"===typeof X?l.decode(X,null!=V):e.parseCBORfloat(X);case 16:da.emit("value",X,Y,fa,ga),u=!1;case 30:if(null==V){f=31;break}m=M=!1;if(!M&&m!==(X!==B.BREAK)){f=33;
break}M=!0;V[y]=1;f=32;break;case 33:if(!M&&m!==!Array.isArray(V)){f=34;break}M=!0;V.push(X);f=32;break;case 34:if(!M&&m!==!(V instanceof n)){f=35;break}M=!0;I=V[C];if(null==I||I===E){f=36;break}da.running=!1;f=-1;throw Error("Invalid major type in indefinite encoding");case 36:V.write(X);case 35:case 32:if(0===--V[y]){f=37;break}u=!0;f=31;break;case 37:--ka;delete V[y];da.emit("stop",V[C]);if(!Array.isArray(V)){f=38;break}G=!1;w=V[C];if(!G&&w!==d.ARRAY){f=41;break}G=!0;X=V;f=40;break;case 41:if(!G&&
w!==d.MAP){f=42;break}k=G=!0;if(0===V.length%2){f=43;break}f=-1;throw Error("Invalid map length: "+V.length);case 43:J=0;for(N=V.length;J<N;J+=2)if("string"!==typeof V[J]){k=!1;break}if(k)for(X={},J=0,N=V.length;J<N;J+=2)X[V[J]]=V[J+1];else for(X=new Map,J=0,N=V.length;J<N;J+=2)X.set(V[J],V[J+1]);f=40;break;case 42:if(!G&&w!==d.TAG){f=44;break}G=!0;q=new c(V[0],V[1]);X=q.convert(da.tags);f=40;break;case 44:case 40:f=39;break;case 38:if(V instanceof n)switch(V[C]){case d.BYTE_STRING:X=V.slice();case d.UTF8_STRING:X=
V.toString("utf-8")}case 39:V=V[B.PARENT];f=30;break;case 31:if(u){f=45;break}f=-1;return{value:X,done:!0};case 45:f=1;break;case 2:f=-1;default:return{value:void 0,done:!0}}}var f=0,q,k,w,G,I,m,M,u,p,t,z,v,ca,T,S,Z,ha,W,ba,R,P,fa,Y,ga,E,ja,na,X,ka,V,da=this,ia={next:function(a){return g(a,void 0)},"throw":function(a){return g(void 0,a)},"return":function(a){throw Error("Not yet implemented");}};$jscomp.initSymbolIterator();ia[Symbol.iterator]=function(){return this};return ia};G.NOT_FOUND=I;m.exports=
G}).call(this,f("buffer").Buffer)},{"../vendor/binary-parse-stream":37,"./constants":30,"./simple":34,"./tagged":35,"./utils":36,"bignumber.js":23,buffer:27,nofilter:108}],32:[function(f,m,k){(function(b){var a=f("stream"),g=f("util"),c=f("./decoder");f("./simple");var l=f("./utils"),e=f("./constants"),h=f("bignumber.js"),n=f("nofilter"),k=e.MT,d=e.SYMS,r=function(b){b=b||{};var d=null!=b.separator?b.separator:"\n";delete b.separator;var e=null!=b.stream_errors?b.stream_errors:!1;delete b.stream_errors;
b.readableObjectMode=!1;b.writableObjectMode=!1;var h=a.Transform.call(this,b)||this;h.float_bytes=-1;h.separator=d;h.stream_errors=e;h.parser=new c(b);h.parser.on("more-bytes",h._on_more.bind(h));h.parser.on("value",h._on_value.bind(h));h.parser.on("start",h._on_start.bind(h));h.parser.on("stop",h._on_stop.bind(h));h.parser.on("data",h._on_data.bind(h));h.parser.on("error",h._on_error.bind(h));return h};$jscomp.inherits(r,a.Transform);r.prototype._transform=function(a,b,d){return this.parser.write(a,
b,d)};r.prototype._flush=function(a){var b=this;return this.parser._flush(function(d){return b.stream_errors?(b._on_error(d),a()):a(d)})};r.diagnose=function(a,b,d){if(null==a)throw Error("input required");var c={},e="hex";switch(typeof b){case "function":d=b;e=l.guessEncoding(a);break;case "object":c=l.extend({},b);e=null!=c.encoding?c.encoding:l.guessEncoding(a);delete c.encoding;break;default:e=null!=b?b:"hex"}var h=new n,g=new r(c);b=null;"function"===typeof d?(g.on("end",function(){return d(null,
h.toString("utf8"))}),g.on("error",d)):b=new Promise(function(a,b){g.on("end",function(){return a(h.toString("utf8"))});return g.on("error",b)});g.pipe(h);g.end(a,e);return b};r.prototype._on_error=function(a){return this.stream_errors?this.push(a.toString()):this.emit("error",a)};r.prototype._on_more=function(a,b,d,c){if(a===k.SIMPLE_FLOAT)return this.float_bytes=function(){switch(b){case 2:return 1;case 4:return 2;case 8:return 3}}()};r.prototype._fore=function(a,b){switch(a){case k.BYTE_STRING:case k.UTF8_STRING:case k.ARRAY:if(0<
b)return this.push(", ");break;case k.MAP:if(0<b)return b%2?this.push(": "):this.push(", ")}};r.prototype._on_value=function(a,c,e){if(a!==d.BREAK)return this._fore(c,e),this.push(function(){switch(!1){case a!==d.NULL:return"null";case a!==d.UNDEFINED:return"undefined";case "string"!==typeof a:return JSON.stringify(a);case !(0<this.float_bytes):var c=this.float_bytes;this.float_bytes=-1;return g.inspect(a)+"_"+c;case !b.isBuffer(a):return"h'"+a.toString("hex")+"'";case !(a instanceof h):return a.toString();
default:return g.inspect(a)}}.call(this))};r.prototype._on_start=function(a,b,c,e){this._fore(c,e);this.push(function(){switch(a){case k.TAG:return b+"(";case k.ARRAY:return"[";case k.MAP:return"{";case k.BYTE_STRING:case k.UTF8_STRING:return"(";default:throw Error("Unknown diagnostic type: "+a);}}());if(b===d.STREAM)return this.push("_ ")};r.prototype._on_stop=function(a){return this.push(function(){switch(a){case k.TAG:return")";case k.ARRAY:return"]";case k.MAP:return"}";case k.BYTE_STRING:case k.UTF8_STRING:return")";
default:throw Error("Unknown diagnostic type: "+a);}}())};r.prototype._on_data=function(){return this.push(this.separator)};m.exports=r}).call(this,{isBuffer:f("../../is-buffer/index.js")})},{"../../is-buffer/index.js":78,"./constants":30,"./decoder":31,"./simple":34,"./utils":36,"bignumber.js":23,nofilter:108,stream:128,util:136}],33:[function(f,m,k){(function(b){var a=f("stream"),g=f("url"),c=f("bignumber.js"),l=f("nofilter");f("./tagged");f("./simple");var e=f("./utils"),h=f("./constants"),n=h.MT,
k=h.NUMBYTES,d=h.SHIFT32,r=h.SYMS,B=h.TAG,F=h.MT.SIMPLE_FLOAT<<5|h.NUMBYTES.TWO,A=h.MT.SIMPLE_FLOAT<<5|h.NUMBYTES.FOUR,y=h.MT.SIMPLE_FLOAT<<5|h.NUMBYTES.EIGHT,C=h.MT.SIMPLE_FLOAT<<5|h.SIMPLE.TRUE,q=h.MT.SIMPLE_FLOAT<<5|h.SIMPLE.FALSE,I=h.MT.SIMPLE_FLOAT<<5|h.SIMPLE.UNDEFINED,G=h.MT.SIMPLE_FLOAT<<5|h.SIMPLE.NULL,K=new c("0x20000000000000"),O=new b("f97e00","hex"),J=new b("f9fc00","hex"),D=new b("f97c00","hex"),L=function(d){d=d||{};d.readableObjectMode=!1;d.writableObjectMode=!0;var e=a.Transform.call(this,
d)||this;e.canonical=d.canonical;e.semanticTypes=[Array,e._pushArray,Date,e._pushDate,b,e._pushBuffer,Map,e._pushMap,l,e._pushNoFilter,RegExp,e._pushRegexp,Set,e._pushSet,g.Url,e._pushUrl,c,e._pushBigNumber];d=d.genTypes||[];for(var h=0,n=d.length;h<n;h+=2)e.addSemanticType(d[h],d[h+1]);return e};$jscomp.inherits(L,a.Transform);L.prototype._transform=function(a,b,d){a=this.pushAny(a);return d(!1===a?Error("Push Error"):void 0)};L.prototype._flush=function(a){return a()};L.prototype.addSemanticType=
function(a,b){for(var d=0,c=this.semanticTypes.length;d<c;d+=2)if(this.semanticTypes[d]===a)return c=this.semanticTypes[d+1],this.semanticTypes[d+1]=b,c;this.semanticTypes.push(a,b);return null};L.prototype._pushUInt8=function(a){var d=new b(1);d.writeUInt8(a);return this.push(d)};L.prototype._pushUInt16BE=function(a){var d=new b(2);d.writeUInt16BE(a);return this.push(d)};L.prototype._pushUInt32BE=function(a){var d=new b(4);d.writeUInt32BE(a);return this.push(d)};L.prototype._pushDoubleBE=function(a){var d=
new b(8);d.writeDoubleBE(a);return this.push(d)};L.prototype._pushNaN=function(){return this.push(O)};L.prototype._pushInfinity=function(a){return this.push(0>a?J:D)};L.prototype._pushFloat=function(a){if(this.canonical){var d=new b(2);if(e.writeHalf(d,a)&&e.parseHalf(d)===a)return this._pushUInt8(F)&&this.push(d);d=new b(4);d.writeFloatBE(a);if(d.readFloatBE()===a)return this._pushUInt8(A)&&this.push(d)}return this._pushUInt8(y)&&this._pushDoubleBE(a)};L.prototype._pushInt=function(a,b,c){var e=
b<<5;switch(!1){case !(24>a):return this._pushUInt8(e|a);case !(255>=a):return this._pushUInt8(e|k.ONE)&&this._pushUInt8(a);case !(65535>=a):return this._pushUInt8(e|k.TWO)&&this._pushUInt16BE(a);case !(4294967295>=a):return this._pushUInt8(e|k.FOUR)&&this._pushUInt32BE(a);case !(a<=Number.MAX_SAFE_INTEGER):return this._pushUInt8(e|k.EIGHT)&&this._pushUInt32BE(Math.floor(a/d))&&this._pushUInt32BE(a%d);default:return b===n.NEG_INT?this._pushFloat(c):this._pushFloat(a)}};L.prototype._pushIntNum=function(a){return 0>
a?this._pushInt(-a-1,n.NEG_INT,a):this._pushInt(a,n.POS_INT)};L.prototype._pushNumber=function(a){switch(!1){case !isNaN(a):return this._pushNaN(a);case isFinite(a):return this._pushInfinity(a);case Math.round(a)!==a:return this._pushIntNum(a);default:return this._pushFloat(a)}};L.prototype._pushString=function(a){var d=b.byteLength(a,"utf8");return this._pushInt(d,n.UTF8_STRING)&&this.push(a,"utf8")};L.prototype._pushBoolean=function(a){return this._pushUInt8(a?C:q)};L.prototype._pushUndefined=function(a){return this._pushUInt8(I)};
L.prototype._pushNull=function(a){return this._pushUInt8(G)};L.prototype._pushArray=function(a,b){var d=b.length;if(!a._pushInt(d,n.ARRAY))return!1;for(var c=0;c<d;c++)if(!a.pushAny(b[c]))return!1;return!0};L.prototype._pushTag=function(a){return this._pushInt(a,n.TAG)};L.prototype._pushDate=function(a,b){return a._pushTag(B.DATE_EPOCH)&&a.pushAny(b/1E3)};L.prototype._pushBuffer=function(a,b){return a._pushInt(b.length,n.BYTE_STRING)&&a.push(b)};L.prototype._pushNoFilter=function(a,b){return a._pushBuffer(a,
b.slice())};L.prototype._pushRegexp=function(a,b){return a._pushTag(B.REGEXP)&&a.pushAny(b.source)};L.prototype._pushSet=function(a,b){if(!a._pushInt(b.size,n.ARRAY))return!1;for(var d=$jscomp.makeIterator(b),c=d.next();!c.done;c=d.next())if(!a.pushAny(c.value))return!1;return!0};L.prototype._pushUrl=function(a,b){return a._pushTag(B.URI)&&a.pushAny(b.format())};L.prototype._pushBigint=function(a){var d=B.POS_BIGINT;a.isNegative()&&(a=a.negated().minus(1),d=B.NEG_BIGINT);a=a.toString(16);a.length%
2&&(a="0"+a);a=new b(a,"hex");return this._pushTag(d)&&this._pushBuffer(this,a)};L.prototype._pushBigNumber=function(a,b){if(b.isNaN())return a._pushNaN();if(!b.isFinite())return a._pushInfinity(b.isNegative()?-Infinity:Infinity);if(b.isInteger())return a._pushBigint(b);if(!a._pushTag(B.DECIMAL_FRAC)||!a._pushInt(2,n.ARRAY))return!1;var d=b.decimalPlaces(),e=b.mul((new c(10)).pow(d));return a._pushIntNum(-d)?e.abs().lessThan(K)?a._pushIntNum(e.toNumber()):a._pushBigint(e):!1};L.prototype._pushMap=
function(a,b){if(!a._pushInt(b.size,n.MAP))return!1;if(a.canonical){for(var d=[],c=$jscomp.makeIterator(b.entries()),e=c.next();!e.done;e=c.next())d.push(e.value);d.sort(function(a,b){var d=L.encode(a[0]),c=L.encode(b[0]);return d.compare(c)});d=$jscomp.makeIterator(d)}else d=$jscomp.makeIterator(b);for(c=d.next();!c.done;c=d.next())if(c=c.value,!a.pushAny(c[0])||!a.pushAny(c[1]))return!1;return!0};L.prototype._pushObject=function(a){if(!a)return this._pushNull(a);for(var b=0,d=this.semanticTypes.length;b<
d;b+=2)if(a instanceof this.semanticTypes[b])return this.semanticTypes[b+1].call(a,this,a);b=a.encodeCBOR;if("function"===typeof b)return b.call(a,this);var b=Object.keys(a),c={};this.canonical&&b.sort(function(a,b){var d=c[a]||(c[a]=L.encode(a)),e=c[b]||(c[b]=L.encode(b));return d.compare(e)});if(!this._pushInt(b.length,n.MAP))return!1;for(var e,d=0,h=b.length;d<h;d++){var g=b[d];if(this.canonical&&(e=c[g])){if(!this.push(e))return!1}else if(!this._pushString(g))return!1;if(!this.pushAny(a[g]))return!1}return!0};
L.prototype.pushAny=function(a){switch(typeof a){case "number":return this._pushNumber(a);case "string":return this._pushString(a);case "boolean":return this._pushBoolean(a);case "undefined":return this._pushUndefined(a);case "object":return this._pushObject(a);case "symbol":switch(a){case r.NULL:return this._pushNull(null);case r.UNDEFINED:return this._pushUndefined(void 0);default:throw Error("Unknown symbol: "+a.toString());}default:throw Error("Unknown type: "+typeof a+", "+(a?a.toString():""));
}};L.prototype._pushAny=function(a){return this.pushAny(a)};L.encode=function(){var a=Array.prototype.slice.apply(arguments),b=new L,d=new l;b.pipe(d);for(var a=$jscomp.makeIterator(a),c=a.next();!c.done;c=a.next())c=c.value,"undefined"===typeof c?b._pushUndefined():null===c?b._pushNull(null):b.write(c);b.end();return d.read()};m.exports=L}).call(this,f("buffer").Buffer)},{"./constants":30,"./simple":34,"./tagged":35,"./utils":36,"bignumber.js":23,buffer:27,nofilter:108,stream:128,url:131}],34:[function(f,
m,k){f=f("./constants");var b=f.MT,a=f.SIMPLE,g=f.SYMS,c=function(a){if("number"!==typeof a)throw Error("Invalid Simple type: "+typeof a);if(0>a||255<a||(a|0)!==a)throw Error("value must be a small positive integer: "+a);this.value=a};c.prototype.toString=function(){return"simple("+this.value+")"};c.prototype.inspect=function(a,b){return"simple("+this.value+")"};c.prototype.encodeCBOR=function(a){return a._pushInt(this.value,b.SIMPLE_FLOAT)};c.isSimple=function(a){return a instanceof c};c.decode=
function(b,e){null==e&&(e=!0);switch(b){case a.FALSE:return!1;case a.TRUE:return!0;case a.NULL:return e?null:g.NULL;case a.UNDEFINED:if(e)break;return g.UNDEFINED;case -1:if(!e)throw Error("Invalid BREAK");return g.BREAK;default:return new c(b)}};m.exports=c},{"./constants":30}],35:[function(f,m,k){k=f("bignumber.js");var b=f("./utils"),a=f("url"),g=new k(-1),c=new k(10),l=new k(2),e=function(a,b,c){this.tag=a;this.value=b;this.err=c;if("number"!==typeof this.tag)throw Error("Invalid tag type ("+
typeof this.tag+")");if(0>this.tag||(this.tag|0)!==this.tag)throw Error("Tag must be a positive integer: "+this.tag);};e.prototype.toString=function(){return this.tag+"("+JSON.stringify(this.value)+")"};e.prototype.encodeCBOR=function(a){a._pushTag(this.tag);return a.pushAny(this.value)};e.prototype.convert=function(a){a=null!=a?a[this.tag]:void 0;if("function"!==typeof a&&(a=e["_tag_"+this.tag],"function"!==typeof a))return this;try{return a.call(e,this.value)}catch(n){return this.err=n,this}};e._tag_0=
function(a){return new Date(a)};e._tag_1=function(a){return new Date(1E3*a)};e._tag_2=function(a){return b.bufferToBignumber(a)};e._tag_3=function(a){return g.minus(b.bufferToBignumber(a))};e._tag_4=function(a){return c.pow(a[0]).times(a[1])};e._tag_5=function(a){return l.pow(a[0]).times(a[1])};e._tag_32=function(b){return a.parse(b)};e._tag_35=function(a){return new RegExp(a)};m.exports=e},{"./utils":36,"bignumber.js":23,url:131}],36:[function(f,m,k){(function(b,a){function g(a){if(null!=a)return console.log(a)}
var c=f("fs"),l=f("stream"),e=f("bignumber.js"),h=f("./constants"),n=h.NUMBYTES,w=h.SHIFT32;k.parseCBORint=function(a,b){switch(a){case n.ONE:return b.readUInt8(0,!0);case n.TWO:return b.readUInt16BE(0,!0);case n.FOUR:return b.readUInt32BE(0,!0);case n.EIGHT:var d=b.readUInt32BE(0);var c=b.readUInt32BE(4);return 2097151<d?(new e(d)).times(w).plus(c):d*w+c;default:throw Error("Invalid additional info for int: "+a);}};k.writeHalf=function(b,c){var d=new a(4);d.writeFloatBE(c);var e=d.readUInt32BE();
if(0!==(e&8191))return!1;var d=e>>16&32768,h=e>>23&255,e=e&8388607;if(113<=h&&142>=h)d+=(h-112<<10)+(e>>13);else if(103<=h&&113>h){if(e&(1<<126-h)-1)return!1;d+=e+8388608>>126-h}else return!1;b.writeUInt16BE(d);return!0};k.parseHalf=function(a){var b=a[0]&128?-1:1;var d=(a[0]&124)>>2;a=(a[0]&3)<<8|a[1];return d?31===d?b*(a?0/0:Infinity):b*Math.pow(2,d-25)*(1024+a):5.9604644775390625E-8*b*a};k.parseCBORfloat=function(a){switch(a.length){case 2:return k.parseHalf(a);case 4:return a.readFloatBE(0,!0);
case 8:return a.readDoubleBE(0,!0);default:throw Error("Invalid float size: "+a.length);}};k.hex=function(b){return new a(b.replace(/^0x/,""),"hex")};k.bin=function(b){var d;b=b.replace(/\s/g,"");var c=0;var e=b.length%8||8;for(d=[];e<=b.length;)d.push(parseInt(b.slice(c,e),2)),c=e,e+=8;return new a(d)};k.extend=function(){var a,b;var c=arguments[0];var e=2<=arguments.length?Array.prototype.slice.call(arguments,1):[];null==c&&(c={});var h=0;for(b=e.length;h<b;h++){var g=e[h];for(a in g){var n=g[a];
c[a]=n}}return c};k.arrayEqual=function(a,b){return null==a&&null==b?!0:null==a||null==b?!1:a.length===b.length&&a.every(function(a,d){return a===b[d]})};k.bufferEqual=function(b,c){var d,e;if(null==b&&null==c)return!0;if(null==b||null==c||!a.isBuffer(b)||!a.isBuffer(c)||b.length!==c.length)return!1;var h=!0;var g=d=0;for(e=b.length;d<e;g=++d){var n=b[g];h&=c[g]===n}return!!h};k.bufferToBignumber=function(a){return new e(a.toString("hex"),16)};h=function(b){var d=l.Readable.call(this)||this;(b=b.replace(/^0x/,
""))&&d.push(new a(b,"hex"));d.push(null);return d};$jscomp.inherits(h,l.Readable);k.DeHexStream=h;h=function(a){return l.Transform.call(this,a)||this};$jscomp.inherits(h,l.Transform);h.prototype._transform=function(a,b,c){this.push(a.toString("hex"));return c()};k.HexStream=h;k.streamFiles=function(a,e,h){null==h&&(h=g);var d=a.shift();if(!d)return h();var n=e();n.on("end",function(){return k.streamFiles(a,e,h)});n.on("error",h);d="-"===d?b.stdin:d instanceof l.Stream?d:c.createReadStream(d);d.on("error",
h);return d.pipe(n)};k.guessEncoding=function(b){switch(!1){case "string"!==typeof b:return"hex";case !a.isBuffer(b):break;default:throw Error("Unknown input type");}}}).call(this,f("_process"),f("buffer").Buffer)},{"./constants":30,_process:110,"bignumber.js":23,buffer:27,fs:24,stream:128}],37:[function(f,m,k){function b(b){a.call(this,b);this._writableState.objectMode=!1;this._readableState.objectMode=!0;this.bs=new g;this.__restart()}k=m.exports=b;var a=f("stream").Transform;m=f("util").inherits;
var g=f("nofilter");k.One=-1;m(b,a);b.prototype._transform=function(a,b,e){for(this.bs.write(a);this.bs.length>=this.__needed;){a=null===this.__needed?void 0:this.bs.read(this.__needed);try{var c=this.__parser.next(a)}catch(n){return e(n)}this.__needed&&(this.__fresh=!1);c.done?(this.push(c.value),this.__restart()):this.__needed=c.value|0}return e()};b.prototype.__restart=function(){this.__needed=null;this.__parser=this._parse();this.__fresh=!0};b.prototype._flush=function(a){a(this.__fresh?null:
Error("unexpected end of input"))}},{nofilter:108,stream:128,util:136}],38:[function(f,m,k){(function(b){k.isArray=function(a){return Array.isArray?Array.isArray(a):"[object Array]"===Object.prototype.toString.call(a)};k.isBoolean=function(a){return"boolean"===typeof a};k.isNull=function(a){return null===a};k.isNullOrUndefined=function(a){return null==a};k.isNumber=function(a){return"number"===typeof a};k.isString=function(a){return"string"===typeof a};k.isSymbol=function(a){return"symbol"===typeof a};
k.isUndefined=function(a){return void 0===a};k.isRegExp=function(a){return"[object RegExp]"===Object.prototype.toString.call(a)};k.isObject=function(a){return"object"===typeof a&&null!==a};k.isDate=function(a){return"[object Date]"===Object.prototype.toString.call(a)};k.isError=function(a){return"[object Error]"===Object.prototype.toString.call(a)||a instanceof Error};k.isFunction=function(a){return"function"===typeof a};k.isPrimitive=function(a){return null===a||"boolean"===typeof a||"number"===
typeof a||"string"===typeof a||"symbol"===typeof a||"undefined"===typeof a};k.isBuffer=b.isBuffer}).call(this,{isBuffer:f("../../is-buffer/index.js")})},{"../../is-buffer/index.js":78}],39:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib.BlockCipher,g=b.algo,c=[],f=[],e=[],h=[],n=[],k=[],d=[],r=[],B=[],m=[];(function(){for(var a=[],b=0;256>b;b++)a[b]=
128>b?b<<1:b<<1^283;for(var g=0,l=0,b=0;256>b;b++){var w=l^l<<1^l<<2^l<<3^l<<4,w=w>>>8^w&255^99;c[g]=w;f[w]=g;var A=a[g],F=a[A],J=a[F],D=257*a[w]^16843008*w;e[g]=D<<24|D>>>8;h[g]=D<<16|D>>>16;n[g]=D<<8|D>>>24;k[g]=D;D=16843009*J^65537*F^257*A^16843008*g;d[w]=D<<24|D>>>8;r[w]=D<<16|D>>>16;B[w]=D<<8|D>>>24;m[w]=D;g?(g=A^a[a[a[J^A]]],l^=a[a[l]]):g=l=1}})();var A=[0,1,2,4,8,16,32,64,128,27,54],g=g.AES=a.extend({_doReset:function(){var a;if(!this._nRounds||this._keyPriorReset!==this._key){var b=this._keyPriorReset=
this._key;var e=b.words,h=b.sigBytes/4,g=4*((this._nRounds=h+6)+1),n=this._keySchedule=[];for(a=0;a<g;a++)a<h?n[a]=e[a]:(b=n[a-1],a%h?6<h&&4==a%h&&(b=c[b>>>24]<<24|c[b>>>16&255]<<16|c[b>>>8&255]<<8|c[b&255]):(b=b<<8|b>>>24,b=c[b>>>24]<<24|c[b>>>16&255]<<16|c[b>>>8&255]<<8|c[b&255],b^=A[a/h|0]<<24),n[a]=n[a-h]^b);e=this._invKeySchedule=[];for(h=0;h<g;h++)a=g-h,b=h%4?n[a]:n[a-4],e[h]=4>h||4>=a?b:d[c[b>>>24]]^r[c[b>>>16&255]]^B[c[b>>>8&255]]^m[c[b&255]]}},encryptBlock:function(a,b){this._doCryptBlock(a,
b,this._keySchedule,e,h,n,k,c)},decryptBlock:function(a,b){var c=a[b+1];a[b+1]=a[b+3];a[b+3]=c;this._doCryptBlock(a,b,this._invKeySchedule,d,r,B,m,f);c=a[b+1];a[b+1]=a[b+3];a[b+3]=c},_doCryptBlock:function(a,b,d,c,e,h,g,n){var f=this._nRounds,l=a[b]^d[0],k=a[b+1]^d[1],q=a[b+2]^d[2];var r=a[b+3]^d[3];for(var w=4,y=1;y<f;y++){var p=c[l>>>24]^e[k>>>16&255]^h[q>>>8&255]^g[r&255]^d[w++];var t=c[k>>>24]^e[q>>>16&255]^h[r>>>8&255]^g[l&255]^d[w++];var A=c[q>>>24]^e[r>>>16&255]^h[l>>>8&255]^g[k&255]^d[w++];
r=c[r>>>24]^e[l>>>16&255]^h[k>>>8&255]^g[q&255]^d[w++];l=p;k=t;q=A}p=(n[l>>>24]<<24|n[k>>>16&255]<<16|n[q>>>8&255]<<8|n[r&255])^d[w++];t=(n[k>>>24]<<24|n[q>>>16&255]<<16|n[r>>>8&255]<<8|n[l&255])^d[w++];A=(n[q>>>24]<<24|n[r>>>16&255]<<16|n[l>>>8&255]<<8|n[k&255])^d[w++];r=(n[r>>>24]<<24|n[l>>>16&255]<<16|n[k>>>8&255]<<8|n[q&255])^d[w++];a[b]=p;a[b+1]=t;a[b+2]=A;a[b+3]=r},keySize:8});b.AES=a._createHelper(g)})();return b.AES})},{"./cipher-core":40,"./core":41,"./enc-base64":42,"./evpkdf":44,"./md5":49}],
40:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){b.lib.Cipher||function(a){var g=b.lib,c=g.Base,f=g.WordArray,e=g.BufferedBlockAlgorithm,h=b.enc.Base64,n=b.algo.EvpKDF,k=g.Cipher=e.extend({cfg:c.extend(),createEncryptor:function(a,b){return this.create(this._ENC_XFORM_MODE,a,b)},createDecryptor:function(a,b){return this.create(this._DEC_XFORM_MODE,a,b)},init:function(a,b,d){this.cfg=this.cfg.extend(d);this._xformMode=a;this._key=b;
this.reset()},reset:function(){e.reset.call(this);this._doReset()},process:function(a){this._append(a);return this._process()},finalize:function(a){a&&this._append(a);return this._doFinalize()},keySize:4,ivSize:4,_ENC_XFORM_MODE:1,_DEC_XFORM_MODE:2,_createHelper:function(){return function(a){return{encrypt:function(b,d,c){return("string"==typeof d?y:A).encrypt(a,b,d,c)},decrypt:function(b,d,c){return("string"==typeof d?y:A).decrypt(a,b,d,c)}}}}()});g.StreamCipher=k.extend({_doFinalize:function(){return this._process(!0)},
blockSize:1});var d=b.mode={},r=g.BlockCipherMode=c.extend({createEncryptor:function(a,b){return this.Encryptor.create(a,b)},createDecryptor:function(a,b){return this.Decryptor.create(a,b)},init:function(a,b){this._cipher=a;this._iv=b}}),d=d.CBC=function(){function b(b,d,c){var e;(e=this._iv)?this._iv=a:e=this._prevBlock;for(var h=0;h<c;h++)b[d+h]^=e[h]}var d=r.extend();d.Encryptor=d.extend({processBlock:function(a,d){var c=this._cipher,e=c.blockSize;b.call(this,a,d,e);c.encryptBlock(a,d);this._prevBlock=
a.slice(d,d+e)}});d.Decryptor=d.extend({processBlock:function(a,d){var c=this._cipher,e=c.blockSize,h=a.slice(d,d+e);c.decryptBlock(a,d);b.call(this,a,d,e);this._prevBlock=h}});return d}(),B=(b.pad={}).Pkcs7={pad:function(a,b){for(var d=4*b,d=d-a.sigBytes%d,c=d<<24|d<<16|d<<8|d,e=[],h=0;h<d;h+=4)e.push(c);d=f.create(e,d);a.concat(d)},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};g.BlockCipher=k.extend({cfg:k.cfg.extend({mode:d,padding:B}),reset:function(){k.reset.call(this);var a=
this.cfg;var b=a.iv,d=a.mode;this._xformMode==this._ENC_XFORM_MODE?a=d.createEncryptor:(a=d.createDecryptor,this._minBufferSize=1);this._mode=a.call(d,this,b&&b.words)},_doProcessBlock:function(a,b){this._mode.processBlock(a,b)},_doFinalize:function(){var a=this.cfg.padding;if(this._xformMode==this._ENC_XFORM_MODE){a.pad(this._data,this.blockSize);var b=this._process(!0)}else b=this._process(!0),a.unpad(b);return b},blockSize:4});var m=g.CipherParams=c.extend({init:function(a){this.mixIn(a)},toString:function(a){return(a||
this.formatter).stringify(this)}}),d=(b.format={}).OpenSSL={stringify:function(a){var b=a.ciphertext;a=a.salt;return(a?f.create([1398893684,1701076831]).concat(a).concat(b):b).toString(h)},parse:function(a){a=h.parse(a);var b=a.words;if(1398893684==b[0]&&1701076831==b[1]){var d=f.create(b.slice(2,4));b.splice(0,4);a.sigBytes-=16}return m.create({ciphertext:a,salt:d})}},A=g.SerializableCipher=c.extend({cfg:c.extend({format:d}),encrypt:function(a,b,d,c){c=this.cfg.extend(c);var e=a.createEncryptor(d,
c);b=e.finalize(b);e=e.cfg;return m.create({ciphertext:b,key:d,iv:e.iv,algorithm:a,mode:e.mode,padding:e.padding,blockSize:a.blockSize,formatter:c.format})},decrypt:function(a,b,d,c){c=this.cfg.extend(c);b=this._parse(b,c.format);return a.createDecryptor(d,c).finalize(b.ciphertext)},_parse:function(a,b){return"string"==typeof a?b.parse(a,this):a}}),c=(b.kdf={}).OpenSSL={execute:function(a,b,d,c){c||(c=f.random(8));a=n.create({keySize:b+d}).compute(a,c);d=f.create(a.words.slice(b),4*d);a.sigBytes=
4*b;return m.create({key:a,iv:d,salt:c})}},y=g.PasswordBasedCipher=A.extend({cfg:A.cfg.extend({kdf:c}),encrypt:function(a,b,d,c){c=this.cfg.extend(c);d=c.kdf.execute(d,a.keySize,a.ivSize);c.iv=d.iv;a=A.encrypt.call(this,a,b,d.key,c);a.mixIn(d);return a},decrypt:function(a,b,d,c){c=this.cfg.extend(c);b=this._parse(b,c.format);d=c.kdf.execute(d,a.keySize,a.ivSize,b.salt);c.iv=d.iv;return A.decrypt.call(this,a,b,d.key,c)}})}()})},{"./core":41}],41:[function(f,m,k){(function(b,a){"object"===typeof k?
m.exports=k=a():b.CryptoJS=a()})(this,function(){var b=b||function(a,b){var c=Object.create||function(){function a(){}return function(b){a.prototype=b;b=new a;a.prototype=null;return b}}(),g={},e=g.lib={},h=e.Base=function(){return{extend:function(a){var b=c(this);a&&b.mixIn(a);b.hasOwnProperty("init")&&this.init!==b.init||(b.init=function(){b.$super.init.apply(this,arguments)});b.init.prototype=b;b.$super=this;return b},create:function(){var a=this.extend();a.init.apply(a,arguments);return a},init:function(){},
mixIn:function(a){for(var b in a)a.hasOwnProperty(b)&&(this[b]=a[b]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}}}(),n=e.WordArray=h.extend({init:function(a,d){a=this.words=a||[];this.sigBytes=d!=b?d:4*a.length},toString:function(a){return(a||d).stringify(this)},concat:function(a){var b=this.words,d=a.words,c=this.sigBytes;a=a.sigBytes;this.clamp();if(c%4)for(var e=0;e<a;e++)b[c+e>>>2]|=(d[e>>>2]>>>24-e%4*8&255)<<24-(c+e)%4*8;
else for(e=0;e<a;e+=4)b[c+e>>>2]=d[e>>>2];this.sigBytes+=a;return this},clamp:function(){var b=this.words,d=this.sigBytes;b[d>>>2]&=4294967295<<32-d%4*8;b.length=a.ceil(d/4)},clone:function(){var a=h.clone.call(this);a.words=this.words.slice(0);return a},random:function(b){for(var d=[],c=function(b){var d=987654321;return function(){d=36969*(d&65535)+(d>>16)&4294967295;b=18E3*(b&65535)+(b>>16)&4294967295;return(((d<<16)+b&4294967295)/4294967296+.5)*(.5<a.random()?1:-1)}},e=0,h;e<b;e+=4){var g=c(4294967296*
(h||a.random()));h=987654071*g();d.push(4294967296*g()|0)}return new n.init(d,b)}}),f=g.enc={},d=f.Hex={stringify:function(a){var b=a.words;a=a.sigBytes;for(var d=[],c=0;c<a;c++){var e=b[c>>>2]>>>24-c%4*8&255;d.push((e>>>4).toString(16));d.push((e&15).toString(16))}return d.join("")},parse:function(a){for(var b=a.length,d=[],c=0;c<b;c+=2)d[c>>>3]|=parseInt(a.substr(c,2),16)<<24-c%8*4;return new n.init(d,b/2)}},k=f.Latin1={stringify:function(a){var b=a.words;a=a.sigBytes;for(var d=[],c=0;c<a;c++)d.push(String.fromCharCode(b[c>>>
2]>>>24-c%4*8&255));return d.join("")},parse:function(a){for(var b=a.length,d=[],c=0;c<b;c++)d[c>>>2]|=(a.charCodeAt(c)&255)<<24-c%4*8;return new n.init(d,b)}},B=f.Utf8={stringify:function(a){try{return decodeURIComponent(escape(k.stringify(a)))}catch(C){throw Error("Malformed UTF-8 data");}},parse:function(a){return k.parse(unescape(encodeURIComponent(a)))}},m=e.BufferedBlockAlgorithm=h.extend({reset:function(){this._data=new n.init;this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=
B.parse(a));this._data.concat(a);this._nDataBytes+=a.sigBytes},_process:function(b){var d,c=this._data,e=c.words,h=c.sigBytes,g=this.blockSize,f=h/(4*g),f=b?a.ceil(f):a.max((f|0)-this._minBufferSize,0);b=f*g;h=a.min(4*b,h);if(b){for(d=0;d<b;d+=g)this._doProcessBlock(e,d);d=e.splice(0,b);c.sigBytes-=h}return new n.init(d,h)},clone:function(){var a=h.clone.call(this);a._data=this._data.clone();return a},_minBufferSize:0});e.Hasher=m.extend({cfg:h.extend(),init:function(a){this.cfg=this.cfg.extend(a);
this.reset()},reset:function(){m.reset.call(this);this._doReset()},update:function(a){this._append(a);this._process();return this},finalize:function(a){a&&this._append(a);return this._doFinalize()},blockSize:16,_createHelper:function(a){return function(b,d){return(new a.init(d)).finalize(b)}},_createHmacHelper:function(a){return function(b,d){return(new A.HMAC.init(a,d)).finalize(b)}}});var A=g.algo={};return g}(Math);return b})},{}],42:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=
k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib.WordArray;b.enc.Base64={stringify:function(a){var b=a.words,g=a.sigBytes,e=this._map;a.clamp();a=[];for(var h=0;h<g;h+=3)for(var n=(b[h>>>2]>>>24-h%4*8&255)<<16|(b[h+1>>>2]>>>24-(h+1)%4*8&255)<<8|b[h+2>>>2]>>>24-(h+2)%4*8&255,f=0;4>f&&h+.75*f<g;f++)a.push(e.charAt(n>>>6*(3-f)&63));if(b=e.charAt(64))for(;a.length%4;)a.push(b);return a.join("")},parse:function(b){var c=b.length,g=this._map,e=this._reverseMap;if(!e)for(var e=this._reverseMap=
[],h=0;h<g.length;h++)e[g.charCodeAt(h)]=h;if(g=g.charAt(64))g=b.indexOf(g),-1!==g&&(c=g);for(var g=[],n=h=0;n<c;n++)if(n%4){var f=e[b.charCodeAt(n-1)]<<n%4*2,d=e[b.charCodeAt(n)]>>>6-n%4*2;g[h>>>2]|=(f|d)<<24-h%4*8;h++}return a.create(g,h)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="}})();return b.enc.Base64})},{"./core":41}],43:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){function a(a){return a<<
8&4278255360|a>>>8&16711935}var g=b.lib.WordArray,c=b.enc;c.Utf16=c.Utf16BE={stringify:function(a){var b=a.words;a=a.sigBytes;for(var c=[],g=0;g<a;g+=2)c.push(String.fromCharCode(b[g>>>2]>>>16-g%4*8&65535));return c.join("")},parse:function(a){for(var b=a.length,c=[],n=0;n<b;n++)c[n>>>1]|=a.charCodeAt(n)<<16-n%2*16;return g.create(c,2*b)}};c.Utf16LE={stringify:function(b){var c=b.words;b=b.sigBytes;for(var h=[],g=0;g<b;g+=2){var f=a(c[g>>>2]>>>16-g%4*8&65535);h.push(String.fromCharCode(f))}return h.join("")},
parse:function(b){for(var c=b.length,h=[],n=0;n<c;n++)h[n>>>1]|=a(b.charCodeAt(n)<<16-n%2*16);return g.create(h,2*c)}}})();return b.enc.Utf16})},{"./core":41}],44:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./sha1"),f("./hmac")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,g=a.Base,c=a.WordArray,a=b.algo,f=a.EvpKDF=g.extend({cfg:g.extend({keySize:4,hasher:a.MD5,iterations:1}),init:function(a){this.cfg=this.cfg.extend(a)},compute:function(a,b){for(var e=
this.cfg,h=e.hasher.create(),d=c.create(),g=d.words,f=e.keySize,e=e.iterations;g.length<f;){l&&h.update(l);var l=h.update(a).finalize(b);h.reset();for(var k=1;k<e;k++)l=h.finalize(l),h.reset();d.concat(l)}d.sigBytes=4*f;return d}});b.EvpKDF=function(a,b,c){return f.create(c).compute(a,b)}})();return b.EvpKDF})},{"./core":41,"./hmac":46,"./sha1":65}],45:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(a){var g=
b.lib.CipherParams,c=b.enc.Hex;b.format.Hex={stringify:function(a){return a.ciphertext.toString(c)},parse:function(a){a=c.parse(a);return g.create({ciphertext:a})}}})();return b.format.Hex})},{"./cipher-core":40,"./core":41}],46:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.enc.Utf8;b.algo.HMAC=b.lib.Base.extend({init:function(b,c){b=this._hasher=new b.init;"string"==typeof c&&(c=a.parse(c));var g=b.blockSize,e=
4*g;c.sigBytes>e&&(c=b.finalize(c));c.clamp();for(var h=this._oKey=c.clone(),n=this._iKey=c.clone(),f=h.words,d=n.words,k=0;k<g;k++)f[k]^=1549556828,d[k]^=909522486;h.sigBytes=n.sigBytes=e;this.reset()},reset:function(){var a=this._hasher;a.reset();a.update(this._iKey)},update:function(a){this._hasher.update(a);return this},finalize:function(a){var b=this._hasher;a=b.finalize(a);b.reset();return b.finalize(this._oKey.clone().concat(a))}})})()})},{"./core":41}],47:[function(f,m,k){(function(b,a,g){"object"===
typeof k?m.exports=k=a(f("./core"),f("./x64-core"),f("./lib-typedarrays"),f("./enc-utf16"),f("./enc-base64"),f("./md5"),f("./sha1"),f("./sha256"),f("./sha224"),f("./sha512"),f("./sha384"),f("./sha3"),f("./ripemd160"),f("./hmac"),f("./pbkdf2"),f("./evpkdf"),f("./cipher-core"),f("./mode-cfb"),f("./mode-ctr"),f("./mode-ctr-gladman"),f("./mode-ofb"),f("./mode-ecb"),f("./pad-ansix923"),f("./pad-iso10126"),f("./pad-iso97971"),f("./pad-zeropadding"),f("./pad-nopadding"),f("./format-hex"),f("./aes"),f("./tripledes"),
f("./rc4"),f("./rabbit"),f("./rabbit-legacy")):b.CryptoJS=a(b.CryptoJS)})(this,function(b){return b})},{"./aes":39,"./cipher-core":40,"./core":41,"./enc-base64":42,"./enc-utf16":43,"./evpkdf":44,"./format-hex":45,"./hmac":46,"./lib-typedarrays":48,"./md5":49,"./mode-cfb":50,"./mode-ctr":52,"./mode-ctr-gladman":51,"./mode-ecb":53,"./mode-ofb":54,"./pad-ansix923":55,"./pad-iso10126":56,"./pad-iso97971":57,"./pad-nopadding":58,"./pad-zeropadding":59,"./pbkdf2":60,"./rabbit":62,"./rabbit-legacy":61,"./rc4":63,
"./ripemd160":64,"./sha1":65,"./sha224":66,"./sha256":67,"./sha3":68,"./sha384":69,"./sha512":70,"./tripledes":71,"./x64-core":72}],48:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){if("function"==typeof ArrayBuffer){var a=b.lib.WordArray,g=a.init;(a.init=function(a){a instanceof ArrayBuffer&&(a=new Uint8Array(a));if(a instanceof Int8Array||"undefined"!==typeof Uint8ClampedArray&&a instanceof Uint8ClampedArray||a instanceof
Int16Array||a instanceof Uint16Array||a instanceof Int32Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array)a=new Uint8Array(a.buffer,a.byteOffset,a.byteLength);if(a instanceof Uint8Array){for(var b=a.byteLength,c=[],h=0;h<b;h++)c[h>>>2]|=a[h]<<24-h%4*8;g.call(this,c,b)}else g.apply(this,arguments)}).prototype=a}})();return b.lib.WordArray})},{"./core":41}],49:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){function g(a,
b,d,c,e,h,g){a=a+(b&d|~b&c)+e+g;return(a<<h|a>>>32-h)+b}function c(a,b,d,c,e,h,g){a=a+(b&c|d&~c)+e+g;return(a<<h|a>>>32-h)+b}function f(a,b,d,c,e,h,g){a=a+(b^d^c)+e+g;return(a<<h|a>>>32-h)+b}function e(a,b,d,c,e,h,g){a=a+(d^(b|~c))+e+g;return(a<<h|a>>>32-h)+b}var h=b.lib,n=h.WordArray,k=h.Hasher,h=b.algo,d=[];(function(){for(var b=0;64>b;b++)d[b]=4294967296*a.abs(a.sin(b+1))|0})();h=h.MD5=k.extend({_doReset:function(){this._hash=new n.init([1732584193,4023233417,2562383102,271733878])},_doProcessBlock:function(a,
b){for(var h=0;16>h;h++){var n=b+h,l=a[n];a[n]=(l<<8|l>>>24)&16711935|(l<<24|l>>>8)&4278255360}var h=this._hash.words,n=a[b+0],l=a[b+1],k=a[b+2],r=a[b+3],w=a[b+4],m=a[b+5],B=a[b+6],O=a[b+7],J=a[b+8],D=a[b+9],L=a[b+10],N=a[b+11],x=a[b+12],U=a[b+13],M=a[b+14],u=a[b+15],p=h[0],t=h[1],z=h[2],v=h[3],p=g(p,t,z,v,n,7,d[0]),v=g(v,p,t,z,l,12,d[1]),z=g(z,v,p,t,k,17,d[2]),t=g(t,z,v,p,r,22,d[3]),p=g(p,t,z,v,w,7,d[4]),v=g(v,p,t,z,m,12,d[5]),z=g(z,v,p,t,B,17,d[6]),t=g(t,z,v,p,O,22,d[7]),p=g(p,t,z,v,J,7,d[8]),v=
g(v,p,t,z,D,12,d[9]),z=g(z,v,p,t,L,17,d[10]),t=g(t,z,v,p,N,22,d[11]),p=g(p,t,z,v,x,7,d[12]),v=g(v,p,t,z,U,12,d[13]),z=g(z,v,p,t,M,17,d[14]),t=g(t,z,v,p,u,22,d[15]),p=c(p,t,z,v,l,5,d[16]),v=c(v,p,t,z,B,9,d[17]),z=c(z,v,p,t,N,14,d[18]),t=c(t,z,v,p,n,20,d[19]),p=c(p,t,z,v,m,5,d[20]),v=c(v,p,t,z,L,9,d[21]),z=c(z,v,p,t,u,14,d[22]),t=c(t,z,v,p,w,20,d[23]),p=c(p,t,z,v,D,5,d[24]),v=c(v,p,t,z,M,9,d[25]),z=c(z,v,p,t,r,14,d[26]),t=c(t,z,v,p,J,20,d[27]),p=c(p,t,z,v,U,5,d[28]),v=c(v,p,t,z,k,9,d[29]),z=c(z,v,p,
t,O,14,d[30]),t=c(t,z,v,p,x,20,d[31]),p=f(p,t,z,v,m,4,d[32]),v=f(v,p,t,z,J,11,d[33]),z=f(z,v,p,t,N,16,d[34]),t=f(t,z,v,p,M,23,d[35]),p=f(p,t,z,v,l,4,d[36]),v=f(v,p,t,z,w,11,d[37]),z=f(z,v,p,t,O,16,d[38]),t=f(t,z,v,p,L,23,d[39]),p=f(p,t,z,v,U,4,d[40]),v=f(v,p,t,z,n,11,d[41]),z=f(z,v,p,t,r,16,d[42]),t=f(t,z,v,p,B,23,d[43]),p=f(p,t,z,v,D,4,d[44]),v=f(v,p,t,z,x,11,d[45]),z=f(z,v,p,t,u,16,d[46]),t=f(t,z,v,p,k,23,d[47]),p=e(p,t,z,v,n,6,d[48]),v=e(v,p,t,z,O,10,d[49]),z=e(z,v,p,t,M,15,d[50]),t=e(t,z,v,p,
m,21,d[51]),p=e(p,t,z,v,x,6,d[52]),v=e(v,p,t,z,r,10,d[53]),z=e(z,v,p,t,L,15,d[54]),t=e(t,z,v,p,l,21,d[55]),p=e(p,t,z,v,J,6,d[56]),v=e(v,p,t,z,u,10,d[57]),z=e(z,v,p,t,B,15,d[58]),t=e(t,z,v,p,U,21,d[59]),p=e(p,t,z,v,w,6,d[60]),v=e(v,p,t,z,N,10,d[61]),z=e(z,v,p,t,k,15,d[62]),t=e(t,z,v,p,D,21,d[63]);h[0]=h[0]+p|0;h[1]=h[1]+t|0;h[2]=h[2]+z|0;h[3]=h[3]+v|0},_doFinalize:function(){var b=this._data,d=b.words,c=8*this._nDataBytes,e=8*b.sigBytes;d[e>>>5]|=128<<24-e%32;var h=a.floor(c/4294967296);d[(e+64>>>
9<<4)+15]=(h<<8|h>>>24)&16711935|(h<<24|h>>>8)&4278255360;d[(e+64>>>9<<4)+14]=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360;b.sigBytes=4*(d.length+1);this._process();b=this._hash;d=b.words;for(c=0;4>c;c++)e=d[c],d[c]=(e<<8|e>>>24)&16711935|(e<<24|e>>>8)&4278255360;return b},clone:function(){var a=k.clone.call(this);a._hash=this._hash.clone();return a}});b.MD5=k._createHelper(h);b.HmacMD5=k._createHmacHelper(h)})(Math);return b.MD5})},{"./core":41}],50:[function(f,m,k){(function(b,a,g){"object"===
typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CFB=function(){function a(a,b,e,h){var c;(c=this._iv)?(c=c.slice(0),this._iv=void 0):c=this._prevBlock;h.encryptBlock(c,0);for(h=0;h<e;h++)a[b+h]^=c[h]}var g=b.lib.BlockCipherMode.extend();g.Encryptor=g.extend({processBlock:function(b,g){var c=this._cipher,h=c.blockSize;a.call(this,b,g,h,c);this._prevBlock=b.slice(g,g+h)}});g.Decryptor=g.extend({processBlock:function(b,g){var c=this._cipher,h=c.blockSize,
f=b.slice(g,g+h);a.call(this,b,g,h,c);this._prevBlock=f}});return g}();return b.mode.CFB})},{"./cipher-core":40,"./core":41}],51:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CTRGladman=function(){function a(a){if(255===(a>>24&255)){var b=a>>16&255,c=a>>8&255;a&=255;255===b?(b=0,255===c?(c=0,255===a?a=0:++a):++c):++b;a=0+(b<<16)+(c<<8)+a}else a+=16777216;return a}var g=b.lib.BlockCipherMode.extend(),c=g.Encryptor=
g.extend({processBlock:function(b,c){var e=this._cipher,g=e.blockSize,f=this._iv,d=this._counter;f&&(d=this._counter=f.slice(0),this._iv=void 0);f=d;0===(f[0]=a(f[0]))&&(f[1]=a(f[1]));d=d.slice(0);e.encryptBlock(d,0);for(e=0;e<g;e++)b[c+e]^=d[e]}});g.Decryptor=c;return g}();return b.mode.CTRGladman})},{"./cipher-core":40,"./core":41}],52:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CTR=function(){var a=
b.lib.BlockCipherMode.extend(),g=a.Encryptor=a.extend({processBlock:function(a,b){var c=this._cipher,h=c.blockSize,g=this._iv,f=this._counter;g&&(f=this._counter=g.slice(0),this._iv=void 0);g=f.slice(0);c.encryptBlock(g,0);f[h-1]=f[h-1]+1|0;for(c=0;c<h;c++)a[b+c]^=g[c]}});a.Decryptor=g;return a}();return b.mode.CTR})},{"./cipher-core":40,"./core":41}],53:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.ECB=
function(){var a=b.lib.BlockCipherMode.extend();a.Encryptor=a.extend({processBlock:function(a,b){this._cipher.encryptBlock(a,b)}});a.Decryptor=a.extend({processBlock:function(a,b){this._cipher.decryptBlock(a,b)}});return a}();return b.mode.ECB})},{"./cipher-core":40,"./core":41}],54:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.OFB=function(){var a=b.lib.BlockCipherMode.extend(),g=a.Encryptor=a.extend({processBlock:function(a,
b){var c=this._cipher,h=c.blockSize,g=this._iv,f=this._keystream;g&&(f=this._keystream=g.slice(0),this._iv=void 0);c.encryptBlock(f,0);for(c=0;c<h;c++)a[b+c]^=f[c]}});a.Decryptor=g;return a}();return b.mode.OFB})},{"./cipher-core":40,"./core":41}],55:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.AnsiX923={pad:function(a,b){var c=a.sigBytes,g=4*b,g=g-c%g,c=c+g-1;a.clamp();a.words[c>>>2]|=g<<24-c%4*8;a.sigBytes+=
g},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};return b.pad.Ansix923})},{"./cipher-core":40,"./core":41}],56:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.Iso10126={pad:function(a,g){var c=4*g,c=c-a.sigBytes%c;a.concat(b.lib.WordArray.random(c-1)).concat(b.lib.WordArray.create([c<<24],1))},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};return b.pad.Iso10126})},{"./cipher-core":40,
"./core":41}],57:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.Iso97971={pad:function(a,g){a.concat(b.lib.WordArray.create([2147483648],1));b.pad.ZeroPadding.pad(a,g)},unpad:function(a){b.pad.ZeroPadding.unpad(a);a.sigBytes--}};return b.pad.Iso97971})},{"./cipher-core":40,"./core":41}],58:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,
function(b){b.pad.NoPadding={pad:function(){},unpad:function(){}};return b.pad.NoPadding})},{"./cipher-core":40,"./core":41}],59:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.ZeroPadding={pad:function(a,b){var c=4*b;a.clamp();a.sigBytes+=c-(a.sigBytes%c||c)},unpad:function(a){for(var b=a.words,c=a.sigBytes-1;!(b[c>>>2]>>>24-c%4*8&255);)c--;a.sigBytes=c+1}};return b.pad.ZeroPadding})},{"./cipher-core":40,"./core":41}],
60:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./sha1"),f("./hmac")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,g=a.Base,c=a.WordArray,a=b.algo,f=a.HMAC,e=a.PBKDF2=g.extend({cfg:g.extend({keySize:4,hasher:a.SHA1,iterations:1}),init:function(a){this.cfg=this.cfg.extend(a)},compute:function(a,b){for(var e=this.cfg,d=f.create(e.hasher,a),h=c.create(),g=c.create([1]),n=h.words,l=g.words,k=e.keySize,e=e.iterations;n.length<k;){var m=d.update(b).finalize(g);
d.reset();for(var q=m.words,I=q.length,G=m,K=1;K<e;K++){G=d.finalize(G);d.reset();for(var O=G.words,J=0;J<I;J++)q[J]^=O[J]}h.concat(m);l[0]++}h.sigBytes=4*k;return h}});b.PBKDF2=function(a,b,c){return e.create(c).compute(a,b)}})();return b.PBKDF2})},{"./core":41,"./hmac":46,"./sha1":65}],61:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=
this._X,b=this._C,d=0;8>d;d++)f[d]=b[d];b[0]=b[0]+1295307597+this._b|0;b[1]=b[1]+3545052371+(b[0]>>>0<f[0]>>>0?1:0)|0;b[2]=b[2]+886263092+(b[1]>>>0<f[1]>>>0?1:0)|0;b[3]=b[3]+1295307597+(b[2]>>>0<f[2]>>>0?1:0)|0;b[4]=b[4]+3545052371+(b[3]>>>0<f[3]>>>0?1:0)|0;b[5]=b[5]+886263092+(b[4]>>>0<f[4]>>>0?1:0)|0;b[6]=b[6]+1295307597+(b[5]>>>0<f[5]>>>0?1:0)|0;b[7]=b[7]+3545052371+(b[6]>>>0<f[6]>>>0?1:0)|0;this._b=b[7]>>>0<f[7]>>>0?1:0;for(d=0;8>d;d++){var c=a[d]+b[d],h=c&65535,g=c>>>16;e[d]=((h*h>>>17)+h*g>>>
15)+g*g^((c&4294901760)*c|0)+((c&65535)*c|0)}a[0]=e[0]+(e[7]<<16|e[7]>>>16)+(e[6]<<16|e[6]>>>16)|0;a[1]=e[1]+(e[0]<<8|e[0]>>>24)+e[7]|0;a[2]=e[2]+(e[1]<<16|e[1]>>>16)+(e[0]<<16|e[0]>>>16)|0;a[3]=e[3]+(e[2]<<8|e[2]>>>24)+e[1]|0;a[4]=e[4]+(e[3]<<16|e[3]>>>16)+(e[2]<<16|e[2]>>>16)|0;a[5]=e[5]+(e[4]<<8|e[4]>>>24)+e[3]|0;a[6]=e[6]+(e[5]<<16|e[5]>>>16)+(e[4]<<16|e[4]>>>16)|0;a[7]=e[7]+(e[6]<<8|e[6]>>>24)+e[5]|0}var g=b.lib.StreamCipher,c=[],f=[],e=[],h=b.algo.RabbitLegacy=g.extend({_doReset:function(){for(var b=
this._key.words,c=this.cfg.iv,d=this._X=[b[0],b[3]<<16|b[2]>>>16,b[1],b[0]<<16|b[3]>>>16,b[2],b[1]<<16|b[0]>>>16,b[3],b[2]<<16|b[1]>>>16],b=this._C=[b[2]<<16|b[2]>>>16,b[0]&4294901760|b[1]&65535,b[3]<<16|b[3]>>>16,b[1]&4294901760|b[2]&65535,b[0]<<16|b[0]>>>16,b[2]&4294901760|b[3]&65535,b[1]<<16|b[1]>>>16,b[3]&4294901760|b[0]&65535],e=this._b=0;4>e;e++)a.call(this);for(e=0;8>e;e++)b[e]^=d[e+4&7];if(c){var d=c.words,c=d[0],d=d[1],c=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360,d=(d<<8|d>>>24)&16711935|
(d<<24|d>>>8)&4278255360,e=c>>>16|d&4294901760,h=d<<16|c&65535;b[0]^=c;b[1]^=e;b[2]^=d;b[3]^=h;b[4]^=c;b[5]^=e;b[6]^=d;b[7]^=h;for(e=0;4>e;e++)a.call(this)}},_doProcessBlock:function(b,e){var d=this._X;a.call(this);c[0]=d[0]^d[5]>>>16^d[3]<<16;c[1]=d[2]^d[7]>>>16^d[5]<<16;c[2]=d[4]^d[1]>>>16^d[7]<<16;c[3]=d[6]^d[3]>>>16^d[1]<<16;for(d=0;4>d;d++)c[d]=(c[d]<<8|c[d]>>>24)&16711935|(c[d]<<24|c[d]>>>8)&4278255360,b[e+d]^=c[d]},blockSize:4,ivSize:2});b.RabbitLegacy=g._createHelper(h)})();return b.RabbitLegacy})},
{"./cipher-core":40,"./core":41,"./enc-base64":42,"./evpkdf":44,"./md5":49}],62:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=this._X,b=this._C,d=0;8>d;d++)f[d]=b[d];b[0]=b[0]+1295307597+this._b|0;b[1]=b[1]+3545052371+(b[0]>>>0<f[0]>>>0?1:0)|0;b[2]=b[2]+886263092+(b[1]>>>0<f[1]>>>0?1:0)|0;b[3]=b[3]+1295307597+(b[2]>>>0<f[2]>>>0?1:0)|0;
b[4]=b[4]+3545052371+(b[3]>>>0<f[3]>>>0?1:0)|0;b[5]=b[5]+886263092+(b[4]>>>0<f[4]>>>0?1:0)|0;b[6]=b[6]+1295307597+(b[5]>>>0<f[5]>>>0?1:0)|0;b[7]=b[7]+3545052371+(b[6]>>>0<f[6]>>>0?1:0)|0;this._b=b[7]>>>0<f[7]>>>0?1:0;for(d=0;8>d;d++){var c=a[d]+b[d],h=c&65535,g=c>>>16;e[d]=((h*h>>>17)+h*g>>>15)+g*g^((c&4294901760)*c|0)+((c&65535)*c|0)}a[0]=e[0]+(e[7]<<16|e[7]>>>16)+(e[6]<<16|e[6]>>>16)|0;a[1]=e[1]+(e[0]<<8|e[0]>>>24)+e[7]|0;a[2]=e[2]+(e[1]<<16|e[1]>>>16)+(e[0]<<16|e[0]>>>16)|0;a[3]=e[3]+(e[2]<<8|
e[2]>>>24)+e[1]|0;a[4]=e[4]+(e[3]<<16|e[3]>>>16)+(e[2]<<16|e[2]>>>16)|0;a[5]=e[5]+(e[4]<<8|e[4]>>>24)+e[3]|0;a[6]=e[6]+(e[5]<<16|e[5]>>>16)+(e[4]<<16|e[4]>>>16)|0;a[7]=e[7]+(e[6]<<8|e[6]>>>24)+e[5]|0}var g=b.lib.StreamCipher,c=[],f=[],e=[],h=b.algo.Rabbit=g.extend({_doReset:function(){for(var b=this._key.words,c=this.cfg.iv,d=0;4>d;d++)b[d]=(b[d]<<8|b[d]>>>24)&16711935|(b[d]<<24|b[d]>>>8)&4278255360;for(var e=this._X=[b[0],b[3]<<16|b[2]>>>16,b[1],b[0]<<16|b[3]>>>16,b[2],b[1]<<16|b[0]>>>16,b[3],b[2]<<
16|b[1]>>>16],b=this._C=[b[2]<<16|b[2]>>>16,b[0]&4294901760|b[1]&65535,b[3]<<16|b[3]>>>16,b[1]&4294901760|b[2]&65535,b[0]<<16|b[0]>>>16,b[2]&4294901760|b[3]&65535,b[1]<<16|b[1]>>>16,b[3]&4294901760|b[0]&65535],d=this._b=0;4>d;d++)a.call(this);for(d=0;8>d;d++)b[d]^=e[d+4&7];if(c){var d=c.words,c=d[0],d=d[1],c=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360,d=(d<<8|d>>>24)&16711935|(d<<24|d>>>8)&4278255360,e=c>>>16|d&4294901760,h=d<<16|c&65535;b[0]^=c;b[1]^=e;b[2]^=d;b[3]^=h;b[4]^=c;b[5]^=e;b[6]^=d;
b[7]^=h;for(d=0;4>d;d++)a.call(this)}},_doProcessBlock:function(b,e){var d=this._X;a.call(this);c[0]=d[0]^d[5]>>>16^d[3]<<16;c[1]=d[2]^d[7]>>>16^d[5]<<16;c[2]=d[4]^d[1]>>>16^d[7]<<16;c[3]=d[6]^d[3]>>>16^d[1]<<16;for(d=0;4>d;d++)c[d]=(c[d]<<8|c[d]>>>24)&16711935|(c[d]<<24|c[d]>>>8)&4278255360,b[e+d]^=c[d]},blockSize:4,ivSize:2});b.Rabbit=g._createHelper(h)})();return b.Rabbit})},{"./cipher-core":40,"./core":41,"./enc-base64":42,"./evpkdf":44,"./md5":49}],63:[function(f,m,k){(function(b,a,g){"object"===
typeof k?m.exports=k=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=this._S,b=this._i,c=this._j,g=0,d=0;4>d;d++){var b=(b+1)%256,c=(c+a[b])%256,f=a[b];a[b]=a[c];a[c]=f;g|=a[(a[b]+a[c])%256]<<24-8*d}this._i=b;this._j=c;return g}var g=b.lib.StreamCipher,c=b.algo,f=c.RC4=g.extend({_doReset:function(){for(var a=this._key,b=a.words,a=a.sigBytes,c=this._S=[],g=0;256>g;g++)c[g]=g;for(var d=g=0;256>g;g++){var f=
g%a,d=(d+c[g]+(b[f>>>2]>>>24-f%4*8&255))%256,f=c[g];c[g]=c[d];c[d]=f}this._i=this._j=0},_doProcessBlock:function(b,c){b[c]^=a.call(this)},keySize:8,ivSize:0});b.RC4=g._createHelper(f);c=c.RC4Drop=f.extend({cfg:f.cfg.extend({drop:192}),_doReset:function(){f._doReset.call(this);for(var b=this.cfg.drop;0<b;b--)a.call(this)}});b.RC4Drop=g._createHelper(c)})();return b.RC4})},{"./cipher-core":40,"./core":41,"./enc-base64":42,"./evpkdf":44,"./md5":49}],64:[function(f,m,k){(function(b,a){"object"===typeof k?
m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){function g(a,b){return a<<b|a>>>32-b}a=b.lib;var c=a.WordArray,f=a.Hasher;a=b.algo;var e=c.create([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,7,4,13,1,10,6,15,3,12,0,9,5,2,14,11,8,3,10,14,4,9,15,8,1,2,7,0,6,13,11,5,12,1,9,11,10,0,8,12,4,13,3,7,15,14,5,6,2,4,0,5,9,7,12,2,10,14,1,3,8,11,6,15,13]),h=c.create([5,14,7,0,9,2,11,4,13,6,15,8,1,10,3,12,6,11,3,7,0,13,5,10,14,15,8,12,4,9,1,2,15,5,1,3,7,14,6,9,11,8,12,2,10,0,4,13,8,6,4,1,3,11,
15,0,5,12,2,13,9,7,10,14,12,15,10,4,1,5,8,7,6,2,13,14,0,3,9,11]),n=c.create([11,14,15,12,5,8,7,9,11,13,14,15,6,7,9,8,7,6,8,13,11,9,7,15,7,12,15,9,11,7,13,12,11,13,6,7,14,9,13,15,14,8,13,6,5,12,7,5,11,12,14,15,14,15,9,8,9,14,5,6,8,6,5,12,9,15,5,11,6,8,13,12,5,12,13,14,11,8,5,6]),k=c.create([8,9,9,11,13,15,15,5,7,7,8,11,14,14,12,6,9,13,15,7,12,8,9,11,7,7,12,7,6,15,13,11,9,7,15,11,8,6,6,14,12,13,5,14,13,13,7,5,15,5,8,11,14,14,6,14,6,9,12,9,12,5,15,8,8,5,12,9,12,5,14,6,8,13,6,5,15,13,11,11]),d=c.create([0,
1518500249,1859775393,2400959708,2840853838]),r=c.create([1352829926,1548603684,1836072691,2053994217,0]);a=a.RIPEMD160=f.extend({_doReset:function(){this._hash=c.create([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(a,b){for(var c=0;16>c;c++){var f=b+c,l=a[f];a[f]=(l<<8|l>>>24)&16711935|(l<<24|l>>>8)&4278255360}var f=this._hash.words,l=d.words,q=r.words,m=e.words,w=h.words,K=n.words,B=k.words,J,F,L,N,x;var U=J=f[0];var M=F=f[1];var u=L=f[2];var p=N=f[3];var t=
x=f[4];for(var z,c=0;80>c;c+=1)z=J+a[b+m[c]]|0,z=16>c?z+((F^L^N)+l[0]):32>c?z+((F&L|~F&N)+l[1]):48>c?z+(((F|~L)^N)+l[2]):64>c?z+((F&N|L&~N)+l[3]):z+((F^(L|~N))+l[4]),z|=0,z=g(z,K[c]),z=z+x|0,J=x,x=N,N=g(L,10),L=F,F=z,z=U+a[b+w[c]]|0,z=16>c?z+((M^(u|~p))+q[0]):32>c?z+((M&p|u&~p)+q[1]):48>c?z+(((M|~u)^p)+q[2]):64>c?z+((M&u|~M&p)+q[3]):z+((M^u^p)+q[4]),z|=0,z=g(z,B[c]),z=z+t|0,U=t,t=p,p=g(u,10),u=M,M=z;z=f[1]+L+p|0;f[1]=f[2]+N+t|0;f[2]=f[3]+x+U|0;f[3]=f[4]+J+M|0;f[4]=f[0]+F+u|0;f[0]=z},_doFinalize:function(){var a=
this._data,b=a.words,d=8*this._nDataBytes,c=8*a.sigBytes;b[c>>>5]|=128<<24-c%32;b[(c+64>>>9<<4)+14]=(d<<8|d>>>24)&16711935|(d<<24|d>>>8)&4278255360;a.sigBytes=4*(b.length+1);this._process();a=this._hash;b=a.words;for(d=0;5>d;d++)c=b[d],b[d]=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360;return a},clone:function(){var a=f.clone.call(this);a._hash=this._hash.clone();return a}});b.RIPEMD160=f._createHelper(a);b.HmacRIPEMD160=f._createHmacHelper(a)})(Math);return b.RIPEMD160})},{"./core":41}],65:[function(f,
m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,g=a.WordArray,c=a.Hasher,f=[],a=b.algo.SHA1=c.extend({_doReset:function(){this._hash=new g.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(a,b){for(var c=this._hash.words,e=c[0],d=c[1],h=c[2],g=c[3],l=c[4],k=0;80>k;k++){if(16>k)f[k]=a[b+k]|0;else{var m=f[k-3]^f[k-8]^f[k-14]^f[k-16];f[k]=m<<1|m>>>31}m=(e<<5|e>>>27)+l+f[k];m=20>k?m+((d&h|
~d&g)+1518500249):40>k?m+((d^h^g)+1859775393):60>k?m+((d&h|d&g|h&g)-1894007588):m+((d^h^g)-899497514);l=g;g=h;h=d<<30|d>>>2;d=e;e=m}c[0]=c[0]+e|0;c[1]=c[1]+d|0;c[2]=c[2]+h|0;c[3]=c[3]+g|0;c[4]=c[4]+l|0},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,g=8*a.sigBytes;b[g>>>5]|=128<<24-g%32;b[(g+64>>>9<<4)+14]=Math.floor(c/4294967296);b[(g+64>>>9<<4)+15]=c;a.sigBytes=4*b.length;this._process();return this._hash},clone:function(){var a=c.clone.call(this);a._hash=this._hash.clone();
return a}});b.SHA1=c._createHelper(a);b.HmacSHA1=c._createHmacHelper(a)})();return b.SHA1})},{"./core":41}],66:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./sha256")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib.WordArray,g=b.algo,c=g.SHA256,g=g.SHA224=c.extend({_doReset:function(){this._hash=new a.init([3238371032,914150663,812702999,4144912697,4290775857,1750603025,1694076839,3204075428])},_doFinalize:function(){var a=c._doFinalize.call(this);a.sigBytes-=
4;return a}});b.SHA224=c._createHelper(g);b.HmacSHA224=c._createHmacHelper(g)})();return b.SHA224})},{"./core":41,"./sha256":67}],67:[function(f,m,k){(function(b,a){"object"===typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){var g=b.lib,c=g.WordArray,f=g.Hasher,g=b.algo,e=[],h=[];(function(){function b(b){for(var d=a.sqrt(b),c=2;c<=d;c++)if(!(b%c))return!1;return!0}function d(a){return 4294967296*(a-(a|0))|0}for(var c=2,g=0;64>g;)b(c)&&(8>g&&(e[g]=d(a.pow(c,.5))),
h[g]=d(a.pow(c,1/3)),g++),c++})();var n=[],g=g.SHA256=f.extend({_doReset:function(){this._hash=new c.init(e.slice(0))},_doProcessBlock:function(a,b){for(var d=this._hash.words,c=d[0],e=d[1],g=d[2],f=d[3],k=d[4],l=d[5],m=d[6],w=d[7],K=0;64>K;K++){if(16>K)n[K]=a[b+K]|0;else{var O=n[K-15],J=n[K-2];n[K]=((O<<25|O>>>7)^(O<<14|O>>>18)^O>>>3)+n[K-7]+((J<<15|J>>>17)^(J<<13|J>>>19)^J>>>10)+n[K-16]}O=w+((k<<26|k>>>6)^(k<<21|k>>>11)^(k<<7|k>>>25))+(k&l^~k&m)+h[K]+n[K];J=((c<<30|c>>>2)^(c<<19|c>>>13)^(c<<10|
c>>>22))+(c&e^c&g^e&g);w=m;m=l;l=k;k=f+O|0;f=g;g=e;e=c;c=O+J|0}d[0]=d[0]+c|0;d[1]=d[1]+e|0;d[2]=d[2]+g|0;d[3]=d[3]+f|0;d[4]=d[4]+k|0;d[5]=d[5]+l|0;d[6]=d[6]+m|0;d[7]=d[7]+w|0},_doFinalize:function(){var b=this._data,d=b.words,c=8*this._nDataBytes,e=8*b.sigBytes;d[e>>>5]|=128<<24-e%32;d[(e+64>>>9<<4)+14]=a.floor(c/4294967296);d[(e+64>>>9<<4)+15]=c;b.sigBytes=4*d.length;this._process();return this._hash},clone:function(){var a=f.clone.call(this);a._hash=this._hash.clone();return a}});b.SHA256=f._createHelper(g);
b.HmacSHA256=f._createHmacHelper(g)})(Math);return b.SHA256})},{"./core":41}],68:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./x64-core")):a(b.CryptoJS)})(this,function(b){(function(a){var g=b.lib,c=g.WordArray,f=g.Hasher,e=b.x64.Word,g=b.algo,h=[],k=[],m=[];(function(){for(var a=1,b=0,d=0;24>d;d++){h[a+5*b]=(d+1)*(d+2)/2%64;var c=(2*a+3*b)%5,a=b%5,b=c}for(a=0;5>a;a++)for(b=0;5>b;b++)k[a+5*b]=b+(2*a+3*b)%5*5;a=1;for(b=0;24>b;b++){for(var g=c=d=0;7>g;g++){if(a&
1){var f=(1<<g)-1;32>f?c^=1<<f:d^=1<<f-32}a=a&128?a<<1^113:a<<1}m[b]=e.create(d,c)}})();var d=[];(function(){for(var a=0;25>a;a++)d[a]=e.create()})();g=g.SHA3=f.extend({cfg:f.cfg.extend({outputLength:512}),_doReset:function(){for(var a=this._state=[],b=0;25>b;b++)a[b]=new e.init;this.blockSize=(1600-2*this.cfg.outputLength)/32},_doProcessBlock:function(a,b){var c,e,g,f=this._state,n=this.blockSize/2;for(c=0;c<n;c++){var l=a[b+2*c];var r=a[b+2*c+1];l=(l<<8|l>>>24)&16711935|(l<<24|l>>>8)&4278255360;
r=(r<<8|r>>>24)&16711935|(r<<24|r>>>8)&4278255360;var w=f[c];w.high^=r;w.low^=l}for(n=0;24>n;n++){for(l=0;5>l;l++){for(e=g=c=0;5>e;e++)w=f[l+5*e],c^=w.high,g^=w.low;w=d[l];w.high=c;w.low=g}for(l=0;5>l;l++)for(r=d[(l+4)%5],c=d[(l+1)%5],w=c.high,e=c.low,c=r.high^(w<<1|e>>>31),g=r.low^(e<<1|w>>>31),e=0;5>e;e++)w=f[l+5*e],w.high^=c,w.low^=g;for(r=1;25>r;r++)w=f[r],l=w.high,e=w.low,w=h[r],32>w?(c=l<<w|e>>>32-w,g=e<<w|l>>>32-w):(c=e<<w-32|l>>>64-w,g=l<<w-32|e>>>64-w),w=d[k[r]],w.high=c,w.low=g;w=d[0];c=
f[0];w.high=c.high;w.low=c.low;for(l=0;5>l;l++)for(e=0;5>e;e++)r=l+5*e,w=f[r],c=d[r],r=d[(l+1)%5+5*e],g=d[(l+2)%5+5*e],w.high=c.high^~r.high&g.high,w.low=c.low^~r.low&g.low;w=f[0];c=m[n];w.high^=c.high;w.low^=c.low}},_doFinalize:function(){var b=this._data,d=b.words,e=8*b.sigBytes,h=32*this.blockSize;d[e>>>5]|=1<<24-e%32;d[(a.ceil((e+1)/h)*h>>>5)-1]|=128;b.sigBytes=4*d.length;this._process();for(var b=this._state,d=this.cfg.outputLength/8,e=d/8,h=[],g=0;g<e;g++){var f=b[g],l=f.high,f=f.low,l=(l<<
8|l>>>24)&16711935|(l<<24|l>>>8)&4278255360,f=(f<<8|f>>>24)&16711935|(f<<24|f>>>8)&4278255360;h.push(f);h.push(l)}return new c.init(h,d)},clone:function(){for(var a=f.clone.call(this),b=a._state=this._state.slice(0),d=0;25>d;d++)b[d]=b[d].clone();return a}});b.SHA3=f._createHelper(g);b.HmacSHA3=f._createHmacHelper(g)})(Math);return b.SHA3})},{"./core":41,"./x64-core":72}],69:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./x64-core"),f("./sha512")):a(b.CryptoJS)})(this,
function(b){(function(){var a=b.x64,g=a.Word,c=a.WordArray,a=b.algo,f=a.SHA512,a=a.SHA384=f.extend({_doReset:function(){this._hash=new c.init([new g.init(3418070365,3238371032),new g.init(1654270250,914150663),new g.init(2438529370,812702999),new g.init(355462360,4144912697),new g.init(1731405415,4290775857),new g.init(2394180231,1750603025),new g.init(3675008525,1694076839),new g.init(1203062813,3204075428)])},_doFinalize:function(){var a=f._doFinalize.call(this);a.sigBytes-=16;return a}});b.SHA384=
f._createHelper(a);b.HmacSHA384=f._createHmacHelper(a)})();return b.SHA384})},{"./core":41,"./sha512":70,"./x64-core":72}],70:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./x64-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){return f.create.apply(f,arguments)}var g=b.lib.Hasher,c=b.x64,f=c.Word,e=c.WordArray,c=b.algo,h=[a(1116352408,3609767458),a(1899447441,602891725),a(3049323471,3964484399),a(3921009573,2173295548),a(961987163,4081628472),
a(1508970993,3053834265),a(2453635748,2937671579),a(2870763221,3664609560),a(3624381080,2734883394),a(310598401,1164996542),a(607225278,1323610764),a(1426881987,3590304994),a(1925078388,4068182383),a(2162078206,991336113),a(2614888103,633803317),a(3248222580,3479774868),a(3835390401,2666613458),a(4022224774,944711139),a(264347078,2341262773),a(604807628,2007800933),a(770255983,1495990901),a(1249150122,1856431235),a(1555081692,3175218132),a(1996064986,2198950837),a(2554220882,3999719339),a(2821834349,
766784016),a(2952996808,2566594879),a(3210313671,3203337956),a(3336571891,1034457026),a(3584528711,2466948901),a(113926993,3758326383),a(338241895,168717936),a(666307205,1188179964),a(773529912,1546045734),a(1294757372,1522805485),a(1396182291,2643833823),a(1695183700,2343527390),a(1986661051,1014477480),a(2177026350,1206759142),a(2456956037,344077627),a(2730485921,1290863460),a(2820302411,3158454273),a(3259730800,3505952657),a(3345764771,106217008),a(3516065817,3606008344),a(3600352804,1432725776),
a(4094571909,1467031594),a(275423344,851169720),a(430227734,3100823752),a(506948616,1363258195),a(659060556,3750685593),a(883997877,3785050280),a(958139571,3318307427),a(1322822218,3812723403),a(1537002063,2003034995),a(1747873779,3602036899),a(1955562222,1575990012),a(2024104815,1125592928),a(2227730452,2716904306),a(2361852424,442776044),a(2428436474,593698344),a(2756734187,3733110249),a(3204031479,2999351573),a(3329325298,3815920427),a(3391569614,3928383900),a(3515267271,566280711),a(3940187606,
3454069534),a(4118630271,4000239992),a(116418474,1914138554),a(174292421,2731055270),a(289380356,3203993006),a(460393269,320620315),a(685471733,587496836),a(852142971,1086792851),a(1017036298,365543100),a(1126000580,2618297676),a(1288033470,3409855158),a(1501505948,4234509866),a(1607167915,987167468),a(1816402316,1246189591)],k=[];(function(){for(var b=0;80>b;b++)k[b]=a()})();c=c.SHA512=g.extend({_doReset:function(){this._hash=new e.init([new f.init(1779033703,4089235720),new f.init(3144134277,2227873595),
new f.init(1013904242,4271175723),new f.init(2773480762,1595750129),new f.init(1359893119,2917565137),new f.init(2600822924,725511199),new f.init(528734635,4215389547),new f.init(1541459225,327033209)])},_doProcessBlock:function(a,b){for(var d,c,e,g,f,l,n,m,w,K=this._hash.words,O=K[0],J=K[1],D=K[2],L=K[3],N=K[4],x=K[5],U=K[6],K=K[7],M=O.high,u=O.low,p=J.high,t=J.low,z=D.high,v=D.low,ca=L.high,T=L.low,S=N.high,Z=N.low,ha=x.high,W=x.low,ba=U.high,R=U.low,P=K.high,fa=K.low,Y=M,ga=u,E=p,ja=t,na=z,X=v,
ka=ca,V=T,da=S,ia=Z,ta=ha,qa=W,ra=ba,sa=R,oa=P,pa=fa,la=0;80>la;la++){w=k[la];16>la?(c=w.high=a[b+2*la]|0,g=w.low=a[b+2*la+1]|0):(c=k[la-15],g=c.high,d=c.low,c=(g>>>1|d<<31)^(g>>>8|d<<24)^g>>>7,m=(d>>>1|g<<31)^(d>>>8|g<<24)^(d>>>7|g<<25),d=k[la-2],g=d.high,f=d.low,d=(g>>>19|f<<13)^(g<<3|f>>>29)^g>>>6,f=(f>>>19|g<<13)^(f<<3|g>>>29)^(f>>>6|g<<26),g=k[la-7],n=g.high,g=g.low,e=k[la-16],l=e.high,e=e.low,g=m+g,c=c+n+(g>>>0<m>>>0?1:0),g+=f,c=c+d+(g>>>0<f>>>0?1:0),g+=e,c=c+l+(g>>>0<e>>>0?1:0),w.high=c,w.low=
g);n=da&ta^~da&ra;e=ia&qa^~ia&sa;w=Y&E^Y&na^E&na;var ua=ga&ja^ga&X^ja&X;d=(Y>>>28|ga<<4)^(Y<<30|ga>>>2)^(Y<<25|ga>>>7);m=(ga>>>28|Y<<4)^(ga<<30|Y>>>2)^(ga<<25|Y>>>7);f=h[la];var H=f.high,ea=f.low;f=pa+((ia>>>14|da<<18)^(ia>>>18|da<<14)^(ia<<23|da>>>9));l=oa+((da>>>14|ia<<18)^(da>>>18|ia<<14)^(da<<23|ia>>>9))+(f>>>0<pa>>>0?1:0);f+=e;l=l+n+(f>>>0<e>>>0?1:0);f+=ea;l=l+H+(f>>>0<ea>>>0?1:0);f+=g;l=l+c+(f>>>0<g>>>0?1:0);g=m+ua;w=d+w+(g>>>0<m>>>0?1:0);oa=ra;pa=sa;ra=ta;sa=qa;ta=da;qa=ia;ia=V+f|0;da=ka+l+
(ia>>>0<V>>>0?1:0)|0;ka=na;V=X;na=E;X=ja;E=Y;ja=ga;ga=f+g|0;Y=l+w+(ga>>>0<f>>>0?1:0)|0}u=O.low=u+ga;O.high=M+Y+(u>>>0<ga>>>0?1:0);t=J.low=t+ja;J.high=p+E+(t>>>0<ja>>>0?1:0);v=D.low=v+X;D.high=z+na+(v>>>0<X>>>0?1:0);T=L.low=T+V;L.high=ca+ka+(T>>>0<V>>>0?1:0);Z=N.low=Z+ia;N.high=S+da+(Z>>>0<ia>>>0?1:0);W=x.low=W+qa;x.high=ha+ta+(W>>>0<qa>>>0?1:0);R=U.low=R+sa;U.high=ba+ra+(R>>>0<sa>>>0?1:0);fa=K.low=fa+pa;K.high=P+oa+(fa>>>0<pa>>>0?1:0)},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,
e=8*a.sigBytes;b[e>>>5]|=128<<24-e%32;b[(e+128>>>10<<5)+30]=Math.floor(c/4294967296);b[(e+128>>>10<<5)+31]=c;a.sigBytes=4*b.length;this._process();return this._hash.toX32()},clone:function(){var a=g.clone.call(this);a._hash=this._hash.clone();return a},blockSize:32});b.SHA512=g._createHelper(c);b.HmacSHA512=g._createHmacHelper(c)})();return b.SHA512})},{"./core":41,"./x64-core":72}],71:[function(f,m,k){(function(b,a,g){"object"===typeof k?m.exports=k=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),
f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(a,b){var d=(this._lBlock>>>a^this._rBlock)&b;this._rBlock^=d;this._lBlock^=d<<a}function g(a,b){var d=(this._rBlock>>>a^this._lBlock)&b;this._lBlock^=d;this._rBlock^=d<<a}var c=b.lib,f=c.WordArray,c=c.BlockCipher,e=b.algo,h=[57,49,41,33,25,17,9,1,58,50,42,34,26,18,10,2,59,51,43,35,27,19,11,3,60,52,44,36,63,55,47,39,31,23,15,7,62,54,46,38,30,22,14,6,61,53,45,37,29,21,13,5,28,20,12,4],k=[14,17,11,24,1,5,3,28,15,6,21,10,23,19,
12,4,26,8,16,7,27,20,13,2,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32],m=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],d=[{0:8421888,268435456:32768,536870912:8421378,805306368:2,1073741824:512,1342177280:8421890,1610612736:8389122,1879048192:8388608,2147483648:514,2415919104:8389120,2684354560:33280,2952790016:8421376,3221225472:32770,3489660928:8388610,3758096384:0,4026531840:33282,134217728:0,402653184:8421890,671088640:33282,939524096:32768,1207959552:8421888,1476395008:512,
1744830464:8421378,2013265920:2,2281701376:8389120,2550136832:33280,2818572288:8421376,3087007744:8389122,3355443200:8388610,3623878656:32770,3892314112:514,4160749568:8388608,1:32768,268435457:2,536870913:8421888,805306369:8388608,1073741825:8421378,1342177281:33280,1610612737:512,1879048193:8389122,2147483649:8421890,2415919105:8421376,2684354561:8388610,2952790017:33282,3221225473:514,3489660929:8389120,3758096385:32770,4026531841:0,134217729:8421890,402653185:8421376,671088641:8388608,939524097:512,
1207959553:32768,1476395009:8388610,1744830465:2,2013265921:33282,2281701377:32770,2550136833:8389122,2818572289:514,3087007745:8421888,3355443201:8389120,3623878657:0,3892314113:33280,4160749569:8421378},{0:1074282512,16777216:16384,33554432:524288,50331648:1074266128,67108864:1073741840,83886080:1074282496,100663296:1073758208,117440512:16,134217728:540672,150994944:1073758224,167772160:1073741824,184549376:540688,201326592:524304,218103808:0,234881024:16400,251658240:1074266112,8388608:1073758208,
25165824:540688,41943040:16,58720256:1073758224,75497472:1074282512,92274688:1073741824,109051904:524288,125829120:1074266128,142606336:524304,159383552:0,176160768:16384,192937984:1074266112,209715200:1073741840,226492416:540672,243269632:1074282496,260046848:16400,268435456:0,285212672:1074266128,301989888:1073758224,318767104:1074282496,335544320:1074266112,352321536:16,369098752:540688,385875968:16384,402653184:16400,419430400:524288,436207616:524304,452984832:1073741840,469762048:540672,486539264:1073758208,
503316480:1073741824,520093696:1074282512,276824064:540688,293601280:524288,310378496:1074266112,327155712:16384,343932928:1073758208,360710144:1074282512,377487360:16,394264576:1073741824,411041792:1074282496,427819008:1073741840,444596224:1073758224,461373440:524304,478150656:0,494927872:16400,511705088:1074266128,528482304:540672},{0:260,1048576:0,2097152:67109120,3145728:65796,4194304:65540,5242880:67108868,6291456:67174660,7340032:67174400,8388608:67108864,9437184:67174656,10485760:65792,11534336:67174404,
12582912:67109124,13631488:65536,14680064:4,15728640:256,524288:67174656,1572864:67174404,2621440:0,3670016:67109120,4718592:67108868,5767168:65536,6815744:65540,7864320:260,8912896:4,9961472:256,11010048:67174400,12058624:65796,13107200:65792,14155776:67109124,15204352:67174660,16252928:67108864,16777216:67174656,17825792:65540,18874368:65536,19922944:67109120,20971520:256,22020096:67174660,23068672:67108868,24117248:0,25165824:67109124,26214400:67108864,27262976:4,28311552:65792,29360128:67174400,
30408704:260,31457280:65796,32505856:67174404,17301504:67108864,18350080:260,19398656:67174656,20447232:0,21495808:65540,22544384:67109120,23592960:256,24641536:67174404,25690112:65536,26738688:67174660,27787264:65796,28835840:67108868,29884416:67109124,30932992:67174400,31981568:4,33030144:65792},{0:2151682048,65536:2147487808,131072:4198464,196608:2151677952,262144:0,327680:4198400,393216:2147483712,458752:4194368,524288:2147483648,589824:4194304,655360:64,720896:2147487744,786432:2151678016,851968:4160,
917504:4096,983040:2151682112,32768:2147487808,98304:64,163840:2151678016,229376:2147487744,294912:4198400,360448:2151682112,425984:0,491520:2151677952,557056:4096,622592:2151682048,688128:4194304,753664:4160,819200:2147483648,884736:4194368,950272:4198464,1015808:2147483712,1048576:4194368,1114112:4198400,1179648:2147483712,1245184:0,1310720:4160,1376256:2151678016,1441792:2151682048,1507328:2147487808,1572864:2151682112,1638400:2147483648,1703936:2151677952,1769472:4198464,1835008:2147487744,1900544:4194304,
1966080:64,2031616:4096,1081344:2151677952,1146880:2151682112,1212416:0,1277952:4198400,1343488:4194368,1409024:2147483648,1474560:2147487808,1540096:64,1605632:2147483712,1671168:4096,1736704:2147487744,1802240:2151678016,1867776:4160,1933312:2151682048,1998848:4194304,2064384:4198464},{0:128,4096:17039360,8192:262144,12288:536870912,16384:537133184,20480:16777344,24576:553648256,28672:262272,32768:16777216,36864:537133056,40960:536871040,45056:553910400,49152:553910272,53248:0,57344:17039488,61440:553648128,
2048:17039488,6144:553648256,10240:128,14336:17039360,18432:262144,22528:537133184,26624:553910272,30720:536870912,34816:537133056,38912:0,43008:553910400,47104:16777344,51200:536871040,55296:553648128,59392:16777216,63488:262272,65536:262144,69632:128,73728:536870912,77824:553648256,81920:16777344,86016:553910272,90112:537133184,94208:16777216,98304:553910400,102400:553648128,106496:17039360,110592:537133056,114688:262272,118784:536871040,122880:0,126976:17039488,67584:553648256,71680:16777216,75776:17039360,
79872:537133184,83968:536870912,88064:17039488,92160:128,96256:553910272,100352:262272,104448:553910400,108544:0,112640:553648128,116736:16777344,120832:262144,124928:537133056,129024:536871040},{0:268435464,256:8192,512:270532608,768:270540808,1024:268443648,1280:2097152,1536:2097160,1792:268435456,2048:0,2304:268443656,2560:2105344,2816:8,3072:270532616,3328:2105352,3584:8200,3840:270540800,128:270532608,384:270540808,640:8,896:2097152,1152:2105352,1408:268435464,1664:268443648,1920:8200,2176:2097160,
2432:8192,2688:268443656,2944:270532616,3200:0,3456:270540800,3712:2105344,3968:268435456,4096:268443648,4352:270532616,4608:270540808,4864:8200,5120:2097152,5376:268435456,5632:268435464,5888:2105344,6144:2105352,6400:0,6656:8,6912:270532608,7168:8192,7424:268443656,7680:270540800,7936:2097160,4224:8,4480:2105344,4736:2097152,4992:268435464,5248:268443648,5504:8200,5760:270540808,6016:270532608,6272:270540800,6528:270532616,6784:8192,7040:2105352,7296:2097160,7552:0,7808:268435456,8064:268443656},
{0:1048576,16:33555457,32:1024,48:1049601,64:34604033,80:0,96:1,112:34603009,128:33555456,144:1048577,160:33554433,176:34604032,192:34603008,208:1025,224:1049600,240:33554432,8:34603009,24:0,40:33555457,56:34604032,72:1048576,88:33554433,104:33554432,120:1025,136:1049601,152:33555456,168:34603008,184:1048577,200:1024,216:34604033,232:1,248:1049600,256:33554432,272:1048576,288:33555457,304:34603009,320:1048577,336:33555456,352:34604032,368:1049601,384:1025,400:34604033,416:1049600,432:1,448:0,464:34603008,
480:33554433,496:1024,264:1049600,280:33555457,296:34603009,312:1,328:33554432,344:1048576,360:1025,376:34604032,392:33554433,408:34603008,424:0,440:34604033,456:1049601,472:1024,488:33555456,504:1048577},{0:134219808,1:131072,2:134217728,3:32,4:131104,5:134350880,6:134350848,7:2048,8:134348800,9:134219776,10:133120,11:134348832,12:2080,13:0,14:134217760,15:133152,2147483648:2048,2147483649:134350880,2147483650:134219808,2147483651:134217728,2147483652:134348800,2147483653:133120,2147483654:133152,
2147483655:32,2147483656:134217760,2147483657:2080,2147483658:131104,2147483659:134350848,2147483660:0,2147483661:134348832,2147483662:134219776,2147483663:131072,16:133152,17:134350848,18:32,19:2048,20:134219776,21:134217760,22:134348832,23:131072,24:0,25:131104,26:134348800,27:134219808,28:134350880,29:133120,30:2080,31:134217728,2147483664:131072,2147483665:2048,2147483666:134348832,2147483667:133152,2147483668:32,2147483669:134348800,2147483670:134217728,2147483671:134219808,2147483672:134350880,
2147483673:134217760,2147483674:134219776,2147483675:0,2147483676:133120,2147483677:2080,2147483678:131104,2147483679:134350848}],r=[4160749569,528482304,33030144,2064384,129024,8064,504,2147483679],B=e.DES=c.extend({_doReset:function(){for(var a=this._key.words,b=[],d=0;56>d;d++){var c=h[d]-1;b[d]=a[c>>>5]>>>31-c%32&1}a=this._subKeys=[];for(c=0;16>c;c++){for(var e=a[c]=[],g=m[c],d=0;24>d;d++)e[d/6|0]|=b[(k[d]-1+g)%28]<<31-d%6,e[4+(d/6|0)]|=b[28+(k[d+24]-1+g)%28]<<31-d%6;e[0]=e[0]<<1|e[0]>>>31;for(d=
1;7>d;d++)e[d]>>>=4*(d-1)+3;e[7]=e[7]<<5|e[7]>>>27}b=this._invSubKeys=[];for(d=0;16>d;d++)b[d]=a[15-d]},encryptBlock:function(a,b){this._doCryptBlock(a,b,this._subKeys)},decryptBlock:function(a,b){this._doCryptBlock(a,b,this._invSubKeys)},_doCryptBlock:function(b,c,e){this._lBlock=b[c];this._rBlock=b[c+1];a.call(this,4,252645135);a.call(this,16,65535);g.call(this,2,858993459);g.call(this,8,16711935);a.call(this,1,1431655765);for(var h=0;16>h;h++){for(var f=e[h],k=this._lBlock,l=this._rBlock,n=0,m=
0;8>m;m++)n|=d[m][((l^f[m])&r[m])>>>0];this._lBlock=l;this._rBlock=k^n}e=this._lBlock;this._lBlock=this._rBlock;this._rBlock=e;a.call(this,1,1431655765);g.call(this,8,16711935);g.call(this,2,858993459);a.call(this,16,65535);a.call(this,4,252645135);b[c]=this._lBlock;b[c+1]=this._rBlock},keySize:2,ivSize:2,blockSize:2});b.DES=c._createHelper(B);e=e.TripleDES=c.extend({_doReset:function(){var a=this._key.words;this._des1=B.createEncryptor(f.create(a.slice(0,2)));this._des2=B.createEncryptor(f.create(a.slice(2,
4)));this._des3=B.createEncryptor(f.create(a.slice(4,6)))},encryptBlock:function(a,b){this._des1.encryptBlock(a,b);this._des2.decryptBlock(a,b);this._des3.encryptBlock(a,b)},decryptBlock:function(a,b){this._des3.decryptBlock(a,b);this._des2.encryptBlock(a,b);this._des1.decryptBlock(a,b)},keySize:6,ivSize:2,blockSize:2});b.TripleDES=c._createHelper(e)})();return b.TripleDES})},{"./cipher-core":40,"./core":41,"./enc-base64":42,"./evpkdf":44,"./md5":49}],72:[function(f,m,k){(function(b,a){"object"===
typeof k?m.exports=k=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){var g=b.lib,c=g.Base,f=g.WordArray,g=b.x64={};g.Word=c.extend({init:function(a,b){this.high=a;this.low=b}});g.WordArray=c.extend({init:function(b,c){b=this.words=b||[];this.sigBytes=c!=a?c:8*b.length},toX32:function(){for(var a=this.words,b=a.length,c=[],g=0;g<b;g++){var d=a[g];c.push(d.high);c.push(d.low)}return f.create(c,this.sigBytes)},clone:function(){for(var a=c.clone.call(this),b=a.words=this.words.slice(0),g=
b.length,f=0;f<g;f++)b[f]=b[f].clone();return a}})})();return b})},{"./core":41}],73:[function(f,m,k){function b(){if(!(this instanceof b))return new b}(function(a){function b(a){for(var b in e)a[b]=e[b];return a}function c(a,b){function e(a){return a!==b&&a.originalListener!==b}var d;if(arguments.length)if(b){if(d=f(this,a,!0)){d=d.filter(e);if(!d.length)return c.call(this,a);this.listeners[a]=d}}else{if(d=this.listeners)if(delete d[a],!Object.keys(d).length)return c.call(this)}else delete this.listeners;
return this}function f(a,b,c){if(!c||a.listeners)return a=a.listeners||(a.listeners={}),a[b]||(a[b]=[])}"undefined"!==typeof m&&(m.exports=a);var e={on:function(a,b){f(this,a).push(b);return this},once:function(a,b){function e(){c.call(d,a,e);b.apply(this,arguments)}var d=this;e.originalListener=b;f(d,a).push(e);return d},off:c,emit:function(a,b){function c(a){a.call(g)}function d(a){a.call(g,b)}function e(a){a.apply(g,l)}var g=this,h=f(g,a,!0);if(!h)return!1;var k=arguments.length;if(1===k)h.forEach(c);
else if(2===k)h.forEach(d);else{var l=Array.prototype.slice.call(arguments,1);h.forEach(e)}return!!h.length}};b(a.prototype);a.mixin=b})(b)},{}],74:[function(f,m,k){function b(){this._events=this._events||{};this._maxListeners=this._maxListeners||void 0}function a(a){return"function"===typeof a}function g(a){return"object"===typeof a&&null!==a}m.exports=b;b.EventEmitter=b;b.prototype._events=void 0;b.prototype._maxListeners=void 0;b.defaultMaxListeners=10;b.prototype.setMaxListeners=function(a){if("number"!==
typeof a||0>a||isNaN(a))throw TypeError("n must be a positive number");this._maxListeners=a;return this};b.prototype.emit=function(b){var c;this._events||(this._events={});if("error"===b&&(!this._events.error||g(this._events.error)&&!this._events.error.length)){var e=arguments[1];if(e instanceof Error)throw e;var h=Error('Uncaught, unspecified "error" event. ('+e+")");h.context=e;throw h;}h=this._events[b];if(void 0===h)return!1;if(a(h))switch(arguments.length){case 1:h.call(this);break;case 2:h.call(this,
arguments[1]);break;case 3:h.call(this,arguments[1],arguments[2]);break;default:e=Array.prototype.slice.call(arguments,1),h.apply(this,e)}else if(g(h)){e=Array.prototype.slice.call(arguments,1);var f=h.slice();h=f.length;for(c=0;c<h;c++)f[c].apply(this,e)}return!0};b.prototype.addListener=function(c,f){var e;if(!a(f))throw TypeError("listener must be a function");this._events||(this._events={});this._events.newListener&&this.emit("newListener",c,a(f.listener)?f.listener:f);this._events[c]?g(this._events[c])?
this._events[c].push(f):this._events[c]=[this._events[c],f]:this._events[c]=f;g(this._events[c])&&!this._events[c].warned&&(e=void 0!==this._maxListeners?this._maxListeners:b.defaultMaxListeners)&&0<e&&this._events[c].length>e&&(this._events[c].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[c].length),"function"===typeof console.trace&&console.trace());return this};b.prototype.on=
b.prototype.addListener;b.prototype.once=function(b,g){function c(){this.removeListener(b,c);h||(h=!0,g.apply(this,arguments))}if(!a(g))throw TypeError("listener must be a function");var h=!1;c.listener=g;this.on(b,c);return this};b.prototype.removeListener=function(b,f){if(!a(f))throw TypeError("listener must be a function");if(!this._events||!this._events[b])return this;var c=this._events[b];var h=c.length;var k=-1;if(c===f||a(c.listener)&&c.listener===f)delete this._events[b],this._events.removeListener&&
this.emit("removeListener",b,f);else if(g(c)){for(;0<h--;)if(c[h]===f||c[h].listener&&c[h].listener===f){k=h;break}if(0>k)return this;1===c.length?(c.length=0,delete this._events[b]):c.splice(k,1);this._events.removeListener&&this.emit("removeListener",b,f)}return this};b.prototype.removeAllListeners=function(b){if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[b]&&delete this._events[b],this;if(0===arguments.length){for(c in this._events)"removeListener"!==
c&&this.removeAllListeners(c);this.removeAllListeners("removeListener");this._events={};return this}var c=this._events[b];if(a(c))this.removeListener(b,c);else if(c)for(;c.length;)this.removeListener(b,c[c.length-1]);delete this._events[b];return this};b.prototype.listeners=function(b){return this._events&&this._events[b]?a(this._events[b])?[this._events[b]]:this._events[b].slice():[]};b.prototype.listenerCount=function(b){if(this._events){b=this._events[b];if(a(b))return 1;if(b)return b.length}return 0};
b.listenerCount=function(a,b){return a.listenerCount(b)}},{}],75:[function(f,m,k){k.read=function(b,a,g,c,f){var e=8*f-c-1;var h=(1<<e)-1,k=h>>1,l=-7;f=g?f-1:0;var d=g?-1:1,r=b[a+f];f+=d;g=r&(1<<-l)-1;r>>=-l;for(l+=e;0<l;g=256*g+b[a+f],f+=d,l-=8);e=g&(1<<-l)-1;g>>=-l;for(l+=c;0<l;e=256*e+b[a+f],f+=d,l-=8);if(0===g)g=1-k;else{if(g===h)return e?NaN:Infinity*(r?-1:1);e+=Math.pow(2,c);g-=k}return(r?-1:1)*e*Math.pow(2,g-c)};k.write=function(b,a,g,c,f,e){var h,k=8*e-f-1,l=(1<<k)-1,d=l>>1,r=23===f?Math.pow(2,
-24)-Math.pow(2,-77):0;e=c?0:e-1;var m=c?1:-1,F=0>a||0===a&&0>1/a?1:0;a=Math.abs(a);isNaN(a)||Infinity===a?(a=isNaN(a)?1:0,c=l):(c=Math.floor(Math.log(a)/Math.LN2),1>a*(h=Math.pow(2,-c))&&(c--,h*=2),a=1<=c+d?a+r/h:a+r*Math.pow(2,1-d),2<=a*h&&(c++,h/=2),c+d>=l?(a=0,c=l):1<=c+d?(a=(a*h-1)*Math.pow(2,f),c+=d):(a=a*Math.pow(2,d-1)*Math.pow(2,f),c=0));for(;8<=f;b[g+e]=a&255,e+=m,a/=256,f-=8);c=c<<f|a;for(k+=f;0<k;b[g+e]=c&255,e+=m,c/=256,k-=8);b[g+e-m]|=128*F}},{}],76:[function(f,m,k){m.exports="function"===
typeof Object.create?function(b,a){b.super_=a;b.prototype=Object.create(a.prototype,{constructor:{value:b,enumerable:!1,writable:!0,configurable:!0}})}:function(b,a){b.super_=a;var g=function(){};g.prototype=a.prototype;b.prototype=new g;b.prototype.constructor=b}},{}],77:[function(f,m,k){(function(b){!function(a){function g(b,g,l){function n(a,b,d,c){if(!(this instanceof n))return new n(a,b,d,c);y&&C&&(a instanceof C&&(a=new y(a)),d instanceof C&&(d=new y(d)));if(a||b||d||G){if(!h(a,b)){var e=G||
Array;c=b;d=a;b=0;a=new e(8)}this.buffer=a;this.offset=b|=0;if("undefined"!==typeof d)if("string"===typeof d){c=c||10;var e=0,g=d.length,f=0,p=0;"-"===d[0]&&e++;for(var l=e;e<g;){var t=parseInt(d[e++],c);if(!(0<=t))break;p=p*c+t;f=f*c+Math.floor(p/4294967296);p%=4294967296}l&&(f=~f,p?p=4294967296-p:f++);J(a,b+O,f);J(a,b+I,p)}else h(d,c)?k(a,b,d,c):"number"===typeof c?(J(a,b+O,d),J(a,b+I,c)):0<d?v(a,b,d):0>d?F(a,b,d):k(a,b,q,0)}else this.buffer=Array.prototype.slice.call(q,0,8)}function w(){var a=
this.buffer,b=this.offset,d=K(a,b+O),a=K(a,b+I);l||(d|=0);return d?4294967296*d+a:a}function J(a,b,d){a[b+z]=d&255;d>>=8;a[b+t]=d&255;d>>=8;a[b+p]=d&255;a[b+u]=d>>8&255}function K(a,b){return 16777216*a[b+u]+(a[b+p]<<16)+(a[b+t]<<8)+a[b+z]}var O=g?0:4,I=g?4:0,u=g?0:3,p=g?1:2,t=g?2:1,z=g?3:0,v=g?m:r,F=g?d:B;g=n.prototype;var T="is"+b,S="_"+T;g.buffer=void 0;g.offset=0;g[S]=!0;g.toNumber=w;g.toString=function(a){var b=this.buffer,d=this.offset,c=K(b,d+O),b=K(b,d+I),d="",e=!l&&c&2147483648;e&&(c=~c,
b=4294967296-b);for(a=a||10;;){var g=c%a*4294967296+b,c=Math.floor(c/a),b=Math.floor(g/a),d=(g%a).toString(a)+d;if(!c&&!b)break}e&&(d="-"+d);return d};g.toJSON=w;g.toArray=c;A&&(g.toBuffer=f);y&&(g.toArrayBuffer=e);n[T]=function(a){return!(!a||!a[S])};return a[b]=n}function c(a){var b=this.buffer,d=this.offset;G=null;return!1!==a&&0===d&&8===b.length&&I(b)?b:Array.prototype.slice.call(b,d,d+8)}function f(a){var d=this.buffer,c=this.offset;G=A;if(!1!==a&&0===c&&8===d.length&&b.isBuffer(d))return d;
a=new A(8);k(a,0,d,c);return a}function e(a){var b=this.buffer,d=this.offset,c=b.buffer;G=y;if(!1!==a&&0===d&&c instanceof C&&8===c.byteLength)return c;a=new y(8);k(a,0,b,d);return a.buffer}function h(a,b){var d=a&&a.length;b|=0;return d&&b+8<=d&&"string"!==typeof a[b]}function k(a,b,d,c){b|=0;c|=0;for(var e=0;8>e;e++)a[b++]=d[c++]&255}function m(a,b,d){for(var c=b+8;c>b;)a[--c]=d&255,d/=256}function d(a,b,d){var c=b+8;for(d++;c>b;)a[--c]=-d&255^255,d/=256}function r(a,b,d){for(var c=b+8;b<c;)a[b++]=
d&255,d/=256}function B(a,b,d){var c=b+8;for(d++;b<c;)a[b++]=-d&255^255,d/=256}function F(a){return!!a&&"[object Array]"==Object.prototype.toString.call(a)}var A="undefined"!==typeof b&&b,y="undefined"!==typeof Uint8Array&&Uint8Array,C="undefined"!==typeof ArrayBuffer&&ArrayBuffer,q=[0,0,0,0,0,0,0,0],I=Array.isArray||F,G;g("Uint64BE",!0,!0);g("Int64BE",!0,!1);g("Uint64LE",!1,!0);g("Int64LE",!1,!1)}("object"===typeof k&&"string"!==typeof k.nodeName?k:this||{})}).call(this,f("buffer").Buffer)},{buffer:27}],
78:[function(f,m,k){function b(a){return!!a.constructor&&"function"===typeof a.constructor.isBuffer&&a.constructor.isBuffer(a)}m.exports=function(a){return null!=a&&(b(a)||"function"===typeof a.readFloatLE&&"function"===typeof a.slice&&b(a.slice(0,0))||!!a._isBuffer)}},{}],79:[function(f,m,k){var b={}.toString;m.exports=Array.isArray||function(a){return"[object Array]"==b.call(a)}},{}],80:[function(f,m,k){k.encode=f("./encode").encode;k.decode=f("./decode").decode;k.Encoder=f("./encoder").Encoder;
k.Decoder=f("./decoder").Decoder;k.createCodec=f("./ext").createCodec;k.codec=f("./codec").codec},{"./codec":89,"./decode":91,"./decoder":92,"./encode":94,"./encoder":95,"./ext":99}],81:[function(f,m,k){(function(b){function a(a){return a&&a.isBuffer&&a}m.exports=a("undefined"!==typeof b&&b)||a(this.Buffer)||a("undefined"!==typeof window&&window.Buffer)||this.Buffer}).call(this,f("buffer").Buffer)},{buffer:27}],82:[function(f,m,k){k.copy=function(b,a,g,c){g||(g=0);c||0===c||(c=this.length);a||(a=
0);var f=c-g;if(b===this&&g<a&&a<c)for(c=f-1;0<=c;c--)b[c+a]=this[c+g];else for(c=0;c<f;c++)b[c+a]=this[c+g];return f};k.toString=function(b,a,g){b=a|0;g||(g=this.length);a="";for(var c;b<g;)c=this[b++],128>c?a+=String.fromCharCode(c):(192===(c&224)?c=(c&31)<<6|this[b++]&63:224===(c&240)?c=(c&15)<<12|(this[b++]&63)<<6|this[b++]&63:240===(c&248)&&(c=(c&7)<<18|(this[b++]&63)<<12|(this[b++]&63)<<6|this[b++]&63),65536<=c?(c-=65536,a+=String.fromCharCode((c>>>10)+55296,(c&1023)+56320)):a+=String.fromCharCode(c));
return a};k.write=function(b,a){for(var g=a||(a|=0),c=b.length,f,e=0;e<c;)f=b.charCodeAt(e++),128>f?this[g++]=f:(2048>f?this[g++]=192|f>>>6:(55296>f||57343<f?this[g++]=224|f>>>12:(f=(f-55296<<10|b.charCodeAt(e++)-56320)+65536,this[g++]=240|f>>>18,this[g++]=128|f>>>12&63),this[g++]=128|f>>>6&63),this[g++]=128|f&63);return g-a}},{}],83:[function(f,m,k){var b=f("./bufferish");k=m.exports=[];k.alloc=function(a){return Array(a)};k.concat=b.concat;k.from=function(a){if(!b.isBuffer(a)&&b.isView(a))a=b.Uint8Array.from(a);
else if(b.isArrayBuffer(a))a=new Uint8Array(a);else{if("string"===typeof a)return b.from.call(k,a);if("number"===typeof a)throw new TypeError('"value" argument must not be a number');}return Array.prototype.slice.call(a)}},{"./bufferish":87}],84:[function(f,m,k){function b(a){return new g(a)}var a=f("./bufferish"),g=a.global;k=m.exports=a.hasBuffer?b(0):[];k.alloc=a.hasBuffer&&g.alloc||b;k.concat=a.concat;k.from=function(b){if(!a.isBuffer(b)&&a.isView(b))b=a.Uint8Array.from(b);else if(a.isArrayBuffer(b))b=
new Uint8Array(b);else{if("string"===typeof b)return a.from.call(k,b);if("number"===typeof b)throw new TypeError('"value" argument must not be a number');}return g.from&&1!==g.from.length?g.from(b):new g(b)}},{"./bufferish":87}],85:[function(f,m,k){function b(b,f,k,d){var h=c.isBuffer(this),n=c.isBuffer(b);if(h&&n)return this.copy(b,f,k,d);if(e||h||n||!c.isView(this)||!c.isView(b))return g.copy.call(this,b,f,k,d);k=k||null!=d?a.call(this,k,d):this;b.set(k,f);return k.length}function a(a,g){var f=
this.slice||!e&&this.subarray;if(f)return f.call(this,a,g);f=c.alloc.call(this,g-a);b.call(this,f,0,a,g);return f}var g=f("./buffer-lite");k.copy=b;k.slice=a;k.toString=function(a,b,e){return(!l&&c.isBuffer(this)?this.toString:g.toString).apply(this,arguments)};k.write=function(a){return function(){return(this[a]||g[a]).apply(this,arguments)}}("write");var c=f("./bufferish");f=c.global;var l=c.hasBuffer&&"TYPED_ARRAY_SUPPORT"in f,e=l&&!f.TYPED_ARRAY_SUPPORT},{"./buffer-lite":82,"./bufferish":87}],
86:[function(f,m,k){function b(a){return new Uint8Array(a)}var a=f("./bufferish");k=m.exports=a.hasArrayBuffer?b(0):[];k.alloc=b;k.concat=a.concat;k.from=function(b){if(a.isView(b)){var c=b.byteOffset,g=b.byteLength;b=b.buffer;b.byteLength!==g&&(b.slice?b=b.slice(c,c+g):(b=new Uint8Array(b),b.byteLength!==g&&(b=Array.prototype.slice.call(b,c,c+g))))}else{if("string"===typeof b)return a.from.call(k,b);if("number"===typeof b)throw new TypeError('"value" argument must not be a number');}return new Uint8Array(b)}},
{"./bufferish":87}],87:[function(f,m,k){function b(a){return g(this).alloc(a)}function a(a){return a instanceof ArrayBuffer||y(a)}function g(a){return w(a)?B:d(a)?F:n(a)?r:e?B:h?F:r}function c(){return!1}function l(a,b){a="[object "+a+"]";return function(d){return null!=d&&{}.toString.call(b?d[b]:d)===a}}m=k.global=f("./buffer-global");var e=k.hasBuffer=m&&!!m.isBuffer,h=k.hasArrayBuffer="undefined"!==typeof ArrayBuffer,n=k.isArray=f("isarray");k.isArrayBuffer=h?a:c;var w=k.isBuffer=e?m.isBuffer:
c,d=k.isView=h?ArrayBuffer.isView||l("ArrayBuffer","buffer"):c;k.alloc=b;k.concat=function(a,d){function c(a){d+=a.length}d||(d=0,Array.prototype.forEach.call(a,c));var e=b.call(this!==k&&this||a[0],d),g=0;Array.prototype.forEach.call(a,function(a){g+=A.copy.call(a,e,g)});return e};k.from=function(a){if("string"===typeof a){var d=3*a.length,c=b.call(this,d);a=A.write.call(c,a);d!==a&&(c=A.slice.call(c,0,a));return c}return g(this).from(a)};var r=k.Array=f("./bufferish-array"),B=k.Buffer=f("./bufferish-buffer"),
F=k.Uint8Array=f("./bufferish-uint8array"),A=k.prototype=f("./bufferish-proto"),y=l("ArrayBuffer")},{"./buffer-global":81,"./bufferish-array":83,"./bufferish-buffer":84,"./bufferish-proto":85,"./bufferish-uint8array":86,isarray:79}],88:[function(f,m,k){function b(a){if(!(this instanceof b))return new b(a);this.options=a;this.init()}function a(a,b){function c(){a.apply(this,arguments);return b.apply(this,arguments)}return a&&b?c:a||b}function g(a){function b(a,b){return b(a)}a=a.slice();return function(c){return a.reduce(b,
c)}}function c(a){return new b(a)}var l=f("isarray");k.createCodec=c;k.install=function(c){for(var e in c)b.prototype[e]=a(b.prototype[e],c[e])};k.filter=function(a){return l(a)?g(a):a};var e=f("./bufferish");b.prototype.init=function(){var a=this.options;a&&a.uint8array&&(this.bufferish=e.Uint8Array);return this};k.preset=c({preset:!0})},{"./bufferish":87,isarray:79}],89:[function(f,m,k){f("./read-core");f("./write-core");k.codec={preset:f("./codec-base").preset}},{"./codec-base":88,"./read-core":101,
"./write-core":104}],90:[function(f,m,k){function b(a){if(!(this instanceof b))return new b(a);a&&(this.options=a,a.codec&&(a=this.codec=a.codec,a.bufferish&&(this.bufferish=a.bufferish)))}k.DecodeBuffer=b;m=f("./read-core").preset;f("./flex-buffer").FlexDecoder.mixin(b.prototype);b.prototype.codec=m;b.prototype.fetch=function(){return this.codec.decode(this)}},{"./flex-buffer":100,"./read-core":101}],91:[function(f,m,k){k.decode=function(a,g){var c=new b(g);c.write(a);return c.read()};var b=f("./decode-buffer").DecodeBuffer},
{"./decode-buffer":90}],92:[function(f,m,k){function b(g){if(!(this instanceof b))return new b(g);a.call(this,g)}k.Decoder=b;m=f("event-lite");var a=f("./decode-buffer").DecodeBuffer;b.prototype=new a;m.mixin(b.prototype);b.prototype.decode=function(a){arguments.length&&this.write(a);this.flush()};b.prototype.push=function(a){this.emit("data",a)};b.prototype.end=function(a){this.decode(a);this.emit("end")}},{"./decode-buffer":90,"event-lite":73}],93:[function(f,m,k){function b(a){if(!(this instanceof
b))return new b(a);a&&(this.options=a,a.codec&&(a=this.codec=a.codec,a.bufferish&&(this.bufferish=a.bufferish)))}k.EncodeBuffer=b;m=f("./write-core").preset;f("./flex-buffer").FlexEncoder.mixin(b.prototype);b.prototype.codec=m;b.prototype.write=function(a){this.codec.encode(this,a)}},{"./flex-buffer":100,"./write-core":104}],94:[function(f,m,k){k.encode=function(a,g){var c=new b(g);c.write(a);return c.read()};var b=f("./encode-buffer").EncodeBuffer},{"./encode-buffer":93}],95:[function(f,m,k){function b(g){if(!(this instanceof
b))return new b(g);a.call(this,g)}k.Encoder=b;m=f("event-lite");var a=f("./encode-buffer").EncodeBuffer;b.prototype=new a;m.mixin(b.prototype);b.prototype.encode=function(a){this.write(a);this.emit("data",this.read())};b.prototype.end=function(a){arguments.length&&this.encode(a);this.flush();this.emit("end")}},{"./encode-buffer":93,"event-lite":73}],96:[function(f,m,k){function b(f,c){if(!(this instanceof b))return new b(f,c);this.buffer=a.from(f);this.type=c}k.ExtBuffer=b;var a=f("./bufferish")},
{"./bufferish":87}],97:[function(f,m,k){function b(a){n||(n=f("./encode").encode);return n(a)}function a(a){return a.valueOf()}function g(a){a=RegExp.prototype.toString.call(a).split("/");a.shift();var b=[a.pop()];b.unshift(a.join("/"));return b}function c(a){var b={},d;for(d in w)b[d]=a[d];return b}k.setExtPackers=function(d){d.addExtPacker(14,Error,[c,b]);d.addExtPacker(1,EvalError,[c,b]);d.addExtPacker(2,RangeError,[c,b]);d.addExtPacker(3,ReferenceError,[c,b]);d.addExtPacker(4,SyntaxError,[c,b]);
d.addExtPacker(5,TypeError,[c,b]);d.addExtPacker(6,URIError,[c,b]);d.addExtPacker(10,RegExp,[g,b]);d.addExtPacker(11,Boolean,[a,b]);d.addExtPacker(12,String,[a,b]);d.addExtPacker(13,Date,[Number,b]);d.addExtPacker(15,Number,[a,b]);"undefined"!==typeof Uint8Array&&(d.addExtPacker(17,Int8Array,h),d.addExtPacker(18,Uint8Array,h),d.addExtPacker(19,Int16Array,h),d.addExtPacker(20,Uint16Array,h),d.addExtPacker(21,Int32Array,h),d.addExtPacker(22,Uint32Array,h),d.addExtPacker(23,Float32Array,h),"undefined"!==
typeof Float64Array&&d.addExtPacker(24,Float64Array,h),"undefined"!==typeof Uint8ClampedArray&&d.addExtPacker(25,Uint8ClampedArray,h),d.addExtPacker(26,ArrayBuffer,h),d.addExtPacker(29,DataView,h));l.hasBuffer&&d.addExtPacker(27,e,l.from)};var l=f("./bufferish"),e=l.global,h=l.Uint8Array.from,n,w={name:1,message:1,stack:1,columnNumber:1,fileName:1,lineNumber:1}},{"./bufferish":87,"./encode":94}],98:[function(f,m,k){function b(a){n||(n=f("./decode").decode);return n(a)}function a(a){return RegExp.apply(null,
a)}function g(a){return function(b){var d=new a,c;for(c in w)d[c]=b[c];return d}}function c(a){return function(b){return new a(b)}}function l(a){return(new Uint8Array(a)).buffer}k.setExtUnpackers=function(d){d.addExtUnpacker(14,[b,g(Error)]);d.addExtUnpacker(1,[b,g(EvalError)]);d.addExtUnpacker(2,[b,g(RangeError)]);d.addExtUnpacker(3,[b,g(ReferenceError)]);d.addExtUnpacker(4,[b,g(SyntaxError)]);d.addExtUnpacker(5,[b,g(TypeError)]);d.addExtUnpacker(6,[b,g(URIError)]);d.addExtUnpacker(10,[b,a]);d.addExtUnpacker(11,
[b,c(Boolean)]);d.addExtUnpacker(12,[b,c(String)]);d.addExtUnpacker(13,[b,c(Date)]);d.addExtUnpacker(15,[b,c(Number)]);"undefined"!==typeof Uint8Array&&(d.addExtUnpacker(17,c(Int8Array)),d.addExtUnpacker(18,c(Uint8Array)),d.addExtUnpacker(19,[l,c(Int16Array)]),d.addExtUnpacker(20,[l,c(Uint16Array)]),d.addExtUnpacker(21,[l,c(Int32Array)]),d.addExtUnpacker(22,[l,c(Uint32Array)]),d.addExtUnpacker(23,[l,c(Float32Array)]),"undefined"!==typeof Float64Array&&d.addExtUnpacker(24,[l,c(Float64Array)]),"undefined"!==
typeof Uint8ClampedArray&&d.addExtUnpacker(25,c(Uint8ClampedArray)),d.addExtUnpacker(26,l),d.addExtUnpacker(29,[l,c(DataView)]));e.hasBuffer&&d.addExtUnpacker(27,c(h))};var e=f("./bufferish"),h=e.global,n,w={name:1,message:1,stack:1,columnNumber:1,fileName:1,lineNumber:1}},{"./bufferish":87,"./decode":91}],99:[function(f,m,k){f("./read-core");f("./write-core");k.createCodec=f("./codec-base").createCodec},{"./codec-base":88,"./read-core":101,"./write-core":104}],100:[function(f,m,k){function b(){if(!(this instanceof
b))return new b}function a(){if(!(this instanceof a))return new a}function g(){throw Error("method not implemented: write()");}function c(){throw Error("method not implemented: fetch()");}function l(){if(!this.buffers||!this.buffers.length)return this.fetch();this.flush();return this.pull()}function e(a){(this.buffers||(this.buffers=[])).push(a)}function h(){return(this.buffers||(this.buffers=[])).shift()}function n(a){return function(b){for(var d in a)b[d]=a[d];return b}}k.FlexDecoder=b;k.FlexEncoder=
a;var w=f("./bufferish");b.mixin=n(function(){return{bufferish:w,write:function(a){var b=this.offset?w.prototype.slice.call(this.buffer,this.offset):this.buffer;this.buffer=b?a?this.bufferish.concat([b,a]):b:a;this.offset=0},fetch:c,flush:function(){for(;this.offset<this.buffer.length;){var a=this.offset;try{var b=this.fetch()}catch(B){if(B&&"BUFFER_SHORTAGE"!=B.message)throw B;this.offset=a;break}this.push(b)}},push:e,pull:h,read:l,reserve:function(a){var b=this.offset;a=b+a;if(a>this.buffer.length)throw Error("BUFFER_SHORTAGE");
this.offset=a;return b},offset:0}}());b.mixin(b.prototype);a.mixin=n(function(){return{bufferish:w,write:g,fetch:function(){var a=this.start;if(a<this.offset){var b=this.start=this.offset;return w.prototype.slice.call(this.buffer,a,b)}},flush:function(){for(;this.start<this.offset;){var a=this.fetch();a&&this.push(a)}},push:e,pull:function(){var a=this.buffers||(this.buffers=[]),b=1<a.length?this.bufferish.concat(a):a[0];a.length=0;return b},read:l,reserve:function(a){var b=a|0;if(this.buffer){var d=
this.buffer.length,c=this.offset|0,e=c+b;if(e<d)return this.offset=e,c;this.flush();a=Math.max(a,Math.min(2*d,this.maxBufferSize))}a=Math.max(a,this.minBufferSize);this.buffer=this.bufferish.alloc(a);this.start=0;this.offset=b;return 0},send:function(a){var b=a.length;b>this.minBufferSize?(this.flush(),this.push(a)):(b=this.reserve(b),w.prototype.copy.call(a,this.buffer,b))},maxBufferSize:65536,minBufferSize:2048,offset:0,start:0}}());a.mixin(a.prototype)},{"./bufferish":87}],101:[function(f,m,k){function b(a){var b=
e.getReadToken(a);return function(a){var d=l(a),c=b[d];if(!c)throw Error("Invalid type: "+(d?"0x"+d.toString(16):d));return c(a)}}function a(){var a=this.options;this.decode=b(a);a&&a.preset&&c.setExtUnpackers(this);return this}var g=f("./ext-buffer").ExtBuffer,c=f("./ext-unpacker"),l=f("./read-format").readUint8,e=f("./read-token"),h=f("./codec-base");h.install({addExtUnpacker:function(a,b){(this.extUnpackers||(this.extUnpackers=[]))[a]=h.filter(b)},getExtUnpacker:function(a){function b(b){return new g(b,
a)}return(this.extUnpackers||(this.extUnpackers=[]))[a]||b},init:a});k.preset=a.call(h.preset)},{"./codec-base":88,"./ext-buffer":96,"./ext-unpacker":98,"./read-format":102,"./read-token":103}],102:[function(f,m,k){function b(a,b){var d={},c,e=Array(b),f=Array(b),g=a.codec.decode;for(c=0;c<b;c++)e[c]=g(a),f[c]=g(a);for(c=0;c<b;c++)d[e[c]]=f[c];return d}function a(a,b){var d=new Map,c,e=Array(b),f=Array(b),g=a.codec.decode;for(c=0;c<b;c++)e[c]=g(a),f[c]=g(a);for(c=0;c<b;c++)d.set(e[c],f[c]);return d}
function g(a,b){for(var d=Array(b),c=a.codec.decode,e=0;e<b;e++)d[e]=c(a);return d}function c(a,b){var d=a.reserve(b);return N.toString.call(a.buffer,"utf-8",d,d+b)}function l(a,b){var d=a.reserve(b),d=N.slice.call(a.buffer,d,d+b);return L.from(d)}function e(a,b){var d=a.reserve(b),d=N.slice.call(a.buffer,d,d+b);return L.Uint8Array.from(d).buffer}function h(a,b){var d=a.reserve(b+1),c=a.buffer[d++],e=d+b,f=a.codec.getExtUnpacker(c);if(!f)throw Error("Invalid ext type: "+(c?"0x"+c.toString(16):c));
d=N.slice.call(a.buffer,d,e);return f(d)}function n(a){var b=a.reserve(1);return a.buffer[b]}function w(a){var b=a.reserve(1);a=a.buffer[b];return a&128?a-256:a}function d(a){var b=a.reserve(2);a=a.buffer;return a[b++]<<8|a[b]}function r(a){var b=a.reserve(2);a=a.buffer;b=a[b++]<<8|a[b];return b&32768?b-65536:b}function B(a){var b=a.reserve(4);a=a.buffer;return 16777216*a[b++]+(a[b++]<<16)+(a[b++]<<8)+a[b]}function F(a){var b=a.reserve(4);a=a.buffer;return a[b++]<<24|a[b++]<<16|a[b++]<<8|a[b]}function A(a,
b){return function(d){var c=d.reserve(a);return b.call(d.buffer,c,U)}}function y(a){return(new J(this,a)).toNumber()}function C(a){return(new D(this,a)).toNumber()}function q(a){return new J(this,a)}function I(a){return new D(this,a)}function G(a){return O.read(this,a,!1,23,4)}function K(a){return O.read(this,a,!1,52,8)}var O=f("ieee754");m=f("int64-buffer");var J=m.Uint64BE,D=m.Int64BE;k.getReadFormat=function(f){var k=f&&f.int64;return{map:x&&f&&f.usemap?a:b,array:g,str:c,bin:L.hasArrayBuffer&&
f&&f.binarraybuffer?e:l,ext:h,uint8:n,uint16:d,uint32:B,uint64:A(8,k?q:y),int8:w,int16:r,int32:F,int64:A(8,k?I:C),float32:A(4,G),float64:A(8,K)}};k.readUint8=n;var L=f("./bufferish"),N=f("./bufferish-proto"),x="undefined"!==typeof Map,U=!0},{"./bufferish":87,"./bufferish-proto":85,ieee754:75,"int64-buffer":77}],103:[function(f,m,k){function b(b){var e,f=Array(256);for(e=0;127>=e;e++)f[e]=a(e);for(e=128;143>=e;e++)f[e]=c(e-128,b.map);for(e=144;159>=e;e++)f[e]=c(e-144,b.array);for(e=160;191>=e;e++)f[e]=
c(e-160,b.str);f[192]=a(null);f[193]=null;f[194]=a(!1);f[195]=a(!0);f[196]=g(b.uint8,b.bin);f[197]=g(b.uint16,b.bin);f[198]=g(b.uint32,b.bin);f[199]=g(b.uint8,b.ext);f[200]=g(b.uint16,b.ext);f[201]=g(b.uint32,b.ext);f[202]=b.float32;f[203]=b.float64;f[204]=b.uint8;f[205]=b.uint16;f[206]=b.uint32;f[207]=b.uint64;f[208]=b.int8;f[209]=b.int16;f[210]=b.int32;f[211]=b.int64;f[212]=c(1,b.ext);f[213]=c(2,b.ext);f[214]=c(4,b.ext);f[215]=c(8,b.ext);f[216]=c(16,b.ext);f[217]=g(b.uint8,b.str);f[218]=g(b.uint16,
b.str);f[219]=g(b.uint32,b.str);f[220]=g(b.uint16,b.array);f[221]=g(b.uint32,b.array);f[222]=g(b.uint16,b.map);f[223]=g(b.uint32,b.map);for(e=224;255>=e;e++)f[e]=a(e-256);return f}function a(a){return function(){return a}}function g(a,b){return function(c){var e=a(c);return b(c,e)}}function c(a,b){return function(c){return b(c,a)}}var l=f("./read-format");k.getReadToken=function(a){var e=l.getReadFormat(a);if(a&&a.useraw){var f=b(e).slice();f[217]=f[196];f[218]=f[197];f[219]=f[198];for(a=160;191>=
a;a++)f[a]=c(a-160,e.bin);return f}return b(e)}},{"./read-format":102}],104:[function(f,m,k){function b(a){var b=l.getWriteType(a);return function(a,d){var c=b[typeof d];if(!c)throw Error('Unsupported type "'+typeof d+'": '+d);c(a,d)}}function a(){var a=this.options;this.encode=b(a);a&&a.preset&&c.setExtPackers(this);return this}var g=f("./ext-buffer").ExtBuffer,c=f("./ext-packer"),l=f("./write-type"),e=f("./codec-base");e.install({addExtPacker:function(a,b,c){function d(b){c&&(b=c(b));return new g(b,
a)}c=e.filter(c);var f=b.name;f&&"Object"!==f?(this.extPackers||(this.extPackers={}))[f]=d:(this.extEncoderList||(this.extEncoderList=[])).unshift([b,d])},getExtPacker:function(a){var b=this.extPackers||(this.extPackers={});if(b=(a=a.constructor)&&a.name&&b[a.name])return b;for(var b=this.extEncoderList||(this.extEncoderList=[]),c=b.length,d=0;d<c;d++){var e=b[d];if(a===e[0])return e[1]}},init:a});k.preset=a.call(e.preset)},{"./codec-base":88,"./ext-buffer":96,"./ext-packer":97,"./write-type":106}],
105:[function(f,m,k){function b(){var b=F.slice();b[196]=a(196);b[197]=g(197);b[198]=c(198);b[199]=a(199);b[200]=g(200);b[201]=c(201);b[202]=l(202,4,q.writeFloatBE||n,!0);b[203]=l(203,8,q.writeDoubleBE||w,!0);b[204]=a(204);b[205]=g(205);b[206]=c(206);b[207]=l(207,8,e);b[208]=a(208);b[209]=g(209);b[210]=c(210);b[211]=l(211,8,h);b[217]=a(217);b[218]=g(218);b[219]=c(219);b[220]=g(220);b[221]=c(221);b[222]=g(222);b[223]=c(223);return b}function a(a){return function(b,d){var c=b.reserve(2),e=b.buffer;
e[c++]=a;e[c]=d}}function g(a){return function(b,d){var c=b.reserve(3),e=b.buffer;e[c++]=a;e[c++]=d>>>8;e[c]=d}}function c(a){return function(b,d){var c=b.reserve(5),e=b.buffer;e[c++]=a;e[c++]=d>>>24;e[c++]=d>>>16;e[c++]=d>>>8;e[c]=d}}function l(a,b,d,c){return function(e,f){var g=e.reserve(b+1);e.buffer[g++]=a;d.call(e.buffer,f,g,c)}}function e(a,b){new r(this,b,a)}function h(a,b){new B(this,b,a)}function n(a,b){d.write(this,a,b,!1,23,4)}function w(a,b){d.write(this,a,b,!1,52,8)}var d=f("ieee754");
m=f("int64-buffer");var r=m.Uint64BE,B=m.Int64BE,F=f("./write-uint8").uint8,A=f("./bufferish"),y=A.global,C=A.hasBuffer&&"TYPED_ARRAY_SUPPORT"in y&&!y.TYPED_ARRAY_SUPPORT,q=A.hasBuffer&&y.prototype||{};k.getWriteToken=function(a){return a&&a.uint8array?(a=b(),a[202]=l(202,4,n),a[203]=l(203,8,w),a):C||A.hasBuffer&&a&&a.safe?(a=F.slice(),a[196]=l(196,1,y.prototype.writeUInt8),a[197]=l(197,2,y.prototype.writeUInt16BE),a[198]=l(198,4,y.prototype.writeUInt32BE),a[199]=l(199,1,y.prototype.writeUInt8),a[200]=
l(200,2,y.prototype.writeUInt16BE),a[201]=l(201,4,y.prototype.writeUInt32BE),a[202]=l(202,4,y.prototype.writeFloatBE),a[203]=l(203,8,y.prototype.writeDoubleBE),a[204]=l(204,1,y.prototype.writeUInt8),a[205]=l(205,2,y.prototype.writeUInt16BE),a[206]=l(206,4,y.prototype.writeUInt32BE),a[207]=l(207,8,e),a[208]=l(208,1,y.prototype.writeInt8),a[209]=l(209,2,y.prototype.writeInt16BE),a[210]=l(210,4,y.prototype.writeInt32BE),a[211]=l(211,8,h),a[217]=l(217,1,y.prototype.writeUInt8),a[218]=l(218,2,y.prototype.writeUInt16BE),
a[219]=l(219,4,y.prototype.writeUInt32BE),a[220]=l(220,2,y.prototype.writeUInt16BE),a[221]=l(221,4,y.prototype.writeUInt32BE),a[222]=l(222,2,y.prototype.writeUInt16BE),a[223]=l(223,4,y.prototype.writeUInt32BE),a):b()}},{"./bufferish":87,"./write-uint8":107,ieee754:75,"int64-buffer":77}],106:[function(f,m,k){var b=f("isarray");m=f("int64-buffer");var a=m.Uint64BE,g=m.Int64BE,c=f("./bufferish"),l=f("./bufferish-proto"),e=f("./write-token"),h=f("./write-uint8").uint8,n=f("./ext-buffer").ExtBuffer,w=
"undefined"!==typeof Uint8Array,d="undefined"!==typeof Map,r=[,212,213,,214,,,,215];r[16]=216;k.getWriteType=function(f){function k(a){return 32>a?1:255>=a?2:65535>=a?3:5}function m(a){return 32>a?1:65535>=a?3:5}function y(d,c){if(null===c)return q(d,c);if(N(c))return x(d,c);if(b(c)){var e=c,f=e.length;J[16>f?144+f:65535>=f?220:221](d,f);for(var k=d.codec.encode,l=0;l<f;l++)k(d,e[l])}else if(a.isUint64BE(c))J[207](d,c.toArray());else if(g.isInt64BE(c))J[211](d,c.toArray());else(e=d.codec.getExtPacker(c))&&
(c=e(c)),c instanceof n?(e=c,f=e.buffer,k=f.length,J[r[k]||(255>k?199:65535>=k?200:201)](d,k),h[e.type](d),d.send(f)):U(d,c)}function B(a,b){if(N(b)){var d=b.length;J[32>d?160+d:65535>=d?218:219](a,d);a.send(b)}else y(a,b)}function q(a,b){J[192](a,b)}function I(a,b){var d=b.length;J[255>d?196:65535>=d?197:198](a,d);a.send(b)}function G(a,b){I(a,new Uint8Array(b))}function K(a,b){var d=Object.keys(b),c=d.length;J[16>c?128+c:65535>=c?222:223](a,c);var e=a.codec.encode;d.forEach(function(d){e(a,d);e(a,
b[d])})}function O(a,b){if(!(b instanceof Map))return K(a,b);var d=b.size;J[16>d?128+d:65535>=d?222:223](a,d);var c=a.codec.encode;b.forEach(function(b,d,e){c(a,d);c(a,b)})}var J=e.getWriteToken(f),D=f&&f.useraw,L=w&&f&&f.binarraybuffer,N=L?c.isArrayBuffer:c.isBuffer,x=L?G:I,U=d&&f&&f.usemap?O:K;return{"boolean":function(a,b){J[b?195:194](a,b)},"function":q,number:function(a,b){var d=b|0;if(b!==d)J[203](a,b);else J[-32<=d&&127>=d?d&255:0<=d?255>=d?204:65535>=d?205:206:-128<=d?208:-32768<=d?209:210](a,
d)},object:D?B:y,string:function(a){return function(b,d){var c=d.length;b.offset=b.reserve(5+3*c);var e=b.buffer,f=a(c),g=b.offset+f,c=l.write.call(e,d,g),h=a(c);f!==h&&l.copy.call(e,e,g+h-f,g,g+c);J[1===h?160+c:3>=h?215+h:219](b,c);b.offset+=c}}(D?m:k),symbol:q,undefined:q}}},{"./bufferish":87,"./bufferish-proto":85,"./ext-buffer":96,"./write-token":105,"./write-uint8":107,"int64-buffer":77,isarray:79}],107:[function(f,m,k){function b(a){return function(b){var c=b.reserve(1);b.buffer[c]=a}}f=k.uint8=
Array(256);for(m=0;255>=m;m++)f[m]=b(m)},{}],108:[function(f,m,k){(function(b){(function(){var a=function(a,b){function c(){this.constructor=a}for(var e in b)g.call(b,e)&&(a[e]=b[e]);c.prototype=b.prototype;a.prototype=new c;a.__super__=b.prototype;return a},g={}.hasOwnProperty;var c=f("stream");var k=f("util");m.exports=function(c){function e(a,d,c){var f,g;null==c&&(c={});var h=f=void 0;switch(typeof a){case "object":b.isBuffer(a)?(f=a,null!=d&&"object"===typeof d&&(c=d)):c=a;break;case "string":f=
a,null!=d&&"object"===typeof d?c=d:h=d}null==c&&(c={});null==f&&(f=c.input);null==h&&(h=c.inputEncoding);delete c.input;delete c.inputEncoding;a=null!=(g=c.watchPipe)?g:!0;delete c.watchPipe;e.__super__.constructor.call(this,c);if(a)this.on("pipe",function(a){return function(b){b=b._readableState.objectMode;if(0<a.length&&b!==a._readableState.objectMode)throw Error("Do not switch objectMode in the middle of the stream");a._readableState.objectMode=b;return a._writableState.objectMode=b}}(this));null!=
f&&this.end(f,h)}a(e,c);e.isNoFilter=function(a){return a instanceof this};e.compare=function(a,b){if(!(a instanceof this))throw new TypeError("Arguments must be NoFilters");return a===b?0:a.compare(b)};e.concat=function(a,c){if(!Array.isArray(a))throw new TypeError("list argument must be an Array of NoFilters");if(0===a.length||0===c)return new b(0);null==c&&(c=a.reduce(function(a,b){if(!(b instanceof e))throw new TypeError("list argument must be an Array of NoFilters");return a+b.length},0));var d=
a.map(function(a){if(!(a instanceof e))throw new TypeError("list argument must be an Array of NoFilters");if(a._readableState.objectMode)throw Error("NoFilter may not be in object mode for concat");return a.slice()});return b.concat(d,c)};e.prototype._transform=function(a,c,e){this._readableState.objectMode||b.isBuffer(a)||(a=new b(a,c));this.push(a);return e()};e.prototype._bufArray=function(){var a=this._readableState.buffer;if(!Array.isArray(a)){var b=a.head;for(a=[];null!=b;)a.push(b.data),b=
b.next}return a};e.prototype.read=function(a){a=e.__super__.read.call(this,a);null!=a&&this.emit("read",a);return a};e.prototype.promise=function(a){var b=!1;return new Promise(function(c){return function(d,e){c.on("finish",function(){var e=c.read();null==a||b||(b=!0,a(null,e));return d(e)});return c.on("error",function(c){null==a||b||(b=!0,a(c));return e(c)})}}(this))};e.prototype.compare=function(a){if(!(a instanceof e))throw new TypeError("Arguments must be NoFilters");if(this._readableState.objectMode||
a._readableState.objectMode)throw Error("Must not be in object mode to compare");return this===a?0:this.slice().compare(a.slice())};e.prototype.equals=function(a){return 0===this.compare(a)};e.prototype.slice=function(a,c){if(this._readableState.objectMode)return this._bufArray().slice(a,c);var d=this._bufArray();switch(d.length){case 0:return new b(0);case 1:return d[0].slice(a,c);default:return d=b.concat(d),d.slice(a,c)}};e.prototype.get=function(a){return this.slice()[a]};e.prototype.toJSON=function(){var a=
this.slice();return b.isBuffer(a)?a.toJSON():a};e.prototype.toString=function(a,b,c){return this.slice().toString(a,b,c)};e.prototype.inspect=function(a,c){var d=this._bufArray().map(function(a){return b.isBuffer(a)?null!=c&&c.stylize?c.stylize(a.toString("hex"),"string"):a.toString("hex"):k.inspect(a,c)}).join(", ");return this.constructor.name+" ["+d+"]"};c=function(a,c){return function(d){d=this.read(c);return b.isBuffer(d)?d[a].call(d,0,!0):null}};var f=function(a,c){return function(d){var e=
new b(c);e[a].call(e,d,0,!0);return this.push(e)}};e.prototype.writeUInt8=f("writeUInt8",1);e.prototype.writeUInt16LE=f("writeUInt16LE",2);e.prototype.writeUInt16BE=f("writeUInt16BE",2);e.prototype.writeUInt32LE=f("writeUInt32LE",4);e.prototype.writeUInt32BE=f("writeUInt32BE",4);e.prototype.writeInt8=f("writeInt8",1);e.prototype.writeInt16LE=f("writeInt16LE",2);e.prototype.writeInt16BE=f("writeInt16BE",2);e.prototype.writeInt32LE=f("writeInt32LE",4);e.prototype.writeInt32BE=f("writeInt32BE",4);e.prototype.writeFloatLE=
f("writeFloatLE",4);e.prototype.writeFloatBE=f("writeFloatBE",4);e.prototype.writeDoubleLE=f("writeDoubleLE",8);e.prototype.writeDoubleBE=f("writeDoubleBE",8);e.prototype.readUInt8=c("readUInt8",1);e.prototype.readUInt16LE=c("readUInt16LE",2);e.prototype.readUInt16BE=c("readUInt16BE",2);e.prototype.readUInt32LE=c("readUInt32LE",4);e.prototype.readUInt32BE=c("readUInt32BE",4);e.prototype.readInt8=c("readInt8",1);e.prototype.readInt16LE=c("readInt16LE",2);e.prototype.readInt16BE=c("readInt16BE",2);
e.prototype.readInt32LE=c("readInt32LE",4);e.prototype.readInt32BE=c("readInt32BE",4);e.prototype.readFloatLE=c("readFloatLE",4);e.prototype.readFloatBE=c("readFloatBE",4);e.prototype.readDoubleLE=c("readDoubleLE",8);e.prototype.readDoubleBE=c("readDoubleBE",8);(function(a){var b;var c=[];for(b in a){var f=a[b];c.push(e.prototype.__defineGetter__(b,f))}return c})({length:function(){return this._readableState.length}});return e}(c.Transform)}).call(this)}).call(this,f("buffer").Buffer)},{buffer:27,
stream:128,util:136}],109:[function(f,m,k){(function(b){function a(a,c,f,e){if("function"!==typeof a)throw new TypeError('"callback" argument must be a function');var g=arguments.length;switch(g){case 0:case 1:return b.nextTick(a);case 2:return b.nextTick(function(){a.call(null,c)});case 3:return b.nextTick(function(){a.call(null,c,f)});case 4:return b.nextTick(function(){a.call(null,c,f,e)});default:var k=Array(g-1);for(g=0;g<k.length;)k[g++]=arguments[g];return b.nextTick(function(){a.apply(null,
k)})}}!b.version||0===b.version.indexOf("v0.")||0===b.version.indexOf("v1.")&&0!==b.version.indexOf("v1.8.")?m.exports=a:m.exports=b.nextTick}).call(this,f("_process"))},{_process:110}],110:[function(f,m,k){function b(){throw Error("setTimeout has not been defined");}function a(){throw Error("clearTimeout has not been defined");}function g(a){if(w===setTimeout)return setTimeout(a,0);if((w===b||!w)&&setTimeout)return w=setTimeout,setTimeout(a,0);try{return w(a,0)}catch(C){try{return w.call(null,a,
0)}catch(q){return w.call(this,a,0)}}}function c(b){if(d===clearTimeout)return clearTimeout(b);if((d===a||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(b);try{return d(b)}catch(C){try{return d.call(null,b)}catch(q){return d.call(this,b)}}}function l(){B&&F&&(B=!1,F.length?r=F.concat(r):A=-1,r.length&&e())}function e(){if(!B){var a=g(l);B=!0;for(var b=r.length;b;){F=r;for(r=[];++A<b;)F&&F[A].run();A=-1;b=r.length}F=null;B=!1;c(a)}}function h(a,b){this.fun=a;this.array=b}function n(){}f=m.exports=
{};try{var w="function"===typeof setTimeout?setTimeout:b}catch(y){w=b}try{var d="function"===typeof clearTimeout?clearTimeout:a}catch(y){d=a}var r=[],B=!1,F,A=-1;f.nextTick=function(a){var b=Array(arguments.length-1);if(1<arguments.length)for(var c=1;c<arguments.length;c++)b[c-1]=arguments[c];r.push(new h(a,b));1!==r.length||B||g(e)};h.prototype.run=function(){this.fun.apply(null,this.array)};f.title="browser";f.browser=!0;f.env={};f.argv=[];f.version="";f.versions={};f.on=n;f.addListener=n;f.once=
n;f.off=n;f.removeListener=n;f.removeAllListeners=n;f.emit=n;f.prependListener=n;f.prependOnceListener=n;f.listeners=function(a){return[]};f.binding=function(a){throw Error("process.binding is not supported");};f.cwd=function(){return"/"};f.chdir=function(a){throw Error("process.chdir is not supported");};f.umask=function(){return 0}},{}],111:[function(f,m,k){(function(b){(function(a){function f(a){throw new RangeError(I[a]);}function c(a,b){for(var c=a.length,d=[];c--;)d[c]=b(a[c]);return d}function l(a,
b){var d=a.split("@"),e="";1<d.length&&(e=d[0]+"@",a=d[1]);a=a.replace(q,".");d=a.split(".");d=c(d,b).join(".");return e+d}function e(a){for(var b=[],c=0,d=a.length,e,f;c<d;)e=a.charCodeAt(c++),55296<=e&&56319>=e&&c<d?(f=a.charCodeAt(c++),56320==(f&64512)?b.push(((e&1023)<<10)+(f&1023)+65536):(b.push(e),c--)):b.push(e);return b}function h(a){return c(a,function(a){var b="";65535<a&&(a-=65536,b+=K(a>>>10&1023|55296),a=56320|a&1023);return b+=K(a)}).join("")}function n(a,b){return a+22+75*(26>a)-((0!=
b)<<5)}function w(a,b,c){var d=0;a=c?G(a/700):a>>1;for(a+=G(a/b);455<a;d+=36)a=G(a/35);return G(d+36*a/(a+38))}function d(a){var b=[],c=a.length,d=0,e=128,g=72,k,l;var p=a.lastIndexOf("-");0>p&&(p=0);for(k=0;k<p;++k)128<=a.charCodeAt(k)&&f("not-basic"),b.push(a.charCodeAt(k));for(p=0<p?p+1:0;p<c;){k=d;var n=1;for(l=36;;l+=36){p>=c&&f("invalid-input");var q=a.charCodeAt(p++);q=10>q-48?q-22:26>q-65?q-65:26>q-97?q-97:36;(36<=q||q>G((2147483647-d)/n))&&f("overflow");d+=q*n;var m=l<=g?1:l>=g+26?26:l-g;
if(q<m)break;q=36-m;n>G(2147483647/q)&&f("overflow");n*=q}n=b.length+1;g=w(d-k,n,0==k);G(d/n)>2147483647-e&&f("overflow");e+=G(d/n);d%=n;b.splice(d++,0,e)}return h(b)}function r(a){var b,c,d,g=[];a=e(a);var h=a.length;var k=128;var l=0;var p=72;for(d=0;d<h;++d){var q=a[d];128>q&&g.push(K(q))}for((b=c=g.length)&&g.push("-");b<h;){var m=2147483647;for(d=0;d<h;++d)q=a[d],q>=k&&q<m&&(m=q);var r=b+1;m-k>G((2147483647-l)/r)&&f("overflow");l+=(m-k)*r;k=m;for(d=0;d<h;++d)if(q=a[d],q<k&&2147483647<++l&&f("overflow"),
q==k){var A=l;for(m=36;;m+=36){q=m<=p?1:m>=p+26?26:m-p;if(A<q)break;var y=A-q;A=36-q;g.push(K(n(q+y%A,0)));A=G(y/A)}g.push(K(n(A,0)));p=w(l,r,b==c);l=0;++b}++l;++k}return g.join("")}var B="object"==typeof k&&k&&!k.nodeType&&k,F="object"==typeof m&&m&&!m.nodeType&&m,A="object"==typeof b&&b;if(A.global===A||A.window===A||A.self===A)a=A;var y=/^xn--/,C=/[^\x20-\x7E]/,q=/[\x2E\u3002\uFF0E\uFF61]/g,I={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)",
"invalid-input":"Invalid input"},G=Math.floor,K=String.fromCharCode,O,A={version:"1.4.1",ucs2:{decode:e,encode:h},decode:d,encode:r,toASCII:function(a){return l(a,function(a){return C.test(a)?"xn--"+r(a):a})},toUnicode:function(a){return l(a,function(a){return y.test(a)?d(a.slice(4).toLowerCase()):a})}};if(B&&F)if(m.exports==B)F.exports=A;else for(O in A)A.hasOwnProperty(O)&&(B[O]=A[O]);else a.punycode=A})(this)}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==
typeof window?window:{})},{}],112:[function(f,m,k){m.exports=function(a,f,c,k){c=c||"=";var e={};if("string"!==typeof a||0===a.length)return e;var g=/\+/g;a=a.split(f||"&");f=1E3;k&&"number"===typeof k.maxKeys&&(f=k.maxKeys);k=a.length;0<f&&k>f&&(k=f);for(f=0;f<k;++f){var l=a[f].replace(g,"%20"),m=l.indexOf(c);if(0<=m){var d=l.substr(0,m);l=l.substr(m+1)}else d=l,l="";d=decodeURIComponent(d);l=decodeURIComponent(l);Object.prototype.hasOwnProperty.call(e,d)?b(e[d])?e[d].push(l):e[d]=[e[d],l]:e[d]=
l}return e};var b=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)}},{}],113:[function(f,m,k){function b(a,b){if(a.map)return a.map(b);for(var c=[],e=0;e<a.length;e++)c.push(b(a[e],e));return c}var a=function(a){switch(typeof a){case "string":return a;case "boolean":return a?"true":"false";case "number":return isFinite(a)?a:"";default:return""}};m.exports=function(f,e,h,k){e=e||"&";h=h||"=";null===f&&(f=void 0);return"object"===typeof f?b(c(f),function(c){var d=
encodeURIComponent(a(c))+h;return g(f[c])?b(f[c],function(b){return d+encodeURIComponent(a(b))}).join(e):d+encodeURIComponent(a(f[c]))}).join(e):k?encodeURIComponent(a(k))+h+encodeURIComponent(a(f)):""};var g=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)},c=Object.keys||function(a){var b=[],c;for(c in a)Object.prototype.hasOwnProperty.call(a,c)&&b.push(c);return b}},{}],114:[function(f,m,k){k.decode=k.parse=f("./decode");k.encode=k.stringify=f("./encode")},
{"./decode":112,"./encode":113}],115:[function(f,m,k){m.exports=f("./lib/_stream_duplex.js")},{"./lib/_stream_duplex.js":116}],116:[function(f,m,k){function b(c){if(!(this instanceof b))return new b(c);l.call(this,c);e.call(this,c);c&&!1===c.readable&&(this.readable=!1);c&&!1===c.writable&&(this.writable=!1);this.allowHalfOpen=!0;c&&!1===c.allowHalfOpen&&(this.allowHalfOpen=!1);this.once("end",a)}function a(){this.allowHalfOpen||this._writableState.ended||c(g,this)}function g(a){a.end()}k=Object.keys||
function(a){var b=[],c;for(c in a)b.push(c);return b};m.exports=b;var c=f("process-nextick-args");m=f("core-util-is");m.inherits=f("inherits");var l=f("./_stream_readable"),e=f("./_stream_writable");m.inherits(b,l);f=k(e.prototype);for(m=0;m<f.length;m++)k=f[m],b.prototype[k]||(b.prototype[k]=e.prototype[k])},{"./_stream_readable":118,"./_stream_writable":120,"core-util-is":38,inherits:76,"process-nextick-args":109}],117:[function(f,m,k){function b(f){if(!(this instanceof b))return new b(f);a.call(this,
f)}m.exports=b;var a=f("./_stream_transform");m=f("core-util-is");m.inherits=f("inherits");m.inherits(b,a);b.prototype._transform=function(a,b,f){f(null,a)}},{"./_stream_transform":119,"core-util-is":38,inherits:76}],118:[function(f,m,k){(function(b){function a(a,b,c){if("function"===typeof a.prependListener)return a.prependListener(b,c);if(a._events&&a._events[b])G(a._events[b])?a._events[b].unshift(c):a._events[b]=[c,a._events[b]];else a.on(b,c)}function g(a,b){K=K||f("./_stream_duplex");a=a||{};
this.objectMode=!!a.objectMode;b instanceof K&&(this.objectMode=this.objectMode||!!a.readableObjectMode);var c=a.highWaterMark,d=this.objectMode?16:16384;this.highWaterMark=c||0===c?c:d;this.highWaterMark=~~this.highWaterMark;this.buffer=new U;this.length=0;this.pipes=null;this.pipesCount=0;this.flowing=null;this.reading=this.endEmitted=this.ended=!1;this.sync=!0;this.resumeScheduled=this.readableListening=this.emittedReadable=this.needReadable=!1;this.defaultEncoding=a.defaultEncoding||"utf8";this.ranOut=
!1;this.awaitDrain=0;this.readingMore=!1;this.encoding=this.decoder=null;a.encoding&&(M||(M=f("string_decoder/").StringDecoder),this.decoder=new M(a.encoding),this.encoding=a.encoding)}function c(a){K=K||f("./_stream_duplex");if(!(this instanceof c))return new c(a);this._readableState=new g(a,this);this.readable=!0;a&&"function"===typeof a.read&&(this._read=a.read);O.call(this)}function k(a,b,c,d,e){var f=c;var g=null;J.isBuffer(f)||"string"===typeof f||null===f||void 0===f||b.objectMode||(g=new TypeError("Invalid non-string/buffer chunk"));
if(f=g)a.emit("error",f);else if(null===c)b.reading=!1,b.ended||(b.decoder&&(c=b.decoder.end())&&c.length&&(b.buffer.push(c),b.length+=b.objectMode?1:c.length),b.ended=!0,h(a));else if(b.objectMode||c&&0<c.length)if(b.ended&&!e)a.emit("error",Error("stream.push() after EOF"));else if(b.endEmitted&&e)a.emit("error",Error("stream.unshift() after end event"));else{if(b.decoder&&!e&&!d){c=b.decoder.write(c);var k=!b.objectMode&&0===c.length}e||(b.reading=!1);k||(b.flowing&&0===b.length&&!b.sync?(a.emit("data",
c),a.read(0)):(b.length+=b.objectMode?1:c.length,e?b.buffer.unshift(c):b.buffer.push(c),b.needReadable&&h(a)));b.readingMore||(b.readingMore=!0,I(w,a,b))}else e||(b.reading=!1);return!b.ended&&(b.needReadable||b.length<b.highWaterMark||0===b.length)}function e(a,b){if(0>=a||0===b.length&&b.ended)return 0;if(b.objectMode)return 1;if(a!==a)return b.flowing&&b.length?b.buffer.head.data.length:b.length;if(a>b.highWaterMark){var c=a;8388608<=c?c=8388608:(c--,c|=c>>>1,c|=c>>>2,c|=c>>>4,c|=c>>>8,c|=c>>>
16,c++);b.highWaterMark=c}return a<=b.length?a:b.ended?b.length:(b.needReadable=!0,0)}function h(a){var b=a._readableState;b.needReadable=!1;b.emittedReadable||(x("emitReadable",b.flowing),b.emittedReadable=!0,b.sync?I(n,a):n(a))}function n(a){x("emit readable");a.emit("readable");F(a)}function w(a,b){for(var c=b.length;!b.reading&&!b.flowing&&!b.ended&&b.length<b.highWaterMark&&(x("maybeReadMore read 0"),a.read(0),c!==b.length);)c=b.length;b.readingMore=!1}function d(a){return function(){var b=a._readableState;
x("pipeOnDrain",b.awaitDrain);b.awaitDrain&&b.awaitDrain--;0===b.awaitDrain&&a.listeners("data").length&&(b.flowing=!0,F(a))}}function r(a){x("readable nexttick read 0");a.read(0)}function B(a,b){b.reading||(x("resume read 0"),a.read(0));b.resumeScheduled=!1;b.awaitDrain=0;a.emit("resume");F(a);b.flowing&&!b.reading&&a.read(0)}function F(a){var b=a._readableState;for(x("flow",b.flowing);b.flowing&&null!==a.read(););}function A(a,b){if(0===b.length)return null;if(b.objectMode)var c=b.buffer.shift();
else if(!a||a>=b.length)c=b.decoder?b.buffer.join(""):1===b.buffer.length?b.buffer.head.data:b.buffer.concat(b.length),b.buffer.clear();else{c=b.buffer;var d=b.decoder;if(a<c.head.data.length)d=c.head.data.slice(0,a),c.head.data=c.head.data.slice(a);else{if(a===c.head.data.length)c=c.shift();else if(d){for(var e=c.head,f=1,g=e.data,d=a-g.length;e=e.next;){var h=e.data,k=d>h.length?h.length:d,g=k===h.length?g+h:g+h.slice(0,d),d=d-k;if(0===d){k===h.length?(++f,c.head=e.next?e.next:c.tail=null):(c.head=
e,e.data=h.slice(k));break}++f}c.length-=f;c=g}else{d=a;e=D.allocUnsafe(d);f=c.head;g=1;f.data.copy(e);for(d-=f.data.length;f=f.next;){h=f.data;k=d>h.length?h.length:d;h.copy(e,e.length-d,0,k);d-=k;if(0===d){k===h.length?(++g,c.head=f.next?f.next:c.tail=null):(c.head=f,f.data=h.slice(k));break}++g}c.length-=g;c=e}d=c}c=d}return c}function y(a){var b=a._readableState;if(0<b.length)throw Error('"endReadable()" called on non-empty stream');b.endEmitted||(b.ended=!0,I(C,b,a))}function C(a,b){a.endEmitted||
0!==a.length||(a.endEmitted=!0,b.readable=!1,b.emit("end"))}function q(a,b){for(var c=0,d=a.length;c<d;c++)if(a[c]===b)return c;return-1}m.exports=c;var I=f("process-nextick-args"),G=f("isarray"),K;c.ReadableState=g;f("events");var O=f("./internal/streams/stream"),J=f("buffer").Buffer,D=f("buffer-shims"),L=f("core-util-is");L.inherits=f("inherits");var N=f("util"),x=void 0,x=N&&N.debuglog?N.debuglog("stream"):function(){},U=f("./internal/streams/BufferList"),M;L.inherits(c,O);var u=["error","close",
"destroy","pause","resume"];c.prototype.push=function(a,b){var c=this._readableState;c.objectMode||"string"!==typeof a||(b=b||c.defaultEncoding,b!==c.encoding&&(a=D.from(a,b),b=""));return k(this,c,a,b,!1)};c.prototype.unshift=function(a){return k(this,this._readableState,a,"",!0)};c.prototype.isPaused=function(){return!1===this._readableState.flowing};c.prototype.setEncoding=function(a){M||(M=f("string_decoder/").StringDecoder);this._readableState.decoder=new M(a);this._readableState.encoding=a;
return this};c.prototype.read=function(a){x("read",a);a=parseInt(a,10);var b=this._readableState,c=a;0!==a&&(b.emittedReadable=!1);if(0===a&&b.needReadable&&(b.length>=b.highWaterMark||b.ended))return x("read: emitReadable",b.length,b.ended),0===b.length&&b.ended?y(this):h(this),null;a=e(a,b);if(0===a&&b.ended)return 0===b.length&&y(this),null;var d=b.needReadable;x("need readable",d);if(0===b.length||b.length-a<b.highWaterMark)d=!0,x("length less than watermark",d);b.ended||b.reading?x("reading or ended",
!1):d&&(x("do read"),b.reading=!0,b.sync=!0,0===b.length&&(b.needReadable=!0),this._read(b.highWaterMark),b.sync=!1,b.reading||(a=e(c,b)));d=0<a?A(a,b):null;null===d?(b.needReadable=!0,a=0):b.length-=a;0===b.length&&(b.ended||(b.needReadable=!0),c!==a&&b.ended&&y(this));null!==d&&this.emit("data",d);return d};c.prototype._read=function(a){this.emit("error",Error("_read() is not implemented"))};c.prototype.pipe=function(c,e){function f(a){x("onunpipe");a===r&&h()}function g(){x("onend");c.end()}function h(){x("cleanup");
c.removeListener("close",p);c.removeListener("finish",n);c.removeListener("drain",G);c.removeListener("error",l);c.removeListener("unpipe",f);r.removeListener("end",g);r.removeListener("end",h);r.removeListener("data",k);A=!0;!t.awaitDrain||c._writableState&&!c._writableState.needDrain||G()}function k(a){x("ondata");w=!1;!1!==c.write(a)||w||((1===t.pipesCount&&t.pipes===c||1<t.pipesCount&&-1!==q(t.pipes,c))&&!A&&(x("false write response, pause",r._readableState.awaitDrain),r._readableState.awaitDrain++,
w=!0),r.pause())}function l(a){x("onerror",a);m();c.removeListener("error",l);0===c.listeners("error").length&&c.emit("error",a)}function p(){c.removeListener("finish",n);m()}function n(){x("onfinish");c.removeListener("close",p);m()}function m(){x("unpipe");r.unpipe(c)}var r=this,t=this._readableState;switch(t.pipesCount){case 0:t.pipes=c;break;case 1:t.pipes=[t.pipes,c];break;default:t.pipes.push(c)}t.pipesCount+=1;x("pipe count=%d opts=%j",t.pipesCount,e);var u=e&&!1===e.end||c===b.stdout||c===
b.stderr?h:g;if(t.endEmitted)I(u);else r.once("end",u);c.on("unpipe",f);var G=d(r);c.on("drain",G);var A=!1,w=!1;r.on("data",k);a(c,"error",l);c.once("close",p);c.once("finish",n);c.emit("pipe",r);t.flowing||(x("pipe resume"),r.resume());return c};c.prototype.unpipe=function(a){var b=this._readableState;if(0===b.pipesCount)return this;if(1===b.pipesCount){if(a&&a!==b.pipes)return this;a||(a=b.pipes);b.pipes=null;b.pipesCount=0;b.flowing=!1;a&&a.emit("unpipe",this);return this}if(!a){a=b.pipes;var c=
b.pipesCount;b.pipes=null;b.pipesCount=0;b.flowing=!1;for(b=0;b<c;b++)a[b].emit("unpipe",this);return this}c=q(b.pipes,a);if(-1===c)return this;b.pipes.splice(c,1);--b.pipesCount;1===b.pipesCount&&(b.pipes=b.pipes[0]);a.emit("unpipe",this);return this};c.prototype.on=function(a,b){var c=O.prototype.on.call(this,a,b);if("data"===a)!1!==this._readableState.flowing&&this.resume();else if("readable"===a){var d=this._readableState;d.endEmitted||d.readableListening||(d.readableListening=d.needReadable=
!0,d.emittedReadable=!1,d.reading?d.length&&h(this,d):I(r,this))}return c};c.prototype.addListener=c.prototype.on;c.prototype.resume=function(){var a=this._readableState;a.flowing||(x("resume"),a.flowing=!0,a.resumeScheduled||(a.resumeScheduled=!0,I(B,this,a)));return this};c.prototype.pause=function(){x("call pause flowing=%j",this._readableState.flowing);!1!==this._readableState.flowing&&(x("pause"),this._readableState.flowing=!1,this.emit("pause"));return this};c.prototype.wrap=function(a){var b=
this._readableState,c=!1,d=this;a.on("end",function(){x("wrapped end");if(b.decoder&&!b.ended){var a=b.decoder.end();a&&a.length&&d.push(a)}d.push(null)});a.on("data",function(e){x("wrapped data");b.decoder&&(e=b.decoder.write(e));b.objectMode&&(null===e||void 0===e)||!(b.objectMode||e&&e.length)||d.push(e)||(c=!0,a.pause())});for(var e in a)void 0===this[e]&&"function"===typeof a[e]&&(this[e]=function(b){return function(){return a[b].apply(a,arguments)}}(e));for(e=0;e<u.length;e++)a.on(u[e],d.emit.bind(d,
u[e]));d._read=function(b){x("wrapped _read",b);c&&(c=!1,a.resume())};return d};c._fromList=A}).call(this,f("_process"))},{"./_stream_duplex":116,"./internal/streams/BufferList":121,"./internal/streams/stream":122,_process:110,buffer:27,"buffer-shims":26,"core-util-is":38,events:74,inherits:76,isarray:79,"process-nextick-args":109,"string_decoder/":129,util:24}],119:[function(f,m,k){function b(a){this.afterTransform=function(b,c){var e=a._transformState;e.transforming=!1;var f=e.writecb;f?(e.writechunk=
null,e.writecb=null,null!==c&&void 0!==c&&a.push(c),f(b),e=a._readableState,e.reading=!1,(e.needReadable||e.length<e.highWaterMark)&&a._read(e.highWaterMark),e=void 0):e=a.emit("error",Error("no writecb in Transform class"));return e};this.transforming=this.needTransform=!1;this.writeencoding=this.writechunk=this.writecb=null}function a(f){if(!(this instanceof a))return new a(f);c.call(this,f);this._transformState=new b(this);var e=this;this._readableState.needReadable=!0;this._readableState.sync=
!1;f&&("function"===typeof f.transform&&(this._transform=f.transform),"function"===typeof f.flush&&(this._flush=f.flush));this.once("prefinish",function(){"function"===typeof this._flush?this._flush(function(a,b){g(e,a,b)}):g(e)})}function g(a,b,c){if(b)return a.emit("error",b);null!==c&&void 0!==c&&a.push(c);b=a._transformState;if(a._writableState.length)throw Error("Calling transform done when ws.length != 0");if(b.transforming)throw Error("Calling transform done when still transforming");return a.push(null)}
m.exports=a;var c=f("./_stream_duplex");m=f("core-util-is");m.inherits=f("inherits");m.inherits(a,c);a.prototype.push=function(a,b){this._transformState.needTransform=!1;return c.prototype.push.call(this,a,b)};a.prototype._transform=function(a,b,c){throw Error("_transform() is not implemented");};a.prototype._write=function(a,b,c){var e=this._transformState;e.writecb=c;e.writechunk=a;e.writeencoding=b;e.transforming||(a=this._readableState,(e.needTransform||a.needReadable||a.length<a.highWaterMark)&&
this._read(a.highWaterMark))};a.prototype._read=function(a){a=this._transformState;null!==a.writechunk&&a.writecb&&!a.transforming?(a.transforming=!0,this._transform(a.writechunk,a.writeencoding,a.afterTransform)):a.needTransform=!0}},{"./_stream_duplex":116,"core-util-is":38,inherits:76}],120:[function(f,m,k){(function(b){function a(){}function g(a,b,c){this.chunk=a;this.encoding=b;this.callback=c;this.next=null}function c(a,b){A=A||f("./_stream_duplex");a=a||{};this.objectMode=!!a.objectMode;b instanceof
A&&(this.objectMode=this.objectMode||!!a.writableObjectMode);var c=a.highWaterMark,d=this.objectMode?16:16384;this.highWaterMark=c||0===c?c:d;this.highWaterMark=~~this.highWaterMark;this.finished=this.ended=this.ending=this.needDrain=!1;this.decodeStrings=!1!==a.decodeStrings;this.defaultEncoding=a.defaultEncoding||"utf8";this.length=0;this.writing=!1;this.corked=0;this.sync=!0;this.bufferProcessing=!1;this.onwrite=function(a){var c=b._writableState,d=c.sync,e=c.writecb;c.writing=!1;c.writecb=null;
c.length-=c.writelen;c.writelen=0;a?(--c.pendingcb,d?B(e,a):e(a),b._writableState.errorEmitted=!0,b.emit("error",a)):((a=w(c))||c.corked||c.bufferProcessing||!c.bufferedRequest||n(b,c),d?F(h,b,c,a,e):h(b,c,a,e))};this.writecb=null;this.writelen=0;this.lastBufferedRequest=this.bufferedRequest=null;this.pendingcb=0;this.errorEmitted=this.prefinished=!1;this.bufferedRequestCount=0;this.corkedRequestsFree=new r(this)}function k(a){A=A||f("./_stream_duplex");if(!(G.call(k,this)||this instanceof A))return new k(a);
this._writableState=new c(a,this);this.writable=!0;a&&("function"===typeof a.write&&(this._write=a.write),"function"===typeof a.writev&&(this._writev=a.writev));C.call(this)}function e(a,b,c,d,e,f,g){b.writelen=d;b.writecb=g;b.writing=!0;b.sync=!0;c?a._writev(e,b.onwrite):a._write(e,f,b.onwrite);b.sync=!1}function h(a,b,c,e){!c&&0===b.length&&b.needDrain&&(b.needDrain=!1,a.emit("drain"));b.pendingcb--;e();d(a,b)}function n(a,b){b.bufferProcessing=!0;var c=b.bufferedRequest;if(a._writev&&c&&c.next){var d=
Array(b.bufferedRequestCount),f=b.corkedRequestsFree;f.entry=c;for(var g=0;c;)d[g]=c,c=c.next,g+=1;e(a,b,!0,b.length,d,"",f.finish);b.pendingcb++;b.lastBufferedRequest=null;f.next?(b.corkedRequestsFree=f.next,f.next=null):b.corkedRequestsFree=new r(b)}else{for(;c&&(d=c.chunk,e(a,b,!1,b.objectMode?1:d.length,d,c.encoding,c.callback),c=c.next,!b.writing););null===c&&(b.lastBufferedRequest=null)}b.bufferedRequestCount=0;b.bufferedRequest=c;b.bufferProcessing=!1}function w(a){return a.ending&&0===a.length&&
null===a.bufferedRequest&&!a.finished&&!a.writing}function d(a,b){var c=w(b);c&&(0===b.pendingcb?(b.prefinished||(b.prefinished=!0,a.emit("prefinish")),b.finished=!0,a.emit("finish")):b.prefinished||(b.prefinished=!0,a.emit("prefinish")));return c}function r(a){var b=this;this.entry=this.next=null;this.finish=function(c){var d=b.entry;for(b.entry=null;d;){var e=d.callback;a.pendingcb--;e(c);d=d.next}a.corkedRequestsFree?a.corkedRequestsFree.next=b:a.corkedRequestsFree=b}}m.exports=k;var B=f("process-nextick-args"),
F=!b.browser&&-1<["v0.10","v0.9."].indexOf(b.version.slice(0,5))?setImmediate:B,A;k.WritableState=c;b=f("core-util-is");b.inherits=f("inherits");var y={deprecate:f("util-deprecate")},C=f("./internal/streams/stream"),q=f("buffer").Buffer,I=f("buffer-shims");b.inherits(k,C);c.prototype.getBuffer=function(){for(var a=this.bufferedRequest,b=[];a;)b.push(a),a=a.next;return b};(function(){try{Object.defineProperty(c.prototype,"buffer",{get:y.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(K){}})();
$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();if("function"===typeof Symbol&&Symbol.hasInstance&&"function"===typeof Function.prototype[Symbol.hasInstance]){$jscomp.initSymbol();var G=Function.prototype[Symbol.hasInstance];$jscomp.initSymbol();Object.defineProperty(k,Symbol.hasInstance,{value:function(a){return G.call(this,a)?!0:a&&a._writableState instanceof c}})}else G=function(a){return a instanceof this};k.prototype.pipe=function(){this.emit("error",Error("Cannot pipe, not readable"))};
k.prototype.write=function(b,c,d){var f=this._writableState,h=!1,k=q.isBuffer(b);"function"===typeof c&&(d=c,c=null);k?c="buffer":c||(c=f.defaultEncoding);"function"!==typeof d&&(d=a);if(f.ended)f=d,k=Error("write after end"),this.emit("error",k),B(f,k);else{var l;if(!(l=k)){l=d;var n=!0,m=!1;null===b?m=new TypeError("May not write null values to stream"):"string"===typeof b||void 0===b||f.objectMode||(m=new TypeError("Invalid non-string/buffer chunk"));m&&(this.emit("error",m),B(l,m),n=!1);l=n}l&&
(f.pendingcb++,h=b,k||(k=h,f.objectMode||!1===f.decodeStrings||"string"!==typeof k||(k=I.from(k,c)),h=k,q.isBuffer(h)&&(c="buffer")),b=f.objectMode?1:h.length,f.length+=b,k=f.length<f.highWaterMark,k||(f.needDrain=!0),f.writing||f.corked?(b=f.lastBufferedRequest,f.lastBufferedRequest=new g(h,c,d),b?b.next=f.lastBufferedRequest:f.bufferedRequest=f.lastBufferedRequest,f.bufferedRequestCount+=1):e(this,f,!1,b,h,c,d),h=k)}return h};k.prototype.cork=function(){this._writableState.corked++};k.prototype.uncork=
function(){var a=this._writableState;a.corked&&(a.corked--,a.writing||a.corked||a.finished||a.bufferProcessing||!a.bufferedRequest||n(this,a))};k.prototype.setDefaultEncoding=function(a){"string"===typeof a&&(a=a.toLowerCase());if(!(-1<"hex utf8 utf-8 ascii binary base64 ucs2 ucs-2 utf16le utf-16le raw".split(" ").indexOf((a+"").toLowerCase())))throw new TypeError("Unknown encoding: "+a);this._writableState.defaultEncoding=a;return this};k.prototype._write=function(a,b,c){c(Error("_write() is not implemented"))};
k.prototype._writev=null;k.prototype.end=function(a,b,c){var e=this._writableState;"function"===typeof a?(c=a,b=a=null):"function"===typeof b&&(c=b,b=null);null!==a&&void 0!==a&&this.write(a,b);e.corked&&(e.corked=1,this.uncork());if(!e.ending&&!e.finished){a=c;e.ending=!0;d(this,e);if(a)if(e.finished)B(a);else this.once("finish",a);e.ended=!0;this.writable=!1}}}).call(this,f("_process"))},{"./_stream_duplex":116,"./internal/streams/stream":122,_process:110,buffer:27,"buffer-shims":26,"core-util-is":38,
inherits:76,"process-nextick-args":109,"util-deprecate":133}],121:[function(f,m,k){function b(){this.tail=this.head=null;this.length=0}f("buffer");var a=f("buffer-shims");m.exports=b;b.prototype.push=function(a){a={data:a,next:null};0<this.length?this.tail.next=a:this.head=a;this.tail=a;++this.length};b.prototype.unshift=function(a){a={data:a,next:this.head};0===this.length&&(this.tail=a);this.head=a;++this.length};b.prototype.shift=function(){if(0!==this.length){var a=this.head.data;this.head=1===
this.length?this.tail=null:this.head.next;--this.length;return a}};b.prototype.clear=function(){this.head=this.tail=null;this.length=0};b.prototype.join=function(a){if(0===this.length)return"";for(var b=this.head,f=""+b.data;b=b.next;)f+=a+b.data;return f};b.prototype.concat=function(b){if(0===this.length)return a.alloc(0);if(1===this.length)return this.head.data;b=a.allocUnsafe(b>>>0);for(var c=this.head,f=0;c;)c.data.copy(b,f),f+=c.data.length,c=c.next;return b}},{buffer:27,"buffer-shims":26}],
122:[function(f,m,k){m.exports=f("events").EventEmitter},{events:74}],123:[function(f,m,k){m.exports=f("./readable").PassThrough},{"./readable":124}],124:[function(f,m,k){k=m.exports=f("./lib/_stream_readable.js");k.Stream=k;k.Readable=k;k.Writable=f("./lib/_stream_writable.js");k.Duplex=f("./lib/_stream_duplex.js");k.Transform=f("./lib/_stream_transform.js");k.PassThrough=f("./lib/_stream_passthrough.js")},{"./lib/_stream_duplex.js":116,"./lib/_stream_passthrough.js":117,"./lib/_stream_readable.js":118,
"./lib/_stream_transform.js":119,"./lib/_stream_writable.js":120}],125:[function(f,m,k){m.exports=f("./readable").Transform},{"./readable":124}],126:[function(f,m,k){m.exports=f("./lib/_stream_writable.js")},{"./lib/_stream_writable.js":120}],127:[function(f,m,k){m.exports=f("buffer")},{buffer:27}],128:[function(f,m,k){function b(){a.call(this)}m.exports=b;var a=f("events").EventEmitter;f("inherits")(b,a);b.Readable=f("readable-stream/readable.js");b.Writable=f("readable-stream/writable.js");b.Duplex=
f("readable-stream/duplex.js");b.Transform=f("readable-stream/transform.js");b.PassThrough=f("readable-stream/passthrough.js");b.Stream=b;b.prototype.pipe=function(b,c){function f(a){b.writable&&!1===b.write(a)&&r.pause&&r.pause()}function e(){r.readable&&r.resume&&r.resume()}function g(){B||(B=!0,b.end())}function k(){B||(B=!0,"function"===typeof b.destroy&&b.destroy())}function m(b){d();if(0===a.listenerCount(this,"error"))throw b;}function d(){r.removeListener("data",f);b.removeListener("drain",
e);r.removeListener("end",g);r.removeListener("close",k);r.removeListener("error",m);b.removeListener("error",m);r.removeListener("end",d);r.removeListener("close",d);b.removeListener("close",d)}var r=this;r.on("data",f);b.on("drain",e);b._isStdio||c&&!1===c.end||(r.on("end",g),r.on("close",k));var B=!1;r.on("error",m);b.on("error",m);r.on("end",d);r.on("close",d);b.on("close",d);b.emit("pipe",r);return b}},{events:74,inherits:76,"readable-stream/duplex.js":115,"readable-stream/passthrough.js":123,
"readable-stream/readable.js":124,"readable-stream/transform.js":125,"readable-stream/writable.js":126}],129:[function(f,m,k){function b(a){if(!a)return"utf8";for(var b;;)switch(a){case "utf8":case "utf-8":return"utf8";case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":return"utf16le";case "latin1":case "binary":return"latin1";case "base64":case "ascii":case "hex":return a;default:if(b)return;a=(""+a).toLowerCase();b=!0}}function a(a){var c=b(a);if("string"!==typeof c&&(B.isEncoding===F||!F(a)))throw Error("Unknown encoding: "+
a);this.encoding=c||a;switch(this.encoding){case "utf16le":this.text=e;this.end=h;a=4;break;case "utf8":this.fillLast=l;a=4;break;case "base64":this.text=n;this.end=w;a=3;break;default:this.write=d;this.end=r;return}this.lastTotal=this.lastNeed=0;this.lastChar=B.allocUnsafe(a)}function g(a){return 127>=a?0:6===a>>5?2:14===a>>4?3:30===a>>3?4:-1}function c(a,b,c){var d=b.length-1;if(d<c)return 0;var e=g(b[d]);if(0<=e)return 0<e&&(a.lastNeed=e-1),e;if(--d<c)return 0;e=g(b[d]);if(0<=e)return 0<e&&(a.lastNeed=
e-2),e;if(--d<c)return 0;e=g(b[d]);return 0<=e?(0<e&&(2===e?e=0:a.lastNeed=e-3),e):0}function l(a){var b=this.lastTotal-this.lastNeed;a:if(128!==(a[0]&192)){this.lastNeed=0;var c="\ufffd".repeat(b)}else{if(1<this.lastNeed&&1<a.length){if(128!==(a[1]&192)){this.lastNeed=1;c="\ufffd".repeat(b+1);break a}if(2<this.lastNeed&&2<a.length&&128!==(a[2]&192)){this.lastNeed=2;c="\ufffd".repeat(b+2);break a}}c=void 0}if(void 0!==c)return c;if(this.lastNeed<=a.length)return a.copy(this.lastChar,b,0,this.lastNeed),
this.lastChar.toString(this.encoding,0,this.lastTotal);a.copy(this.lastChar,b,0,a.length);this.lastNeed-=a.length}function e(a,b){if(0===(a.length-b)%2){var c=a.toString("utf16le",b);if(c){var d=c.charCodeAt(c.length-1);if(55296<=d&&56319>=d)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=a[a.length-2],this.lastChar[1]=a[a.length-1],c.slice(0,-1)}return c}this.lastNeed=1;this.lastTotal=2;this.lastChar[0]=a[a.length-1];return a.toString("utf16le",b,a.length-1)}function h(a){a=a&&a.length?
this.write(a):"";return this.lastNeed?a+this.lastChar.toString("utf16le",0,this.lastTotal-this.lastNeed):a}function n(a,b){var c=(a.length-b)%3;if(0===c)return a.toString("base64",b);this.lastNeed=3-c;this.lastTotal=3;1===c?this.lastChar[0]=a[a.length-1]:(this.lastChar[0]=a[a.length-2],this.lastChar[1]=a[a.length-1]);return a.toString("base64",b,a.length-c)}function w(a){a=a&&a.length?this.write(a):"";return this.lastNeed?a+this.lastChar.toString("base64",0,3-this.lastNeed):a}function d(a){return a.toString(this.encoding)}
function r(a){return a&&a.length?this.write(a):""}var B=f("safe-buffer").Buffer,F=B.isEncoding||function(a){a=""+a;switch(a&&a.toLowerCase()){case "hex":case "utf8":case "utf-8":case "ascii":case "binary":case "base64":case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":case "raw":return!0;default:return!1}};k.StringDecoder=a;a.prototype.write=function(a){if(0===a.length)return"";if(this.lastNeed){var b=this.fillLast(a);if(void 0===b)return"";var c=this.lastNeed;this.lastNeed=0}else c=0;return c<
a.length?b?b+this.text(a,c):this.text(a,c):b||""};a.prototype.end=function(a){a=a&&a.length?this.write(a):"";return this.lastNeed?a+"\ufffd".repeat(this.lastTotal-this.lastNeed):a};a.prototype.text=function(a,b){var d=c(this,a,b);if(!this.lastNeed)return a.toString("utf8",b);this.lastTotal=d;d=a.length-(d-this.lastNeed);a.copy(this.lastChar,0,d);return a.toString("utf8",b,d)};a.prototype.fillLast=function(a){if(this.lastNeed<=a.length)return a.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),
this.lastChar.toString(this.encoding,0,this.lastTotal);a.copy(this.lastChar,this.lastTotal-this.lastNeed,0,a.length);this.lastNeed-=a.length}},{"safe-buffer":127}],130:[function(f,m,k){(function(b){function a(a,b,c,d){a[b]=c>>24&255;a[b+1]=c>>16&255;a[b+2]=c>>8&255;a[b+3]=c&255;a[b+4]=d>>24&255;a[b+5]=d>>16&255;a[b+6]=d>>8&255;a[b+7]=d&255}function g(a,b,c,d,e){var f,g=0;for(f=0;f<e;f++)g|=a[b+f]^c[d+f];return(1&g-1>>>8)-1}function c(a,b,c,d){return g(a,b,c,d,16)}function k(a,b,c,d){return g(a,b,
c,d,32)}function e(a,b,c,d){var e=d[0]&255|(d[1]&255)<<8|(d[2]&255)<<16|(d[3]&255)<<24,f=c[0]&255|(c[1]&255)<<8|(c[2]&255)<<16|(c[3]&255)<<24,g=c[4]&255|(c[5]&255)<<8|(c[6]&255)<<16|(c[7]&255)<<24,h=c[8]&255|(c[9]&255)<<8|(c[10]&255)<<16|(c[11]&255)<<24,k=c[12]&255|(c[13]&255)<<8|(c[14]&255)<<16|(c[15]&255)<<24,aa=d[4]&255|(d[5]&255)<<8|(d[6]&255)<<16|(d[7]&255)<<24,l=b[0]&255|(b[1]&255)<<8|(b[2]&255)<<16|(b[3]&255)<<24,p=b[4]&255|(b[5]&255)<<8|(b[6]&255)<<16|(b[7]&255)<<24,n=b[8]&255|(b[9]&255)<<
8|(b[10]&255)<<16|(b[11]&255)<<24;b=b[12]&255|(b[13]&255)<<8|(b[14]&255)<<16|(b[15]&255)<<24;var q=d[8]&255|(d[9]&255)<<8|(d[10]&255)<<16|(d[11]&255)<<24,m=c[16]&255|(c[17]&255)<<8|(c[18]&255)<<16|(c[19]&255)<<24,ea=c[20]&255|(c[21]&255)<<8|(c[22]&255)<<16|(c[23]&255)<<24,r=c[24]&255|(c[25]&255)<<8|(c[26]&255)<<16|(c[27]&255)<<24;c=c[28]&255|(c[29]&255)<<8|(c[30]&255)<<16|(c[31]&255)<<24;d=d[12]&255|(d[13]&255)<<8|(d[14]&255)<<16|(d[15]&255)<<24;for(var H=e,u=f,t=g,G=h,ma=k,w=aa,y=l,W=p,B=n,A=b,J=
q,z=m,I=ea,K=r,F=c,O=d,v,L=0;20>L;L+=2)v=H+I|0,ma^=v<<7|v>>>25,v=ma+H|0,B^=v<<9|v>>>23,v=B+ma|0,I^=v<<13|v>>>19,v=I+B|0,H^=v<<18|v>>>14,v=w+u|0,A^=v<<7|v>>>25,v=A+w|0,K^=v<<9|v>>>23,v=K+A|0,u^=v<<13|v>>>19,v=u+K|0,w^=v<<18|v>>>14,v=J+y|0,F^=v<<7|v>>>25,v=F+J|0,t^=v<<9|v>>>23,v=t+F|0,y^=v<<13|v>>>19,v=y+t|0,J^=v<<18|v>>>14,v=O+z|0,G^=v<<7|v>>>25,v=G+O|0,W^=v<<9|v>>>23,v=W+G|0,z^=v<<13|v>>>19,v=z+W|0,O^=v<<18|v>>>14,v=H+G|0,u^=v<<7|v>>>25,v=u+H|0,t^=v<<9|v>>>23,v=t+u|0,G^=v<<13|v>>>19,v=G+t|0,H^=v<<
18|v>>>14,v=w+ma|0,y^=v<<7|v>>>25,v=y+w|0,W^=v<<9|v>>>23,v=W+y|0,ma^=v<<13|v>>>19,v=ma+W|0,w^=v<<18|v>>>14,v=J+A|0,z^=v<<7|v>>>25,v=z+J|0,B^=v<<9|v>>>23,v=B+z|0,A^=v<<13|v>>>19,v=A+B|0,J^=v<<18|v>>>14,v=O+F|0,I^=v<<7|v>>>25,v=I+O|0,K^=v<<9|v>>>23,v=K+I|0,F^=v<<13|v>>>19,v=F+K|0,O^=v<<18|v>>>14;H=H+e|0;u=u+f|0;t=t+g|0;G=G+h|0;ma=ma+k|0;w=w+aa|0;y=y+l|0;W=W+p|0;B=B+n|0;A=A+b|0;J=J+q|0;z=z+m|0;I=I+ea|0;K=K+r|0;F=F+c|0;O=O+d|0;a[0]=H>>>0&255;a[1]=H>>>8&255;a[2]=H>>>16&255;a[3]=H>>>24&255;a[4]=u>>>0&255;
a[5]=u>>>8&255;a[6]=u>>>16&255;a[7]=u>>>24&255;a[8]=t>>>0&255;a[9]=t>>>8&255;a[10]=t>>>16&255;a[11]=t>>>24&255;a[12]=G>>>0&255;a[13]=G>>>8&255;a[14]=G>>>16&255;a[15]=G>>>24&255;a[16]=ma>>>0&255;a[17]=ma>>>8&255;a[18]=ma>>>16&255;a[19]=ma>>>24&255;a[20]=w>>>0&255;a[21]=w>>>8&255;a[22]=w>>>16&255;a[23]=w>>>24&255;a[24]=y>>>0&255;a[25]=y>>>8&255;a[26]=y>>>16&255;a[27]=y>>>24&255;a[28]=W>>>0&255;a[29]=W>>>8&255;a[30]=W>>>16&255;a[31]=W>>>24&255;a[32]=B>>>0&255;a[33]=B>>>8&255;a[34]=B>>>16&255;a[35]=B>>>
24&255;a[36]=A>>>0&255;a[37]=A>>>8&255;a[38]=A>>>16&255;a[39]=A>>>24&255;a[40]=J>>>0&255;a[41]=J>>>8&255;a[42]=J>>>16&255;a[43]=J>>>24&255;a[44]=z>>>0&255;a[45]=z>>>8&255;a[46]=z>>>16&255;a[47]=z>>>24&255;a[48]=I>>>0&255;a[49]=I>>>8&255;a[50]=I>>>16&255;a[51]=I>>>24&255;a[52]=K>>>0&255;a[53]=K>>>8&255;a[54]=K>>>16&255;a[55]=K>>>24&255;a[56]=F>>>0&255;a[57]=F>>>8&255;a[58]=F>>>16&255;a[59]=F>>>24&255;a[60]=O>>>0&255;a[61]=O>>>8&255;a[62]=O>>>16&255;a[63]=O>>>24&255}function h(a,b,c,d){var e=d[0]&255|
(d[1]&255)<<8|(d[2]&255)<<16|(d[3]&255)<<24,f=c[0]&255|(c[1]&255)<<8|(c[2]&255)<<16|(c[3]&255)<<24,g=c[4]&255|(c[5]&255)<<8|(c[6]&255)<<16|(c[7]&255)<<24,h=c[8]&255|(c[9]&255)<<8|(c[10]&255)<<16|(c[11]&255)<<24,k=c[12]&255|(c[13]&255)<<8|(c[14]&255)<<16|(c[15]&255)<<24,aa=d[4]&255|(d[5]&255)<<8|(d[6]&255)<<16|(d[7]&255)<<24,l=b[0]&255|(b[1]&255)<<8|(b[2]&255)<<16|(b[3]&255)<<24,p=b[4]&255|(b[5]&255)<<8|(b[6]&255)<<16|(b[7]&255)<<24,n=b[8]&255|(b[9]&255)<<8|(b[10]&255)<<16|(b[11]&255)<<24;b=b[12]&
255|(b[13]&255)<<8|(b[14]&255)<<16|(b[15]&255)<<24;var q=d[8]&255|(d[9]&255)<<8|(d[10]&255)<<16|(d[11]&255)<<24,m=c[16]&255|(c[17]&255)<<8|(c[18]&255)<<16|(c[19]&255)<<24,ea=c[20]&255|(c[21]&255)<<8|(c[22]&255)<<16|(c[23]&255)<<24,r=c[24]&255|(c[25]&255)<<8|(c[26]&255)<<16|(c[27]&255)<<24;c=c[28]&255|(c[29]&255)<<8|(c[30]&255)<<16|(c[31]&255)<<24;d=d[12]&255|(d[13]&255)<<8|(d[14]&255)<<16|(d[15]&255)<<24;for(var H,u=0;20>u;u+=2)H=e+ea|0,k^=H<<7|H>>>25,H=k+e|0,n^=H<<9|H>>>23,H=n+k|0,ea^=H<<13|H>>>
19,H=ea+n|0,e^=H<<18|H>>>14,H=aa+f|0,b^=H<<7|H>>>25,H=b+aa|0,r^=H<<9|H>>>23,H=r+b|0,f^=H<<13|H>>>19,H=f+r|0,aa^=H<<18|H>>>14,H=q+l|0,c^=H<<7|H>>>25,H=c+q|0,g^=H<<9|H>>>23,H=g+c|0,l^=H<<13|H>>>19,H=l+g|0,q^=H<<18|H>>>14,H=d+m|0,h^=H<<7|H>>>25,H=h+d|0,p^=H<<9|H>>>23,H=p+h|0,m^=H<<13|H>>>19,H=m+p|0,d^=H<<18|H>>>14,H=e+h|0,f^=H<<7|H>>>25,H=f+e|0,g^=H<<9|H>>>23,H=g+f|0,h^=H<<13|H>>>19,H=h+g|0,e^=H<<18|H>>>14,H=aa+k|0,l^=H<<7|H>>>25,H=l+aa|0,p^=H<<9|H>>>23,H=p+l|0,k^=H<<13|H>>>19,H=k+p|0,aa^=H<<18|H>>>
14,H=q+b|0,m^=H<<7|H>>>25,H=m+q|0,n^=H<<9|H>>>23,H=n+m|0,b^=H<<13|H>>>19,H=b+n|0,q^=H<<18|H>>>14,H=d+c|0,ea^=H<<7|H>>>25,H=ea+d|0,r^=H<<9|H>>>23,H=r+ea|0,c^=H<<13|H>>>19,H=c+r|0,d^=H<<18|H>>>14;a[0]=e>>>0&255;a[1]=e>>>8&255;a[2]=e>>>16&255;a[3]=e>>>24&255;a[4]=aa>>>0&255;a[5]=aa>>>8&255;a[6]=aa>>>16&255;a[7]=aa>>>24&255;a[8]=q>>>0&255;a[9]=q>>>8&255;a[10]=q>>>16&255;a[11]=q>>>24&255;a[12]=d>>>0&255;a[13]=d>>>8&255;a[14]=d>>>16&255;a[15]=d>>>24&255;a[16]=l>>>0&255;a[17]=l>>>8&255;a[18]=l>>>16&255;
a[19]=l>>>24&255;a[20]=p>>>0&255;a[21]=p>>>8&255;a[22]=p>>>16&255;a[23]=p>>>24&255;a[24]=n>>>0&255;a[25]=n>>>8&255;a[26]=n>>>16&255;a[27]=n>>>24&255;a[28]=b>>>0&255;a[29]=b>>>8&255;a[30]=b>>>16&255;a[31]=b>>>24&255}function n(a,b,c,d,f,g,h){var k=new Uint8Array(16),aa=new Uint8Array(64),l;for(l=0;16>l;l++)k[l]=0;for(l=0;8>l;l++)k[l]=g[l];for(;64<=f;){e(aa,k,h,oa);for(l=0;64>l;l++)a[b+l]=c[d+l]^aa[l];g=1;for(l=8;16>l;l++)g=g+(k[l]&255)|0,k[l]=g&255,g>>>=8;f-=64;b+=64;d+=64}if(0<f)for(e(aa,k,h,oa),
l=0;l<f;l++)a[b+l]=c[d+l]^aa[l];return 0}function m(a,b,c,d,f){var g=new Uint8Array(16),h=new Uint8Array(64),k;for(k=0;16>k;k++)g[k]=0;for(k=0;8>k;k++)g[k]=d[k];for(;64<=c;){e(h,g,f,oa);for(k=0;64>k;k++)a[b+k]=h[k];d=1;for(k=8;16>k;k++)d=d+(g[k]&255)|0,g[k]=d&255,d>>>=8;c-=64;b+=64}if(0<c)for(e(h,g,f,oa),k=0;k<c;k++)a[b+k]=h[k];return 0}function d(a,b,c,d,e){var f=new Uint8Array(32);h(f,d,e,oa);e=new Uint8Array(8);for(var g=0;8>g;g++)e[g]=d[g+16];return m(a,b,c,e,f)}function r(a,b,c,d,e,f,g){var k=
new Uint8Array(32);h(k,f,g,oa);g=new Uint8Array(8);for(var aa=0;8>aa;aa++)g[aa]=f[aa+16];return n(a,b,c,d,e,g,k)}function B(a,b,c,d,e,f){f=new pa(f);f.update(c,d,e);f.finish(a,b);return 0}function F(a,b,d,e,f,g){var h=new Uint8Array(16);B(h,0,d,e,f,g);return c(a,b,h,0)}function A(a,b,c,d,e){if(32>c)return-1;r(a,0,b,0,c,d,e);B(a,16,a,32,c-32,a);for(b=0;16>b;b++)a[b]=0;return 0}function y(a,b,c,e,f){var g=new Uint8Array(32);if(32>c)return-1;d(g,0,32,e,f);if(0!==F(b,16,b,32,c-32,g))return-1;r(a,0,b,
0,c,e,f);for(b=0;32>b;b++)a[b]=0;return 0}function C(a,b){var c;for(c=0;16>c;c++)a[c]=b[c]|0}function q(a){var b,c=1;for(b=0;16>b;b++){var d=a[b]+c+65535;c=Math.floor(d/65536);a[b]=d-65536*c}a[0]+=c-1+37*(c-1)}function I(a,b,c){for(var d=~(c-1),e=0;16>e;e++)c=d&(a[e]^b[e]),a[e]^=c,b[e]^=c}function G(a,b){var c,d,e=E(),f=E();for(c=0;16>c;c++)f[c]=b[c];q(f);q(f);q(f);for(d=0;2>d;d++){e[0]=f[0]-65517;for(c=1;15>c;c++)e[c]=f[c]-65535-(e[c-1]>>16&1),e[c-1]&=65535;e[15]=f[15]-32767-(e[14]>>16&1);c=e[15]>>
16&1;e[14]&=65535;I(f,e,1-c)}for(c=0;16>c;c++)a[2*c]=f[c]&255,a[2*c+1]=f[c]>>8}function K(a,b){var c=new Uint8Array(32),d=new Uint8Array(32);G(c,a);G(d,b);return k(c,0,d,0)}function O(a){var b=new Uint8Array(32);G(b,a);return b[0]&1}function J(a,b){var c;for(c=0;16>c;c++)a[c]=b[2*c]+(b[2*c+1]<<8);a[15]&=32767}function D(a,b,c){for(var d=0;16>d;d++)a[d]=b[d]+c[d]}function L(a,b,c){for(var d=0;16>d;d++)a[d]=b[d]-c[d]}function N(a,b,c){var d=c[0],e=c[1],f=c[2],g=c[3],h=c[4],k=c[5],l=c[6],p=c[7],n=c[8],
q=c[9],m=c[10],r=c[11],H=c[12],u=c[13],t=c[14],G=c[15];c=b[0];var w=0+c*d;var ea=0+c*e;var v=0+c*f;var aa=0+c*g;var y=0+c*h;var W=0+c*k;var B=0+c*l;var A=0+c*p;var J=0+c*n;var z=0+c*q;var I=0+c*m;var K=0+c*r;var F=0+c*H;var O=0+c*u;var L=0+c*t;var N=0+c*G;c=b[1];ea+=c*d;v+=c*e;aa+=c*f;y+=c*g;W+=c*h;B+=c*k;A+=c*l;J+=c*p;z+=c*n;I+=c*q;K+=c*m;F+=c*r;O+=c*H;L+=c*u;N+=c*t;var ba=0+c*G;c=b[2];v+=c*d;aa+=c*e;y+=c*f;W+=c*g;B+=c*h;A+=c*k;J+=c*l;z+=c*p;I+=c*n;K+=c*q;F+=c*m;O+=c*r;L+=c*H;N+=c*u;ba+=c*t;var M=
0+c*G;c=b[3];aa+=c*d;y+=c*e;W+=c*f;B+=c*g;A+=c*h;J+=c*k;z+=c*l;I+=c*p;K+=c*n;F+=c*q;O+=c*m;L+=c*r;N+=c*H;ba+=c*u;M+=c*t;var x=0+c*G;c=b[4];y+=c*d;W+=c*e;B+=c*f;A+=c*g;J+=c*h;z+=c*k;I+=c*l;K+=c*p;F+=c*n;O+=c*q;L+=c*m;N+=c*r;ba+=c*H;M+=c*u;x+=c*t;var D=0+c*G;c=b[5];W+=c*d;B+=c*e;A+=c*f;J+=c*g;z+=c*h;I+=c*k;K+=c*l;F+=c*p;O+=c*n;L+=c*q;N+=c*m;ba+=c*r;M+=c*H;x+=c*u;D+=c*t;var P=0+c*G;c=b[6];B+=c*d;A+=c*e;J+=c*f;z+=c*g;I+=c*h;K+=c*k;F+=c*l;O+=c*p;L+=c*n;N+=c*q;ba+=c*m;M+=c*r;x+=c*H;D+=c*u;P+=c*t;var C=
0+c*G;c=b[7];A+=c*d;J+=c*e;z+=c*f;I+=c*g;K+=c*h;F+=c*k;O+=c*l;L+=c*p;N+=c*n;ba+=c*q;M+=c*m;x+=c*r;D+=c*H;P+=c*u;C+=c*t;var E=0+c*G;c=b[8];J+=c*d;z+=c*e;I+=c*f;K+=c*g;F+=c*h;O+=c*k;L+=c*l;N+=c*p;ba+=c*n;M+=c*q;x+=c*m;D+=c*r;P+=c*H;C+=c*u;E+=c*t;var R=0+c*G;c=b[9];z+=c*d;I+=c*e;K+=c*f;F+=c*g;O+=c*h;L+=c*k;N+=c*l;ba+=c*p;M+=c*n;x+=c*q;D+=c*m;P+=c*r;C+=c*H;E+=c*u;R+=c*t;var T=0+c*G;c=b[10];I+=c*d;K+=c*e;F+=c*f;O+=c*g;L+=c*h;N+=c*k;ba+=c*l;M+=c*p;x+=c*n;D+=c*q;P+=c*m;C+=c*r;E+=c*H;R+=c*u;T+=c*t;var S=
0+c*G;c=b[11];K+=c*d;F+=c*e;O+=c*f;L+=c*g;N+=c*h;ba+=c*k;M+=c*l;x+=c*p;D+=c*n;P+=c*q;C+=c*m;E+=c*r;R+=c*H;T+=c*u;S+=c*t;var U=0+c*G;c=b[12];F+=c*d;O+=c*e;L+=c*f;N+=c*g;ba+=c*h;M+=c*k;x+=c*l;D+=c*p;P+=c*n;C+=c*q;E+=c*m;R+=c*r;T+=c*H;S+=c*u;U+=c*t;var V=0+c*G;c=b[13];O+=c*d;L+=c*e;N+=c*f;ba+=c*g;M+=c*h;x+=c*k;D+=c*l;P+=c*p;C+=c*n;E+=c*q;R+=c*m;T+=c*r;S+=c*H;U+=c*u;V+=c*t;var Y=0+c*G;c=b[14];L+=c*d;N+=c*e;ba+=c*f;M+=c*g;x+=c*h;D+=c*k;P+=c*l;C+=c*p;E+=c*n;R+=c*q;T+=c*m;S+=c*r;U+=c*H;V+=c*u;Y+=c*t;var fa=
0+c*G;c=b[15];N+=c*d;ea+=38*(M+c*f);v+=38*(x+c*g);aa+=38*(D+c*h);y+=38*(P+c*k);W+=38*(C+c*l);B+=38*(E+c*p);A+=38*(R+c*n);J+=38*(T+c*q);z+=38*(S+c*m);I+=38*(U+c*r);K+=38*(V+c*H);F+=38*(Y+c*u);O+=38*(fa+c*t);L+=38*(0+c*G);c=w+38*(ba+c*e)+1+65535;b=Math.floor(c/65536);w=c-65536*b;c=ea+b+65535;b=Math.floor(c/65536);ea=c-65536*b;c=v+b+65535;b=Math.floor(c/65536);v=c-65536*b;c=aa+b+65535;b=Math.floor(c/65536);aa=c-65536*b;c=y+b+65535;b=Math.floor(c/65536);y=c-65536*b;c=W+b+65535;b=Math.floor(c/65536);W=
c-65536*b;c=B+b+65535;b=Math.floor(c/65536);B=c-65536*b;c=A+b+65535;b=Math.floor(c/65536);A=c-65536*b;c=J+b+65535;b=Math.floor(c/65536);J=c-65536*b;c=z+b+65535;b=Math.floor(c/65536);z=c-65536*b;c=I+b+65535;b=Math.floor(c/65536);I=c-65536*b;c=K+b+65535;b=Math.floor(c/65536);K=c-65536*b;c=F+b+65535;b=Math.floor(c/65536);F=c-65536*b;c=O+b+65535;b=Math.floor(c/65536);O=c-65536*b;c=L+b+65535;b=Math.floor(c/65536);L=c-65536*b;c=N+b+65535;b=Math.floor(c/65536);N=c-65536*b;w+=b-1+37*(b-1);c=w+1+65535;b=Math.floor(c/
65536);w=c-65536*b;c=ea+b+65535;b=Math.floor(c/65536);ea=c-65536*b;c=v+b+65535;b=Math.floor(c/65536);v=c-65536*b;c=aa+b+65535;b=Math.floor(c/65536);aa=c-65536*b;c=y+b+65535;b=Math.floor(c/65536);y=c-65536*b;c=W+b+65535;b=Math.floor(c/65536);W=c-65536*b;c=B+b+65535;b=Math.floor(c/65536);B=c-65536*b;c=A+b+65535;b=Math.floor(c/65536);A=c-65536*b;c=J+b+65535;b=Math.floor(c/65536);J=c-65536*b;c=z+b+65535;b=Math.floor(c/65536);z=c-65536*b;c=I+b+65535;b=Math.floor(c/65536);I=c-65536*b;c=K+b+65535;b=Math.floor(c/
65536);K=c-65536*b;c=F+b+65535;b=Math.floor(c/65536);F=c-65536*b;c=O+b+65535;b=Math.floor(c/65536);O=c-65536*b;c=L+b+65535;b=Math.floor(c/65536);L=c-65536*b;c=N+b+65535;b=Math.floor(c/65536);a[0]=w+(b-1+37*(b-1));a[1]=ea;a[2]=v;a[3]=aa;a[4]=y;a[5]=W;a[6]=B;a[7]=A;a[8]=J;a[9]=z;a[10]=I;a[11]=K;a[12]=F;a[13]=O;a[14]=L;a[15]=c-65536*b}function x(a,b){N(a,b,b)}function U(a,b){var c=E(),d;for(d=0;16>d;d++)c[d]=b[d];for(d=253;0<=d;d--)x(c,c),2!==d&&4!==d&&N(c,c,b);for(d=0;16>d;d++)a[d]=c[d]}function M(a,
b,c){var d=new Uint8Array(32),e=new Float64Array(80),f,g=E(),h=E(),k=E(),l=E(),p=E(),n=E();for(f=0;31>f;f++)d[f]=b[f];d[31]=b[31]&127|64;d[0]&=248;J(e,c);for(f=0;16>f;f++)h[f]=e[f],l[f]=g[f]=k[f]=0;g[0]=l[0]=1;for(f=254;0<=f;--f)b=d[f>>>3]>>>(f&7)&1,I(g,h,b),I(k,l,b),D(p,g,k),L(g,g,k),D(k,h,l),L(h,h,l),x(l,p),x(n,g),N(g,k,g),N(k,h,p),D(p,g,k),L(g,g,k),x(h,g),L(k,l,n),N(g,k,da),D(g,g,l),N(k,k,g),N(g,l,n),N(l,h,e),x(h,p),I(g,h,b),I(k,l,b);for(f=0;16>f;f++)e[f+16]=g[f],e[f+32]=k[f],e[f+48]=h[f],e[f+
64]=l[f];d=e.subarray(32);e=e.subarray(16);U(d,d);N(e,e,d);G(a,e);return 0}function u(a,b){return M(a,b,X)}function p(a,b){ja(b,32);return u(a,b)}function t(a,b,c){var d=new Uint8Array(32);M(d,c,b);h(a,na,d,oa)}function z(a,b,c,d){var e=new Int32Array(16),f=new Int32Array(16),g;var h=a[0];var k=a[1],l=a[2],p=a[3],n=a[4],q=a[5],m=a[6],r=a[7];var u=b[0];for(var H=b[1],t=b[2],G=b[3],w=b[4],v=b[5],y=b[6],W=b[7],ea=0;128<=d;){for(g=0;16>g;g++){var B=8*g+ea;e[g]=c[B+0]<<24|c[B+1]<<16|c[B+2]<<8|c[B+3];f[g]=
c[B+4]<<24|c[B+5]<<16|c[B+6]<<8|c[B+7]}for(g=0;80>g;g++){B=h;var aa=k;var A=l;var J=p;var z=n;var I=q;var K=m;var F=u;var O=H;var ma=t;var L=G;var N=w;var ba=v;var M=y;var x=r;var D=W;var P=D&65535;var C=D>>>16;var E=x&65535;var R=x>>>16;x=(n>>>14|w<<18)^(n>>>18|w<<14)^(w>>>9|n<<23);D=(w>>>14|n<<18)^(w>>>18|n<<14)^(n>>>9|w<<23);P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;x=n&q^~n&m;D=w&v^~w&y;P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;x=la[2*g];D=la[2*g+1];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;x=
e[g%16];D=f[g%16];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;var T=E&65535|R<<16;var S=P&65535|C<<16;x=T;D=S;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=(h>>>28|u<<4)^(u>>>2|h<<30)^(u>>>7|h<<25);D=(u>>>28|h<<4)^(h>>>2|u<<30)^(h>>>7|u<<25);P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;x=h&k^h&l^k&l;D=u&H^u&t^H&t;P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;h=E&65535|R<<16;u=P&65535|C<<16;x=J;D=L;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=T;D=S;P+=D&65535;
C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;J=E&65535|R<<16;L=P&65535|C<<16;k=B;l=aa;p=A;n=J;q=z;m=I;r=K;H=F;t=O;G=ma;w=L;v=N;y=ba;W=M;if(15===g%16)for(B=0;16>B;B++)x=e[B],D=f[B],P=D&65535,C=D>>>16,E=x&65535,R=x>>>16,x=e[(B+9)%16],D=f[(B+9)%16],P+=D&65535,C+=D>>>16,E+=x&65535,R+=x>>>16,T=e[(B+1)%16],S=f[(B+1)%16],x=(T>>>1|S<<31)^(T>>>8|S<<24)^T>>>7,D=(S>>>1|T<<31)^(S>>>8|T<<24)^(S>>>7|T<<25),P+=D&65535,C+=D>>>16,E+=x&65535,R+=x>>>16,T=e[(B+14)%16],S=f[(B+14)%16],x=(T>>>19|S<<13)^
(S>>>29|T<<3)^T>>>6,D=(S>>>19|T<<13)^(T>>>29|S<<3)^(S>>>6|T<<26),P+=D&65535,C+=D>>>16,E+=x&65535,R+=x>>>16,C+=P>>>16,E+=C>>>16,R+=E>>>16,e[B]=E&65535|R<<16,f[B]=P&65535|C<<16}x=h;D=u;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[0];D=b[0];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[0]=h=E&65535|R<<16;b[0]=u=P&65535|C<<16;x=k;D=H;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[1];D=b[1];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[1]=k=E&65535|R<<16;
b[1]=H=P&65535|C<<16;x=l;D=t;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[2];D=b[2];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[2]=l=E&65535|R<<16;b[2]=t=P&65535|C<<16;x=p;D=G;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[3];D=b[3];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[3]=p=E&65535|R<<16;b[3]=G=P&65535|C<<16;x=n;D=w;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[4];D=b[4];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;
a[4]=n=E&65535|R<<16;b[4]=w=P&65535|C<<16;x=q;D=v;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[5];D=b[5];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[5]=q=E&65535|R<<16;b[5]=v=P&65535|C<<16;x=m;D=y;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[6];D=b[6];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;E+=C>>>16;R+=E>>>16;a[6]=m=E&65535|R<<16;b[6]=y=P&65535|C<<16;x=r;D=W;P=D&65535;C=D>>>16;E=x&65535;R=x>>>16;x=a[7];D=b[7];P+=D&65535;C+=D>>>16;E+=x&65535;R+=x>>>16;C+=P>>>16;
E+=C>>>16;R+=E>>>16;a[7]=r=E&65535|R<<16;b[7]=W=P&65535|C<<16;ea+=128;d-=128}return d}function v(b,c,d){var e=new Int32Array(8),f=new Int32Array(8),g=new Uint8Array(256),h,k=d;e[0]=1779033703;e[1]=3144134277;e[2]=1013904242;e[3]=2773480762;e[4]=1359893119;e[5]=2600822924;e[6]=528734635;e[7]=1541459225;f[0]=4089235720;f[1]=2227873595;f[2]=4271175723;f[3]=1595750129;f[4]=2917565137;f[5]=725511199;f[6]=4215389547;f[7]=327033209;z(e,f,c,d);d%=128;for(h=0;h<d;h++)g[h]=c[k-d+h];g[d]=128;d=256-128*(112>
d?1:0);g[d-9]=0;a(g,d-8,k/536870912|0,k<<3);z(e,f,g,d);for(h=0;8>h;h++)a(b,8*h,e[h],f[h]);return 0}function ca(a,b){var c=E(),d=E(),e=E(),f=E(),g=E(),h=E(),k=E(),l=E(),p=E();L(c,a[1],a[0]);L(p,b[1],b[0]);N(c,c,p);D(d,a[0],a[1]);D(p,b[0],b[1]);N(d,d,p);N(e,a[3],b[3]);N(e,e,ta);N(f,a[2],b[2]);D(f,f,f);L(g,d,c);L(h,f,e);D(k,f,e);D(l,d,c);N(a[0],g,h);N(a[1],l,k);N(a[2],k,h);N(a[3],g,l)}function T(a,b){var c=E(),d=E(),e=E();U(e,b[2]);N(c,b[0],e);N(d,b[1],e);G(a,d);a[31]^=O(c)<<7}function S(a,b,c){var d;
C(a[0],ka);C(a[1],V);C(a[2],V);C(a[3],ka);for(d=255;0<=d;--d){var e=c[d/8|0]>>(d&7)&1;var f,g=a,h=b,k=e;for(f=0;4>f;f++)I(g[f],h[f],k);ca(b,a);ca(a,a);f=a;g=b;h=e;for(e=0;4>e;e++)I(f[e],g[e],h)}}function Z(a,b){var c=[E(),E(),E(),E()];C(c[0],qa);C(c[1],ra);C(c[2],V);N(c[3],qa,ra);S(a,c,b)}function ha(a,b,c){var d=new Uint8Array(64),e=[E(),E(),E(),E()];c||ja(b,32);v(d,b,32);d[0]&=248;d[31]&=127;d[31]|=64;Z(e,d);T(a,e);for(c=0;32>c;c++)b[c+32]=a[c];return 0}function W(a,b){var c,d;for(c=63;32<=c;--c){var e=
0;var f=c-32;for(d=c-12;f<d;++f)b[f]+=e-16*b[c]*ua[f-(c-32)],e=b[f]+128>>8,b[f]-=256*e;b[f]+=e;b[c]=0}for(f=e=0;32>f;f++)b[f]+=e-(b[31]>>4)*ua[f],e=b[f]>>8,b[f]&=255;for(f=0;32>f;f++)b[f]-=e*ua[f];for(c=0;32>c;c++)b[c+1]+=b[c]>>8,a[c]=b[c]&255}function ba(a){var b=new Float64Array(64),c;for(c=0;64>c;c++)b[c]=a[c];for(c=0;64>c;c++)a[c]=0;W(a,b)}function R(a,b,c,d){var e=new Uint8Array(64),f=new Uint8Array(64),g=new Uint8Array(64),h,k=new Float64Array(64),l=[E(),E(),E(),E()];v(e,d,32);e[0]&=248;e[31]&=
127;e[31]|=64;var p=c+64;for(h=0;h<c;h++)a[64+h]=b[h];for(h=0;32>h;h++)a[32+h]=e[32+h];v(g,a.subarray(32),c+32);ba(g);Z(l,g);T(a,l);for(h=32;64>h;h++)a[h]=d[h];v(f,a,c+64);ba(f);for(h=0;64>h;h++)k[h]=0;for(h=0;32>h;h++)k[h]=g[h];for(h=0;32>h;h++)for(b=0;32>b;b++)k[h+b]+=f[h]*e[b];W(a.subarray(32),k);return p}function P(a,b,c,d){var e=new Uint8Array(32),f=new Uint8Array(64),g=[E(),E(),E(),E()],h=[E(),E(),E(),E()];if(64>c)return-1;var l=E();var p=E(),n=E(),q=E(),m=E(),r=E(),u=E();C(h[2],V);J(h[1],d);
x(n,h[1]);N(q,n,ia);L(n,n,h[2]);D(q,h[2],q);x(m,q);x(r,m);N(u,r,m);N(l,u,n);N(l,l,q);m=E();for(r=0;16>r;r++)m[r]=l[r];for(r=250;0<=r;r--)x(m,m),1!==r&&N(m,m,l);for(r=0;16>r;r++)l[r]=m[r];N(l,l,n);N(l,l,q);N(l,l,q);N(h[0],l,q);x(p,h[0]);N(p,p,q);K(p,n)&&N(h[0],h[0],sa);x(p,h[0]);N(p,p,q);K(p,n)?l=-1:(O(h[0])===d[31]>>7&&L(h[0],ka,h[0]),N(h[3],h[0],h[1]),l=0);if(l)return-1;for(l=0;l<c;l++)a[l]=b[l];for(l=0;32>l;l++)a[l+32]=d[l];v(f,a,c);ba(f);S(g,h,f);Z(h,b.subarray(32));ca(g,h);T(e,g);c-=64;if(k(b,
0,e,0)){for(l=0;l<c;l++)a[l]=0;return-1}for(l=0;l<c;l++)a[l]=b[l+64];return c}function fa(a,b){if(32!==a.length)throw Error("bad key size");if(24!==b.length)throw Error("bad nonce size");}function Y(){for(var a=0;a<arguments.length;a++)if(!(arguments[a]instanceof Uint8Array))throw new TypeError("unexpected type, use Uint8Array");}function ga(a){for(var b=0;b<a.length;b++)a[b]=0}var E=function(a){var b,c=new Float64Array(16);if(a)for(b=0;b<a.length;b++)c[b]=a[b];return c},ja=function(){throw Error("no PRNG");
},na=new Uint8Array(16),X=new Uint8Array(32);X[0]=9;var ka=E(),V=E([1]),da=E([56129,1]),ia=E([30883,4953,19914,30187,55467,16705,2637,112,59544,30585,16505,36039,65139,11119,27886,20995]),ta=E([61785,9906,39828,60374,45398,33411,5274,224,53552,61171,33010,6542,64743,22239,55772,9222]),qa=E([54554,36645,11616,51542,42930,38181,51040,26924,56412,64982,57905,49316,21502,52590,14035,8553]),ra=E([26200,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214]),sa=E([41136,
18958,6951,50414,58488,44335,6150,12099,55207,15867,153,11085,57099,20417,9344,11139]),oa=new Uint8Array([101,120,112,97,110,100,32,51,50,45,98,121,116,101,32,107]),pa=function(a){this.buffer=new Uint8Array(16);this.r=new Uint16Array(10);this.h=new Uint16Array(10);this.pad=new Uint16Array(8);this.fin=this.leftover=0;var b=a[0]&255|(a[1]&255)<<8;this.r[0]=b&8191;var c=a[2]&255|(a[3]&255)<<8;this.r[1]=(b>>>13|c<<3)&8191;b=a[4]&255|(a[5]&255)<<8;this.r[2]=(c>>>10|b<<6)&7939;c=a[6]&255|(a[7]&255)<<8;
this.r[3]=(b>>>7|c<<9)&8191;b=a[8]&255|(a[9]&255)<<8;this.r[4]=(c>>>4|b<<12)&255;this.r[5]=b>>>1&8190;c=a[10]&255|(a[11]&255)<<8;this.r[6]=(b>>>14|c<<2)&8191;b=a[12]&255|(a[13]&255)<<8;this.r[7]=(c>>>11|b<<5)&8065;c=a[14]&255|(a[15]&255)<<8;this.r[8]=(b>>>8|c<<8)&8191;this.r[9]=c>>>5&127;this.pad[0]=a[16]&255|(a[17]&255)<<8;this.pad[1]=a[18]&255|(a[19]&255)<<8;this.pad[2]=a[20]&255|(a[21]&255)<<8;this.pad[3]=a[22]&255|(a[23]&255)<<8;this.pad[4]=a[24]&255|(a[25]&255)<<8;this.pad[5]=a[26]&255|(a[27]&
255)<<8;this.pad[6]=a[28]&255|(a[29]&255)<<8;this.pad[7]=a[30]&255|(a[31]&255)<<8};pa.prototype.blocks=function(a,b,c){for(var d=this.fin?0:2048,e,f,g,h,k,l,p,n,q,m,r,u=this.h[0],t=this.h[1],G=this.h[2],w=this.h[3],v=this.h[4],B=this.h[5],H=this.h[6],y=this.h[7],W=this.h[8],A=this.h[9],J=this.r[0],z=this.r[1],x=this.r[2],I=this.r[3],K=this.r[4],D=this.r[5],F=this.r[6],O=this.r[7],C=this.r[8],E=this.r[9];16<=c;)e=a[b+0]&255|(a[b+1]&255)<<8,u+=e&8191,f=a[b+2]&255|(a[b+3]&255)<<8,t+=(e>>>13|f<<3)&8191,
e=a[b+4]&255|(a[b+5]&255)<<8,G+=(f>>>10|e<<6)&8191,f=a[b+6]&255|(a[b+7]&255)<<8,w+=(e>>>7|f<<9)&8191,e=a[b+8]&255|(a[b+9]&255)<<8,v+=(f>>>4|e<<12)&8191,B+=e>>>1&8191,f=a[b+10]&255|(a[b+11]&255)<<8,H+=(e>>>14|f<<2)&8191,e=a[b+12]&255|(a[b+13]&255)<<8,y+=(f>>>11|e<<5)&8191,f=a[b+14]&255|(a[b+15]&255)<<8,W+=(e>>>8|f<<8)&8191,A+=f>>>5|d,e=f=0,e+=u*J,e+=5*t*E,e+=5*G*C,e+=5*w*O,e+=5*v*F,f=e>>>13,e&=8191,e+=5*B*D,e+=5*H*K,e+=5*y*I,e+=5*W*x,e+=5*A*z,f+=e>>>13,e&=8191,g=f,g+=u*z,g+=t*J,g+=5*G*E,g+=5*w*C,g+=
5*v*O,f=g>>>13,g&=8191,g+=5*B*F,g+=5*H*D,g+=5*y*K,g+=5*W*I,g+=5*A*x,f+=g>>>13,g&=8191,h=f,h+=u*x,h+=t*z,h+=G*J,h+=5*w*E,h+=5*v*C,f=h>>>13,h&=8191,h+=5*B*O,h+=5*H*F,h+=5*y*D,h+=5*W*K,h+=5*A*I,f+=h>>>13,h&=8191,k=f,k+=u*I,k+=t*x,k+=G*z,k+=w*J,k+=5*v*E,f=k>>>13,k&=8191,k+=5*B*C,k+=5*H*O,k+=5*y*F,k+=5*W*D,k+=5*A*K,f+=k>>>13,k&=8191,l=f,l+=u*K,l+=t*I,l+=G*x,l+=w*z,l+=v*J,f=l>>>13,l&=8191,l+=5*B*E,l+=5*H*C,l+=5*y*O,l+=5*W*F,l+=5*A*D,f+=l>>>13,l&=8191,p=f,p+=u*D,p+=t*K,p+=G*I,p+=w*x,p+=v*z,f=p>>>13,p&=8191,
p+=B*J,p+=5*H*E,p+=5*y*C,p+=5*W*O,p+=5*A*F,f+=p>>>13,p&=8191,n=f,n+=u*F,n+=t*D,n+=G*K,n+=w*I,n+=v*x,f=n>>>13,n&=8191,n+=B*z,n+=H*J,n+=5*y*E,n+=5*W*C,n+=5*A*O,f+=n>>>13,n&=8191,q=f,q+=u*O,q+=t*F,q+=G*D,q+=w*K,q+=v*I,f=q>>>13,q&=8191,q+=B*x,q+=H*z,q+=y*J,q+=5*W*E,q+=5*A*C,f+=q>>>13,q&=8191,m=f,m+=u*C,m+=t*O,m+=G*F,m+=w*D,m+=v*K,f=m>>>13,m&=8191,m+=B*I,m+=H*x,m+=y*z,m+=W*J,m+=5*A*E,f+=m>>>13,m&=8191,r=f,r+=u*E,r+=t*C,r+=G*O,r+=w*F,r+=v*D,f=r>>>13,r&=8191,r+=B*K,r+=H*I,r+=y*x,r+=W*z,r+=A*J,f+=r>>>13,
r&=8191,f=(f<<2)+f|0,f=f+e|0,e=f&8191,f>>>=13,g+=f,u=e,t=g,G=h,w=k,v=l,B=p,H=n,y=q,W=m,A=r,b+=16,c-=16;this.h[0]=u;this.h[1]=t;this.h[2]=G;this.h[3]=w;this.h[4]=v;this.h[5]=B;this.h[6]=H;this.h[7]=y;this.h[8]=W;this.h[9]=A};pa.prototype.finish=function(a,b){var c=new Uint16Array(10);if(this.leftover){var d=this.leftover;for(this.buffer[d++]=1;16>d;d++)this.buffer[d]=0;this.fin=1;this.blocks(this.buffer,0,16)}var e=this.h[1]>>>13;this.h[1]&=8191;for(d=2;10>d;d++)this.h[d]+=e,e=this.h[d]>>>13,this.h[d]&=
8191;this.h[0]+=5*e;e=this.h[0]>>>13;this.h[0]&=8191;this.h[1]+=e;e=this.h[1]>>>13;this.h[1]&=8191;this.h[2]+=e;c[0]=this.h[0]+5;e=c[0]>>>13;c[0]&=8191;for(d=1;10>d;d++)c[d]=this.h[d]+e,e=c[d]>>>13,c[d]&=8191;c[9]-=8192;e=(e^1)-1;for(d=0;10>d;d++)c[d]&=e;e=~e;for(d=0;10>d;d++)this.h[d]=this.h[d]&e|c[d];this.h[0]=(this.h[0]|this.h[1]<<13)&65535;this.h[1]=(this.h[1]>>>3|this.h[2]<<10)&65535;this.h[2]=(this.h[2]>>>6|this.h[3]<<7)&65535;this.h[3]=(this.h[3]>>>9|this.h[4]<<4)&65535;this.h[4]=(this.h[4]>>>
12|this.h[5]<<1|this.h[6]<<14)&65535;this.h[5]=(this.h[6]>>>2|this.h[7]<<11)&65535;this.h[6]=(this.h[7]>>>5|this.h[8]<<8)&65535;this.h[7]=(this.h[8]>>>8|this.h[9]<<5)&65535;c=this.h[0]+this.pad[0];this.h[0]=c&65535;for(d=1;8>d;d++)c=(this.h[d]+this.pad[d]|0)+(c>>>16)|0,this.h[d]=c&65535;a[b+0]=this.h[0]>>>0&255;a[b+1]=this.h[0]>>>8&255;a[b+2]=this.h[1]>>>0&255;a[b+3]=this.h[1]>>>8&255;a[b+4]=this.h[2]>>>0&255;a[b+5]=this.h[2]>>>8&255;a[b+6]=this.h[3]>>>0&255;a[b+7]=this.h[3]>>>8&255;a[b+8]=this.h[4]>>>
0&255;a[b+9]=this.h[4]>>>8&255;a[b+10]=this.h[5]>>>0&255;a[b+11]=this.h[5]>>>8&255;a[b+12]=this.h[6]>>>0&255;a[b+13]=this.h[6]>>>8&255;a[b+14]=this.h[7]>>>0&255;a[b+15]=this.h[7]>>>8&255};pa.prototype.update=function(a,b,c){var d;if(this.leftover){var e=16-this.leftover;e>c&&(e=c);for(d=0;d<e;d++)this.buffer[this.leftover+d]=a[b+d];c-=e;b+=e;this.leftover+=e;if(16>this.leftover)return;this.blocks(this.buffer,0,16);this.leftover=0}16<=c&&(e=c-c%16,this.blocks(a,b,e),b+=e,c-=e);if(c){for(d=0;d<c;d++)this.buffer[this.leftover+
d]=a[b+d];this.leftover+=c}};var la=[1116352408,3609767458,1899447441,602891725,3049323471,3964484399,3921009573,2173295548,961987163,4081628472,1508970993,3053834265,2453635748,2937671579,2870763221,3664609560,3624381080,2734883394,310598401,1164996542,607225278,1323610764,1426881987,3590304994,1925078388,4068182383,2162078206,991336113,2614888103,633803317,3248222580,3479774868,3835390401,2666613458,4022224774,944711139,264347078,2341262773,604807628,2007800933,770255983,1495990901,1249150122,1856431235,
1555081692,3175218132,1996064986,2198950837,2554220882,3999719339,2821834349,766784016,2952996808,2566594879,3210313671,3203337956,3336571891,1034457026,3584528711,2466948901,113926993,3758326383,338241895,168717936,666307205,1188179964,773529912,1546045734,1294757372,1522805485,1396182291,2643833823,1695183700,2343527390,1986661051,1014477480,2177026350,1206759142,2456956037,344077627,2730485921,1290863460,2820302411,3158454273,3259730800,3505952657,3345764771,106217008,3516065817,3606008344,3600352804,
1432725776,4094571909,1467031594,275423344,851169720,430227734,3100823752,506948616,1363258195,659060556,3750685593,883997877,3785050280,958139571,3318307427,1322822218,3812723403,1537002063,2003034995,1747873779,3602036899,1955562222,1575990012,2024104815,1125592928,2227730452,2716904306,2361852424,442776044,2428436474,593698344,2756734187,3733110249,3204031479,2999351573,3329325298,3815920427,3391569614,3928383900,3515267271,566280711,3940187606,3454069534,4118630271,4000239992,116418474,1914138554,
174292421,2731055270,289380356,3203993006,460393269,320620315,685471733,587496836,852142971,1086792851,1017036298,365543100,1126000580,2618297676,1288033470,3409855158,1501505948,4234509866,1607167915,987167468,1816402316,1246189591],ua=new Float64Array([237,211,245,92,26,99,18,88,214,156,247,162,222,249,222,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16]);b.lowlevel={crypto_core_hsalsa20:function(a,b,c,d){h(a,b,c,d)},crypto_stream_xor:r,crypto_stream:d,crypto_stream_salsa20_xor:n,crypto_stream_salsa20:m,crypto_onetimeauth:B,
crypto_onetimeauth_verify:F,crypto_verify_16:c,crypto_verify_32:k,crypto_secretbox:A,crypto_secretbox_open:y,crypto_scalarmult:M,crypto_scalarmult_base:u,crypto_box_beforenm:t,crypto_box_afternm:A,crypto_box:function(a,b,c,d,e,f){var g=new Uint8Array(32);t(g,e,f);return A(a,b,c,d,g)},crypto_box_open:function(a,b,c,d,e,f){var g=new Uint8Array(32);t(g,e,f);return y(a,b,c,d,g)},crypto_box_keypair:p,crypto_hash:v,crypto_sign:R,crypto_sign_keypair:ha,crypto_sign_open:P,crypto_secretbox_KEYBYTES:32,crypto_secretbox_NONCEBYTES:24,
crypto_secretbox_ZEROBYTES:32,crypto_secretbox_BOXZEROBYTES:16,crypto_scalarmult_BYTES:32,crypto_scalarmult_SCALARBYTES:32,crypto_box_PUBLICKEYBYTES:32,crypto_box_SECRETKEYBYTES:32,crypto_box_BEFORENMBYTES:32,crypto_box_NONCEBYTES:24,crypto_box_ZEROBYTES:32,crypto_box_BOXZEROBYTES:16,crypto_sign_BYTES:64,crypto_sign_PUBLICKEYBYTES:32,crypto_sign_SECRETKEYBYTES:64,crypto_sign_SEEDBYTES:32,crypto_hash_BYTES:64};b.randomBytes=function(a){var b=new Uint8Array(a);ja(b,a);return b};b.secretbox=function(a,
b,c){Y(a,b,c);fa(c,b);for(var d=new Uint8Array(32+a.length),e=new Uint8Array(d.length),f=0;f<a.length;f++)d[f+32]=a[f];A(e,d,d.length,b,c);return e.subarray(16)};b.secretbox.open=function(a,b,c){Y(a,b,c);fa(c,b);for(var d=new Uint8Array(16+a.length),e=new Uint8Array(d.length),f=0;f<a.length;f++)d[f+16]=a[f];return 32>d.length||0!==y(e,d,d.length,b,c)?null:e.subarray(32)};b.secretbox.keyLength=32;b.secretbox.nonceLength=24;b.secretbox.overheadLength=16;b.scalarMult=function(a,b){Y(a,b);if(32!==a.length)throw Error("bad n size");
if(32!==b.length)throw Error("bad p size");var c=new Uint8Array(32);M(c,a,b);return c};b.scalarMult.base=function(a){Y(a);if(32!==a.length)throw Error("bad n size");var b=new Uint8Array(32);u(b,a);return b};b.scalarMult.scalarLength=32;b.scalarMult.groupElementLength=32;b.box=function(a,c,d,e){d=b.box.before(d,e);return b.secretbox(a,c,d)};b.box.before=function(a,b){Y(a,b);if(32!==a.length)throw Error("bad public key size");if(32!==b.length)throw Error("bad secret key size");var c=new Uint8Array(32);
t(c,a,b);return c};b.box.after=b.secretbox;b.box.open=function(a,c,d,e){d=b.box.before(d,e);return b.secretbox.open(a,c,d)};b.box.open.after=b.secretbox.open;b.box.keyPair=function(){var a=new Uint8Array(32),b=new Uint8Array(32);p(a,b);return{publicKey:a,secretKey:b}};b.box.keyPair.fromSecretKey=function(a){Y(a);if(32!==a.length)throw Error("bad secret key size");var b=new Uint8Array(32);u(b,a);return{publicKey:b,secretKey:new Uint8Array(a)}};b.box.publicKeyLength=32;b.box.secretKeyLength=32;b.box.sharedKeyLength=
32;b.box.nonceLength=24;b.box.overheadLength=b.secretbox.overheadLength;b.sign=function(a,b){Y(a,b);if(64!==b.length)throw Error("bad secret key size");var c=new Uint8Array(64+a.length);R(c,a,a.length,b);return c};b.sign.open=function(a,b){Y(a,b);if(32!==b.length)throw Error("bad public key size");var c=new Uint8Array(a.length),d=P(c,a,a.length,b);if(0>d)return null;for(var d=new Uint8Array(d),e=0;e<d.length;e++)d[e]=c[e];return d};b.sign.detached=function(a,c){for(var d=b.sign(a,c),e=new Uint8Array(64),
f=0;f<e.length;f++)e[f]=d[f];return e};b.sign.detached.verify=function(a,b,c){Y(a,b,c);if(64!==b.length)throw Error("bad signature size");if(32!==c.length)throw Error("bad public key size");var d=new Uint8Array(64+a.length),e=new Uint8Array(64+a.length),f;for(f=0;64>f;f++)d[f]=b[f];for(f=0;f<a.length;f++)d[f+64]=a[f];return 0<=P(e,d,d.length,c)};b.sign.keyPair=function(){var a=new Uint8Array(32),b=new Uint8Array(64);ha(a,b);return{publicKey:a,secretKey:b}};b.sign.keyPair.fromSecretKey=function(a){Y(a);
if(64!==a.length)throw Error("bad secret key size");for(var b=new Uint8Array(32),c=0;c<b.length;c++)b[c]=a[32+c];return{publicKey:b,secretKey:new Uint8Array(a)}};b.sign.keyPair.fromSeed=function(a){Y(a);if(32!==a.length)throw Error("bad seed size");for(var b=new Uint8Array(32),c=new Uint8Array(64),d=0;32>d;d++)c[d]=a[d];ha(b,c,!0);return{publicKey:b,secretKey:c}};b.sign.publicKeyLength=32;b.sign.secretKeyLength=64;b.sign.seedLength=32;b.sign.signatureLength=64;b.hash=function(a){Y(a);var b=new Uint8Array(64);
v(b,a,a.length);return b};b.hash.hashLength=64;b.verify=function(a,b){Y(a,b);return 0===a.length||0===b.length||a.length!==b.length?!1:0===g(a,0,b,0,a.length)?!0:!1};b.setPRNG=function(a){ja=a};(function(){var a="undefined"!==typeof self?self.crypto||self.msCrypto:null;a&&a.getRandomValues?b.setPRNG(function(b,c){var d,e=new Uint8Array(c);for(d=0;d<c;d+=65536)a.getRandomValues(e.subarray(d,d+Math.min(c-d,65536)));for(d=0;d<c;d++)b[d]=e[d];ga(e)}):"undefined"!==typeof f&&(a=f("crypto"))&&a.randomBytes&&
b.setPRNG(function(b,c){var d,e=a.randomBytes(c);for(d=0;d<c;d++)b[d]=e[d];ga(e)})})()})("undefined"!==typeof m&&m.exports?m.exports:self.nacl=self.nacl||{})},{crypto:24}],131:[function(f,m,k){function b(){this.href=this.path=this.pathname=this.query=this.search=this.hash=this.hostname=this.port=this.host=this.auth=this.slashes=this.protocol=null}function a(a,d,e){if(a&&c.isObject(a)&&a instanceof b)return a;var f=new b;f.parse(a,d,e);return f}var g=f("punycode"),c=f("./util");k.parse=a;k.resolve=
function(b,c){return a(b,!1,!0).resolve(c)};k.resolveObject=function(b,c){return b?a(b,!1,!0).resolveObject(c):c};k.format=function(d){c.isString(d)&&(d=a(d));return d instanceof b?d.format():b.prototype.format.call(d)};k.Url=b;var l=/^([a-z0-9.+-]+:)/i,e=/:[0-9]*$/,h=/^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/;m="{}|\\^`".split("").concat('<>"` \r\n\t'.split(""));var n=["'"].concat(m),w=["%","/","?",";","#"].concat(n),d=["/","?","#"],r=/^[+a-z0-9A-Z_-]{0,63}$/,B=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,F={javascript:!0,
"javascript:":!0},A={javascript:!0,"javascript:":!0},y={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},C=f("querystring");b.prototype.parse=function(a,b,e){var f,k;if(!c.isString(a))throw new TypeError("Parameter 'url' must be a string, not "+typeof a);var m=a.indexOf("?"),m=-1!==m&&m<a.indexOf("#")?"?":"#";a=a.split(m);a[0]=a[0].replace(/\\/g,"/");a=a.join(m);m=a.trim();if(!e&&1===a.split("#").length&&(a=h.exec(m)))return this.href=this.path=m,
this.pathname=a[1],a[2]?(this.search=a[2],this.query=b?C.parse(this.search.substr(1)):this.search.substr(1)):b&&(this.search="",this.query={}),this;if(a=l.exec(m))a=a[0],this.protocol=k=a.toLowerCase(),m=m.substr(a.length);if(e||a||m.match(/^\/\/[^@\/]+@[^@\/]+/))!(f="//"===m.substr(0,2))||a&&A[a]||(m=m.substr(2),this.slashes=!0);if(!A[a]&&(f||a&&!y[a])){a=-1;for(e=0;e<d.length;e++)f=m.indexOf(d[e]),-1!==f&&(-1===a||f<a)&&(a=f);f=-1===a?m.lastIndexOf("@"):m.lastIndexOf("@",a);-1!==f&&(e=m.slice(0,
f),m=m.slice(f+1),this.auth=decodeURIComponent(e));a=-1;for(e=0;e<w.length;e++)f=m.indexOf(w[e]),-1!==f&&(-1===a||f<a)&&(a=f);-1===a&&(a=m.length);this.host=m.slice(0,a);m=m.slice(a);this.parseHost();this.hostname=this.hostname||"";f="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!f){var q=this.hostname.split(/\./);e=0;for(a=q.length;e<a;e++){var G=q[e];if(G&&!G.match(r)){for(var I="",x=0,U=G.length;x<U;x++)I=127<G.charCodeAt(x)?I+"x":I+G[x];if(!I.match(r)){a=q.slice(0,e);
e=q.slice(e+1);if(G=G.match(B))a.push(G[1]),e.unshift(G[2]);e.length&&(m="/"+e.join(".")+m);this.hostname=a.join(".");break}}}}this.hostname=255<this.hostname.length?"":this.hostname.toLowerCase();f||(this.hostname=g.toASCII(this.hostname));e=this.port?":"+this.port:"";this.host=(this.hostname||"")+e;this.href+=this.host;f&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==m[0]&&(m="/"+m))}if(!F[k])for(e=0,a=n.length;e<a;e++)f=n[e],-1!==m.indexOf(f)&&(G=encodeURIComponent(f),G===
f&&(G=escape(f)),m=m.split(f).join(G));e=m.indexOf("#");-1!==e&&(this.hash=m.substr(e),m=m.slice(0,e));e=m.indexOf("?");-1!==e?(this.search=m.substr(e),this.query=m.substr(e+1),b&&(this.query=C.parse(this.query)),m=m.slice(0,e)):b&&(this.search="",this.query={});m&&(this.pathname=m);y[k]&&this.hostname&&!this.pathname&&(this.pathname="/");if(this.pathname||this.search)e=this.pathname||"",this.path=e+(this.search||"");this.href=this.format();return this};b.prototype.format=function(){var a=this.auth||
"";a&&(a=encodeURIComponent(a),a=a.replace(/%3A/i,":"),a+="@");var b=this.protocol||"",d=this.pathname||"",e=this.hash||"",f=!1,g="";this.host?f=a+this.host:this.hostname&&(f=a+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(f+=":"+this.port));this.query&&c.isObject(this.query)&&Object.keys(this.query).length&&(g=C.stringify(this.query));a=this.search||g&&"?"+g||"";b&&":"!==b.substr(-1)&&(b+=":");this.slashes||(!b||y[b])&&!1!==f?(f="//"+(f||""),d&&"/"!==d.charAt(0)&&
(d="/"+d)):f||(f="");e&&"#"!==e.charAt(0)&&(e="#"+e);a&&"?"!==a.charAt(0)&&(a="?"+a);d=d.replace(/[?#]/g,function(a){return encodeURIComponent(a)});a=a.replace("#","%23");return b+f+d+a+e};b.prototype.resolve=function(b){return this.resolveObject(a(b,!1,!0)).format()};b.prototype.resolveObject=function(a){var d;if(c.isString(a)){var e=new b;e.parse(a,!1,!0);a=e}for(var e=new b,f=Object.keys(this),g=0;g<f.length;g++){var h=f[g];e[h]=this[h]}e.hash=a.hash;if(""===a.href)return e.href=e.format(),e;if(a.slashes&&
!a.protocol){f=Object.keys(a);for(g=0;g<f.length;g++)h=f[g],"protocol"!==h&&(e[h]=a[h]);y[e.protocol]&&e.hostname&&!e.pathname&&(e.path=e.pathname="/");e.href=e.format();return e}if(a.protocol&&a.protocol!==e.protocol){if(!y[a.protocol]){f=Object.keys(a);for(g=0;g<f.length;g++)h=f[g],e[h]=a[h];e.href=e.format();return e}e.protocol=a.protocol;if(a.host||A[a.protocol])e.pathname=a.pathname;else{for(d=(a.pathname||"").split("/");d.length&&!(a.host=d.shift()););a.host||(a.host="");a.hostname||(a.hostname=
"");""!==d[0]&&d.unshift("");2>d.length&&d.unshift("");e.pathname=d.join("/")}e.search=a.search;e.query=a.query;e.host=a.host||"";e.auth=a.auth;e.hostname=a.hostname||a.host;e.port=a.port;if(e.pathname||e.search)e.path=(e.pathname||"")+(e.search||"");e.slashes=e.slashes||a.slashes;e.href=e.format();return e}var f=e.pathname&&"/"===e.pathname.charAt(0),k=a.host||a.pathname&&"/"===a.pathname.charAt(0),l=f=k||f||e.host&&a.pathname,g=e.pathname&&e.pathname.split("/")||[];d=a.pathname&&a.pathname.split("/")||
[];if(h=e.protocol&&!y[e.protocol])e.hostname="",e.port=null,e.host&&(""===g[0]?g[0]=e.host:g.unshift(e.host)),e.host="",a.protocol&&(a.hostname=null,a.port=null,a.host&&(""===d[0]?d[0]=a.host:d.unshift(a.host)),a.host=null),f=f&&(""===d[0]||""===g[0]);if(k)e.host=a.host||""===a.host?a.host:e.host,e.hostname=a.hostname||""===a.hostname?a.hostname:e.hostname,e.search=a.search,e.query=a.query,g=d;else if(d.length)g||(g=[]),g.pop(),g=g.concat(d),e.search=a.search,e.query=a.query;else if(!c.isNullOrUndefined(a.search))return h&&
(e.hostname=e.host=g.shift(),h=e.host&&0<e.host.indexOf("@")?e.host.split("@"):!1)&&(e.auth=h.shift(),e.host=e.hostname=h.shift()),e.search=a.search,e.query=a.query,c.isNull(e.pathname)&&c.isNull(e.search)||(e.path=(e.pathname?e.pathname:"")+(e.search?e.search:"")),e.href=e.format(),e;if(!g.length)return e.pathname=null,e.path=e.search?"/"+e.search:null,e.href=e.format(),e;k=g.slice(-1)[0];d=(e.host||a.host||1<g.length)&&("."===k||".."===k)||""===k;for(var n=0,m=g.length;0<=m;m--)k=g[m],"."===k?g.splice(m,
1):".."===k?(g.splice(m,1),n++):n&&(g.splice(m,1),n--);if(!f&&!l)for(;n--;n)g.unshift("..");!f||""===g[0]||g[0]&&"/"===g[0].charAt(0)||g.unshift("");d&&"/"!==g.join("/").substr(-1)&&g.push("");l=""===g[0]||g[0]&&"/"===g[0].charAt(0);h&&(e.hostname=e.host=l?"":g.length?g.shift():"",h=e.host&&0<e.host.indexOf("@")?e.host.split("@"):!1)&&(e.auth=h.shift(),e.host=e.hostname=h.shift());(f=f||e.host&&g.length)&&!l&&g.unshift("");g.length?e.pathname=g.join("/"):(e.pathname=null,e.path=null);c.isNull(e.pathname)&&
c.isNull(e.search)||(e.path=(e.pathname?e.pathname:"")+(e.search?e.search:""));e.auth=a.auth||e.auth;e.slashes=e.slashes||a.slashes;e.href=e.format();return e};b.prototype.parseHost=function(){var a=this.host,b=e.exec(a);b&&(b=b[0],":"!==b&&(this.port=b.substr(1)),a=a.substr(0,a.length-b.length));a&&(this.hostname=a)}},{"./util":132,punycode:111,querystring:114}],132:[function(f,m,k){m.exports={isString:function(b){return"string"===typeof b},isObject:function(b){return"object"===typeof b&&null!==
b},isNull:function(b){return null===b},isNullOrUndefined:function(b){return null==b}}},{}],133:[function(f,m,k){(function(b){function a(a){try{if(!b.localStorage)return!1}catch(c){return!1}a=b.localStorage[a];return null==a?!1:"true"===String(a).toLowerCase()}m.exports=function(b,c){if(a("noDeprecation"))return b;var f=!1;return function(){if(!f){if(a("throwDeprecation"))throw Error(c);a("traceDeprecation")?console.trace(c):console.warn(c);f=!0}return b.apply(this,arguments)}}}).call(this,"undefined"!==
typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],134:[function(f,m,k){arguments[4][76][0].apply(k,arguments)},{dup:76}],135:[function(f,m,k){m.exports=function(b){return b&&"object"===typeof b&&"function"===typeof b.copy&&"function"===typeof b.fill&&"function"===typeof b.readUInt8}},{}],136:[function(f,m,k){(function(b,a){function g(a,b){var d={seen:[],stylize:l};3<=arguments.length&&(d.depth=arguments[2]);4<=arguments.length&&(d.colors=arguments[3]);
A(b)?d.showHidden=b:b&&k._extend(d,b);q(d.showHidden)&&(d.showHidden=!1);q(d.depth)&&(d.depth=2);q(d.colors)&&(d.colors=!1);q(d.customInspect)&&(d.customInspect=!0);d.colors&&(d.stylize=c);return h(d,a,d.depth)}function c(a,b){var c=g.styles[b];return c?"\u001b["+g.colors[c][0]+"m"+a+"\u001b["+g.colors[c][1]+"m":a}function l(a,b){return a}function e(a){var b={};a.forEach(function(a,c){b[a]=!0});return b}function h(a,b,c){if(a.customInspect&&b&&J(b.inspect)&&b.inspect!==k.inspect&&(!b.constructor||
b.constructor.prototype!==b)){var f=b.inspect(c,a);C(f)||(f=h(a,f,c));return f}if(f=n(a,b))return f;var g=Object.keys(b),l=e(g);a.showHidden&&(g=Object.getOwnPropertyNames(b));if(O(b)&&(0<=g.indexOf("message")||0<=g.indexOf("description")))return m(b);if(0===g.length){if(J(b))return a.stylize("[Function"+(b.name?": "+b.name:"")+"]","special");if(I(b))return a.stylize(RegExp.prototype.toString.call(b),"regexp");if(K(b))return a.stylize(Date.prototype.toString.call(b),"date");if(O(b))return m(b)}var f=
"",p=!1,q=["{","}"];F(b)&&(p=!0,q=["[","]"]);J(b)&&(f=" [Function"+(b.name?": "+b.name:"")+"]");I(b)&&(f=" "+RegExp.prototype.toString.call(b));K(b)&&(f=" "+Date.prototype.toUTCString.call(b));O(b)&&(f=" "+m(b));if(0===g.length&&(!p||0==b.length))return q[0]+f+q[1];if(0>c)return I(b)?a.stylize(RegExp.prototype.toString.call(b),"regexp"):a.stylize("[Object]","special");a.seen.push(b);g=p?d(a,b,c,l,g):g.map(function(d){return r(a,b,c,l,d,p)});a.seen.pop();return B(g,f,q)}function n(a,b){if(q(b))return a.stylize("undefined",
"undefined");if(C(b)){var c="'"+JSON.stringify(b).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return a.stylize(c,"string")}if(y(b))return a.stylize(""+b,"number");if(A(b))return a.stylize(""+b,"boolean");if(null===b)return a.stylize("null","null")}function m(a){return"["+Error.prototype.toString.call(a)+"]"}function d(a,b,c,d,e){for(var f=[],g=0,h=b.length;g<h;++g)Object.prototype.hasOwnProperty.call(b,String(g))?f.push(r(a,b,c,d,String(g),!0)):f.push("");e.forEach(function(e){e.match(/^\d+$/)||
f.push(r(a,b,c,d,e,!0))});return f}function r(a,b,c,d,e,f){var g,k;b=Object.getOwnPropertyDescriptor(b,e)||{value:b[e]};b.get?k=b.set?a.stylize("[Getter/Setter]","special"):a.stylize("[Getter]","special"):b.set&&(k=a.stylize("[Setter]","special"));Object.prototype.hasOwnProperty.call(d,e)||(g="["+e+"]");k||(0>a.seen.indexOf(b.value)?(k=null===c?h(a,b.value,null):h(a,b.value,c-1),-1<k.indexOf("\n")&&(k=f?k.split("\n").map(function(a){return"  "+a}).join("\n").substr(2):"\n"+k.split("\n").map(function(a){return"   "+
a}).join("\n"))):k=a.stylize("[Circular]","special"));if(q(g)){if(f&&e.match(/^\d+$/))return k;g=JSON.stringify(""+e);g.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(g=g.substr(1,g.length-2),g=a.stylize(g,"name")):(g=g.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),g=a.stylize(g,"string"))}return g+": "+k}function B(a,b,c){var d=0;return 60<a.reduce(function(a,b){d++;0<=b.indexOf("\n")&&d++;return a+b.replace(/\u001b\[\d\d?m/g,"").length+1},0)?c[0]+(""===b?"":b+"\n ")+" "+a.join(",\n  ")+
" "+c[1]:c[0]+b+" "+a.join(", ")+" "+c[1]}function F(a){return Array.isArray(a)}function A(a){return"boolean"===typeof a}function y(a){return"number"===typeof a}function C(a){return"string"===typeof a}function q(a){return void 0===a}function I(a){return G(a)&&"[object RegExp]"===Object.prototype.toString.call(a)}function G(a){return"object"===typeof a&&null!==a}function K(a){return G(a)&&"[object Date]"===Object.prototype.toString.call(a)}function O(a){return G(a)&&("[object Error]"===Object.prototype.toString.call(a)||
a instanceof Error)}function J(a){return"function"===typeof a}function D(a){return 10>a?"0"+a.toString(10):a.toString(10)}function L(){var a=new Date,b=[D(a.getHours()),D(a.getMinutes()),D(a.getSeconds())].join(":");return[a.getDate(),M[a.getMonth()],b].join(" ")}var N=/%[sdj%]/g;k.format=function(a){if(!C(a)){for(var b=[],c=0;c<arguments.length;c++)b.push(g(arguments[c]));return b.join(" ")}for(var c=1,d=arguments,e=d.length,b=String(a).replace(N,function(a){if("%%"===a)return"%";if(c>=e)return a;
switch(a){case "%s":return String(d[c++]);case "%d":return Number(d[c++]);case "%j":try{return JSON.stringify(d[c++])}catch(S){return"[Circular]"}default:return a}}),f=d[c];c<e;f=d[++c])b=null!==f&&G(f)?b+(" "+g(f)):b+(" "+f);return b};k.deprecate=function(c,d){if(q(a.process))return function(){return k.deprecate(c,d).apply(this,arguments)};if(!0===b.noDeprecation)return c;var e=!1;return function(){if(!e){if(b.throwDeprecation)throw Error(d);b.traceDeprecation?console.trace(d):console.error(d);e=
!0}return c.apply(this,arguments)}};var x={},U;k.debuglog=function(a){q(U)&&(U=b.env.NODE_DEBUG||"");a=a.toUpperCase();if(!x[a])if((new RegExp("\\b"+a+"\\b","i")).test(U)){var c=b.pid;x[a]=function(){var b=k.format.apply(k,arguments);console.error("%s %d: %s",a,c,b)}}else x[a]=function(){};return x[a]};k.inspect=g;g.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,
39]};g.styles={special:"cyan",number:"yellow","boolean":"yellow",undefined:"grey","null":"bold",string:"green",date:"magenta",regexp:"red"};k.isArray=F;k.isBoolean=A;k.isNull=function(a){return null===a};k.isNullOrUndefined=function(a){return null==a};k.isNumber=y;k.isString=C;k.isSymbol=function(a){return"symbol"===typeof a};k.isUndefined=q;k.isRegExp=I;k.isObject=G;k.isDate=K;k.isError=O;k.isFunction=J;k.isPrimitive=function(a){return null===a||"boolean"===typeof a||"number"===typeof a||"string"===
typeof a||"symbol"===typeof a||"undefined"===typeof a};k.isBuffer=f("./support/isBuffer");var M="Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" ");k.log=function(){console.log("%s - %s",L(),k.format.apply(k,arguments))};k.inherits=f("inherits");k._extend=function(a,b){if(!b||!G(b))return a;for(var c=Object.keys(b),d=c.length;d--;)a[c[d]]=b[c[d]];return a}}).call(this,f("_process"),"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./support/isBuffer":135,
_process:110,inherits:134}],137:[function(f,m,k){(function(b){b(function(a){function b(a){var b=1<arguments.length?k.call(arguments,1):[];return function(){return h(a,this,b.concat(k.call(arguments)))}}var c=a("./when"),f=c["try"],e=a("./lib/liftAll"),h=a("./lib/apply")(c.Promise),k=Array.prototype.slice;return{lift:b,liftAll:function(a,c,f){return e(b,c,f,a)},call:f,apply:function(a,b){return h(a,this,null==b?[]:k.call(b))},compose:function(a){var b=k.call(arguments,1);return function(){var d=this,
e=k.call(arguments),e=f.apply(d,[a].concat(e));return c.reduce(b,function(a,b){return b.call(d,a)},e)}}}})})(function(b){m.exports=b(f)})},{"./lib/apply":141,"./lib/liftAll":153,"./when":161}],138:[function(f,m,k){(function(b){b(function(a){var b=a("./makePromise"),c=a("./Scheduler");a=a("./env").asap;return b({scheduler:new c(a)})})})(function(b){m.exports=b(f)})},{"./Scheduler":139,"./env":151,"./makePromise":154}],139:[function(f,m,k){(function(b){b(function(){function a(a){this._async=a;this._running=
!1;this._queue=this;this._queueLen=0;this._afterQueue={};this._afterQueueLen=0;var b=this;this.drain=function(){b._drain()}}a.prototype.enqueue=function(a){this._queue[this._queueLen++]=a;this.run()};a.prototype.afterQueue=function(a){this._afterQueue[this._afterQueueLen++]=a;this.run()};a.prototype.run=function(){this._running||(this._running=!0,this._async(this.drain))};a.prototype._drain=function(){for(var a=0;a<this._queueLen;++a)this._queue[a].run(),this._queue[a]=void 0;this._queueLen=0;this._running=
!1;for(a=0;a<this._afterQueueLen;++a)this._afterQueue[a].run(),this._afterQueue[a]=void 0;this._afterQueueLen=0};return a})})(function(b){m.exports=b()})},{}],140:[function(f,m,k){(function(b){b(function(){function a(b){Error.call(this);this.message=b;this.name=a.name;"function"===typeof Error.captureStackTrace&&Error.captureStackTrace(this,a)}a.prototype=Object.create(Error.prototype);return a.prototype.constructor=a})})(function(b){m.exports=b()})},{}],141:[function(f,m,k){(function(b){b(function(){function a(a,
f){function c(b,c){if(0>b.i)return f(b.f,b.thisArg,b.params,c);a._handler(b.args[b.i]).fold(g,b,void 0,c)}function g(a,b,d){a.params[a.i]=b;--a.i;c(a,d)}2>arguments.length&&(f=b);return function(b,e,d){var g=a._defer(),h=d.length;c({f:b,thisArg:e,args:d,params:Array(h),i:h-1,call:f},g._handler);return g}}function b(a,b,e,f){try{f.resolve(a.apply(b,e))}catch(n){f.reject(n)}}a.tryCatchResolve=b;return a})})(function(b){m.exports=b()})},{}],142:[function(f,m,k){(function(b){b(function(a){var b=a("../state"),
c=a("../apply");return function(a){function e(c){var d;c instanceof a&&(d=c._handler.join());if(d&&0===d.state()||!d)return k(c).then(b.fulfilled,b.rejected);d._unreport();return b.inspect(d)}function f(a){return function(b,c,d){return g(a,void 0,[b,c,d])}}var g=c(a),k=a.resolve,d=a.all,l=Array.prototype.reduce,m=Array.prototype.reduceRight,F=Array.prototype.slice;a.any=function(b){function c(a){k=null;this.resolve(a)}function d(a){this.resolved||(k.push(a),0===--h&&this.reject(k))}for(var e=a._defer(),
f=e._handler,g=b.length>>>0,h=g,k=[],l,n=0;n<g;++n)if(l=b[n],void 0!==l||n in b)if(l=a._handler(l),0<l.state()){f.become(l);a._visitRemaining(b,n,l);break}else l.visit(f,c,d);else--h;0===h&&f.reject(new RangeError("any(): array must not be empty"));return e};a.some=function(b,c){function d(a){this.resolved||(h.push(a),0===--n&&(k=null,this.resolve(h)))}function e(a){this.resolved||(k.push(a),0===--w&&(h=null,this.reject(k)))}var f=a._defer(),g=f._handler,h=[],k=[],l=b.length>>>0,n=0,m;for(m=0;m<l;++m){var r=
b[m];(void 0!==r||m in b)&&++n}c=Math.max(c,0);var w=n-c+1;n=Math.min(c,n);c>n?g.reject(new RangeError("some(): array must contain at least "+c+" item(s), but had "+n)):0===n&&g.resolve(h);for(m=0;m<l;++m)r=b[m],(void 0!==r||m in b)&&a._handler(r).visit(g,d,e,g.notify);return f};a.settle=function(a){return d(a.map(e))};a.map=function(b,c){return a._traverse(c,b)};a.filter=function(b,c){var d=F.call(b);return a._traverse(c,d).then(function(b){for(var c=b.length,e=Array(c),f=0,g=0;f<c;++f)b[f]&&(e[g++]=
a._handler(d[f]).value);e.length=g;return e})};a.reduce=function(a,b){return 2<arguments.length?l.call(a,f(b),arguments[2]):l.call(a,f(b))};a.reduceRight=function(a,b){return 2<arguments.length?m.call(a,f(b),arguments[2]):m.call(a,f(b))};a.prototype.spread=function(a){return this.then(d).then(function(b){return a.apply(this,b)})};return a}})})(function(b){m.exports=b(f)})},{"../apply":141,"../state":155}],143:[function(f,m,k){(function(b){b(function(){function a(){throw new TypeError("catch predicate must be a function");
}function b(a){return a}return function(c){function f(a,b){return function(c){return(b===Error||null!=b&&b.prototype instanceof Error?c instanceof b:b(c))?a.call(this,c):m(c)}}function e(a,b,c,d){a=a.call(b);return"object"!==typeof a&&"function"!==typeof a||null===a?c(d):g(a,c,d)}function g(a,b,c){return k(a).then(function(){return b(c)})}var k=c.resolve,m=c.reject,d=c.prototype["catch"];c.prototype.done=function(a,b){this._handler.visit(this._handler.receiver,a,b)};c.prototype["catch"]=c.prototype.otherwise=
function(b){return 2>arguments.length?d.call(this,b):"function"!==typeof b?this.ensure(a):d.call(this,f(arguments[1],b))};c.prototype["finally"]=c.prototype.ensure=function(a){return"function"!==typeof a?this:this.then(function(c){return e(a,this,b,c)},function(b){return e(a,this,m,b)})};c.prototype["else"]=c.prototype.orElse=function(a){return this.then(void 0,function(){return a})};c.prototype.yield=function(a){return this.then(function(){return a})};c.prototype.tap=function(a){return this.then(a).yield(this)};
return c}})})(function(b){m.exports=b()})},{}],144:[function(f,m,k){(function(b){b(function(){return function(a){a.prototype.fold=function(b,c){var f=this._beget();this._handler.fold(function(c,f,g){a._handler(c).fold(function(a,c,e){e.resolve(b.call(this,c,a))},f,this,g)},c,f._handler.receiver,f._handler);return f};return a}})})(function(b){m.exports=b()})},{}],145:[function(f,m,k){(function(b){b(function(a){var b=a("../state").inspect;return function(a){a.prototype.inspect=function(){return b(a._handler(this))};
return a}})})(function(b){m.exports=b(f)})},{"../state":155}],146:[function(f,m,k){(function(b){b(function(){return function(a){function b(a,e,f,g){function h(d,g){return c(f(d)).then(function(){return b(a,e,f,g)})}return c(g).then(function(b){return c(e(b)).then(function(d){return d?b:c(a(b)).spread(h)})})}var c=a.resolve;a.iterate=function(a,c,f,g){return b(function(b){return[b,a(b)]},c,f,g)};a.unfold=b;return a}})})(function(b){m.exports=b()})},{}],147:[function(f,m,k){(function(b){b(function(){return function(a){a.prototype.progress=
function(a){return this.then(void 0,void 0,a)};return a}})})(function(b){m.exports=b()})},{}],148:[function(f,m,k){(function(b){b(function(a){function b(a,b,f,g){return c.setTimer(function(){a(f,g,b)},b)}var c=a("../env"),f=a("../TimeoutError");return function(a){function e(a,c,e){b(g,a,c,e)}function g(a,b){b.resolve(a)}function k(a,b,c){a="undefined"===typeof a?new f("timed out after "+c+"ms"):a;b.reject(a)}a.prototype.delay=function(a){var b=this._beget();this._handler.fold(e,a,void 0,b._handler);
return b};a.prototype.timeout=function(a,e){var d=this._beget(),f=d._handler,g=b(k,a,e,d._handler);this._handler.visit(f,function(a){c.clearTimer(g);this.resolve(a)},function(a){c.clearTimer(g);this.reject(a)},f.notify);return d};return a}})})(function(b){m.exports=b(f)})},{"../TimeoutError":140,"../env":151}],149:[function(f,m,k){(function(b){b(function(a){function b(a){throw a;}function c(){}var f=a("../env").setTimer,e=a("../format");return function(a){function g(a){a.handled||(C.push(a),l("Potentially unhandled rejection ["+
a.id+"] "+e.formatError(a.value)))}function h(a){var b=C.indexOf(a);0<=b&&(C.splice(b,1),m("Handled previous rejection ["+a.id+"] "+e.formatObject(a.value)))}function d(a,b){y.push(a,b);null===q&&(q=f(k,0))}function k(){for(q=null;0<y.length;)y.shift()(y.shift())}var l=c,m=c;if("undefined"!==typeof console){var A=console;l="undefined"!==typeof A.error?function(a){A.error(a)}:function(a){A.log(a)};m="undefined"!==typeof A.info?function(a){A.info(a)}:function(a){A.log(a)}}a.onPotentiallyUnhandledRejection=
function(a){d(g,a)};a.onPotentiallyUnhandledRejectionHandled=function(a){d(h,a)};a.onFatalRejection=function(a){d(b,a.value)};var y=[],C=[],q=null;return a}})})(function(b){m.exports=b(f)})},{"../env":151,"../format":152}],150:[function(f,m,k){(function(b){b(function(){return function(a){a.prototype["with"]=a.prototype.withThis=function(a){var b=this._beget(),f=b._handler;f.receiver=a;this._handler.chain(f,a);return b};return a}})})(function(b){m.exports=b()})},{}],151:[function(f,m,k){(function(b){(function(a){a(function(a){function c(a){var b,
c=document.createTextNode("");(new a(function(){var a=b;b=void 0;a()})).observe(c,{characterData:!0});var d=0;return function(a){b=a;c.data=d^=1}}var f,e="undefined"!==typeof setTimeout&&setTimeout,g=function(a,b){return setTimeout(a,b)},k=function(a){return clearTimeout(a)},m=function(a){return e(a,0)};if("undefined"!==typeof b&&"[object process]"===Object.prototype.toString.call(b))m=function(a){return b.nextTick(a)};else if(f="undefined"!==typeof MutationObserver&&MutationObserver||"undefined"!==
typeof WebKitMutationObserver&&WebKitMutationObserver)m=c(f);else if(!e)var d=a("vertx"),g=function(a,b){return d.setTimer(b,a)},k=d.cancelTimer,m=d.runOnLoop||d.runOnContext;return{setTimer:g,clearTimer:k,asap:m}})})(function(a){m.exports=a(f)})}).call(this,f("_process"))},{_process:110}],152:[function(f,m,k){(function(b){b(function(){function a(a){var c=String(a);"[object Object]"===c&&"undefined"!==typeof JSON&&(c=b(a,c));return c}function b(a,b){try{return JSON.stringify(a)}catch(e){return b}}
return{formatError:function(b){var c="object"===typeof b&&null!==b&&(b.stack||b.message)?b.stack||b.message:a(b);return b instanceof Error?c:c+" (WARNING: non-Error used)"},formatObject:a,tryStringify:b}})})(function(b){m.exports=b()})},{}],153:[function(f,m,k){(function(b){b(function(){function a(a,b,e){a[e]=b;return a}function b(a){return"function"===typeof a?a.bind():Object.create(a)}return function(c,f,e,g){"undefined"===typeof f&&(f=a);return Object.keys(g).reduce(function(a,b){var d=g[b];return"function"===
typeof d?f(a,c(d),b):a},"undefined"===typeof e?b(g):e)}})})(function(b){m.exports=b()})},{}],154:[function(f,m,k){(function(b){(function(a){a(function(){return function(a){function c(a,b){this._handler=a===F?b:f(a)}function f(a){function b(a){e.resolve(a)}function c(a){e.reject(a)}function d(a){e.notify(a)}var e=new y;try{a(b,c,d)}catch(Y){c(Y)}return e}function e(a){return a instanceof c?a:new c(F,new C(r(a)))}function g(a){return new c(F,new C(new G(a)))}function k(a,b,d){function e(c,e,g){g.resolved||
m(d,f,c,a(b,e,c),g)}function f(a,b,c){l[a]=b;0===--k&&c.become(new I(l))}for(var g="function"===typeof b?e:f,h=new y,k=d.length>>>0,l=Array(k),n=0,p;n<d.length&&!h.resolved;++n)p=d[n],void 0!==p||n in d?m(d,g,n,p,h):--k;0===k&&h.become(new I(l));return new c(F,h)}function m(a,b,e,f,g){if(U(f)){f=f instanceof c?f._handler.join():B(f);var h=f.state();0===h?f.fold(b,e,void 0,g):0<h?b(e,f.value,g):(g.become(f),d(a,e+1,f))}else b(e,f,g)}function d(a,b,c){for(;b<a.length;++b){var d=r(a[b]);if(d!==c){var e=
d.state();0===e?d.visit(d,void 0,d._unreport):0>e&&d._unreport()}}}function r(a){return a instanceof c?a._handler.join():U(a)?B(a):new I(a)}function B(a){try{var b=a.then;return"function"===typeof b?new q(b,a):new I(a)}catch(R){return new G(R)}}function F(){}function A(){}function y(a,b){c.createContext(this,b);this.consumers=void 0;this.receiver=a;this.handler=void 0;this.resolved=!1}function C(a){this.handler=a}function q(a,b){y.call(this);v.enqueue(new L(a,b,this))}function I(a){c.createContext(this);
this.value=a}function G(a){c.createContext(this);this.id=++Z;this.value=a;this.reported=this.handled=!1;this._report()}function K(a,b){this.rejection=a;this.context=b}function O(a){this.rejection=a}function J(a,b){this.continuation=a;this.handler=b}function D(a,b){this.handler=b;this.value=a}function L(a,b,c){this._then=a;this.thenable=b;this.resolver=c}function N(a,b,c,d,e){try{a.call(b,c,d,e)}catch(Y){d(Y)}}function x(a,b,c,d){this.f=a;this.z=b;this.c=c;this.to=d;this.resolver=S;this.receiver=this}
function U(a){return("object"===typeof a||"function"===typeof a)&&null!==a}function M(a,b,d,e){if("function"!==typeof a)return e.become(b);c.enterContext(b);try{e.become(r(a.call(d,b.value)))}catch(fa){e.become(new G(fa))}c.exitContext()}function u(a,b,c){try{return a(b,c)}catch(P){return g(P)}}function p(a,b){b.prototype=T(a.prototype);b.prototype.constructor=b}function t(a,b){return b}function z(){}var v=a.scheduler,ca=function(){if("undefined"!==typeof b&&null!==b&&"function"===typeof b.emit)var a=
function(a,c){return"unhandledRejection"===a?b.emit(a,c.value,c):b.emit(a,c)};else{if(a="undefined"!==typeof self)a:{if("function"===typeof CustomEvent)try{a=new CustomEvent("unhandledRejection")instanceof CustomEvent;break a}catch(ba){}a=!1}if(a)a=function(a,b){return function(c,d){var e=new b(c,{detail:{reason:d.value,key:d},bubbles:!1,cancelable:!0});return!a.dispatchEvent(e)}}(self,CustomEvent);else{if(a="undefined"!==typeof self)a:{if("undefined"!==typeof document&&"function"===typeof document.createEvent)try{document.createEvent("CustomEvent").initCustomEvent("eventType",
!1,!0,{});a=!0;break a}catch(ba){}a=!1}a=a?function(a,b){return function(c,d){var e=b.createEvent("CustomEvent");e.initCustomEvent(c,!1,!0,{reason:d.value,key:d});return!a.dispatchEvent(e)}}(self,document):z}}return a}(),T=Object.create||function(a){function b(){}b.prototype=a;return new b};c.resolve=e;c.reject=g;c.never=function(){return ha};c._defer=function(){return new c(F,new y)};c._handler=r;c.prototype.then=function(a,b,c){var d=this._handler,e=d.join().state();if("function"!==typeof a&&0<
e||"function"!==typeof b&&0>e)return new this.constructor(F,d);e=this._beget();d.chain(e._handler,d.receiver,a,b,c);return e};c.prototype["catch"]=function(a){return this.then(void 0,a)};c.prototype._beget=function(){var a=this._handler,b=this.constructor,a=new y(a.receiver,a.join().context);return new b(F,a)};c.all=function(a){return k(t,null,a)};c.race=function(a){if("object"!==typeof a||null===a)return g(new TypeError("non-iterable passed to race()"));if(0===a.length)a=ha;else if(1===a.length)a=
e(a[0]);else{var b=new y,f;for(f=0;f<a.length;++f){var h=a[f];if(void 0!==h||f in a)if(h=r(h),0!==h.state()){b.become(h);d(a,f+1,h);break}else h.visit(b,b.resolve,b.reject)}a=new c(F,b)}return a};c._traverse=function(a,b){return k(u,a,b)};c._visitRemaining=d;F.prototype.when=F.prototype.become=F.prototype.notify=F.prototype.fail=F.prototype._unreport=F.prototype._report=z;F.prototype._state=0;F.prototype.state=function(){return this._state};F.prototype.join=function(){for(var a=this;void 0!==a.handler;)a=
a.handler;return a};F.prototype.chain=function(a,b,c,d,e){this.when({resolver:a,receiver:b,fulfilled:c,rejected:d,progress:e})};F.prototype.visit=function(a,b,c,d){this.chain(S,a,b,c,d)};F.prototype.fold=function(a,b,c,d){this.when(new x(a,b,c,d))};p(F,A);A.prototype.become=function(a){a.fail()};var S=new A;p(F,y);y.prototype._state=0;y.prototype.resolve=function(a){this.become(r(a))};y.prototype.reject=function(a){this.resolved||this.become(new G(a))};y.prototype.join=function(){if(!this.resolved)return this;
for(var a=this;void 0!==a.handler;)if(a=a.handler,a===this)return this.handler=new G(new TypeError("Promise cycle"));return a};y.prototype.run=function(){var a=this.consumers,b=this.handler;this.handler=this.handler.join();this.consumers=void 0;for(var c=0;c<a.length;++c)b.when(a[c])};y.prototype.become=function(a){this.resolved||(this.resolved=!0,this.handler=a,void 0!==this.consumers&&v.enqueue(this),void 0!==this.context&&a._report(this.context))};y.prototype.when=function(a){this.resolved?v.enqueue(new J(a,
this.handler)):void 0===this.consumers?this.consumers=[a]:this.consumers.push(a)};y.prototype.notify=function(a){this.resolved||v.enqueue(new D(a,this))};y.prototype.fail=function(a){a="undefined"===typeof a?this.context:a;this.resolved&&this.handler.join().fail(a)};y.prototype._report=function(a){this.resolved&&this.handler.join()._report(a)};y.prototype._unreport=function(){this.resolved&&this.handler.join()._unreport()};p(F,C);C.prototype.when=function(a){v.enqueue(new J(a,this))};C.prototype._report=
function(a){this.join()._report(a)};C.prototype._unreport=function(){this.join()._unreport()};p(y,q);p(F,I);I.prototype._state=1;I.prototype.fold=function(a,b,d,e){if("function"!==typeof a)e.become(this);else{c.enterContext(this);try{a.call(d,b,this.value,e)}catch(fa){e.become(new G(fa))}c.exitContext()}};I.prototype.when=function(a){M(a.fulfilled,this,a.receiver,a.resolver)};var Z=0;p(F,G);G.prototype._state=-1;G.prototype.fold=function(a,b,c,d){d.become(this)};G.prototype.when=function(a){"function"===
typeof a.rejected&&this._unreport();M(a.rejected,this,a.receiver,a.resolver)};G.prototype._report=function(a){v.afterQueue(new K(this,a))};G.prototype._unreport=function(){this.handled||(this.handled=!0,v.afterQueue(new O(this)))};G.prototype.fail=function(a){this.reported=!0;ca("unhandledRejection",this);c.onFatalRejection(this,void 0===a?this.context:a)};K.prototype.run=function(){this.rejection.handled||this.rejection.reported||(this.rejection.reported=!0,ca("unhandledRejection",this.rejection)||
c.onPotentiallyUnhandledRejection(this.rejection,this.context))};O.prototype.run=function(){this.rejection.reported&&(ca("rejectionHandled",this.rejection)||c.onPotentiallyUnhandledRejectionHandled(this.rejection))};c.createContext=c.enterContext=c.exitContext=c.onPotentiallyUnhandledRejection=c.onPotentiallyUnhandledRejectionHandled=c.onFatalRejection=z;a=new F;var ha=new c(F,a);J.prototype.run=function(){this.handler.join().when(this.continuation)};D.prototype.run=function(){var a=this.handler.consumers;
if(void 0!==a)for(var b,d=0;d<a.length;++d){b=a[d];var e=b.progress,f=this.value,g=this.handler,h=b.receiver;b=b.resolver;if("function"!==typeof e)b.notify(f);else{c.enterContext(g);g=b;try{g.notify(e.call(h,f))}catch(E){g.notify(E)}c.exitContext()}}};L.prototype.run=function(){var a=this.resolver;N(this._then,this.thenable,function(b){a.resolve(b)},function(b){a.reject(b)},function(b){a.notify(b)})};x.prototype.fulfilled=function(a){this.f.call(this.c,this.z,a,this.to)};x.prototype.rejected=function(a){this.to.reject(a)};
x.prototype.progress=function(a){this.to.notify(a)};return c}})})(function(a){m.exports=a()})}).call(this,f("_process"))},{_process:110}],155:[function(f,m,k){(function(b){b(function(){function a(){return{state:"pending"}}function b(a){return{state:"rejected",reason:a}}function c(a){return{state:"fulfilled",value:a}}return{pending:a,fulfilled:c,rejected:b,inspect:function(f){var e=f.state();return 0===e?a():0<e?c(f.value):b(f.value)}}})})(function(b){m.exports=b()})},{}],156:[function(f,m,k){(function(b){b(function(a){var b=
a("./monitor/PromiseMonitor");a=a("./monitor/ConsoleReporter");var c=new b(new a);return function(a){return c.monitor(a)}})})(function(b){m.exports=b(f)})},{"./monitor/ConsoleReporter":157,"./monitor/PromiseMonitor":158}],157:[function(f,m,k){(function(b){b(function(a){function b(){this._previouslyReported=!1}function c(){}var f=a("./error");b.prototype=function(){var a;if("undefined"===typeof console)var b=a=c;else{var f=console;if("function"===typeof f.error&&"function"===typeof f.dir){if(a=function(a){f.error(a)},
b=function(a){f.log(a)},"function"===typeof f.groupCollapsed){var g=function(a){f.groupCollapsed(a)};var d=function(){f.groupEnd()}}}else b="undefined"!==typeof f.log&&"undefined"!==typeof JSON?a=function(a){if("string"!==typeof a)try{a=JSON.stringify(a)}catch(B){}f.log(a)}:a=c}return{msg:b,warn:a,groupStart:g||a,groupEnd:d||c}}();b.prototype.log=function(a){if(0===a.length)this._previouslyReported&&(this._previouslyReported=!1,this.msg("[promises] All previously unhandled rejections have now been handled"));
else{this._previouslyReported=!0;this.groupStart("[promises] Unhandled rejections: "+a.length);try{this._log(a)}finally{this.groupEnd()}}};b.prototype._log=function(a){for(var b=0;b<a.length;++b)this.warn(f.format(a[b]))};return b})})(function(b){m.exports=b(f)})},{"./error":160}],158:[function(f,m,k){(function(b){b(function(a){function b(a){this.logDelay=0;this.stackFilter=e;this.stackJumpSeparator="from execution context:";this.filterDuplicateFrames=!0;this._reporter=a;"function"===typeof a.configurePromiseMonitor&&
a.configurePromiseMonitor(this);this._traces=[];this._traceTask=0;var b=this;this._doLogTraces=function(){b._logTraces()}}function c(a,b){return b.filter(function(b){return!a.test(b)})}function f(a){return!a.handler.handled}var e=/[\s\(\/\\](node|module|timers)\.js:|when([\/\\]{1,2}(lib|monitor|es6-shim)[\/\\]{1,2}|\.js)|(new\sPromise)\b|(\b(PromiseMonitor|ConsoleReporter|Scheduler|RunHandlerTask|ProgressTask|Promise|.*Handler)\.[\w_]\w\w+\b)|\b(tryCatch\w+|getHandler\w*)\b/i,h=a("../lib/env").setTimer,
k=a("./error"),m=[];b.prototype.monitor=function(a){var b=this;a.createContext=function(a,c){a.context=b.createContext(a,c)};a.enterContext=function(a){m.push(a.context)};a.exitContext=function(){m.pop()};a.onPotentiallyUnhandledRejection=function(a,c){return b.addTrace(a,c)};a.onPotentiallyUnhandledRejectionHandled=function(a){return b.removeTrace(a)};a.onFatalRejection=function(a,c){return b.fatal(a,c)};return this};b.prototype.createContext=function(a,b){var c={parent:b||m[m.length-1],stack:void 0};
k.captureStack(c,a.constructor);return c};b.prototype.addTrace=function(a,b){var c;for(c=this._traces.length-1;0<=c;--c){var d=this._traces[c];if(d.handler===a)break}0<=c?d.extraContext=b:this._traces.push({handler:a,extraContext:b});this.logTraces()};b.prototype.removeTrace=function(){this.logTraces()};b.prototype.fatal=function(a,b){var c=Error();c.stack=this._createLongTrace(a.value,a.context,b).join("\n");h(function(){throw c;},0)};b.prototype.logTraces=function(){this._traceTask||(this._traceTask=
h(this._doLogTraces,this.logDelay))};b.prototype._logTraces=function(){this._traceTask=void 0;this._traces=this._traces.filter(f);this._reporter.log(this.formatTraces(this._traces))};b.prototype.formatTraces=function(a){return a.map(function(a){return this._createLongTrace(a.handler.value,a.handler.context,a.extraContext)},this)};b.prototype._createLongTrace=function(a,b,e){a=k.parse(a)||[String(a)+" (WARNING: non-Error used)"];a=c(this.stackFilter,a,0);this._appendContext(a,b);this._appendContext(a,
e);return this.filterDuplicateFrames?this._removeDuplicates(a):a};b.prototype._removeDuplicates=function(a){var b={},c=this.stackJumpSeparator,d=0;return a.reduceRight(function(a,e,f){0===f?a.unshift(e):e===c?0<d&&(a.unshift(e),d=0):b[e]||(b[e]=!0,a.unshift(e),++d);return a},[])};b.prototype._appendContext=function(a,b){a.push.apply(a,this._createTrace(b))};b.prototype._createTrace=function(a){for(var b=[],d;a;){if(d=k.parse(a)){d=c(this.stackFilter,d);var e=b;1<d.length&&(d[0]=this.stackJumpSeparator,
e.push.apply(e,d))}a=a.parent}return b};return b})})(function(b){m.exports=b(f)})},{"../lib/env":151,"./error":160}],159:[function(f,m,k){(function(b){b(function(a){var b=a("../monitor");a=a("../when").Promise;return b(a)})})(function(b){m.exports=b(f)})},{"../monitor":156,"../when":161}],160:[function(f,m,k){(function(b){b(function(){function a(a){try{throw Error();}catch(r){a.stack=r.stack}}function b(a){a.stack=Error().stack}function c(a){return e(a)}function f(a){var b=Error();b.stack=e(a);return b}
function e(a){for(var b=!1,c="",d=0;d<a.length;++d)b?c+="\n"+a[d]:(c+=a[d],b=!0);return c}if(Error.captureStackTrace){var h=function(a){return a&&a.stack&&a.stack.split("\n")};var k=c;var m=Error.captureStackTrace}else h=function(a){var b=a&&a.stack&&a.stack.split("\n");b&&a.message&&b.unshift(a.message);return b},"string"!==typeof Error().stack?(k=c,m=a):(k=f,m=b);return{parse:h,format:k,captureStack:m}})})(function(b){m.exports=b()})},{}],161:[function(f,m,k){(function(b){b(function(a){function b(a,
b,c,d){var e=q.resolve(a);return 2>arguments.length?e:e.then(b,c,d)}function c(a){return function(){for(var b=0,c=arguments.length,d=Array(c);b<c;++b)d[b]=arguments[b];return I(a,this,d)}}function f(a){for(var b=0,c=arguments.length-1,d=Array(c);b<c;++b)d[b]=arguments[b+1];return I(a,this,d)}function e(){function a(a){d._handler.resolve(a)}function b(a){d._handler.reject(a)}function c(a){d._handler.notify(a)}var d=q._defer();this.promise=d;this.resolve=a;this.reject=b;this.notify=c;this.resolver=
{resolve:a,reject:b,notify:c}}var h=a("./lib/decorators/timed"),k=a("./lib/decorators/array"),m=a("./lib/decorators/flow"),d=a("./lib/decorators/fold"),r=a("./lib/decorators/inspect"),B=a("./lib/decorators/iterate"),F=a("./lib/decorators/progress"),A=a("./lib/decorators/with"),y=a("./lib/decorators/unhandledRejection"),C=a("./lib/TimeoutError"),q=[k,m,d,B,F,r,A,h,y].reduce(function(a,b){return b(a)},a("./lib/Promise")),I=a("./lib/apply")(q);b.promise=function(a){return new q(a)};b.resolve=q.resolve;
b.reject=q.reject;b.lift=c;b["try"]=f;b.attempt=f;b.iterate=q.iterate;b.unfold=q.unfold;b.join=function(){return q.all(arguments)};b.all=function(a){return b(a,q.all)};b.settle=function(a){return b(a,q.settle)};b.any=c(q.any);b.some=c(q.some);b.race=c(q.race);b.map=function(a,c){return b(a,function(a){return q.map(a,c)})};b.filter=function(a,c){return b(a,function(a){return q.filter(a,c)})};b.reduce=c(q.reduce);b.reduceRight=c(q.reduceRight);b.isPromiseLike=function(a){return a&&"function"===typeof a.then};
b.Promise=q;b.defer=function(){return new e};b.TimeoutError=C;return b})})(function(b){m.exports=b(f)})},{"./lib/Promise":138,"./lib/TimeoutError":140,"./lib/apply":141,"./lib/decorators/array":142,"./lib/decorators/flow":143,"./lib/decorators/fold":144,"./lib/decorators/inspect":145,"./lib/decorators/iterate":146,"./lib/decorators/progress":147,"./lib/decorators/timed":148,"./lib/decorators/unhandledRejection":149,"./lib/decorators/with":150}],162:[function(f,m,k){m.exports={name:"autobahn",version:"17.5.2",
description:"An implementation of The Web Application Messaging Protocol (WAMP).",main:"index.js",scripts:{test:"nodeunit test/test.js"},engines:{node:">= 4.2.6"},dependencies:{"crypto-js":">= 3.1.8","int64-buffer":">= 0.1.9","msgpack-lite":">= 0.1.26",cbor:">= 3.0.0",tweetnacl:">= 0.14.3",when:">= 3.7.7",ws:">= 1.1.4"},optionalDependencies:{bufferutil:">= 1.2.1","utf-8-validate":">= 1.2.1"},devDependencies:{browserify:">= 13.1.1","deep-equal":">= 1.0.1","google-closure-compiler":"^20170218.0.0",
nodeunit:">= 0.10.2"},browser:{ws:!1,"lib/transport/rawsocket.js":!1},repository:{type:"git",url:"git://github.com/crossbario/autobahn-js.git"},keywords:["WAMP","WebSocket","RPC","PubSub"],author:"Crossbar.io Technologies GmbH",license:"MIT"}},{}]},{},[4])(4)});
